from optimus_prime.utils import default_types, DefaultType, Enum, Object
import os

base_types = [b_type for b_type in default_types]
base_types += [DefaultType.Integer, DefaultType.Unicode, DefaultType.Boolean]


def get_instantiator(serializer_type, g_objects):
    if hasattr(serializer_type, "name"):
        serializer_type = serializer_type.name

    if serializer_type in [DefaultType.Integer, DefaultType.Unicode, DefaultType.Boolean]:
        return None
    elif serializer_type in base_types:
        return "LacieLib.%s_Instantiator" % serializer_type
    else:
        current_service = g_objects[serializer_type]
        config = g_objects.config
        full_name = "%s.%s" % (config.lib_path, current_service.get_import_path(config.min_version, "default"))
        return "%s.%s_Instantiator" % (full_name, serializer_type)


def check_and_create_gen_file(obj, gen_date, config):

    start = ""

    splited_path = [config.output, config.lib_path] + obj.get_import_path(config.min_version, "default").split('.')

    for path in splited_path:
        start = os.path.join(start, path)
        if os.path.exists(start):
            pass
        else:
            os.mkdir(start)

    # Create the file
    file_path = os.path.join(*splited_path)
    file_path = os.path.join(file_path, "%s.js" % obj.name)

    file = open(file_path, "w")

    return file


base_types = [b_type for b_type in default_types]
base_types += [DefaultType.Integer, DefaultType.Unicode, DefaultType.Boolean]

base_type = {
    DefaultType.Unicode: "string",
    DefaultType.Integer: "int",
    DefaultType.Long: "long",
    DefaultType.Boolean: "bool",
    "void": "NULL",
}


def get_imports(o_object, objects):

    list_imports = ["lib/lib.js"]
    for obj_type in o_object.imports:
        if not(obj_type in base_type) and not(obj_type in default_types):
            ob = objects[obj_type]

            if isinstance(ob, Enum):
                pass
                #string += "requires(\"%s/%s.php\");\n" % (
                #    objects.config.lib_path,
                #    ob.get_import_path(objects.config.min_version, "default").replace(".", "/")
                #)
            else:
                list_imports.append("%s/%s/%s.js" % (
                    objects.config.lib_path,
                    ob.get_import_path(objects.config.min_version, "default").replace(".", "/"),
                    obj_type
                ))

    return "loader.requires([%s]);\n" % ",".join(['"%s"' % p for p in list_imports])
