#!/usr/bin/python
import sys
import shutil
import os

GEN_DATE_OFFSET  = 16
GEN_DATE_STRING = "#GEN_DATE "

def copy(file1, file2, info=False):
    copy = False
    if os.path.exists(file2):
        with open(file1) as f:
            file1_lines = f.readlines()
        with open(file2) as f:
            file2_lines = f.readlines()
        if len(file1_lines) != len(file2_lines):
            copy = True
        else:
            gen_date_over = False
            for i in range(0, len(file1_lines)):
                if file1_lines[i] != file2_lines[i]:
                    if not gen_date_over and \
                      file1_lines[i].startswith(GEN_DATE_STRING) and \
                      file2_lines[i].startswith(GEN_DATE_STRING) :
                        gen_date_over = True
                        assert(i < GEN_DATE_OFFSET + 1)
                        continue
                    copy = True
                    break
    else:
        copy = True
    if copy and not info:
        shutil.copyfile(file1, file2)

    return copy

if __name__ == "__main__":
    copy(sys.argv[1], sys.argv[2])
