from transformer.serialization.s_json import Serializer
from transformer.lib.errors import error_table


class Error(Exception):
    def __init__(self, error_code, text):
        self.error_code = error_code
        self.text       = text

    def __str__(self):
        return "%s:%s" % (self.error_code, self.text)

serializer = Serializer


def set_serializer(new_serializer):
    global serializer
    serializer = new_serializer


class ClientSerializer(object):

    @classmethod
    def from_string(cls, context, status, stuff):
        if status:
            return serializer.from_string(context, stuff)
        else:
            error_code, text, file_line = serializer.deserialize_error(context, stuff)
            error = error_table[error_code](text)
            error.file_line = file_line
            raise error

    @classmethod
    def to_string(cls, context, stuff):
        return serializer.to_string(context, stuff, None)
