#!/usr/bin/python
# -*- coding: utf-8 -*-
#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2010, All Rights Reserved.
try:
    from transformer.plugins.lacie import LacieClientAuthentication
    authentication_plugin = LacieClientAuthentication()
except:
    authentication_plugin = None

from transformer.lib.tool_kit import deprecated


class Error(Exception):
    def __init__(self, text):
        self.text = text

client = None


def set_client(new_client):
    global client
    client = new_client
    client.set_authentication(authentication_plugin)


def get_client():
    return client


class ClientTransport(object):

    def set_authentication(self, authentication):
        client.set_authentication(authentication)

    @classmethod
    def send(cls, url, body):
        try:
            return client.send(url, body)
        except Error:
            pass

    @classmethod
    def async(cls, url, body, callback, application_id):
        try:
            client.async(url, body, callback, application_id)
        except Error:
            pass

    @classmethod
    @deprecated("Please use the Authentication plugin method")
    def set_password(cls, value):
        #to keep compatibility but should not be used like this anymore
        client.authentication_plugin.password = value

    @classmethod
    @deprecated("Please use the Authentication plugin method")
    def set_user(cls, user):
        client.authentication_plugin.user = user

    @classmethod
    @deprecated("Please use the Authentication plugin method")
    def set_token(cls, token):
        client.authentication_plugin.token = token

    @classmethod
    def stop(cls):
        client.stop()

    @classmethod
    def start_requests_bundle(cls):
        client.start_requests_bundle()

    @classmethod
    def stop_requests_bundle(cls):
        client.stop_requests_bundle()

    @classmethod
    def get_capabilities(cls, version=None):
        client.get_capabilities(version)

    @classmethod
    def get_job_status(cls, job_id):
        return client.get_job_status(job_id)

    @classmethod
    def get_jobs_list(cls, list_info):
        return client.get_jobs_list(list_info)