import warnings


class deprecated(object):
    def __init__(self, text):
        self.text = text

    def __call__(self, func):
        '''This is a decorator which can be used to mark functions
        as deprecated. It will result in a warning being emitted
        when the function is used.'''

        def new_func(*args, **kwargs):
            warnings.warn_explicit(
                "Call to deprecated function {}. %s %s" % (format(func.__name__), self.text),
                category=DeprecationWarning,
                filename=func.func_code.co_filename,
                lineno=func.func_code.co_firstlineno + 1
            )
            print "Warning using deprecated method for function {} %s" % format(func.__name__)
            print "%s:%s" % (func.func_code.co_filename, func.func_code.co_firstlineno + 1)
            print self.text

            return func(*args, **kwargs)
        return new_func
