def bool_from_string(value):
    if value in ["True", "true", 1, True, "1"]:
        return True
    return False


def int_from_string(value):
    return int(value)


def unicode_from_string(value):
    return unicode(value)


def list_from_string(value):
    assert(value[0] == "[")
    assert(value[-1] == "]")
    splitted_values = value[1:-1].split(",")
    digit = True
    for v in splitted_values:
        if not v.isdigit():
            digit = False
    if digit:
        return [int(v) for v in splitted_values]
    return splitted_values


class search_criteria(object):
    def __init__(self, list_info_name, **kwargs):
        self.list_info_name = list_info_name
        self.search_criterias = kwargs

    def __call__(self, function):
        def check_function(*args, **kwargs):
            list_info = kwargs[self.list_info_name]
            if list_info.search_parameters is not None:
                for k, v in list_info.search_parameters.iteritems():
                    if not k in self.search_criterias:
                        raise Exception("Not in search_criterias %s" % k)

                    else:
                        list_info.search_parameters[k] = self.search_criterias[k](v)
            return function(*args, **kwargs)
        return check_function


class order_by_criteria(object):
    def __init__(self, list_info_name, **kwargs):
        self.list_info_name = list_info_name
        self.order_by_criteria = kwargs

    def __call__(self, function):
        def check_function(*args, **kwargs):
            list_info = kwargs[self.list_info_name]
            if list_info.order is not None:
                if not list_info.order.order_by in self.order_by_criteria:
                    raise Exception("Not in order_by_criteria %s" %
                            list_info.order.order_by)
            return function(*args, **kwargs)
        return check_function


class Task(object):
    pass


class TaskManager(object):

    def list(self, auth_struct):

        return
