from transformer.lib import get_instantiator

class BundleledRequest(object):
    url     = ""
    data    = ""
    uid     = -1
    code    = -1



class DefaultSerializer(object):
    @classmethod
    def serialize(cls, context, obj, with_params, v_type=None):
        if obj is None:
            return None

        if v_type is not None and hasattr(v_type, '__instantiator__'):
            if hasattr(obj, "__instantiator__"):
                assert(v_type.__instantiator__ == obj.__instantiator__)
            return v_type.__instantiator__.serialize(context, obj, with_params, cls)
        elif hasattr(obj, "__instantiator__"):

            return obj.__instantiator__.serialize(context, obj, with_params, cls)
        #elif isinstance(list, obj):
        #    return [serialize(elem) for elem in obj]
        elif isinstance(obj, list):
            return [cls.serialize(context, elem, with_params, cls) for elem in obj]
        elif isinstance(obj, dict):

            d = dict()
            for key, value in obj.iteritems():
                d[key] = cls.serialize(context, value, with_params, cls)
            return d
        else:

            return obj

    @classmethod
    def deserialize(cls, context, value, instantiator=None, serializer=None, version=None, sub_version=None):
        if value is None:
            return None
        if isinstance(value, str):
            return unicode(value)
        elif isinstance(value, int) or isinstance(value, unicode) or isinstance(value, float) or isinstance(value, long):
            return value
        elif isinstance(value, list):
            l = list()
            for elem in value:
                l.append(cls.deserialize(context, elem, version=version, sub_version=sub_version))
            return l
        elif value.has_key('__type__'):
            #Check if version is present
            type_name = value['__type__']

            if value.has_key('__version__'):
                #Now we have to check loop on subversion than version
                #And finally look in default
                version = value['__version__']
                sub_version = value['__sub_version__']

            instantiator = get_instantiator(context, type_name, version,
                    sub_version)
            return instantiator.deserialize(context, value, instantiator, cls, version=version, sub_version=sub_version)

        elif isinstance(value, dict):
            d = dict()
            for elem in value:
                d[elem]= cls.deserialize(context, value[elem], version=version, sub_version=sub_version)
            return d
        else:
            return instantiator(value, cls.TYPE)
