import tornado.web
try:
    import tornado.auth
    class AuthenticateWithGoogle(tornado.web.RequestHandler, tornado.auth.GoogleMixin):
        @tornado.web.asynchronous
        def get(self):
            if self.get_argument("openid.mode", None):
                self.get_authenticated_user(self.async_callback(self._on_auth))
                return
            self.authenticate_redirect()
        def _on_auth(self, user):
            if not user:
                raise tornado.web.HTTPError(500, "Google auth failed")
                # Save the user with, e.g., set_secure_cookie()

            if not self.check_user(user):
                raise tornado.web.HTTPError(500, "Couldn't authenticate")
            self.write("<script language='javascript'> window.location = '%s'; </script>" % self.request.path)
            self.finish()

        def check_user(self, user_dict):
            return True
except:
    class AuthenticateWithGoogle(tornado.web.RequestHandler):
        def get(self):
            raise tornado.web.HTTPError(500, "Google auth failed")

