
import SocketServer
from lib import deserialize, serialize

declared_function_list = {}

def load_dispatcher():
    from dispatch import services
    print "loading dispatcher"
    for service_class in services:
        splitted = service_class.split(".")
        module_name = ".".join(splitted)
        class_name = splitted[len(splitted) -1]

        __module__ = __import__(module_name, fromlist=[class_name,])

        cls = getattr(__module__, class_name)
        for func in cls.validators:
            declared_function_list["%s.%s" % (service_class, func)] = (cls, func)


def get_instance(cls):
    return cls()

load_dispatcher()

def check(json_value, validators):
    import json
    res_json = json.loads(json_value)
    res = deserialize(res_json, "json")

    assert(len(res) == len(validators['input']))
    for name, obj in validators['input'].iteritems():
        assert(isinstance(res[name], obj))
    return res

def send(sock, message):
    #print "===> sending %s" % message
    sock.send(message)
    #print "message sent <==="

def receive(sock, size=None):
    data = ''
    while 1:
        new_data = sock.recv(1024)
        data += new_data
        if not new_data or len(data) < 1024:
            break;
        #print "new data %s" % new_data


    #print "received _%s_" % data
    if size is None:
        return data

    return data[:size]

class MyTCPHandler(SocketServer.BaseRequestHandler):
    """
    The RequestHandler class for our server.

    It is instantiated once per connection to the server, and must
    override the handle() method to implement communication to the
    client.
    """
    context_client = {}

    def handle(self):

        self.context_client.setdefault(self.client_address[0], {'state':0})
        ctx  = self.context_client[self.client_address[0]]
        import time
        while 1:
            start = time.time()
            # self.request is the TCP socket connected to the client
            self.data = receive(self.request).strip()
            size, function = self.data.split(":")
            ctx['size'] = int(size)
            ctx['function'] = function
            ctx['state'] = 1
            send(self.request, "start")

            body = receive(self.request, ctx['size'])
            function = ctx['function']
            (cls, function) = declared_function_list[function]
            kwargs = check(body, cls.validators[function])
            res = getattr(get_instance(cls), function)(**kwargs)

            import json
            ctx['state'] = 2
            self.ser = json.dumps(serialize(res, "json"))
            send(self.request, "%s" % len(self.ser))

            ctx['state'] = 0
            receive(self.request)
            send(self.request, self.ser)

            print "Request handled in %s" % (time.time() -start)



if __name__ == "__main__":
    import getopt
    import sys
    try:
        opts, args = getopt.getopt(sys.argv[1:], "h", ["help", ])
    except getopt.error, msg:
        print msg
        print "for help use --help"
        sys.exit(2)

    HOST, PORT = "localhost", 9999
    if len(args) == 0:
        HOST = "localhost"
    elif 1 == len(args):
        HOST = args[0]
    elif 2 == len(args):
        HOST, PORT = args
    else:
        sys.exit(2)


    # Create the server, binding to localhost on port 9999
    print "starting server on %s:%s" % (HOST, PORT)
    server = SocketServer.TCPServer((HOST, PORT), MyTCPHandler)

    # Activate the server; this will keep running until you
    # interrupt the program with Ctrl-C
    server.serve_forever()





