from transformer.lib.errors import ClientError as Error
from transformer.lib.errors import (error_table, AuthenticationError, TimeIsSkewedError,
		WrongCredentialsError, NotEnoughRights, UnknownToken, ElapsedToken, WrongValue, UnknownResource)
try:
    from unicorn.core.translation import _
except:
    class _(object):
        def __init__(self, text):
            self.text = text


class Offsets:
    MULTI_NIC = 4000
    SHARING = 2000
    NETWORK = 4500
    BTSYNC = 6000
    GENERIC = 210
    ISCSI = 5000
    WELCOME = 500
    STORAGE = 5500
    BIG_WUALA = 3000
    SETTINGS_BACKUP = 7000
    AUTHENTICATION = 100
    APPSTORE = 6500
    UNICORN = 1000
    SERIALIZATION = 200

class TooManyTokens(Error):
    real_id  = 120

class MissingProperty(Error):
    real_id  = 201

class BadPropertyType(Error):
    real_id  = 202

class MalformedBody(Error):
    real_id  = 203

class WrongFunctionPrototype(Error):
    real_id  = 204

class UnexpectedProperty(Error):
    real_id  = 205

class NtpServerError(Error):
    real_id  = 222

class WelcomeAlreadyDone(Error):
    real_id  = 501

class WelcomeUserCreationFailed(Error):
    real_id  = 502

class WelcomeShareCreationFailed(Error):
    real_id  = 503

class WelcomeUserNotFound(Error):
    real_id  = 504

class InvalidRequestConfig(Error):
    real_id  = 1001

class QuotaNotAllowed(Error):
    real_id  = 2001

class BrowsingInvalidPath(Error):
    real_id  = 2005

class BrowsingWrongAccess(Error):
    real_id  = 2006

class BrowsingUnknownToken(Error):
    real_id  = 2007

class BrowsingAlreadyExists(Error):
    real_id  = 2008

class BrowsingWrongPassword(Error):
    real_id  = 2009

class ShareNotFound(Error):
    real_id  = 2010

class ShareNameException(Error):
    real_id  = 2011

class ShareNameAlreadyExists(Error):
    real_id  = 2012

class ShareForbidenName(Error):
    real_id  = 2013

class UserNotFound(Error):
    real_id  = 2020

class UserNameException(Error):
    real_id  = 2021

class UserNameAlreadyExists(Error):
    real_id  = 2022

class UserForbidenName(Error):
    real_id  = 2023

class WrongInputId(Error):
    real_id  = 2024

class DomainError(Error):
    real_id  = 2025

class GroupNotFound(Error):
    real_id  = 2030

class GroupNameException(Error):
    real_id  = 2031

class VolumeNotFound(Error):
    real_id  = 2032

class QuotaNotFound(Error):
    real_id  = 2033

class GroupForbiddenName(Error):
    real_id  = 2034

class PrinterNotFound(Error):
    real_id  = 2050

class HostNotFound(Error):
    real_id  = 2100

class ServiceNotFound(Error):
    real_id  = 2101

class PortAlreadyInUse(Error):
    real_id  = 2102

class RemoteBackupActivationUserAlreadyExists(Error):
    real_id  = 2132

class NetBackupNotActive(Error):
    real_id  = 2133

class NetBackupAlreadyActive(Error):
    real_id  = 2134

class NetBackupAlreadyCreated(Error):
    real_id  = 2135

class NetBackupNotCreated(Error):
    real_id  = 2136

class UpsDeviceNotFound(Error):
    real_id  = 2150

class BwAlreadyExists(Error):
    real_id  = 3001

class BwDoesNotExists(Error):
    real_id  = 3002

class NetworkGenericError(Error):
    real_id  = 4000

class BackendGenericError(Error):
    real_id  = 4001

class InterfaceDeleteForbidden(Error):
    real_id  = 4002

class IDNotFound(Error):
    real_id  = 4003

class InvalidHostname(Error):
    real_id  = 4004

class InvalidWorkgroup(Error):
    real_id  = 4005

class InvalidProxyConfig(Error):
    real_id  = 4006

class InvalidBondingMode(Error):
    real_id  = 4007

class InvalidIPMode(Error):
    real_id  = 4008

class InvalidIPAddress(Error):
    real_id  = 4009

class InvalidMonitorInterval(Error):
    real_id  = 4010

class InterfaceNotMaster(Error):
    real_id  = 4011

class BondingNotEnoughSlaves(Error):
    real_id  = 4012

class BondingPrimaryNotSlave(Error):
    real_id  = 4013

class InterfaceConfigIncomplete(Error):
    real_id  = 4014

class ReadOnlyAttribute(Error):
    real_id  = 4015

class HostnameLocked(Error):
    real_id  = 4016

class FriendlyNameAlreadyUsed(Error):
    real_id  = 4017

class BondingInterfaceNotFound(Error):
    real_id  = 4018

class InterfaceSlaveAlreadyUsed(Error):
    real_id  = 4019

class CannotDisableAllInterfaces(Error):
    real_id  = 4020

class InterfaceSlaveMissing(Error):
    real_id  = 4021

class CannotDisablePrimaryInterface(Error):
    real_id  = 4022

class ServiceByNicNotFound(Error):
    real_id  = 4030

class PortMappingNotFound(Error):
    real_id  = 4501

class IscsiTargetNotFound(Error):
    real_id  = 5001

class IscsiTargetCreationFailed(Error):
    real_id  = 5002

class IscsiTargetTotalCountExceeded(Error):
    real_id  = 5003

class IscsiTargetInvalidLunCount(Error):
    real_id  = 5004

class IscsiLunNotFound(Error):
    real_id  = 5051

class IscsiLunCreationFailed(Error):
    real_id  = 5052

class IscsiLunVolumeCountExceeded(Error):
    real_id  = 5053

class IscsiLunFileNotEnoughSpace(Error):
    real_id  = 5054

class IscsiLunFileExportFailed(Error):
    real_id  = 5055

class IscsiLunFileOpNotCanceled(Error):
    real_id  = 5056

class IscsiLunFileEmpty(Error):
    real_id  = 5057

class ISCSILunFileOpInProgress(Error):
    real_id  = 5058

class IscsiIqnInvalidFormat(Error):
    real_id  = 5071

class IscsiDuplicateIqnError(Error):
    real_id  = 5072

class IscsiLunUnknownKind(Error):
    real_id  = 5101

class IscsiLunInvalidKind(Error):
    real_id  = 5102

class UnknownDevice(Error):
    real_id  = 5501

class no_slots(Error):
    real_id  = 5502

class no_free_space(Error):
    real_id  = 5503

class slots_not_new(Error):
    real_id  = 5504

class slots_already_used(Error):
    real_id  = 5505

class not_enough_slots(Error):
    real_id  = 5506

class partitionning_error(Error):
    real_id  = 5507

class raid_not_available(Error):
    real_id  = 5510

class no_encryption_password(Error):
    real_id  = 5520

class RaidBadPassword(Error):
    real_id  = 5521

class RaidBadMountpoint(Error):
    real_id  = 5522

class RaidWriteError(Error):
    real_id  = 5523

class RaidInvalidChar(Error):
    real_id  = 5524

class RaidWaitUnlockError(Error):
    real_id  = 5525

class UnknownPool(Error):
    real_id  = 5540

class UnknownSlot(Error):
    real_id  = 5541

class BtsyncShareCreationFailed(Error):
    real_id  = 6001

class BtsyncShareDeletionFailed(Error):
    real_id  = 6002

class BtsyncShareNotFound(Error):
    real_id  = 6003

class BtsyncGenSecretFailed(Error):
    real_id  = 6004

class AppStoreGenericError(Error):
    real_id  = 6510

class AppStoreConnectionError(Error):
    real_id  = 6511

class AppStoreMissingDependenciesError(Error):
    real_id  = 6512

class AppStoreAppNotFoundError(Error):
    real_id  = 6513

class AppStoreUpdateConflictingError(Error):
    real_id  = 6514

class AppStoreDownloadError(Error):
    real_id  = 6515

class AppStoreAppIsBrokenError(Error):
    real_id  = 6516

class AppStoreRainbowGenericError(Error):
    real_id  = 6517

class AppStorePortConflict1Error(Error):
    real_id  = 6518

class AppStorePortConflict2Error(Error):
    real_id  = 6519

class AppStorePortConflict3Error(Error):
    real_id  = 6520

class AppStorePortConflictsError(Error):
    real_id  = 6521

class AppStoreMissingDependenciesDetailedError(Error):
    real_id  = 6530

class AppStorePackageVerificationError(Error):
    real_id  = 6531

class AppStorePackageIntegrityError(Error):
    real_id  = 6532

class AppStoreRunningScriptError(Error):
    real_id  = 6533

class AppStoreWrongOsMinimalVersionError(Error):
    real_id  = 6534

class AppStoreWrongOsMaximalVersionError(Error):
    real_id  = 6535

class AppStoreWrongOsVersionError(Error):
    real_id  = 6536

class AppStoreProductCompatibilityError(Error):
    real_id  = 6537

class AppStoreProductArchitectureCompatibilityError(Error):
    real_id  = 6538

class SettingsFileReadError(Error):
    real_id  = 7001

class SettingsFileNoLongerExists(Error):
    real_id  = 7002

class SettingsFileUploadInProgress(Error):
    real_id  = 7003

class SettingsVolumeMappingError(Error):
    real_id  = 7004

class SettingsFileVersionError(Error):
    real_id  = 7005

class SettingsChecksumError(Error):
    real_id  = 7006
error_table[2050] = PrinterNotFound
error_table[4011] = InterfaceNotMaster
error_table[2150] = UpsDeviceNotFound
error_table[4501] = PortMappingNotFound
error_table[2135] = NetBackupAlreadyCreated
error_table[5506] = not_enough_slots
error_table[4013] = BondingPrimaryNotSlave
error_table[5507] = partitionning_error
error_table[5510] = raid_not_available
error_table[4018] = BondingInterfaceNotFound
error_table[4019] = InterfaceSlaveAlreadyUsed
error_table[2100] = HostNotFound
error_table[2101] = ServiceNotFound
error_table[2102] = PortAlreadyInUse
error_table[5001] = IscsiTargetNotFound
error_table[5002] = IscsiTargetCreationFailed
error_table[1001] = InvalidRequestConfig
error_table[2132] = RemoteBackupActivationUserAlreadyExists
error_table[2133] = NetBackupNotActive
error_table[2134] = NetBackupAlreadyActive
error_table[105] = ElapsedToken
error_table[2136] = NetBackupNotCreated
error_table[7001] = SettingsFileReadError
error_table[7002] = SettingsFileNoLongerExists
error_table[7003] = SettingsFileUploadInProgress
error_table[7004] = SettingsVolumeMappingError
error_table[7005] = SettingsFileVersionError
error_table[7006] = SettingsChecksumError
error_table[100] = AuthenticationError
error_table[101] = TimeIsSkewedError
error_table[102] = WrongCredentialsError
error_table[103] = NotEnoughRights
error_table[104] = UnknownToken
error_table[6516] = AppStoreAppIsBrokenError
error_table[6510] = AppStoreGenericError
error_table[6511] = AppStoreConnectionError
error_table[6512] = AppStoreMissingDependenciesError
error_table[6001] = BtsyncShareCreationFailed
error_table[6002] = BtsyncShareDeletionFailed
error_table[6003] = BtsyncShareNotFound
error_table[6004] = BtsyncGenSecretFailed
error_table[6517] = AppStoreRainbowGenericError
error_table[6518] = AppStorePortConflict1Error
error_table[6519] = AppStorePortConflict2Error
error_table[120] = TooManyTokens
error_table[6521] = AppStorePortConflictsError
error_table[5501] = UnknownDevice
error_table[5502] = no_slots
error_table[5503] = no_free_space
error_table[5504] = slots_not_new
error_table[5505] = slots_already_used
error_table[6530] = AppStoreMissingDependenciesDetailedError
error_table[6531] = AppStorePackageVerificationError
error_table[6532] = AppStorePackageIntegrityError
error_table[6533] = AppStoreRunningScriptError
error_table[6534] = AppStoreWrongOsMinimalVersionError
error_table[6535] = AppStoreWrongOsMaximalVersionError
error_table[6536] = AppStoreWrongOsVersionError
error_table[6537] = AppStoreProductCompatibilityError
error_table[6538] = AppStoreProductArchitectureCompatibilityError
error_table[5003] = IscsiTargetTotalCountExceeded
error_table[5004] = IscsiTargetInvalidLunCount
error_table[5520] = no_encryption_password
error_table[5521] = RaidBadPassword
error_table[5522] = RaidBadMountpoint
error_table[5523] = RaidWriteError
error_table[5524] = RaidInvalidChar
error_table[5525] = RaidWaitUnlockError
error_table[4000] = NetworkGenericError
error_table[4001] = BackendGenericError
error_table[4002] = InterfaceDeleteForbidden
error_table[4003] = IDNotFound
error_table[5540] = UnknownPool
error_table[5541] = UnknownSlot
error_table[4006] = InvalidProxyConfig
error_table[6513] = AppStoreAppNotFoundError
error_table[4008] = InvalidIPMode
error_table[4009] = InvalidIPAddress
error_table[4010] = InvalidMonitorInterval
error_table[4004] = InvalidHostname
error_table[4012] = BondingNotEnoughSlaves
error_table[6514] = AppStoreUpdateConflictingError
error_table[4014] = InterfaceConfigIncomplete
error_table[4015] = ReadOnlyAttribute
error_table[4016] = HostnameLocked
error_table[4017] = FriendlyNameAlreadyUsed
error_table[5102] = IscsiLunInvalidKind
error_table[6515] = AppStoreDownloadError
error_table[4020] = CannotDisableAllInterfaces
error_table[4021] = InterfaceSlaveMissing
error_table[4022] = CannotDisablePrimaryInterface
error_table[3001] = BwAlreadyExists
error_table[3002] = BwDoesNotExists
error_table[5051] = IscsiLunNotFound
error_table[5052] = IscsiLunCreationFailed
error_table[5053] = IscsiLunVolumeCountExceeded
error_table[5054] = IscsiLunFileNotEnoughSpace
error_table[5055] = IscsiLunFileExportFailed
error_table[5056] = IscsiLunFileOpNotCanceled
error_table[5057] = IscsiLunFileEmpty
error_table[5058] = ISCSILunFileOpInProgress
error_table[4030] = ServiceByNicNotFound
error_table[201] = MissingProperty
error_table[202] = BadPropertyType
error_table[203] = MalformedBody
error_table[204] = WrongFunctionPrototype
error_table[205] = UnexpectedProperty
error_table[5071] = IscsiIqnInvalidFormat
error_table[5072] = IscsiDuplicateIqnError
error_table[2001] = QuotaNotAllowed
error_table[211] = WrongValue
error_table[212] = UnknownResource
error_table[2005] = BrowsingInvalidPath
error_table[2006] = BrowsingWrongAccess
error_table[2007] = BrowsingUnknownToken
error_table[2008] = BrowsingAlreadyExists
error_table[2009] = BrowsingWrongPassword
error_table[2010] = ShareNotFound
error_table[2011] = ShareNameException
error_table[2012] = ShareNameAlreadyExists
error_table[2013] = ShareForbidenName
error_table[222] = NtpServerError
error_table[4005] = InvalidWorkgroup
error_table[6520] = AppStorePortConflict3Error
error_table[2020] = UserNotFound
error_table[2021] = UserNameException
error_table[2022] = UserNameAlreadyExists
error_table[2023] = UserForbidenName
error_table[2024] = WrongInputId
error_table[2025] = DomainError
error_table[4007] = InvalidBondingMode
error_table[5101] = IscsiLunUnknownKind
error_table[2030] = GroupNotFound
error_table[2031] = GroupNameException
error_table[2032] = VolumeNotFound
error_table[2033] = QuotaNotFound
error_table[2034] = GroupForbiddenName
error_table[501] = WelcomeAlreadyDone
error_table[502] = WelcomeUserCreationFailed
error_table[503] = WelcomeShareCreationFailed
error_table[504] = WelcomeUserNotFound
