#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Jun 18 2013 14:14:51
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v3.sv0.auto_update import UpdateStatusCode
from unicorn_api.v3.sv0.auto_update import UpdateErrorCode


class AutoUpdateStatusInstantiator(Instantiator):
    version = 3
    sub_version = 0
    attributes = {
        'download_progress': int,
        'last_update_check': unicode,
        'update_available': bool,
        'update_branches': unicode,
        'update_error_code': UpdateErrorCode,
        'update_size': int,
        'update_status': UpdateStatusCode,
        'xml_build_revision': unicode,
        'xml_misc_info': unicode,
        'xml_product_name': unicode,
        'xml_product_version': unicode,
        'xml_release_date': unicode,
    }
    w_attributes = []
    r_attributes = ["download_progress", "last_update_check", "update_available", "update_branches", "update_error_code", "update_size", "update_status", "xml_build_revision", "xml_misc_info", "xml_product_name", "xml_product_version", "xml_release_date"]
    h_attributes = []
    op_values = {}

    @classmethod
    def name(cls):
        return u'AutoUpdateStatus'

    @classmethod
    def new_object(cls):
        return AutoUpdateStatus()


class AutoUpdateStatus(ClientObject):

    def getdownload_progress(self):
        return self.download_progress

    def getlast_update_check(self):
        return self.last_update_check

    def getupdate_available(self):
        return self.update_available

    def getupdate_branches(self):
        return self.update_branches

    def getupdate_error_code(self):
        return self.update_error_code

    def getupdate_size(self):
        return self.update_size

    def getupdate_status(self):
        return self.update_status

    def getxml_build_revision(self):
        return self.xml_build_revision

    def getxml_misc_info(self):
        return self.xml_misc_info

    def getxml_product_name(self):
        return self.xml_product_name

    def getxml_product_version(self):
        return self.xml_product_version

    def getxml_release_date(self):
        return self.xml_release_date
    __instantiator__ = AutoUpdateStatusInstantiator
register_instantiator('unicorn_api', AutoUpdateStatusInstantiator, True)
