#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Jun 18 2013 14:14:51
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v3.sv0.multi_nic import BondingMode

from transformer.lib import IP


class BondingInstantiator(Instantiator):
    version = 3
    sub_version = 0
    attributes = {
        'active_slave_id': int,
        'arp_ip_target': Optional(IP),
        'mode': BondingMode,
        'monitor_interval': Optional(int),
        'primary_id': int,
    }
    w_attributes = ["arp_ip_target", "mode", "monitor_interval", "primary_id"]
    r_attributes = ["active_slave_id", "arp_ip_target", "mode", "monitor_interval", "primary_id"]
    h_attributes = []
    op_values = {'arp_ip_target': None, 'monitor_interval': 0}

    @classmethod
    def name(cls):
        return u'Bonding'

    @classmethod
    def new_object(cls):
        return Bonding()


class Bonding(ClientObject):

    def setarp_ip_target(self, value):
        self.arp_ip_target = value

    def setmode(self, value):
        self.mode = value

    def setmonitor_interval(self, value):
        self.monitor_interval = value

    def setprimary_id(self, value):
        self.primary_id = value

    def getactive_slave_id(self):
        return self.active_slave_id

    def getarp_ip_target(self):
        return self.arp_ip_target

    def getmode(self):
        return self.mode

    def getmonitor_interval(self):
        return self.monitor_interval

    def getprimary_id(self):
        return self.primary_id
    __instantiator__ = BondingInstantiator
register_instantiator('unicorn_api', BondingInstantiator, True)
