#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Jun 18 2013 14:14:51
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject

from transformer.lib import IP


class PortMappingInstantiator(Instantiator):
    version = 3
    sub_version = 0
    attributes = {
        'enabled': bool,
        'external_addr': IP,
        'external_port': int,
        'id': int,
        'internal_addr': IP,
        'internal_port': int,
        'is_working': bool,
        'protocol': unicode,
        'service_name': unicode,
    }
    w_attributes = ["enabled"]
    r_attributes = ["enabled", "external_addr", "external_port", "id", "internal_addr", "internal_port", "is_working", "protocol", "service_name"]
    h_attributes = []
    op_values = {}

    @classmethod
    def name(cls):
        return u'PortMapping'

    @classmethod
    def new_object(cls):
        return PortMapping()


class PortMapping(ClientObject):

    def setenabled(self, value):
        self.enabled = value

    def getenabled(self):
        return self.enabled

    def getexternal_addr(self):
        return self.external_addr

    def getexternal_port(self):
        return self.external_port

    def getid(self):
        return self.id

    def getinternal_addr(self):
        return self.internal_addr

    def getinternal_port(self):
        return self.internal_port

    def getis_working(self):
        return self.is_working

    def getprotocol(self):
        return self.protocol

    def getservice_name(self):
        return self.service_name
    __instantiator__ = PortMappingInstantiator
register_instantiator('unicorn_api', PortMappingInstantiator, True)
