#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Jun 18 2013 14:14:51
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v3.sv0.raid import MigrationStatus
from unicorn_api.v3.sv0.raid.LevelInfo import LevelInfo


class MigrationStatusInfoInstantiator(Instantiator):
    version = 3
    sub_version = 0
    attributes = {
        'level_info': LevelInfo,
        'nb_devices': int,
        'status': MigrationStatus,
    }
    w_attributes = ["level_info", "nb_devices", "status"]
    r_attributes = ["level_info", "nb_devices", "status"]
    h_attributes = []
    op_values = {}

    @classmethod
    def name(cls):
        return u'MigrationStatusInfo'

    @classmethod
    def new_object(cls):
        return MigrationStatusInfo()


class MigrationStatusInfo(ClientObject):

    def setlevel_info(self, value):
        self.level_info = value

    def setnb_devices(self, value):
        self.nb_devices = value

    def setstatus(self, value):
        self.status = value

    def getlevel_info(self):
        return self.level_info

    def getnb_devices(self):
        return self.nb_devices

    def getstatus(self):
        return self.status
    __instantiator__ = MigrationStatusInfoInstantiator
register_instantiator('unicorn_api', MigrationStatusInfoInstantiator, True)
