#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Jun 18 2013 14:14:51
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v3.sv0.raid.Slice import Slice
from unicorn_api.v3.sv0.raid import RaidState
from unicorn_api.v3.sv0.raid.LevelInfo import LevelInfo

from transformer.lib import Long, List, Double, Time


class PoolInstantiator(Instantiator):
    version = 3
    sub_version = 0
    attributes = {
        'busy_progress': int,
        'expansion_size': Long,
        'is_busy': bool,
        'is_resizing': bool,
        'level_info': LevelInfo,
        'name': unicode,
        'nb_slices': int,
        'nb_slots': int,
        'nb_volumes': int,
        'redundancy_size': Long,
        'size': Long,
        'slices': List(Slice),
        'slots': List(int),
        'state': RaidState,
        'sync_progress': Double,
        'sync_time': Time,
    }
    w_attributes = ["busy_progress", "is_busy", "is_resizing", "level_info", "slices", "slots"]
    r_attributes = ["busy_progress", "expansion_size", "is_busy", "is_resizing", "level_info", "name", "nb_slices", "nb_slots", "nb_volumes", "redundancy_size", "size", "slices", "slots", "state", "sync_progress", "sync_time"]
    h_attributes = ["nb_slices", "slices"]
    op_values = {}

    @classmethod
    def name(cls):
        return u'Pool'

    @classmethod
    def new_object(cls):
        return Pool()


class Pool(ClientObject):

    def setbusy_progress(self, value):
        self.busy_progress = value

    def setis_busy(self, value):
        self.is_busy = value

    def setis_resizing(self, value):
        self.is_resizing = value

    def setlevel_info(self, value):
        self.level_info = value

    def setslices(self, value):
        self.slices = value

    def setslots(self, value):
        self.slots = value

    def getbusy_progress(self):
        return self.busy_progress

    def getexpansion_size(self):
        return self.expansion_size

    def getis_busy(self):
        return self.is_busy

    def getis_resizing(self):
        return self.is_resizing

    def getlevel_info(self):
        return self.level_info

    def getname(self):
        return self.name

    def getnb_slices(self):
        return self.nb_slices

    def getnb_slots(self):
        return self.nb_slots

    def getnb_volumes(self):
        return self.nb_volumes

    def getredundancy_size(self):
        return self.redundancy_size

    def getsize(self):
        return self.size

    def getslices(self):
        return self.slices

    def getslots(self):
        return self.slots

    def getstate(self):
        return self.state

    def getsync_progress(self):
        return self.sync_progress

    def getsync_time(self):
        return self.sync_time
    __instantiator__ = PoolInstantiator
register_instantiator('unicorn_api', PoolInstantiator, True)
