#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Jun 18 2013 14:14:51
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

from transformer.lib import Optional
from unicorn_api.v3.sv0.raid.Pool import Pool
from unicorn_api.v3.sv0.raid import RaidMode
from unicorn_api.v3.sv0.raid import RaidLevel
from unicorn_api.v3.sv0.raid import RedundancyLevel
from unicorn_api.v3.sv0.raid.Slot import Slot
from unicorn_api.v3.sv0.raid.RaidLevelInfo import RaidLevelInfo
from unicorn_api.v3.sv0.raid.LevelInfo import LevelInfo
from unicorn_api.v3.sv0.raid.MigrationStatusInfo import MigrationStatusInfo
from unicorn_api.v3.sv0.raid.AnyRaidSizeInfo import AnyRaidSizeInfo

from transformer.lib import List

from transformer.client_transport import ClientTransport
from transformer.client_serializer import ClientSerializer


class RaidManagement(object):


    def add_slots(self, pool_name, slot_indexes, __client__=None):
        params = dict()
        params['pool_name'] = pool_name
        params['slot_indexes'] = slot_indexes
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/3.0/raid.Management.add_slots"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return 

    def add_slots_async(self, pool_name, slot_indexes, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['pool_name'] = pool_name
        params['slot_indexes'] = slot_indexes
        url = "api/external/3.0/raid.Management.add_slots"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def add_spares(self, pool_name, slots_indexes, __client__=None):
        params = dict()
        params['pool_name'] = pool_name
        params['slots_indexes'] = slots_indexes
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/3.0/raid.Management.add_spares"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return 

    def add_spares_async(self, pool_name, slots_indexes, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['pool_name'] = pool_name
        params['slots_indexes'] = slots_indexes
        url = "api/external/3.0/raid.Management.add_spares"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def can_add_spares(self, pool_name, slots_list, __client__=None):
        params = dict()
        params['pool_name'] = pool_name
        params['slots_list'] = slots_list
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/3.0/raid.Management.can_add_spares"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['nb_spares']

    def can_add_spares_async(self, pool_name, slots_list, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['pool_name'] = pool_name
        params['slots_list'] = slots_list
        url = "api/external/3.0/raid.Management.can_add_spares"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def can_change_mode(self, pool_name, __client__=None):
        params = dict()
        params['pool_name'] = pool_name
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/3.0/raid.Management.can_change_mode"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['future_mode']

    def can_change_mode_async(self, pool_name, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['pool_name'] = pool_name
        url = "api/external/3.0/raid.Management.can_change_mode"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def can_expand(self, pool_name, __client__=None):
        params = dict()
        params['pool_name'] = pool_name
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/3.0/raid.Management.can_expand"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['status']

    def can_expand_async(self, pool_name, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['pool_name'] = pool_name
        url = "api/external/3.0/raid.Management.can_expand"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def change_mode(self, pool_name, future_mode, __client__=None):
        params = dict()
        params['pool_name'] = pool_name
        params['future_mode'] = future_mode
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/3.0/raid.Management.change_mode"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return 

    def change_mode_async(self, pool_name, future_mode, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['pool_name'] = pool_name
        params['future_mode'] = future_mode
        url = "api/external/3.0/raid.Management.change_mode"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def clear_migration_plan(self, pool_name, __client__=None):
        params = dict()
        params['pool_name'] = pool_name
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/3.0/raid.Management.clear_migration_plan"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return 

    def clear_migration_plan_async(self, pool_name, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['pool_name'] = pool_name
        url = "api/external/3.0/raid.Management.clear_migration_plan"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def compute_raid_sizes(self, redundancy_level, slots, __client__=None):
        params = dict()
        params['redundancy_level'] = redundancy_level
        params['slots'] = slots
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/3.0/raid.Management.compute_raid_sizes"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['size_info']

    def compute_raid_sizes_async(self, redundancy_level, slots, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['redundancy_level'] = redundancy_level
        params['slots'] = slots
        url = "api/external/3.0/raid.Management.compute_raid_sizes"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def create_pool(self, name, list_of_slots, raid_mode, raid_level, redundancy_level, __client__=None):
        """
        raid_level: only used when raid_mode == RaidMode.MANUAL
        redundancy_level: only used when raid_mode ==RaidMode.OPTIMUM
        redundancy_level: else set to RedundancyLevel.UNKNOWN
        """
        params = dict()
        params['name'] = name
        params['list_of_slots'] = list_of_slots
        params['raid_mode'] = raid_mode
        params['raid_level'] = raid_level
        params['redundancy_level'] = redundancy_level
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/3.0/raid.Management.create_pool"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return 

    def create_pool_async(self, name, list_of_slots, raid_mode, raid_level, redundancy_level, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['name'] = name
        params['list_of_slots'] = list_of_slots
        params['raid_mode'] = raid_mode
        params['raid_level'] = raid_level
        params['redundancy_level'] = redundancy_level
        url = "api/external/3.0/raid.Management.create_pool"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def destroy_pool(self, pool_name, __client__=None):
        params = dict()
        params['pool_name'] = pool_name
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/3.0/raid.Management.destroy_pool"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return 

    def destroy_pool_async(self, pool_name, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['pool_name'] = pool_name
        url = "api/external/3.0/raid.Management.destroy_pool"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def expand(self, pool_name, __client__=None):
        params = dict()
        params['pool_name'] = pool_name
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/3.0/raid.Management.expand"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return 

    def expand_async(self, pool_name, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['pool_name'] = pool_name
        url = "api/external/3.0/raid.Management.expand"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def get_migration_plan(self, pool_name, __client__=None):
        params = dict()
        params['pool_name'] = pool_name
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/3.0/raid.Management.get_migration_plan"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['migration_plan']

    def get_migration_plan_async(self, pool_name, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['pool_name'] = pool_name
        url = "api/external/3.0/raid.Management.get_migration_plan"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def get_pool_property(self, pool_name, __client__=None):
        params = dict()
        params['pool_name'] = pool_name
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/3.0/raid.Management.get_pool_property"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['pool']

    def get_pool_property_async(self, pool_name, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['pool_name'] = pool_name
        url = "api/external/3.0/raid.Management.get_pool_property"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def get_slot_property(self, slot_id, __client__=None):
        params = dict()
        params['slot_id'] = slot_id
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/3.0/raid.Management.get_slot_property"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['slot']

    def get_slot_property_async(self, slot_id, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['slot_id'] = slot_id
        url = "api/external/3.0/raid.Management.get_slot_property"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def is_small_drive(self, index, pool_name, __client__=None):
        params = dict()
        params['index'] = index
        params['pool_name'] = pool_name
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/3.0/raid.Management.is_small_drive"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['status']

    def is_small_drive_async(self, index, pool_name, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['index'] = index
        params['pool_name'] = pool_name
        url = "api/external/3.0/raid.Management.is_small_drive"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def list_migrations(self, pool_name, slots, __client__=None):
        params = dict()
        params['pool_name'] = pool_name
        params['slots'] = slots
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/3.0/raid.Management.list_migrations"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['raid_migrations']

    def list_migrations_async(self, pool_name, slots, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['pool_name'] = pool_name
        params['slots'] = slots
        url = "api/external/3.0/raid.Management.list_migrations"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def list_pools(self, with_parameters, __client__=None):
        params = dict()
        params['with_parameters'] = with_parameters
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/3.0/raid.Management.list_pools"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['pools']

    def list_pools_async(self, with_parameters, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['with_parameters'] = with_parameters
        url = "api/external/3.0/raid.Management.list_pools"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def list_raid_levels(self, slots, __client__=None):
        params = dict()
        params['slots'] = slots
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/3.0/raid.Management.list_raid_levels"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['raid_levels']

    def list_raid_levels_async(self, slots, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['slots'] = slots
        url = "api/external/3.0/raid.Management.list_raid_levels"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def list_slots(self, __client__=None):
        params = dict()

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/3.0/raid.Management.list_slots"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['list_slots']

    def list_slots_async(self, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()

        url = "api/external/3.0/raid.Management.list_slots"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def list_subsitute_slots(self, pool_name, __client__=None):
        params = dict()
        params['pool_name'] = pool_name
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/3.0/raid.Management.list_subsitute_slots"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['slots_id']

    def list_subsitute_slots_async(self, pool_name, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['pool_name'] = pool_name
        url = "api/external/3.0/raid.Management.list_subsitute_slots"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def migrate_pool(self, pool_name, slots, raid_level, __client__=None):
        params = dict()
        params['pool_name'] = pool_name
        params['slots'] = slots
        params['raid_level'] = raid_level
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/3.0/raid.Management.migrate_pool"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return 

    def migrate_pool_async(self, pool_name, slots, raid_level, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['pool_name'] = pool_name
        params['slots'] = slots
        params['raid_level'] = raid_level
        url = "api/external/3.0/raid.Management.migrate_pool"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def replace_slot(self, pool_name, index, __client__=None):
        params = dict()
        params['pool_name'] = pool_name
        params['index'] = index
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/3.0/raid.Management.replace_slot"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return 

    def replace_slot_async(self, pool_name, index, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['pool_name'] = pool_name
        params['index'] = index
        url = "api/external/3.0/raid.Management.replace_slot"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')
