#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Jun 18 2013 14:14:51
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v3.sv0.raid.RaidElement import RaidElement
from unicorn_api.v3.sv0.raid import RaidElementState
from unicorn_api.v3.sv0.raid import RaidLevel

from transformer.lib import List, Long, Time


class SliceInstantiator(Instantiator):
    version = 3
    sub_version = 0
    attributes = {
        'device': unicode,
        'elements': List(RaidElement),
        'id': int,
        'level': RaidLevel,
        'name': unicode,
        'size': Long,
        'status': RaidElementState,
        'sync_progress': int,
        'sync_time': Time,
    }
    w_attributes = ["elements", "id", "level", "size", "status", "sync_progress", "sync_time"]
    r_attributes = ["device", "elements", "id", "level", "name", "size", "status", "sync_progress", "sync_time"]
    h_attributes = []
    op_values = {}

    @classmethod
    def name(cls):
        return u'Slice'

    @classmethod
    def new_object(cls):
        return Slice()


class Slice(ClientObject):

    def setelements(self, value):
        self.elements = value

    def setid(self, value):
        self.id = value

    def setlevel(self, value):
        self.level = value

    def setsize(self, value):
        self.size = value

    def setstatus(self, value):
        self.status = value

    def setsync_progress(self, value):
        self.sync_progress = value

    def setsync_time(self, value):
        self.sync_time = value

    def getdevice(self):
        return self.device

    def getelements(self):
        return self.elements

    def getid(self):
        return self.id

    def getlevel(self):
        return self.level

    def getname(self):
        return self.name

    def getsize(self):
        return self.size

    def getstatus(self):
        return self.status

    def getsync_progress(self):
        return self.sync_progress

    def getsync_time(self):
        return self.sync_time
    __instantiator__ = SliceInstantiator
register_instantiator('unicorn_api', SliceInstantiator, True)
