#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Jun 18 2013 14:14:51
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v3.sv0.raid.RaidElement import RaidElement
from unicorn_api.v3.sv0.raid import RaidElementState

from transformer.lib import Dict, List, Long


class SlotInstantiator(Instantiator):
    version = 3
    sub_version = 0
    attributes = {
        'elements': List(RaidElement),
        'id': int,
        'name': unicode,
        'properties': Dict(bool),
        'size': Long,
        'slot_number': int,
        'state': RaidElementState,
        'usable_size': Long,
    }
    w_attributes = ["elements", "properties", "size", "state", "usable_size"]
    r_attributes = ["elements", "id", "name", "properties", "size", "slot_number", "state", "usable_size"]
    h_attributes = []
    op_values = {}

    @classmethod
    def name(cls):
        return u'Slot'

    @classmethod
    def new_object(cls):
        return Slot()


class Slot(ClientObject):

    def setelements(self, value):
        self.elements = value

    def setproperties(self, value):
        self.properties = value

    def setsize(self, value):
        self.size = value

    def setstate(self, value):
        self.state = value

    def setusable_size(self, value):
        self.usable_size = value

    def getelements(self):
        return self.elements

    def getid(self):
        return self.id

    def getname(self):
        return self.name

    def getproperties(self):
        return self.properties

    def getsize(self):
        return self.size

    def getslot_number(self):
        return self.slot_number

    def getstate(self):
        return self.state

    def getusable_size(self):
        return self.usable_size
    __instantiator__ = SlotInstantiator
register_instantiator('unicorn_api', SlotInstantiator, True)
