#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Jun 18 2013 14:14:51
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

from transformer.lib import Optional

from transformer.client_transport import ClientTransport
from transformer.client_serializer import ClientSerializer


class ItunesServiceAdministration(object):


    def force_rescan(self, __client__=None):
        params = dict()

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/3.0/services.itunes.ItunesAdministration.force_rescan"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return 

    def force_rescan_async(self, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()

        url = "api/external/3.0/services.itunes.ItunesAdministration.force_rescan"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')
