#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Jun 18 2013 14:14:51
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v3.sv0.quotas.Quota import Quota
from unicorn_api.v3.sv0.sharing import Access


class ShareInstantiator(Instantiator):
    version = 3
    sub_version = 0
    attributes = {
        'comment': unicode,
        'enabled': bool,
        'external': bool,
        'id': int,
        'name': unicode,
        'nb_groups': int,
        'nb_users': int,
        'public_access': Optional(Access),
        'quota': Optional(Quota),
        'volume_id': Optional(int),
    }
    w_attributes = ["comment", "name", "public_access", "quota", "volume_id"]
    r_attributes = ["comment", "enabled", "external", "id", "name", "nb_groups", "nb_users", "public_access", "quota", "volume_id"]
    h_attributes = ["nb_groups", "nb_users"]
    op_values = {'public_access': None, 'quota': None, 'volume_id': None}

    @classmethod
    def name(cls):
        return u'Share'

    @classmethod
    def new_object(cls):
        return Share()


class Share(ClientObject):

    def setcomment(self, value):
        self.comment = value

    def setname(self, value):
        self.name = value

    def setpublic_access(self, value):
        self.public_access = value

    def setquota(self, value):
        self.quota = value

    def setvolume_id(self, value):
        self.volume_id = value

    def getcomment(self):
        return self.comment

    def getenabled(self):
        return self.enabled

    def getexternal(self):
        return self.external

    def getid(self):
        return self.id

    def getname(self):
        return self.name

    def getnb_groups(self):
        return self.nb_groups

    def getnb_users(self):
        return self.nb_users

    def getpublic_access(self):
        return self.public_access

    def getquota(self):
        return self.quota

    def getvolume_id(self):
        return self.volume_id
    __instantiator__ = ShareInstantiator
register_instantiator('unicorn_api', ShareInstantiator, True)
