#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Jun 18 2013 14:14:51
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v3.sv0.user_group_share import UserType


class GroupInstantiator(Instantiator):
    version = 3
    sub_version = 0
    attributes = {
        'comment': Optional(unicode),
        'domain_name': unicode,
        'enabled': bool,
        'id': int,
        'name': unicode,
        'shares_count': int,
        'sid': Optional(unicode),
        'type': UserType,
        'users_count': int,
    }
    w_attributes = ["comment", "name", "sid", "type"]
    r_attributes = ["comment", "domain_name", "enabled", "id", "name", "shares_count", "sid", "type", "users_count"]
    h_attributes = ["shares_count", "users_count"]
    op_values = {'comment': u"", 'sid': u""}

    @classmethod
    def name(cls):
        return u'Group'

    @classmethod
    def new_object(cls):
        return Group()


class Group(ClientObject):

    def setcomment(self, value):
        self.comment = value

    def setname(self, value):
        self.name = value

    def setsid(self, value):
        self.sid = value

    def settype(self, value):
        self.type = value

    def getcomment(self):
        return self.comment

    def getdomain_name(self):
        return self.domain_name

    def getenabled(self):
        return self.enabled

    def getid(self):
        return self.id

    def getname(self):
        return self.name

    def getshares_count(self):
        return self.shares_count

    def getsid(self):
        return self.sid

    def gettype(self):
        return self.type

    def getusers_count(self):
        return self.users_count
    __instantiator__ = GroupInstantiator
register_instantiator('unicorn_api', GroupInstantiator, True)
