#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Jun 18 2013 14:14:51
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v3.sv0.sharing import Access


class ShareGroupAccessInstantiator(Instantiator):
    version = 3
    sub_version = 0
    attributes = {
        'access': Access,
        'group_id': int,
        'group_name': unicode,
        'share_id': int,
        'share_name': unicode,
    }
    w_attributes = ["access", "group_id", "share_id"]
    r_attributes = ["access", "group_id", "group_name", "share_id", "share_name"]
    h_attributes = []
    op_values = {}

    @classmethod
    def name(cls):
        return u'ShareGroupAccess'

    @classmethod
    def new_object(cls):
        return ShareGroupAccess()


class ShareGroupAccess(ClientObject):

    def setaccess(self, value):
        self.access = value

    def setgroup_id(self, value):
        self.group_id = value

    def setshare_id(self, value):
        self.share_id = value

    def getaccess(self):
        return self.access

    def getgroup_id(self):
        return self.group_id

    def getgroup_name(self):
        return self.group_name

    def getshare_id(self):
        return self.share_id

    def getshare_name(self):
        return self.share_name
    __instantiator__ = ShareGroupAccessInstantiator
register_instantiator('unicorn_api', ShareGroupAccessInstantiator, True)
