#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Jun 18 2013 14:14:51
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v3.sv0.volume_quotas import QuotaKind
from unicorn_api.v3.sv0.quotas.Quota import Quota


class VolumeQuotaInstantiator(Instantiator):
    version = 3
    sub_version = 0
    attributes = {
        'generic_id': int,
        'kind': QuotaKind,
        'quota': Quota,
        'volume_id': int,
    }
    w_attributes = ["generic_id", "kind", "quota", "volume_id"]
    r_attributes = ["generic_id", "kind", "quota", "volume_id"]
    h_attributes = []
    op_values = {}

    @classmethod
    def name(cls):
        return u'VolumeQuota'

    @classmethod
    def new_object(cls):
        return VolumeQuota()


class VolumeQuota(ClientObject):

    def setgeneric_id(self, value):
        self.generic_id = value

    def setkind(self, value):
        self.kind = value

    def setquota(self, value):
        self.quota = value

    def setvolume_id(self, value):
        self.volume_id = value

    def getgeneric_id(self):
        return self.generic_id

    def getkind(self):
        return self.kind

    def getquota(self):
        return self.quota

    def getvolume_id(self):
        return self.volume_id
    __instantiator__ = VolumeQuotaInstantiator
register_instantiator('unicorn_api', VolumeQuotaInstantiator, True)
