#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Jun 18 2013 14:14:51
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject

from transformer.lib import Long


class VolumeInstantiator(Instantiator):
    version = 3
    sub_version = 0
    attributes = {
        'available': Long,
        'enabled': bool,
        'external': bool,
        'id': int,
        'is_mounted': bool,
        'is_read_only': bool,
        'label': unicode,
        'percent_usage': Long,
        'real_size': Long,
        'root_device': bool,
        'size': Long,
        'storage_uid': unicode,
        'used': Long,
    }
    w_attributes = []
    r_attributes = ["available", "enabled", "external", "id", "is_mounted", "is_read_only", "label", "percent_usage", "real_size", "root_device", "size", "storage_uid", "used"]
    h_attributes = []
    op_values = {}

    @classmethod
    def name(cls):
        return u'Volume'

    @classmethod
    def new_object(cls):
        return Volume()


class Volume(ClientObject):

    def getavailable(self):
        return self.available

    def getenabled(self):
        return self.enabled

    def getexternal(self):
        return self.external

    def getid(self):
        return self.id

    def getis_mounted(self):
        return self.is_mounted

    def getis_read_only(self):
        return self.is_read_only

    def getlabel(self):
        return self.label

    def getpercent_usage(self):
        return self.percent_usage

    def getreal_size(self):
        return self.real_size

    def getroot_device(self):
        return self.root_device

    def getsize(self):
        return self.size

    def getstorage_uid(self):
        return self.storage_uid

    def getused(self):
        return self.used
    __instantiator__ = VolumeInstantiator
register_instantiator('unicorn_api', VolumeInstantiator, True)
