#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE May 14 2014 12:22:35
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v5.sv0.app_manager import RegisteredAppStatus

from transformer.lib import List


class RegisteredAppInstantiator(Instantiator):
    version = 5
    sub_version = 0
    attributes = {
        'allowed_optional_permissions': List(unicode),
        'app_id': unicode,
        'mandatory_permissions': List(unicode),
        'name': unicode,
        'optional_permissions': List(unicode),
        'status': RegisteredAppStatus,
        'token': unicode,
    }
    w_attributes = []
    r_attributes = ["allowed_optional_permissions", "app_id", "mandatory_permissions", "name", "optional_permissions", "status", "token"]
    h_attributes = []
    op_values = {}

    @classmethod
    def name(cls):
        return u'RegisteredApp'

    @classmethod
    def new_object(cls):
        return RegisteredApp()


class RegisteredApp(ClientObject):

    def getallowed_optional_permissions(self):
        return self.allowed_optional_permissions

    def getapp_id(self):
        return self.app_id

    def getmandatory_permissions(self):
        return self.mandatory_permissions

    def getname(self):
        return self.name

    def getoptional_permissions(self):
        return self.optional_permissions

    def getstatus(self):
        return self.status

    def gettoken(self):
        return self.token
    __instantiator__ = RegisteredAppInstantiator
register_instantiator('unicorn_api', RegisteredAppInstantiator, True)
