#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE May 14 2014 12:22:35
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v5.sv0.appstore import AppPackageState
from unicorn_api.v5.sv0.appstore import ApplicationType
from unicorn_api.v5.sv0.appstore import AppState
from unicorn_api.v5.sv0.appstore import AppOperationState
from unicorn_api.v5.sv0.appstore import AppBlockingState
from unicorn_api.v5.sv0.appstore import ApplicationMode
from unicorn_api.v5.sv0.appstore import AppStartupMode

from transformer.lib import List, Dict, Long


class AppFullInfoInstantiator(Instantiator):
    version = 5
    sub_version = 0
    attributes = {
        'app_mode': ApplicationMode,
        'blocking_state': AppBlockingState,
        'categories': List(unicode),
        'changelog': unicode,
        'config_path': unicode,
        'description_long': unicode,
        'description_short': unicode,
        'disclaimer': unicode,
        'icons': Dict(unicode),
        'id': unicode,
        'name': unicode,
        'operation_state': AppOperationState,
        'package_state': AppPackageState,
        'privacy_url': unicode,
        'progress': int,
        'publication_date': unicode,
        'publisher_contact': unicode,
        'publisher_name': unicode,
        'screenshots': Dict(unicode),
        'size': Long,
        'speed': Long,
        'startup_mode': AppStartupMode,
        'state': AppState,
        'state_msg': unicode,
        'supported_languages': List(unicode),
        'type': ApplicationType,
        'version': unicode,
        'volume_id': int,
        'web_path': unicode,
        'website_url': unicode,
    }
    w_attributes = []
    r_attributes = ["app_mode", "blocking_state", "categories", "changelog", "config_path", "description_long", "description_short", "disclaimer", "icons", "id", "name", "operation_state", "package_state", "privacy_url", "progress", "publication_date", "publisher_contact", "publisher_name", "screenshots", "size", "speed", "startup_mode", "state", "state_msg", "supported_languages", "type", "version", "volume_id", "web_path", "website_url"]
    h_attributes = []
    op_values = {}

    @classmethod
    def name(cls):
        return u'AppFullInfo'

    @classmethod
    def new_object(cls):
        return AppFullInfo()


class AppFullInfo(ClientObject):

    def getapp_mode(self):
        return self.app_mode

    def getblocking_state(self):
        return self.blocking_state

    def getcategories(self):
        return self.categories

    def getchangelog(self):
        return self.changelog

    def getconfig_path(self):
        return self.config_path

    def getdescription_long(self):
        return self.description_long

    def getdescription_short(self):
        return self.description_short

    def getdisclaimer(self):
        return self.disclaimer

    def geticons(self):
        return self.icons

    def getid(self):
        return self.id

    def getname(self):
        return self.name

    def getoperation_state(self):
        return self.operation_state

    def getpackage_state(self):
        return self.package_state

    def getprivacy_url(self):
        return self.privacy_url

    def getprogress(self):
        return self.progress

    def getpublication_date(self):
        return self.publication_date

    def getpublisher_contact(self):
        return self.publisher_contact

    def getpublisher_name(self):
        return self.publisher_name

    def getscreenshots(self):
        return self.screenshots

    def getsize(self):
        return self.size

    def getspeed(self):
        return self.speed

    def getstartup_mode(self):
        return self.startup_mode

    def getstate(self):
        return self.state

    def getstate_msg(self):
        return self.state_msg

    def getsupported_languages(self):
        return self.supported_languages

    def gettype(self):
        return self.type

    def getversion(self):
        return self.version

    def getvolume_id(self):
        return self.volume_id

    def getweb_path(self):
        return self.web_path

    def getwebsite_url(self):
        return self.website_url
    __instantiator__ = AppFullInfoInstantiator
register_instantiator('unicorn_api', AppFullInfoInstantiator, True)
