#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE May 14 2014 12:22:35
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

from transformer.lib import Optional
from unicorn_api.v5.sv0.appstore.AppSimpleInfo import AppSimpleInfo
from unicorn_api.v5.sv0.appstore import AppState
from unicorn_api.v5.sv0.appstore.AppOnlineSimpleInfo import AppOnlineSimpleInfo
from unicorn_api.v5.sv0.appstore.CategoryInfo import CategoryInfo
from unicorn_api.v5.sv0.appstore.ServerStatus import ServerStatus
from unicorn_api.v5.sv0.appstore.AppAccess import AppAccess
from unicorn_api.v5.sv0.appstore.ServersStatus import ServersStatus
from unicorn_api.v5.sv0.appstore.AppFullInfo import AppFullInfo

from transformer.lib import List, ListInfo, ResultSet, Dict

from transformer.client_transport import ClientTransport
from transformer.client_serializer import ClientSerializer


class AppstoreManager(object):


    def add_apps_for_group(self, group_id, app_ids, __client__=None):
        params = dict()
        params['group_id'] = group_id
        params['app_ids'] = app_ids
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/appstore.AppstoreManager.add_apps_for_group"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['failed_apps']

    def add_apps_for_group_async(self, group_id, app_ids, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['group_id'] = group_id
        params['app_ids'] = app_ids
        url = "api/external/5.0/appstore.AppstoreManager.add_apps_for_group"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def add_groups(self, app_id, groups_id, __client__=None):
        params = dict()
        params['app_id'] = app_id
        params['groups_id'] = groups_id
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/appstore.AppstoreManager.add_groups"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['failed_groups']

    def add_groups_async(self, app_id, groups_id, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['app_id'] = app_id
        params['groups_id'] = groups_id
        url = "api/external/5.0/appstore.AppstoreManager.add_groups"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def cancel_operation(self, app_id, __client__=None):
        params = dict()
        params['app_id'] = app_id
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/appstore.AppstoreManager.cancel_operation"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return 

    def cancel_operation_async(self, app_id, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['app_id'] = app_id
        url = "api/external/5.0/appstore.AppstoreManager.cancel_operation"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def check_default_apps(self, __client__=None):
        params = dict()

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/appstore.AppstoreManager.check_default_apps"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return 

    def check_default_apps_async(self, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()

        url = "api/external/5.0/appstore.AppstoreManager.check_default_apps"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def clear_operation_errors(self, app_id, __client__=None):
        params = dict()
        params['app_id'] = app_id
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/appstore.AppstoreManager.clear_operation_errors"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return 

    def clear_operation_errors_async(self, app_id, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['app_id'] = app_id
        url = "api/external/5.0/appstore.AppstoreManager.clear_operation_errors"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def get_app_full_info(self, app_id, latest, __client__=None):
        """
        latest: The latest field will return the information lastest information about a package
        latest: If latest is set to false it will return the information of the application at install time.
        """
        params = dict()
        params['app_id'] = app_id
        params['latest'] = latest
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/appstore.AppstoreManager.get_app_full_info"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['app_info']

    def get_app_full_info_async(self, app_id, latest, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['app_id'] = app_id
        params['latest'] = latest
        url = "api/external/5.0/appstore.AppstoreManager.get_app_full_info"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def get_icons(self, app_id, latest, __client__=None):
        """
        icons will contain a default key
        """
        params = dict()
        params['app_id'] = app_id
        params['latest'] = latest
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/appstore.AppstoreManager.get_icons"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['icons']

    def get_icons_async(self, app_id, latest, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['app_id'] = app_id
        params['latest'] = latest
        url = "api/external/5.0/appstore.AppstoreManager.get_icons"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def get_manual_install_token(self, package_name, volume_id, __client__=None):
        """
        This will return and install token, which will allow uploading manually a file to be installed
        """
        params = dict()
        params['package_name'] = package_name
        params['volume_id'] = volume_id
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/appstore.AppstoreManager.get_manual_install_token"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['token']

    def get_manual_install_token_async(self, package_name, volume_id, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['package_name'] = package_name
        params['volume_id'] = volume_id
        url = "api/external/5.0/appstore.AppstoreManager.get_manual_install_token"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def get_operations_table(self, __client__=None):
        params = dict()

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/appstore.AppstoreManager.get_operations_table"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['operations_table']

    def get_operations_table_async(self, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()

        url = "api/external/5.0/appstore.AppstoreManager.get_operations_table"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def get_server_urls(self, __client__=None):
        params = dict()

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/appstore.AppstoreManager.get_server_urls"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['list']

    def get_server_urls_async(self, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()

        url = "api/external/5.0/appstore.AppstoreManager.get_server_urls"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def get_servers_status(self, __client__=None):
        params = dict()

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/appstore.AppstoreManager.get_servers_status"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['statuses']

    def get_servers_status_async(self, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()

        url = "api/external/5.0/appstore.AppstoreManager.get_servers_status"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def install_app(self, async_client_ref, app_id, volume_id, __client__=None):
        params = dict()
        params['async_client_ref'] = async_client_ref
        params['app_id'] = app_id
        params['volume_id'] = volume_id
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/appstore.AppstoreManager.install_app"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['async_job_id']


    def install_app_result(self, async_job_id,__client__=None):
        params = dict()
        params['async_job_id'] = async_job_id

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/appstore.AppstoreManager.install_app_result"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return 



    def list_application(self, with_parameters, list_info, __client__=None):
        """
        update_available only works for online=True
        """
        params = dict()
        params['with_parameters'] = with_parameters
        params['list_info'] = list_info
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/appstore.AppstoreManager.list_application"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['list']

    def list_application_async(self, with_parameters, list_info, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['with_parameters'] = with_parameters
        params['list_info'] = list_info
        url = "api/external/5.0/appstore.AppstoreManager.list_application"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def list_application_installed(self, with_parameters, list_info, __client__=None):
        """
        with_parameters: only icons is available
        """
        params = dict()
        params['with_parameters'] = with_parameters
        params['list_info'] = list_info
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/appstore.AppstoreManager.list_application_installed"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['list']

    def list_application_installed_async(self, with_parameters, list_info, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['with_parameters'] = with_parameters
        params['list_info'] = list_info
        url = "api/external/5.0/appstore.AppstoreManager.list_application_installed"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def list_apps_access(self, group_id, list_info, __client__=None):
        params = dict()
        params['group_id'] = group_id
        params['list_info'] = list_info
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/appstore.AppstoreManager.list_apps_access"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['accesses']

    def list_apps_access_async(self, group_id, list_info, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['group_id'] = group_id
        params['list_info'] = list_info
        url = "api/external/5.0/appstore.AppstoreManager.list_apps_access"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def list_category(self, list_info, __client__=None):
        params = dict()
        params['list_info'] = list_info
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/appstore.AppstoreManager.list_category"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['list']

    def list_category_async(self, list_info, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['list_info'] = list_info
        url = "api/external/5.0/appstore.AppstoreManager.list_category"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def list_groups_access(self, app_id, list_info, __client__=None):
        """
        For some more information about the groups you can use the GroupAdministration service and the search_parameters.
        """
        params = dict()
        params['app_id'] = app_id
        params['list_info'] = list_info
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/appstore.AppstoreManager.list_groups_access"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['accesses']

    def list_groups_access_async(self, app_id, list_info, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['app_id'] = app_id
        params['list_info'] = list_info
        url = "api/external/5.0/appstore.AppstoreManager.list_groups_access"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def myApps(self, with_parameters, list_info, __client__=None):
        """
        Return the list of apps user has access to.
        Chroot and utilities won't be returned
        """
        params = dict()
        params['with_parameters'] = with_parameters
        params['list_info'] = list_info
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/appstore.AppstoreManager.myApps"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['list']

    def myApps_async(self, with_parameters, list_info, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['with_parameters'] = with_parameters
        params['list_info'] = list_info
        url = "api/external/5.0/appstore.AppstoreManager.myApps"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def periodic_check(self, __client__=None):
        params = dict()

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/appstore.AppstoreManager.periodic_check"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return 

    def periodic_check_async(self, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()

        url = "api/external/5.0/appstore.AppstoreManager.periodic_check"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def remove_app(self, async_client_ref, app_id, __client__=None):
        params = dict()
        params['async_client_ref'] = async_client_ref
        params['app_id'] = app_id
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/appstore.AppstoreManager.remove_app"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['async_job_id']


    def remove_app_result(self, async_job_id,__client__=None):
        params = dict()
        params['async_job_id'] = async_job_id

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/appstore.AppstoreManager.remove_app_result"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return 



    def remove_apps_for_group(self, group_id, app_ids, __client__=None):
        params = dict()
        params['group_id'] = group_id
        params['app_ids'] = app_ids
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/appstore.AppstoreManager.remove_apps_for_group"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['failed_apps']

    def remove_apps_for_group_async(self, group_id, app_ids, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['group_id'] = group_id
        params['app_ids'] = app_ids
        url = "api/external/5.0/appstore.AppstoreManager.remove_apps_for_group"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def remove_groups(self, app_id, groups_id, __client__=None):
        params = dict()
        params['app_id'] = app_id
        params['groups_id'] = groups_id
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/appstore.AppstoreManager.remove_groups"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['failed_groups']

    def remove_groups_async(self, app_id, groups_id, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['app_id'] = app_id
        params['groups_id'] = groups_id
        url = "api/external/5.0/appstore.AppstoreManager.remove_groups"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def set_server_urls(self, list, __client__=None):
        params = dict()
        params['list'] = list
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/appstore.AppstoreManager.set_server_urls"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return 

    def set_server_urls_async(self, list, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['list'] = list
        url = "api/external/5.0/appstore.AppstoreManager.set_server_urls"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def start_application(self, async_client_ref, app_id, __client__=None):
        params = dict()
        params['async_client_ref'] = async_client_ref
        params['app_id'] = app_id
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/appstore.AppstoreManager.start_application"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['async_job_id']


    def start_application_result(self, async_job_id,__client__=None):
        params = dict()
        params['async_job_id'] = async_job_id

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/appstore.AppstoreManager.start_application_result"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return 



    def stop_application(self, async_client_ref, app_id, __client__=None):
        params = dict()
        params['async_client_ref'] = async_client_ref
        params['app_id'] = app_id
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/appstore.AppstoreManager.stop_application"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['async_job_id']


    def stop_application_result(self, async_job_id,__client__=None):
        params = dict()
        params['async_job_id'] = async_job_id

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/appstore.AppstoreManager.stop_application_result"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return 



    def update_all(self, __client__=None):
        """
        Update all apps
        """
        params = dict()

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/appstore.AppstoreManager.update_all"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return 

    def update_all_async(self, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()

        url = "api/external/5.0/appstore.AppstoreManager.update_all"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def update_app(self, async_client_ref, app_id, __client__=None):
        params = dict()
        params['async_client_ref'] = async_client_ref
        params['app_id'] = app_id
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/appstore.AppstoreManager.update_app"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['async_job_id']


    def update_app_result(self, async_job_id,__client__=None):
        params = dict()
        params['async_job_id'] = async_job_id

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/appstore.AppstoreManager.update_app_result"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return 

