#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE May 14 2014 12:22:35
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v5.sv0.auto_update import UpdateMode


class AutoUpdateConfigInstantiator(Instantiator):
    version = 5
    sub_version = 0
    attributes = {
        'schedule_hour': int,
        'schedule_minute': int,
        'schedule_period': int,
        'update_mode': UpdateMode,
        'update_server_address': unicode,
        'update_server_branch_path': unicode,
    }
    w_attributes = ["schedule_hour", "schedule_minute", "schedule_period", "update_mode", "update_server_address", "update_server_branch_path"]
    r_attributes = ["schedule_hour", "schedule_minute", "schedule_period", "update_mode", "update_server_address", "update_server_branch_path"]
    h_attributes = []
    op_values = {}

    @classmethod
    def name(cls):
        return u'AutoUpdateConfig'

    @classmethod
    def new_object(cls):
        return AutoUpdateConfig()


class AutoUpdateConfig(ClientObject):

    def setschedule_hour(self, value):
        self.schedule_hour = value

    def setschedule_minute(self, value):
        self.schedule_minute = value

    def setschedule_period(self, value):
        self.schedule_period = value

    def setupdate_mode(self, value):
        self.update_mode = value

    def setupdate_server_address(self, value):
        self.update_server_address = value

    def setupdate_server_branch_path(self, value):
        self.update_server_branch_path = value

    def getschedule_hour(self):
        return self.schedule_hour

    def getschedule_minute(self):
        return self.schedule_minute

    def getschedule_period(self):
        return self.schedule_period

    def getupdate_mode(self):
        return self.update_mode

    def getupdate_server_address(self):
        return self.update_server_address

    def getupdate_server_branch_path(self):
        return self.update_server_branch_path
    __instantiator__ = AutoUpdateConfigInstantiator
register_instantiator('unicorn_api', AutoUpdateConfigInstantiator, True)
