#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE May 14 2014 12:22:35
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

from transformer.lib import Enum
class UpdateErrorCode(Enum):
    UNKNOWN= -1
    AU_SUCCESS= 0
    AU_INIT_ERROR= 1
    AU_INIT_INVALID_PROTOCOL= 2
    AU_INIT_INVALID_VERSION= 3
    AU_INIT_INVALID_EXTENSION= 4
    AU_INIT_INVALID_DL_PATH= 5
    AU_INIT_INVALID_ROOT_PATH= 6
    AU_INIT_PLUGIN_OPEN_ERROR= 7
    AU_CHECK_ERROR= 8
    AU_CHECK_NO_UPDATE= 9
    AU_GET_ERROR= 10
    AU_GET_INVALID_PATH= 11
    AU_GET_CONNECT_ERROR= 12
    AU_GET_DL_ERROR= 13
    AU_GET_INVALID_XML= 14
    AU_GET_INVALID_UPDATE= 15
    AU_GET_PROXY_CONF_ERROR= 16
    AU_SET_INVALID_PROXY_CONF= 17
    AU_GET_INFO_ERROR= 18
    AU_INTERRUPTED_BY_SIGNAL= 19
    AU_SET_INVALID_SERVER_AUTH= 20
    AU_GET_SERVER_AUTH_ERROR= 21
    AU_SET_ERROR= 22
    AU_NULL_PARAMETER= 23
    AU_INVALID_CONTEXT= 24
    AU_GET_BRANCHES_ERROR= 25
    AU_GLOBAL_ALREADY_INITIALIZED= 26
    AU_GLOBAL_ERROR= 27
    AU_INIT_NON_EXIST_DL_PATH= 28
    AU_CHECK_INVALID_MIN_VERSION= 29
    AU_CHECK_INVALID_VERSION= 30
    AU_CHECK_VERSION_MISMATCH= 31
    AU_NOT_ENOUGH_SPACE= 32
    AU_CAPUSLE_EXTRACT_ERROR= 100
    AU_AGENT_START_ERROR= 101
    AU_CAPSULE_OBSOLETE= 102
    @classmethod
    def from_cli(cls, value):
        return cls(getattr(cls, value))
class UpdateMode(Enum):
    UNKNOWN= -1
    DISABLE= 0
    AUTO_CHECK= 1
    AUTO_DOWNLOAD= 2
    AUTO_INSTALL= 3
    GET_UPDATE_BRANCHES= 4
    @classmethod
    def from_cli(cls, value):
        return cls(getattr(cls, value))
class UpdateStatusCode(Enum):
    UNKNOWN= -1
    AU_IDLE= 0
    AU_INITIALIZING= 1
    AU_INITIALIZING_OVER= 2
    AU_CHECKING_UPDATE= 3
    AU_CHECKING_UPDATE_OVER= 4
    AU_DOWNLOADING= 5
    AU_DOWNLOADING_OVER= 6
    AU_INSTALLING= 7
    AU_INSTALLING_OVER= 8
    @classmethod
    def from_cli(cls, value):
        return cls(getattr(cls, value))
