#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE May 14 2014 12:22:35
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v5.sv0.sharing.Share import Share


class BtsyncShareInstantiator(Instantiator):
    version = 5
    sub_version = 0
    attributes = {
        'directory': unicode,
        'enabled': bool,
        'id': int,
        'ro_secret': unicode,
        'search_lan': bool,
        'secret': unicode,
        'share': Share,
        'use_dht': bool,
        'use_relay_server': bool,
        'use_sync_trash': bool,
        'use_tracker': bool,
    }
    w_attributes = ["enabled", "search_lan", "secret", "use_dht", "use_relay_server", "use_sync_trash", "use_tracker"]
    r_attributes = ["directory", "enabled", "id", "ro_secret", "search_lan", "secret", "share", "use_dht", "use_relay_server", "use_sync_trash", "use_tracker"]
    h_attributes = []
    op_values = {}

    @classmethod
    def name(cls):
        return u'BtsyncShare'

    @classmethod
    def new_object(cls):
        return BtsyncShare()


class BtsyncShare(ClientObject):

    def setenabled(self, value):
        self.enabled = value

    def setsearch_lan(self, value):
        self.search_lan = value

    def setsecret(self, value):
        self.secret = value

    def setuse_dht(self, value):
        self.use_dht = value

    def setuse_relay_server(self, value):
        self.use_relay_server = value

    def setuse_sync_trash(self, value):
        self.use_sync_trash = value

    def setuse_tracker(self, value):
        self.use_tracker = value

    def getdirectory(self):
        return self.directory

    def getenabled(self):
        return self.enabled

    def getid(self):
        return self.id

    def getro_secret(self):
        return self.ro_secret

    def getsearch_lan(self):
        return self.search_lan

    def getsecret(self):
        return self.secret

    def getshare(self):
        return self.share

    def getuse_dht(self):
        return self.use_dht

    def getuse_relay_server(self):
        return self.use_relay_server

    def getuse_sync_trash(self):
        return self.use_sync_trash

    def getuse_tracker(self):
        return self.use_tracker
    __instantiator__ = BtsyncShareInstantiator
register_instantiator('unicorn_api', BtsyncShareInstantiator, True)
