#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE May 14 2014 12:22:35
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject


class EmailConfigInstantiator(Instantiator):
    version = 5
    sub_version = 0
    attributes = {
        'smtp_auth_pwd': Optional(unicode),
        'smtp_auth_user': Optional(unicode),
        'smtp_need_auth': bool,
        'smtp_port': int,
        'smtp_secure_connection': bool,
        'smtp_server': unicode,
        'use_smtp': bool,
    }
    w_attributes = ["smtp_auth_pwd", "smtp_auth_user", "smtp_need_auth", "smtp_port", "smtp_secure_connection", "smtp_server", "use_smtp"]
    r_attributes = ["smtp_auth_user", "smtp_need_auth", "smtp_port", "smtp_secure_connection", "smtp_server", "use_smtp"]
    h_attributes = []
    op_values = {'smtp_auth_pwd': None, 'smtp_auth_user': None}

    @classmethod
    def name(cls):
        return u'EmailConfig'

    @classmethod
    def new_object(cls):
        return EmailConfig()


class EmailConfig(ClientObject):

    def setsmtp_auth_pwd(self, value):
        self.smtp_auth_pwd = value

    def setsmtp_auth_user(self, value):
        self.smtp_auth_user = value

    def setsmtp_need_auth(self, value):
        self.smtp_need_auth = value

    def setsmtp_port(self, value):
        self.smtp_port = value

    def setsmtp_secure_connection(self, value):
        self.smtp_secure_connection = value

    def setsmtp_server(self, value):
        self.smtp_server = value

    def setuse_smtp(self, value):
        self.use_smtp = value

    def getsmtp_auth_user(self):
        return self.smtp_auth_user

    def getsmtp_need_auth(self):
        return self.smtp_need_auth

    def getsmtp_port(self):
        return self.smtp_port

    def getsmtp_secure_connection(self):
        return self.smtp_secure_connection

    def getsmtp_server(self):
        return self.smtp_server

    def getuse_smtp(self):
        return self.use_smtp
    __instantiator__ = EmailConfigInstantiator
register_instantiator('unicorn_api', EmailConfigInstantiator, True)
