#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE May 14 2014 12:22:35
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

from transformer.lib import Optional
from unicorn_api.v5.sv0.filebrowser.ShareLink import ShareLink
from unicorn_api.v5.sv0.sharing import Access
from unicorn_api.v5.sv0.filebrowser.FileIOResource import FileIOResource
from unicorn_api.v5.sv0.filebrowser import OpenMode
from unicorn_api.v5.sv0.filebrowser.FileIOProperty import FileIOProperty
from unicorn_api.v5.sv0.filebrowser import UploadBehavior

from transformer.lib import ListInfo, ResultSet, List, Long, Blob, Date

from transformer.client_transport import ClientTransport
from transformer.client_serializer import ClientSerializer


class FileBrowsing(object):


    def add_comment(self, resource_id, comment, __client__=None):
        params = dict()
        params['resource_id'] = resource_id
        params['comment'] = comment
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/filebrowser.FileBrowsing.add_comment"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['comments']

    def add_comment_async(self, resource_id, comment, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['resource_id'] = resource_id
        params['comment'] = comment
        url = "api/external/5.0/filebrowser.FileBrowsing.add_comment"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def close(self, file_id, __client__=None):
        params = dict()
        params['file_id'] = file_id
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/filebrowser.FileBrowsing.close"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return 

    def close_async(self, file_id, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['file_id'] = file_id
        url = "api/external/5.0/filebrowser.FileBrowsing.close"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def close_enumeration(self, enumeration_id, __client__=None):
        params = dict()
        params['enumeration_id'] = enumeration_id
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/filebrowser.FileBrowsing.close_enumeration"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return 

    def close_enumeration_async(self, enumeration_id, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['enumeration_id'] = enumeration_id
        url = "api/external/5.0/filebrowser.FileBrowsing.close_enumeration"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def create_folder(self, folder_id, recursive, __client__=None):
        params = dict()
        params['folder_id'] = folder_id
        params['recursive'] = recursive
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/filebrowser.FileBrowsing.create_folder"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['new_resource']

    def create_folder_async(self, folder_id, recursive, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['folder_id'] = folder_id
        params['recursive'] = recursive
        url = "api/external/5.0/filebrowser.FileBrowsing.create_folder"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def create_share_link(self, share_link, __client__=None):
        params = dict()
        params['share_link'] = share_link
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/filebrowser.FileBrowsing.create_share_link"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['link']

    def create_share_link_async(self, share_link, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['share_link'] = share_link
        url = "api/external/5.0/filebrowser.FileBrowsing.create_share_link"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def delete(self, resource_id, __client__=None):
        """
        Can be used to delete a file or a folder
        """
        params = dict()
        params['resource_id'] = resource_id
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/filebrowser.FileBrowsing.delete"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return 

    def delete_async(self, resource_id, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['resource_id'] = resource_id
        url = "api/external/5.0/filebrowser.FileBrowsing.delete"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def delete_share_link(self, uri, __client__=None):
        params = dict()
        params['uri'] = uri
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/filebrowser.FileBrowsing.delete_share_link"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return 

    def delete_share_link_async(self, uri, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['uri'] = uri
        url = "api/external/5.0/filebrowser.FileBrowsing.delete_share_link"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def download_completed(self, uri, __client__=None):
        params = dict()
        params['uri'] = uri
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/local/5.0/filebrowser.FileBrowsing.download_completed"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return 

    def download_completed_async(self, uri, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['uri'] = uri
        url = "api/local/5.0/filebrowser.FileBrowsing.download_completed"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def enumerate_folder(self, folder_id, list_info, __client__=None):
        """
        The idea of this function is to get a snapshot of a folder at a given time
        This will prevent having twice an element when browsing or missing one element
        folders_only: we only want to browse sub folders
        Offset and Limit should be set to 0 and -1 and will be discarded
        """
        params = dict()
        params['folder_id'] = folder_id
        params['list_info'] = list_info
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/filebrowser.FileBrowsing.enumerate_folder"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['enumeration_id']

    def enumerate_folder_async(self, folder_id, list_info, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['folder_id'] = folder_id
        params['list_info'] = list_info
        url = "api/external/5.0/filebrowser.FileBrowsing.enumerate_folder"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def get_properties(self, resource_id, properties_list, __client__=None):
        """
        properties_list: if all in list then all properties will be returned
        """
        params = dict()
        params['resource_id'] = resource_id
        params['properties_list'] = properties_list
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/filebrowser.FileBrowsing.get_properties"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['properties']

    def get_properties_async(self, resource_id, properties_list, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['resource_id'] = resource_id
        params['properties_list'] = properties_list
        url = "api/external/5.0/filebrowser.FileBrowsing.get_properties"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def get_resource(self, file_id, __client__=None):
        params = dict()
        params['file_id'] = file_id
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/filebrowser.FileBrowsing.get_resource"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['resource']

    def get_resource_async(self, file_id, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['file_id'] = file_id
        url = "api/external/5.0/filebrowser.FileBrowsing.get_resource"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def get_share_link_path(self, uri, password, __client__=None):
        """
        Return the actual path to share
        """
        params = dict()
        params['uri'] = uri
        params['password'] = password
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/local/5.0/filebrowser.FileBrowsing.get_share_link_path"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['path']

    def get_share_link_path_async(self, uri, password, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['uri'] = uri
        params['password'] = password
        url = "api/local/5.0/filebrowser.FileBrowsing.get_share_link_path"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def get_thumbnail(self, file_id, __client__=None):
        params = dict()
        params['file_id'] = file_id
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/filebrowser.FileBrowsing.get_thumbnail"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['thumbnail']

    def get_thumbnail_async(self, file_id, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['file_id'] = file_id
        url = "api/external/5.0/filebrowser.FileBrowsing.get_thumbnail"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def get_upload_path(self, token, __client__=None):
        """
        Return the extected upload path
        Since this method is only allowed throught local, this will be the actual path on the system
        """
        params = dict()
        params['token'] = token
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/local/5.0/filebrowser.FileBrowsing.get_upload_path"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['path']

    def get_upload_path_async(self, token, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['token'] = token
        url = "api/local/5.0/filebrowser.FileBrowsing.get_upload_path"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def get_upload_token(self, destination, behavior, __client__=None):
        """
        Append token to http://ip/upload/?token=token_value
        """
        params = dict()
        params['destination'] = destination
        params['behavior'] = behavior
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/filebrowser.FileBrowsing.get_upload_token"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['token']

    def get_upload_token_async(self, destination, behavior, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['destination'] = destination
        params['behavior'] = behavior
        url = "api/external/5.0/filebrowser.FileBrowsing.get_upload_token"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def list_children(self, enumeration_id, list_info, with_properties, __client__=None):
        """
        if all included in with_properties
        all the properties will be returned
        """
        params = dict()
        params['enumeration_id'] = enumeration_id
        params['list_info'] = list_info
        params['with_properties'] = with_properties
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/filebrowser.FileBrowsing.list_children"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['files']

    def list_children_async(self, enumeration_id, list_info, with_properties, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['enumeration_id'] = enumeration_id
        params['list_info'] = list_info
        params['with_properties'] = with_properties
        url = "api/external/5.0/filebrowser.FileBrowsing.list_children"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def list_comments(self, resource_id, __client__=None):
        params = dict()
        params['resource_id'] = resource_id
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/filebrowser.FileBrowsing.list_comments"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['comments']

    def list_comments_async(self, resource_id, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['resource_id'] = resource_id
        url = "api/external/5.0/filebrowser.FileBrowsing.list_comments"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def list_share_links(self, list_info, __client__=None):
        """
        If user request, only sees it
        """
        params = dict()
        params['list_info'] = list_info
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/filebrowser.FileBrowsing.list_share_links"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['share_links']

    def list_share_links_async(self, list_info, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['list_info'] = list_info
        url = "api/external/5.0/filebrowser.FileBrowsing.list_share_links"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def move(self, async_client_ref, resource_id, destination_id, __client__=None):
        """
        Can be used to move a file or a folder
        """
        params = dict()
        params['async_client_ref'] = async_client_ref
        params['resource_id'] = resource_id
        params['destination_id'] = destination_id
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/filebrowser.FileBrowsing.move"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['async_job_id']


    def move_result(self, async_job_id,__client__=None):
        params = dict()
        params['async_job_id'] = async_job_id

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/filebrowser.FileBrowsing.move_result"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return 



    def my_share_links(self, list_info, __client__=None):
        params = dict()
        params['list_info'] = list_info
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/filebrowser.FileBrowsing.my_share_links"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['share_links']

    def my_share_links_async(self, list_info, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['list_info'] = list_info
        url = "api/external/5.0/filebrowser.FileBrowsing.my_share_links"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def open(self, file_id, mode, __client__=None):
        """
        This can only be used for files
        """
        params = dict()
        params['file_id'] = file_id
        params['mode'] = mode
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/filebrowser.FileBrowsing.open"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['file_id']

    def open_async(self, file_id, mode, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['file_id'] = file_id
        params['mode'] = mode
        url = "api/external/5.0/filebrowser.FileBrowsing.open"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def read(self, file_id, size, __client__=None):
        params = dict()
        params['file_id'] = file_id
        params['size'] = size
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/filebrowser.FileBrowsing.read"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['data']

    def read_async(self, file_id, size, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['file_id'] = file_id
        params['size'] = size
        url = "api/external/5.0/filebrowser.FileBrowsing.read"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def rename(self, resource_id, new_name, __client__=None):
        params = dict()
        params['resource_id'] = resource_id
        params['new_name'] = new_name
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/filebrowser.FileBrowsing.rename"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['new_resource_id']

    def rename_async(self, resource_id, new_name, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['resource_id'] = resource_id
        params['new_name'] = new_name
        url = "api/external/5.0/filebrowser.FileBrowsing.rename"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def resize(self, file_id, new_size, __client__=None):
        params = dict()
        params['file_id'] = file_id
        params['new_size'] = new_size
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/filebrowser.FileBrowsing.resize"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return 

    def resize_async(self, file_id, new_size, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['file_id'] = file_id
        params['new_size'] = new_size
        url = "api/external/5.0/filebrowser.FileBrowsing.resize"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def seek(self, file_id, position, __client__=None):
        params = dict()
        params['file_id'] = file_id
        params['position'] = position
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/filebrowser.FileBrowsing.seek"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return 

    def seek_async(self, file_id, position, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['file_id'] = file_id
        params['position'] = position
        url = "api/external/5.0/filebrowser.FileBrowsing.seek"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def set_enabled_share_link(self, URI, enabled, __client__=None):
        params = dict()
        params['URI'] = URI
        params['enabled'] = enabled
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/filebrowser.FileBrowsing.set_enabled_share_link"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['share_link']

    def set_enabled_share_link_async(self, URI, enabled, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['URI'] = URI
        params['enabled'] = enabled
        url = "api/external/5.0/filebrowser.FileBrowsing.set_enabled_share_link"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def set_property(self, resource_id, property, __client__=None):
        params = dict()
        params['resource_id'] = resource_id
        params['property'] = property
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/filebrowser.FileBrowsing.set_property"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return 

    def set_property_async(self, resource_id, property, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['resource_id'] = resource_id
        params['property'] = property
        url = "api/external/5.0/filebrowser.FileBrowsing.set_property"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def share(self, file_id, __client__=None):
        """
        uri: append to the protocol://host + uri
        """
        params = dict()
        params['file_id'] = file_id
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/filebrowser.FileBrowsing.share"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['uri']

    def share_async(self, file_id, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['file_id'] = file_id
        url = "api/external/5.0/filebrowser.FileBrowsing.share"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def update_modify_date(self, resource_id, modify_date, __client__=None):
        params = dict()
        params['resource_id'] = resource_id
        params['modify_date'] = modify_date
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/filebrowser.FileBrowsing.update_modify_date"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['new_file']

    def update_modify_date_async(self, resource_id, modify_date, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['resource_id'] = resource_id
        params['modify_date'] = modify_date
        url = "api/external/5.0/filebrowser.FileBrowsing.update_modify_date"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def upload_done(self, token, __client__=None):
        """
        Receive notification that the upload has be completed
        """
        params = dict()
        params['token'] = token
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/local/5.0/filebrowser.FileBrowsing.upload_done"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return 

    def upload_done_async(self, token, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['token'] = token
        url = "api/local/5.0/filebrowser.FileBrowsing.upload_done"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def write(self, file_id, data, __client__=None):
        params = dict()
        params['file_id'] = file_id
        params['data'] = data
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/filebrowser.FileBrowsing.write"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['writen']

    def write_async(self, file_id, data, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['file_id'] = file_id
        params['data'] = data
        url = "api/external/5.0/filebrowser.FileBrowsing.write"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')
