#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE May 14 2014 12:22:35
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v5.sv0.sharing import Access
from unicorn_api.v5.sv0.filebrowser.FileIOProperty import FileIOProperty

from transformer.lib import Long, Date, List


class FileIOResourceInstantiator(Instantiator):
    version = 5
    sub_version = 0
    attributes = {
        'a_date': Date,
        'access': Access,
        'c_date': Date,
        'file_name': unicode,
        'has_sub_dir': bool,
        'id': unicode,
        'is_dir': bool,
        'is_file': bool,
        'm_date': Date,
        'properties': List(FileIOProperty),
        'size': Long,
    }
    w_attributes = ["properties"]
    r_attributes = ["a_date", "access", "c_date", "file_name", "has_sub_dir", "id", "is_dir", "is_file", "m_date", "properties", "size"]
    h_attributes = []
    op_values = {}

    @classmethod
    def name(cls):
        return u'FileIOResource'

    @classmethod
    def new_object(cls):
        return FileIOResource()


class FileIOResource(ClientObject):

    def setproperties(self, value):
        self.properties = value

    def geta_date(self):
        return self.a_date

    def getaccess(self):
        return self.access

    def getc_date(self):
        return self.c_date

    def getfile_name(self):
        return self.file_name

    def gethas_sub_dir(self):
        return self.has_sub_dir

    def getid(self):
        return self.id

    def getis_dir(self):
        return self.is_dir

    def getis_file(self):
        return self.is_file

    def getm_date(self):
        return self.m_date

    def getproperties(self):
        return self.properties

    def getsize(self):
        return self.size
    __instantiator__ = FileIOResourceInstantiator
register_instantiator('unicorn_api', FileIOResourceInstantiator, True)
