#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE May 14 2014 12:22:35
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject

from transformer.lib import Date


class ShareLinkInstantiator(Instantiator):
    version = 5
    sub_version = 0
    attributes = {
        'expires': Optional(Date),
        'filename': Optional(unicode),
        'has_password': bool,
        'password': Optional(unicode),
        'path': unicode,
        'share_count': Optional(int),
        'token': Optional(unicode),
        'uri': unicode,
    }
    w_attributes = ["expires", "filename", "password", "path", "share_count", "token"]
    r_attributes = ["expires", "has_password", "path", "share_count", "token", "uri"]
    h_attributes = []
    op_values = {'password': None, 'expires': None, 'share_count': -1, 'token': None, 'filename': None}

    @classmethod
    def name(cls):
        return u'ShareLink'

    @classmethod
    def new_object(cls):
        return ShareLink()


class ShareLink(ClientObject):

    def setexpires(self, value):
        self.expires = value

    def setfilename(self, value):
        self.filename = value

    def setpassword(self, value):
        self.password = value

    def setpath(self, value):
        self.path = value

    def setshare_count(self, value):
        self.share_count = value

    def settoken(self, value):
        self.token = value

    def getexpires(self):
        return self.expires

    def gethas_password(self):
        return self.has_password

    def getpath(self):
        return self.path

    def getshare_count(self):
        return self.share_count

    def gettoken(self):
        return self.token

    def geturi(self):
        return self.uri
    __instantiator__ = ShareLinkInstantiator
register_instantiator('unicorn_api', ShareLinkInstantiator, True)
