#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE May 14 2014 12:22:35
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v5.sv0.hw_monitoring import DriveStatus
from unicorn_api.v5.sv0.hw_monitoring import SmartStatus

from transformer.lib import Long


class DriveInfoInstantiator(Instantiator):
    version = 5
    sub_version = 0
    attributes = {
        'can_run_smart_test': bool,
        'device_model': unicode,
        'firmware_version': unicode,
        'serial_number': unicode,
        'size': Long,
        'slot': int,
        'smart_status': SmartStatus,
        'status': DriveStatus,
        'temperature': int,
    }
    w_attributes = ["can_run_smart_test", "device_model", "firmware_version", "serial_number", "size", "slot", "smart_status", "status", "temperature"]
    r_attributes = ["can_run_smart_test", "device_model", "firmware_version", "serial_number", "size", "slot", "smart_status", "status", "temperature"]
    h_attributes = []
    op_values = {}

    @classmethod
    def name(cls):
        return u'DriveInfo'

    @classmethod
    def new_object(cls):
        return DriveInfo()


class DriveInfo(ClientObject):

    def setcan_run_smart_test(self, value):
        self.can_run_smart_test = value

    def setdevice_model(self, value):
        self.device_model = value

    def setfirmware_version(self, value):
        self.firmware_version = value

    def setserial_number(self, value):
        self.serial_number = value

    def setsize(self, value):
        self.size = value

    def setslot(self, value):
        self.slot = value

    def setsmart_status(self, value):
        self.smart_status = value

    def setstatus(self, value):
        self.status = value

    def settemperature(self, value):
        self.temperature = value

    def getcan_run_smart_test(self):
        return self.can_run_smart_test

    def getdevice_model(self):
        return self.device_model

    def getfirmware_version(self):
        return self.firmware_version

    def getserial_number(self):
        return self.serial_number

    def getsize(self):
        return self.size

    def getslot(self):
        return self.slot

    def getsmart_status(self):
        return self.smart_status

    def getstatus(self):
        return self.status

    def gettemperature(self):
        return self.temperature
    __instantiator__ = DriveInfoInstantiator
register_instantiator('unicorn_api', DriveInfoInstantiator, True)
