#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE May 14 2014 12:22:35
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v5.sv0.hw_monitoring import HardwareComponentStatus


class FanInstantiator(Instantiator):
    version = 5
    sub_version = 0
    attributes = {
        'current_rpm': int,
        'group_id': unicode,
        'max_rpm': int,
        'name': unicode,
        'status': HardwareComponentStatus,
    }
    w_attributes = ["current_rpm", "group_id", "max_rpm", "name", "status"]
    r_attributes = ["current_rpm", "group_id", "max_rpm", "name", "status"]
    h_attributes = []
    op_values = {}

    @classmethod
    def name(cls):
        return u'Fan'

    @classmethod
    def new_object(cls):
        return Fan()


class Fan(ClientObject):

    def setcurrent_rpm(self, value):
        self.current_rpm = value

    def setgroup_id(self, value):
        self.group_id = value

    def setmax_rpm(self, value):
        self.max_rpm = value

    def setname(self, value):
        self.name = value

    def setstatus(self, value):
        self.status = value

    def getcurrent_rpm(self):
        return self.current_rpm

    def getgroup_id(self):
        return self.group_id

    def getmax_rpm(self):
        return self.max_rpm

    def getname(self):
        return self.name

    def getstatus(self):
        return self.status
    __instantiator__ = FanInstantiator
register_instantiator('unicorn_api', FanInstantiator, True)
