#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE May 14 2014 12:22:35
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v5.sv0.hw_monitoring import SmartUnit

from transformer.lib import Long


class SmartInfoInstantiator(Instantiator):
    version = 5
    sub_version = 0
    attributes = {
        'attribute': unicode,
        'id': int,
        'raw_data': Long,
        'raw_unit': SmartUnit,
        'status': bool,
        'threshold': int,
        'value': int,
        'worst': int,
    }
    w_attributes = ["attribute", "id", "raw_data", "raw_unit", "status", "threshold", "value", "worst"]
    r_attributes = ["attribute", "id", "raw_data", "raw_unit", "status", "threshold", "value", "worst"]
    h_attributes = []
    op_values = {}

    @classmethod
    def name(cls):
        return u'SmartInfo'

    @classmethod
    def new_object(cls):
        return SmartInfo()


class SmartInfo(ClientObject):

    def setattribute(self, value):
        self.attribute = value

    def setid(self, value):
        self.id = value

    def setraw_data(self, value):
        self.raw_data = value

    def setraw_unit(self, value):
        self.raw_unit = value

    def setstatus(self, value):
        self.status = value

    def setthreshold(self, value):
        self.threshold = value

    def setvalue(self, value):
        self.value = value

    def setworst(self, value):
        self.worst = value

    def getattribute(self):
        return self.attribute

    def getid(self):
        return self.id

    def getraw_data(self):
        return self.raw_data

    def getraw_unit(self):
        return self.raw_unit

    def getstatus(self):
        return self.status

    def getthreshold(self):
        return self.threshold

    def getvalue(self):
        return self.value

    def getworst(self):
        return self.worst
    __instantiator__ = SmartInfoInstantiator
register_instantiator('unicorn_api', SmartInfoInstantiator, True)
