#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE May 14 2014 12:22:35
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v5.sv0.iscsi.IscsiUser import IscsiUser


class IscsiChapUserInstantiator(Instantiator):
    version = 5
    sub_version = 0
    attributes = {
        'login': unicode,
        'mutual_chap_user': Optional(IscsiUser),
        'password': Optional(unicode),
    }
    w_attributes = ["login", "mutual_chap_user", "password"]
    r_attributes = ["login", "mutual_chap_user"]
    h_attributes = []
    op_values = {'password': None, 'mutual_chap_user': None}

    @classmethod
    def name(cls):
        return u'IscsiChapUser'

    @classmethod
    def new_object(cls):
        return IscsiChapUser()


class IscsiChapUser(ClientObject):

    def setlogin(self, value):
        self.login = value

    def setmutual_chap_user(self, value):
        self.mutual_chap_user = value

    def setpassword(self, value):
        self.password = value

    def getlogin(self):
        return self.login

    def getmutual_chap_user(self):
        return self.mutual_chap_user
    __instantiator__ = IscsiChapUserInstantiator
register_instantiator('unicorn_api', IscsiChapUserInstantiator, True)
