#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE May 14 2014 12:22:35
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v5.sv0.iscsi import IscsiLunKind
from unicorn_api.v5.sv0.iscsi import LunStatus

from transformer.lib import Long


class IscsiLunInstantiator(Instantiator):
    version = 5
    sub_version = 0
    attributes = {
        'current_progress': int,
        'description': unicode,
        'enabled': bool,
        'id': int,
        'kind': IscsiLunKind,
        'size': Long,
        'status': LunStatus,
        'target_id': int,
        'volume_id': int,
    }
    w_attributes = ["description", "id", "kind"]
    r_attributes = ["current_progress", "description", "enabled", "id", "kind", "size", "status", "target_id", "volume_id"]
    h_attributes = []
    op_values = {}

    @classmethod
    def name(cls):
        return u'IscsiLun'

    @classmethod
    def new_object(cls):
        return IscsiLun()


class IscsiLun(ClientObject):

    def setdescription(self, value):
        self.description = value

    def setid(self, value):
        self.id = value

    def setkind(self, value):
        self.kind = value

    def getcurrent_progress(self):
        return self.current_progress

    def getdescription(self):
        return self.description

    def getenabled(self):
        return self.enabled

    def getid(self):
        return self.id

    def getkind(self):
        return self.kind

    def getsize(self):
        return self.size

    def getstatus(self):
        return self.status

    def gettarget_id(self):
        return self.target_id

    def getvolume_id(self):
        return self.volume_id
    __instantiator__ = IscsiLunInstantiator
register_instantiator('unicorn_api', IscsiLunInstantiator, True)
