#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE May 14 2014 12:22:35
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

from transformer.lib import Optional
from unicorn_api.v5.sv0.iscsi.SimpleIscsiTarget import SimpleIscsiTarget

from transformer.lib import ListInfo, ResultSet, Long

from transformer.client_transport import ClientTransport
from transformer.client_serializer import ClientSerializer


class SimpleIscsiAdministration(object):


    def add_iqn(self, target_id, iqn, __client__=None):
        params = dict()
        params['target_id'] = target_id
        params['iqn'] = iqn
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/iscsi.SimpleIscsiAdministration.add_iqn"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['isci']

    def add_iqn_async(self, target_id, iqn, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['target_id'] = target_id
        params['iqn'] = iqn
        url = "api/external/5.0/iscsi.SimpleIscsiAdministration.add_iqn"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def cancel_duplicate_lun(self, target_id, __client__=None):
        """
         To cancel an iSCSI Lun duplication
        """
        params = dict()
        params['target_id'] = target_id
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/iscsi.SimpleIscsiAdministration.cancel_duplicate_lun"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['iscsi']

    def cancel_duplicate_lun_async(self, target_id, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['target_id'] = target_id
        url = "api/external/5.0/iscsi.SimpleIscsiAdministration.cancel_duplicate_lun"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def cancel_export_lun(self, target_id, __client__=None):
        """
         To cancel an iSCSI Lun export
        """
        params = dict()
        params['target_id'] = target_id
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/iscsi.SimpleIscsiAdministration.cancel_export_lun"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['iscsi']

    def cancel_export_lun_async(self, target_id, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['target_id'] = target_id
        url = "api/external/5.0/iscsi.SimpleIscsiAdministration.cancel_export_lun"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def cancel_import_lun(self, target_id, __client__=None):
        """
         To cancel an iSCSI Lun import
        """
        params = dict()
        params['target_id'] = target_id
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/iscsi.SimpleIscsiAdministration.cancel_import_lun"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['iscsi']

    def cancel_import_lun_async(self, target_id, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['target_id'] = target_id
        url = "api/external/5.0/iscsi.SimpleIscsiAdministration.cancel_import_lun"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def check_iqn(self, iqn, __client__=None):
        """
         To check validity of an iqn
        """
        params = dict()
        params['iqn'] = iqn
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/iscsi.SimpleIscsiAdministration.check_iqn"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['valid']

    def check_iqn_async(self, iqn, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['iqn'] = iqn
        url = "api/external/5.0/iscsi.SimpleIscsiAdministration.check_iqn"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def clear_error(self, target_id, __client__=None):
        params = dict()
        params['target_id'] = target_id
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/iscsi.SimpleIscsiAdministration.clear_error"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['iscsi']

    def clear_error_async(self, target_id, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['target_id'] = target_id
        url = "api/external/5.0/iscsi.SimpleIscsiAdministration.clear_error"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def create(self, async_client_ref, volume_id, size, lun_description, iscsi, __client__=None):
        """
         To create an iSCSI
        """
        params = dict()
        params['async_client_ref'] = async_client_ref
        params['volume_id'] = volume_id
        params['size'] = size
        params['lun_description'] = lun_description
        params['iscsi'] = iscsi
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/iscsi.SimpleIscsiAdministration.create"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['async_job_id']


    def create_result(self, async_job_id,__client__=None):
        params = dict()
        params['async_job_id'] = async_job_id

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/iscsi.SimpleIscsiAdministration.create_result"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['iscsi']



    def delete(self, async_client_ref, id, __client__=None):
        """
         To delete an iSCSI
        """
        params = dict()
        params['async_client_ref'] = async_client_ref
        params['id'] = id
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/iscsi.SimpleIscsiAdministration.delete"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['async_job_id']


    def delete_result(self, async_job_id,__client__=None):
        params = dict()
        params['async_job_id'] = async_job_id

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/iscsi.SimpleIscsiAdministration.delete_result"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return 



    def duplicate_lun(self, async_client_ref, volume_id, target_id, lun_description, iscsi, __client__=None):
        """
         To duplicate an iSCSI Lun
        """
        params = dict()
        params['async_client_ref'] = async_client_ref
        params['volume_id'] = volume_id
        params['target_id'] = target_id
        params['lun_description'] = lun_description
        params['iscsi'] = iscsi
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/iscsi.SimpleIscsiAdministration.duplicate_lun"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['async_job_id']


    def duplicate_lun_result(self, async_job_id,__client__=None):
        params = dict()
        params['async_job_id'] = async_job_id

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/iscsi.SimpleIscsiAdministration.duplicate_lun_result"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['iscsi']



    def export_lun(self, async_client_ref, target_id, lun_dest_file, __client__=None):
        """
         To export an iSCSI Lun
        """
        params = dict()
        params['async_client_ref'] = async_client_ref
        params['target_id'] = target_id
        params['lun_dest_file'] = lun_dest_file
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/iscsi.SimpleIscsiAdministration.export_lun"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['async_job_id']


    def export_lun_result(self, async_job_id,__client__=None):
        params = dict()
        params['async_job_id'] = async_job_id

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/iscsi.SimpleIscsiAdministration.export_lun_result"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return 



    def import_lun(self, async_client_ref, volume_id, lun_src_file, lun_description, iscsi, __client__=None):
        """
         To import an iSCSI Lun
        """
        params = dict()
        params['async_client_ref'] = async_client_ref
        params['volume_id'] = volume_id
        params['lun_src_file'] = lun_src_file
        params['lun_description'] = lun_description
        params['iscsi'] = iscsi
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/iscsi.SimpleIscsiAdministration.import_lun"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['async_job_id']


    def import_lun_result(self, async_job_id,__client__=None):
        params = dict()
        params['async_job_id'] = async_job_id

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/iscsi.SimpleIscsiAdministration.import_lun_result"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['iscsi']



    def list(self, listInfo, __client__=None):
        """
         To list all iSCSIs
        """
        params = dict()
        params['listInfo'] = listInfo
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/iscsi.SimpleIscsiAdministration.list"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['iscsis']

    def list_async(self, listInfo, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['listInfo'] = listInfo
        url = "api/external/5.0/iscsi.SimpleIscsiAdministration.list"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def modify(self, id, isci, __client__=None):
        """
         To modify advanced parameters of an iSCSI
         (Header digest, Data digest, CHAP, Multual CHAP)
        """
        params = dict()
        params['id'] = id
        params['isci'] = isci
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/iscsi.SimpleIscsiAdministration.modify"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['isci']

    def modify_async(self, id, isci, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['id'] = id
        params['isci'] = isci
        url = "api/external/5.0/iscsi.SimpleIscsiAdministration.modify"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def remove_iqn(self, target_id, iqn, __client__=None):
        params = dict()
        params['target_id'] = target_id
        params['iqn'] = iqn
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/iscsi.SimpleIscsiAdministration.remove_iqn"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['isci']

    def remove_iqn_async(self, target_id, iqn, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['target_id'] = target_id
        params['iqn'] = iqn
        url = "api/external/5.0/iscsi.SimpleIscsiAdministration.remove_iqn"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')
