#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE May 14 2014 12:22:35
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v5.sv0.iscsi.IscsiLun import IscsiLun
from unicorn_api.v5.sv0.iscsi.IscsiChapUser import IscsiChapUser

from transformer.lib import List


class SimpleIscsiTargetInstantiator(Instantiator):
    version = 5
    sub_version = 0
    attributes = {
        'chap_user': Optional(IscsiChapUser),
        'connected': bool,
        'data_digest': bool,
        'header_digest': bool,
        'id': int,
        'initiator_iqns': Optional(List(unicode)),
        'iqn_prefix': unicode,
        'iqn_suffix': unicode,
        'lun': Optional(IscsiLun),
        'multiple_session': bool,
        'name': unicode,
    }
    w_attributes = ["chap_user", "data_digest", "header_digest", "initiator_iqns", "iqn_suffix", "lun", "multiple_session", "name"]
    r_attributes = ["chap_user", "connected", "data_digest", "header_digest", "id", "initiator_iqns", "iqn_prefix", "iqn_suffix", "lun", "multiple_session", "name"]
    h_attributes = []
    op_values = {'chap_user': None, 'lun': None, 'initiator_iqns': None}

    @classmethod
    def name(cls):
        return u'SimpleIscsiTarget'

    @classmethod
    def new_object(cls):
        return SimpleIscsiTarget()


class SimpleIscsiTarget(ClientObject):

    def setchap_user(self, value):
        self.chap_user = value

    def setdata_digest(self, value):
        self.data_digest = value

    def setheader_digest(self, value):
        self.header_digest = value

    def setinitiator_iqns(self, value):
        self.initiator_iqns = value

    def setiqn_suffix(self, value):
        self.iqn_suffix = value

    def setlun(self, value):
        self.lun = value

    def setmultiple_session(self, value):
        self.multiple_session = value

    def setname(self, value):
        self.name = value

    def getchap_user(self):
        return self.chap_user

    def getconnected(self):
        return self.connected

    def getdata_digest(self):
        return self.data_digest

    def getheader_digest(self):
        return self.header_digest

    def getid(self):
        return self.id

    def getinitiator_iqns(self):
        return self.initiator_iqns

    def getiqn_prefix(self):
        return self.iqn_prefix

    def getiqn_suffix(self):
        return self.iqn_suffix

    def getlun(self):
        return self.lun

    def getmultiple_session(self):
        return self.multiple_session

    def getname(self):
        return self.name
    __instantiator__ = SimpleIscsiTargetInstantiator
register_instantiator('unicorn_api', SimpleIscsiTargetInstantiator, True)
