#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE May 14 2014 12:22:35
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v5.sv0.multi_nic import IPMode
from unicorn_api.v5.sv0.multi_nic import IPv6Mode

from transformer.lib import IP, List


class IPConfigInstantiator(Instantiator):
    version = 5
    sub_version = 0
    attributes = {
        'dhcp_server': IP,
        'dns_servers': Optional(List(IP)),
        'dns_suffix': Optional(unicode),
        'gateway': Optional(IP),
        'ipv4': Optional(IP),
        'ipv6_gateway': Optional(unicode),
        'ipv6_local_ip': unicode,
        'ipv6_mode': IPv6Mode,
        'ipv6_public_ip': Optional(unicode),
        'mode': IPMode,
        'netmask': Optional(IP),
    }
    w_attributes = ["dns_servers", "dns_suffix", "gateway", "ipv4", "ipv6_gateway", "ipv6_mode", "ipv6_public_ip", "mode", "netmask"]
    r_attributes = ["dhcp_server", "dns_servers", "dns_suffix", "gateway", "ipv4", "ipv6_gateway", "ipv6_local_ip", "ipv6_mode", "ipv6_public_ip", "mode", "netmask"]
    h_attributes = []
    op_values = {'ipv6_public_ip': u"", 'dns_servers': None, 'dns_suffix': u"", 'netmask': None, 'ipv4': None, 'ipv6_gateway': u"", 'gateway': None}

    @classmethod
    def name(cls):
        return u'IPConfig'

    @classmethod
    def new_object(cls):
        return IPConfig()


class IPConfig(ClientObject):

    def setdns_servers(self, value):
        self.dns_servers = value

    def setdns_suffix(self, value):
        self.dns_suffix = value

    def setgateway(self, value):
        self.gateway = value

    def setipv4(self, value):
        self.ipv4 = value

    def setipv6_gateway(self, value):
        self.ipv6_gateway = value

    def setipv6_mode(self, value):
        self.ipv6_mode = value

    def setipv6_public_ip(self, value):
        self.ipv6_public_ip = value

    def setmode(self, value):
        self.mode = value

    def setnetmask(self, value):
        self.netmask = value

    def getdhcp_server(self):
        return self.dhcp_server

    def getdns_servers(self):
        return self.dns_servers

    def getdns_suffix(self):
        return self.dns_suffix

    def getgateway(self):
        return self.gateway

    def getipv4(self):
        return self.ipv4

    def getipv6_gateway(self):
        return self.ipv6_gateway

    def getipv6_local_ip(self):
        return self.ipv6_local_ip

    def getipv6_mode(self):
        return self.ipv6_mode

    def getipv6_public_ip(self):
        return self.ipv6_public_ip

    def getmode(self):
        return self.mode

    def getnetmask(self):
        return self.netmask
    __instantiator__ = IPConfigInstantiator
register_instantiator('unicorn_api', IPConfigInstantiator, True)
