#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE May 14 2014 12:22:35
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v5.sv0.multi_nic import InterfaceType
from unicorn_api.v5.sv0.multi_nic.IPConfig import IPConfig
from unicorn_api.v5.sv0.multi_nic.Ethernet import Ethernet
from unicorn_api.v5.sv0.multi_nic.Bonding import Bonding

from transformer.lib import List


class InterfaceInstantiator(Instantiator):
    version = 5
    sub_version = 0
    attributes = {
        'bonding_config': Optional(Bonding),
        'enabled': bool,
        'ethernet_config': Optional(Ethernet),
        'friendly_name': unicode,
        'id': int,
        'ip_config': Optional(IPConfig),
        'link_up': bool,
        'mac': unicode,
        'master_id': int,
        'name': unicode,
        'slaves': List(int),
        'speed': int,
        'type': InterfaceType,
    }
    w_attributes = ["bonding_config", "enabled", "ethernet_config", "friendly_name", "ip_config", "type"]
    r_attributes = ["bonding_config", "enabled", "ethernet_config", "friendly_name", "id", "ip_config", "link_up", "mac", "master_id", "name", "slaves", "speed", "type"]
    h_attributes = []
    op_values = {'ethernet_config': None, 'bonding_config': None, 'ip_config': None}

    @classmethod
    def name(cls):
        return u'Interface'

    @classmethod
    def new_object(cls):
        return Interface()


class Interface(ClientObject):

    def setbonding_config(self, value):
        self.bonding_config = value

    def setenabled(self, value):
        self.enabled = value

    def setethernet_config(self, value):
        self.ethernet_config = value

    def setfriendly_name(self, value):
        self.friendly_name = value

    def setip_config(self, value):
        self.ip_config = value

    def settype(self, value):
        self.type = value

    def getbonding_config(self):
        return self.bonding_config

    def getenabled(self):
        return self.enabled

    def getethernet_config(self):
        return self.ethernet_config

    def getfriendly_name(self):
        return self.friendly_name

    def getid(self):
        return self.id

    def getip_config(self):
        return self.ip_config

    def getlink_up(self):
        return self.link_up

    def getmac(self):
        return self.mac

    def getmaster_id(self):
        return self.master_id

    def getname(self):
        return self.name

    def getslaves(self):
        return self.slaves

    def getspeed(self):
        return self.speed

    def gettype(self):
        return self.type
    __instantiator__ = InterfaceInstantiator
register_instantiator('unicorn_api', InterfaceInstantiator, True)
