#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE May 14 2014 12:22:35
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject


class NetBackupInstantiator(Instantiator):
    version = 5
    sub_version = 0
    attributes = {
        'enabled': bool,
        'is_created': bool,
        'login': unicode,
        'password': unicode,
        'port': int,
        'port_with_encryption': int,
        'share_id': int,
        'share_name': unicode,
        'volume_id': int,
    }
    w_attributes = ["enabled", "is_created", "login", "password", "share_id", "volume_id"]
    r_attributes = ["enabled", "is_created", "login", "port", "port_with_encryption", "share_id", "share_name", "volume_id"]
    h_attributes = []
    op_values = {}

    @classmethod
    def name(cls):
        return u'NetBackup'

    @classmethod
    def new_object(cls):
        return NetBackup()


class NetBackup(ClientObject):

    def setenabled(self, value):
        self.enabled = value

    def setis_created(self, value):
        self.is_created = value

    def setlogin(self, value):
        self.login = value

    def setpassword(self, value):
        self.password = value

    def setshare_id(self, value):
        self.share_id = value

    def setvolume_id(self, value):
        self.volume_id = value

    def getenabled(self):
        return self.enabled

    def getis_created(self):
        return self.is_created

    def getlogin(self):
        return self.login

    def getport(self):
        return self.port

    def getport_with_encryption(self):
        return self.port_with_encryption

    def getshare_id(self):
        return self.share_id

    def getshare_name(self):
        return self.share_name

    def getvolume_id(self):
        return self.volume_id
    __instantiator__ = NetBackupInstantiator
register_instantiator('unicorn_api', NetBackupInstantiator, True)
