#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE May 14 2014 12:22:35
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v5.sv0.raid import RaidMode
from unicorn_api.v5.sv0.raid import RaidLevel
from unicorn_api.v5.sv0.raid import RedundancyLevel


class LevelInfoInstantiator(Instantiator):
    version = 5
    sub_version = 0
    attributes = {
        'level': Optional(RaidLevel),
        'mode': RaidMode,
        'redundancy': Optional(RedundancyLevel),
    }
    w_attributes = ["level", "mode", "redundancy"]
    r_attributes = ["level", "mode", "redundancy"]
    h_attributes = []
    op_values = {'redundancy': RedundancyLevel.UNKNOWN, 'level': RaidLevel.UNKNOWN}

    @classmethod
    def name(cls):
        return u'LevelInfo'

    @classmethod
    def new_object(cls):
        return LevelInfo()


class LevelInfo(ClientObject):

    def setlevel(self, value):
        self.level = value

    def setmode(self, value):
        self.mode = value

    def setredundancy(self, value):
        self.redundancy = value

    def getlevel(self):
        return self.level

    def getmode(self):
        return self.mode

    def getredundancy(self):
        return self.redundancy
    __instantiator__ = LevelInfoInstantiator
register_instantiator('unicorn_api', LevelInfoInstantiator, True)
