#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE May 14 2014 12:22:35
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v5.sv0.raid.LevelInfo import LevelInfo

from transformer.lib import Long


class RaidLevelInfoInstantiator(Instantiator):
    version = 5
    sub_version = 0
    attributes = {
        'expansion_size': Long,
        'level_info': LevelInfo,
        'nb_devices': int,
        'nb_spares': int,
        'preferred': bool,
        'redundancy_size': Long,
        'size': Long,
    }
    w_attributes = ["expansion_size", "level_info", "nb_devices", "nb_spares", "preferred", "redundancy_size", "size"]
    r_attributes = ["expansion_size", "level_info", "nb_devices", "nb_spares", "preferred", "redundancy_size", "size"]
    h_attributes = []
    op_values = {}

    @classmethod
    def name(cls):
        return u'RaidLevelInfo'

    @classmethod
    def new_object(cls):
        return RaidLevelInfo()


class RaidLevelInfo(ClientObject):

    def setexpansion_size(self, value):
        self.expansion_size = value

    def setlevel_info(self, value):
        self.level_info = value

    def setnb_devices(self, value):
        self.nb_devices = value

    def setnb_spares(self, value):
        self.nb_spares = value

    def setpreferred(self, value):
        self.preferred = value

    def setredundancy_size(self, value):
        self.redundancy_size = value

    def setsize(self, value):
        self.size = value

    def getexpansion_size(self):
        return self.expansion_size

    def getlevel_info(self):
        return self.level_info

    def getnb_devices(self):
        return self.nb_devices

    def getnb_spares(self):
        return self.nb_spares

    def getpreferred(self):
        return self.preferred

    def getredundancy_size(self):
        return self.redundancy_size

    def getsize(self):
        return self.size
    __instantiator__ = RaidLevelInfoInstantiator
register_instantiator('unicorn_api', RaidLevelInfoInstantiator, True)
