#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE May 14 2014 12:22:35
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v5.sv0.recovery import RecoveryStatus


class RecoveryInfoInstantiator(Instantiator):
    version = 5
    sub_version = 0
    attributes = {
        'share_recovery_enabled': bool,
        'share_recovery_source': unicode,
        'share_remaining': int,
        'share_total': int,
        'status': RecoveryStatus,
        'volume_remaining': int,
        'volume_total': int,
    }
    w_attributes = []
    r_attributes = ["share_recovery_enabled", "share_recovery_source", "share_remaining", "share_total", "status", "volume_remaining", "volume_total"]
    h_attributes = []
    op_values = {}

    @classmethod
    def name(cls):
        return u'RecoveryInfo'

    @classmethod
    def new_object(cls):
        return RecoveryInfo()


class RecoveryInfo(ClientObject):

    def getshare_recovery_enabled(self):
        return self.share_recovery_enabled

    def getshare_recovery_source(self):
        return self.share_recovery_source

    def getshare_remaining(self):
        return self.share_remaining

    def getshare_total(self):
        return self.share_total

    def getstatus(self):
        return self.status

    def getvolume_remaining(self):
        return self.volume_remaining

    def getvolume_total(self):
        return self.volume_total
    __instantiator__ = RecoveryInfoInstantiator
register_instantiator('unicorn_api', RecoveryInfoInstantiator, True)
