#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE May 14 2014 12:22:35
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

from transformer.lib import Optional
from unicorn_api.v5.sv0.sharing.remote.RemoteShare import RemoteShare

from transformer.lib import ListInfo, ResultSet

from transformer.client_transport import ClientTransport
from transformer.client_serializer import ClientSerializer


class RemoteShareManager(object):


    def createRemoteShare(self, remote_share, __client__=None):
        """
        createRemoteShare: Add a new remote share
        """
        params = dict()
        params['remote_share'] = remote_share
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/sharing.remote.RemoteShareManager.createRemoteShare"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['created_remote_share']

    def createRemoteShare_async(self, remote_share, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['remote_share'] = remote_share
        url = "api/external/5.0/sharing.remote.RemoteShareManager.createRemoteShare"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def enableDFS(self, enable, __client__=None):
        """
        enableDFS enable or disable DFS functionnality
        """
        params = dict()
        params['enable'] = enable
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/sharing.remote.RemoteShareManager.enableDFS"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return 

    def enableDFS_async(self, enable, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['enable'] = enable
        url = "api/external/5.0/sharing.remote.RemoteShareManager.enableDFS"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def getSharesFromHost(self, list_info, host_name_or_ip, login, password, __client__=None):
        """
        getSharesFromHost: Returns the share list of the given host
        """
        params = dict()
        params['list_info'] = list_info
        params['host_name_or_ip'] = host_name_or_ip
        params['login'] = login
        params['password'] = password
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/sharing.remote.RemoteShareManager.getSharesFromHost"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['share_list']

    def getSharesFromHost_async(self, list_info, host_name_or_ip, login, password, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['list_info'] = list_info
        params['host_name_or_ip'] = host_name_or_ip
        params['login'] = login
        params['password'] = password
        url = "api/external/5.0/sharing.remote.RemoteShareManager.getSharesFromHost"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def isDFSEnabled(self, __client__=None):
        """
        isDFSEnabled return the status of DFS (enabled or disabled)
        """
        params = dict()

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/sharing.remote.RemoteShareManager.isDFSEnabled"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['enabled']

    def isDFSEnabled_async(self, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()

        url = "api/external/5.0/sharing.remote.RemoteShareManager.isDFSEnabled"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def isRemoteShareNameValid(self, share_name, __client__=None):
        params = dict()
        params['share_name'] = share_name
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/sharing.remote.RemoteShareManager.isRemoteShareNameValid"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return 

    def isRemoteShareNameValid_async(self, share_name, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['share_name'] = share_name
        url = "api/external/5.0/sharing.remote.RemoteShareManager.isRemoteShareNameValid"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def list(self, list_info, __client__=None):
        """
        list: Returns the local share list
        list_info: search by ID is available
        list_info: search by ENABLED is available
        """
        params = dict()
        params['list_info'] = list_info
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/sharing.remote.RemoteShareManager.list"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['share_list']

    def list_async(self, list_info, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['list_info'] = list_info
        url = "api/external/5.0/sharing.remote.RemoteShareManager.list"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def removeRemoteShare(self, share_id, __client__=None):
        """
        removeRemoteShare: Removes a share, or throw an exception if the share doesn't exist
        """
        params = dict()
        params['share_id'] = share_id
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/sharing.remote.RemoteShareManager.removeRemoteShare"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['removed_remote_share']

    def removeRemoteShare_async(self, share_id, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['share_id'] = share_id
        url = "api/external/5.0/sharing.remote.RemoteShareManager.removeRemoteShare"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def updateRemoteShare(self, share_local_id, remote_share, __client__=None):
        """
        updateRemoteShare: updates a share, or throw an exception
        update name, description, status
        """
        params = dict()
        params['share_local_id'] = share_local_id
        params['remote_share'] = remote_share
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/sharing.remote.RemoteShareManager.updateRemoteShare"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['updated_remote_share']

    def updateRemoteShare_async(self, share_local_id, remote_share, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['share_local_id'] = share_local_id
        params['remote_share'] = remote_share
        url = "api/external/5.0/sharing.remote.RemoteShareManager.updateRemoteShare"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')
