#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE May 14 2014 12:22:35
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v5.sv0.snmp import SnmpVersion
from unicorn_api.v5.sv0.snmp.Snmpv1Config import Snmpv1Config
from unicorn_api.v5.sv0.snmp.Snmpv3Config import Snmpv3Config


class SnmpConfigInstantiator(Instantiator):
    version = 5
    sub_version = 0
    attributes = {
        'contact': unicode,
        'enabled': bool,
        'location': unicode,
        'port': int,
        'v1_config': Optional(Snmpv1Config),
        'v3_config': Optional(Snmpv3Config),
        'version': SnmpVersion,
    }
    w_attributes = ["contact", "enabled", "location", "port", "v1_config", "v3_config", "version"]
    r_attributes = ["contact", "enabled", "location", "port", "v1_config", "v3_config", "version"]
    h_attributes = []
    op_values = {'v1_config': None, 'v3_config': None}

    @classmethod
    def name(cls):
        return u'SnmpConfig'

    @classmethod
    def new_object(cls):
        return SnmpConfig()


class SnmpConfig(ClientObject):

    def setcontact(self, value):
        self.contact = value

    def setenabled(self, value):
        self.enabled = value

    def setlocation(self, value):
        self.location = value

    def setport(self, value):
        self.port = value

    def setv1_config(self, value):
        self.v1_config = value

    def setv3_config(self, value):
        self.v3_config = value

    def setversion(self, value):
        self.version = value

    def getcontact(self):
        return self.contact

    def getenabled(self):
        return self.enabled

    def getlocation(self):
        return self.location

    def getport(self):
        return self.port

    def getv1_config(self):
        return self.v1_config

    def getv3_config(self):
        return self.v3_config

    def getversion(self):
        return self.version
    __instantiator__ = SnmpConfigInstantiator
register_instantiator('unicorn_api', SnmpConfigInstantiator, True)
