#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE May 14 2014 12:22:35
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v5.sv0.snmp import SnmpAuthProtocol


class Snmpv3ConfigInstantiator(Instantiator):
    version = 5
    sub_version = 0
    attributes = {
        'authEnable': bool,
        'authPassword': Optional(unicode),
        'authProtocol': Optional(SnmpAuthProtocol),
        'privPassword': Optional(unicode),
        'privacyEnable': bool,
        'v3UserName': unicode,
    }
    w_attributes = ["authEnable", "authPassword", "authProtocol", "privPassword", "privacyEnable", "v3UserName"]
    r_attributes = ["authEnable", "authPassword", "authProtocol", "privPassword", "privacyEnable", "v3UserName"]
    h_attributes = ["authPassword", "privPassword"]
    op_values = {'privPassword': None, 'authPassword': None, 'authProtocol': None}

    @classmethod
    def name(cls):
        return u'Snmpv3Config'

    @classmethod
    def new_object(cls):
        return Snmpv3Config()


class Snmpv3Config(ClientObject):

    def setauthEnable(self, value):
        self.authEnable = value

    def setauthPassword(self, value):
        self.authPassword = value

    def setauthProtocol(self, value):
        self.authProtocol = value

    def setprivPassword(self, value):
        self.privPassword = value

    def setprivacyEnable(self, value):
        self.privacyEnable = value

    def setv3UserName(self, value):
        self.v3UserName = value

    def getauthEnable(self):
        return self.authEnable

    def getauthPassword(self):
        return self.authPassword

    def getauthProtocol(self):
        return self.authProtocol

    def getprivPassword(self):
        return self.privPassword

    def getprivacyEnable(self):
        return self.privacyEnable

    def getv3UserName(self):
        return self.v3UserName
    __instantiator__ = Snmpv3ConfigInstantiator
register_instantiator('unicorn_api', Snmpv3ConfigInstantiator, True)
