#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE May 14 2014 12:22:35
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v5.sv0.support.logger import LogSeverity

from transformer.lib import Date


class LoggerEntryInstantiator(Instantiator):
    version = 5
    sub_version = 0
    attributes = {
        'category_id': unicode,
        'event_id': unicode,
        'id': int,
        'is_system': bool,
        'message': unicode,
        'severity': LogSeverity,
        'timestamp': Date,
    }
    w_attributes = []
    r_attributes = ["category_id", "event_id", "id", "is_system", "message", "severity", "timestamp"]
    h_attributes = []
    op_values = {}

    @classmethod
    def name(cls):
        return u'LoggerEntry'

    @classmethod
    def new_object(cls):
        return LoggerEntry()


class LoggerEntry(ClientObject):

    def getcategory_id(self):
        return self.category_id

    def getevent_id(self):
        return self.event_id

    def getid(self):
        return self.id

    def getis_system(self):
        return self.is_system

    def getmessage(self):
        return self.message

    def getseverity(self):
        return self.severity

    def gettimestamp(self):
        return self.timestamp
    __instantiator__ = LoggerEntryInstantiator
register_instantiator('unicorn_api', LoggerEntryInstantiator, True)
