#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE May 14 2014 12:22:35
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

from transformer.lib import Optional
from unicorn_api.v5.sv0.ups.UpsModel import UpsModel
from unicorn_api.v5.sv0.ups.NetUpsInfo import NetUpsInfo

from transformer.lib import List

from transformer.client_transport import ClientTransport
from transformer.client_serializer import ClientSerializer


class UpsAdministration(object):


    def get_enabled(self, __client__=None):
        params = dict()

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/ups.UpsAdministration.get_enabled"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['enabled']

    def get_enabled_async(self, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()

        url = "api/external/5.0/ups.UpsAdministration.get_enabled"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def list(self, __client__=None):
        params = dict()

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/ups.UpsAdministration.list"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['ups']

    def list_async(self, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()

        url = "api/external/5.0/ups.UpsAdministration.list"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def netups_scan(self, start_ip, end_ip, __client__=None):
        params = dict()
        params['start_ip'] = start_ip
        params['end_ip'] = end_ip
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/ups.UpsAdministration.netups_scan"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['netups_list']

    def netups_scan_async(self, start_ip, end_ip, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['start_ip'] = start_ip
        params['end_ip'] = end_ip
        url = "api/external/5.0/ups.UpsAdministration.netups_scan"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def remove(self, ups_id, __client__=None):
        params = dict()
        params['ups_id'] = ups_id
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/ups.UpsAdministration.remove"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return 

    def remove_async(self, ups_id, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['ups_id'] = ups_id
        url = "api/external/5.0/ups.UpsAdministration.remove"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def set_enabled(self, enabled, __client__=None):
        params = dict()
        params['enabled'] = enabled
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/ups.UpsAdministration.set_enabled"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['enabled']

    def set_enabled_async(self, enabled, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['enabled'] = enabled
        url = "api/external/5.0/ups.UpsAdministration.set_enabled"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def set_server_on(self, ups_id, enabled, __client__=None):
        params = dict()
        params['ups_id'] = ups_id
        params['enabled'] = enabled
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/ups.UpsAdministration.set_server_on"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['ups']

    def set_server_on_async(self, ups_id, enabled, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['ups_id'] = ups_id
        params['enabled'] = enabled
        url = "api/external/5.0/ups.UpsAdministration.set_server_on"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def set_slave_mode(self, master_ip_or_hostname, __client__=None):
        params = dict()
        params['master_ip_or_hostname'] = master_ip_or_hostname
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/ups.UpsAdministration.set_slave_mode"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['ups']

    def set_slave_mode_async(self, master_ip_or_hostname, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['master_ip_or_hostname'] = master_ip_or_hostname
        url = "api/external/5.0/ups.UpsAdministration.set_slave_mode"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def set_snmp_mode(self, device_ip, snmp_community, __client__=None):
        params = dict()
        params['device_ip'] = device_ip
        params['snmp_community'] = snmp_community
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/ups.UpsAdministration.set_snmp_mode"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['ups']

    def set_snmp_mode_async(self, device_ip, snmp_community, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['device_ip'] = device_ip
        params['snmp_community'] = snmp_community
        url = "api/external/5.0/ups.UpsAdministration.set_snmp_mode"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def set_threshold(self, ups_id, threshold, __client__=None):
        params = dict()
        params['ups_id'] = ups_id
        params['threshold'] = threshold
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/ups.UpsAdministration.set_threshold"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['ups']

    def set_threshold_async(self, ups_id, threshold, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['ups_id'] = ups_id
        params['threshold'] = threshold
        url = "api/external/5.0/ups.UpsAdministration.set_threshold"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')
