#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE May 14 2014 12:22:35
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v5.sv0.ups import UpsMode


class UpsModelInstantiator(Instantiator):
    version = 5
    sub_version = 0
    attributes = {
        'ac_power': bool,
        'charge': int,
        'critical': bool,
        'enabled': bool,
        'id': int,
        'master_ip': unicode,
        'mode': UpsMode,
        'model': unicode,
        'server_on': bool,
        'snmp_community': unicode,
        'snmp_ip': unicode,
        'threshold': int,
    }
    w_attributes = []
    r_attributes = ["ac_power", "charge", "critical", "enabled", "id", "master_ip", "mode", "model", "server_on", "snmp_community", "snmp_ip", "threshold"]
    h_attributes = []
    op_values = {}

    @classmethod
    def name(cls):
        return u'UpsModel'

    @classmethod
    def new_object(cls):
        return UpsModel()


class UpsModel(ClientObject):

    def getac_power(self):
        return self.ac_power

    def getcharge(self):
        return self.charge

    def getcritical(self):
        return self.critical

    def getenabled(self):
        return self.enabled

    def getid(self):
        return self.id

    def getmaster_ip(self):
        return self.master_ip

    def getmode(self):
        return self.mode

    def getmodel(self):
        return self.model

    def getserver_on(self):
        return self.server_on

    def getsnmp_community(self):
        return self.snmp_community

    def getsnmp_ip(self):
        return self.snmp_ip

    def getthreshold(self):
        return self.threshold
    __instantiator__ = UpsModelInstantiator
register_instantiator('unicorn_api', UpsModelInstantiator, True)
