#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE May 14 2014 12:22:35
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

from transformer.lib import Optional
from unicorn_api.v5.sv0.user_group_share.ShareUserAccess import ShareUserAccess
from unicorn_api.v5.sv0.user_group_share.ShareGroupAccess import ShareGroupAccess
from unicorn_api.v5.sv0.user_group_share.IDAccessStruct import IDAccessStruct
from unicorn_api.v5.sv0.user_group_share.UserAccessThrough import UserAccessThrough
from unicorn_api.v5.sv0.sharing.ShareAccessThrough import ShareAccessThrough

from transformer.lib import ListInfo, ResultSet, List

from transformer.client_transport import ClientTransport
from transformer.client_serializer import ClientSerializer


class ShareAccess(object):


    def add_group_to_shares(self, group_id, shares, __client__=None):
        params = dict()
        params['group_id'] = group_id
        params['shares'] = shares
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/user_group_share.ShareAccess.add_group_to_shares"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['errors']

    def add_group_to_shares_async(self, group_id, shares, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['group_id'] = group_id
        params['shares'] = shares
        url = "api/external/5.0/user_group_share.ShareAccess.add_group_to_shares"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def add_share_access_for_group(self, share_id, group_struct, __client__=None):
        params = dict()
        params['share_id'] = share_id
        params['group_struct'] = group_struct
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/user_group_share.ShareAccess.add_share_access_for_group"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['share_access']

    def add_share_access_for_group_async(self, share_id, group_struct, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['share_id'] = share_id
        params['group_struct'] = group_struct
        url = "api/external/5.0/user_group_share.ShareAccess.add_share_access_for_group"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def add_share_access_for_groups(self, share_id, groups, __client__=None):
        params = dict()
        params['share_id'] = share_id
        params['groups'] = groups
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/user_group_share.ShareAccess.add_share_access_for_groups"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['errors']

    def add_share_access_for_groups_async(self, share_id, groups, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['share_id'] = share_id
        params['groups'] = groups
        url = "api/external/5.0/user_group_share.ShareAccess.add_share_access_for_groups"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def add_share_access_for_user(self, share_id, user_struct, __client__=None):
        params = dict()
        params['share_id'] = share_id
        params['user_struct'] = user_struct
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/user_group_share.ShareAccess.add_share_access_for_user"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['share_access']

    def add_share_access_for_user_async(self, share_id, user_struct, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['share_id'] = share_id
        params['user_struct'] = user_struct
        url = "api/external/5.0/user_group_share.ShareAccess.add_share_access_for_user"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def add_share_access_for_users(self, share_id, users, __client__=None):
        params = dict()
        params['share_id'] = share_id
        params['users'] = users
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/user_group_share.ShareAccess.add_share_access_for_users"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['errors']

    def add_share_access_for_users_async(self, share_id, users, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['share_id'] = share_id
        params['users'] = users
        url = "api/external/5.0/user_group_share.ShareAccess.add_share_access_for_users"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def add_user_to_shares(self, group_id, shares, __client__=None):
        params = dict()
        params['group_id'] = group_id
        params['shares'] = shares
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/user_group_share.ShareAccess.add_user_to_shares"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['errors']

    def add_user_to_shares_async(self, group_id, shares, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['group_id'] = group_id
        params['shares'] = shares
        url = "api/external/5.0/user_group_share.ShareAccess.add_user_to_shares"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def del_share_access_for_group(self, share_id, user_id, __client__=None):
        params = dict()
        params['share_id'] = share_id
        params['user_id'] = user_id
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/user_group_share.ShareAccess.del_share_access_for_group"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return 

    def del_share_access_for_group_async(self, share_id, user_id, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['share_id'] = share_id
        params['user_id'] = user_id
        url = "api/external/5.0/user_group_share.ShareAccess.del_share_access_for_group"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def del_share_access_for_groups(self, share_id, groups_id, __client__=None):
        params = dict()
        params['share_id'] = share_id
        params['groups_id'] = groups_id
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/user_group_share.ShareAccess.del_share_access_for_groups"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['errors']

    def del_share_access_for_groups_async(self, share_id, groups_id, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['share_id'] = share_id
        params['groups_id'] = groups_id
        url = "api/external/5.0/user_group_share.ShareAccess.del_share_access_for_groups"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def del_share_access_for_user(self, share_id, user_id, __client__=None):
        params = dict()
        params['share_id'] = share_id
        params['user_id'] = user_id
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/user_group_share.ShareAccess.del_share_access_for_user"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return 

    def del_share_access_for_user_async(self, share_id, user_id, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['share_id'] = share_id
        params['user_id'] = user_id
        url = "api/external/5.0/user_group_share.ShareAccess.del_share_access_for_user"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def del_share_access_for_users(self, share_id, users_id, __client__=None):
        params = dict()
        params['share_id'] = share_id
        params['users_id'] = users_id
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/user_group_share.ShareAccess.del_share_access_for_users"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['errors']

    def del_share_access_for_users_async(self, share_id, users_id, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['share_id'] = share_id
        params['users_id'] = users_id
        url = "api/external/5.0/user_group_share.ShareAccess.del_share_access_for_users"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def group_shares(self, group_id, list_info, __client__=None):
        params = dict()
        params['group_id'] = group_id
        params['list_info'] = list_info
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/user_group_share.ShareAccess.group_shares"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['share_access']

    def group_shares_async(self, group_id, list_info, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['group_id'] = group_id
        params['list_info'] = list_info
        url = "api/external/5.0/user_group_share.ShareAccess.group_shares"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def groups_in_share(self, share_id, list_info, __client__=None):
        params = dict()
        params['share_id'] = share_id
        params['list_info'] = list_info
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/user_group_share.ShareAccess.groups_in_share"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['share_access']

    def groups_in_share_async(self, share_id, list_info, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['share_id'] = share_id
        params['list_info'] = list_info
        url = "api/external/5.0/user_group_share.ShareAccess.groups_in_share"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def modify_groups_access_for_share(self, share_id, groups_struct, __client__=None):
        params = dict()
        params['share_id'] = share_id
        params['groups_struct'] = groups_struct
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/user_group_share.ShareAccess.modify_groups_access_for_share"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['errors']

    def modify_groups_access_for_share_async(self, share_id, groups_struct, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['share_id'] = share_id
        params['groups_struct'] = groups_struct
        url = "api/external/5.0/user_group_share.ShareAccess.modify_groups_access_for_share"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def modify_share_access_for_group(self, share_id, group_struct, __client__=None):
        params = dict()
        params['share_id'] = share_id
        params['group_struct'] = group_struct
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/user_group_share.ShareAccess.modify_share_access_for_group"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['share_access']

    def modify_share_access_for_group_async(self, share_id, group_struct, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['share_id'] = share_id
        params['group_struct'] = group_struct
        url = "api/external/5.0/user_group_share.ShareAccess.modify_share_access_for_group"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def modify_share_access_for_user(self, share_id, user_struct, __client__=None):
        params = dict()
        params['share_id'] = share_id
        params['user_struct'] = user_struct
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/user_group_share.ShareAccess.modify_share_access_for_user"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['share_access']

    def modify_share_access_for_user_async(self, share_id, user_struct, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['share_id'] = share_id
        params['user_struct'] = user_struct
        url = "api/external/5.0/user_group_share.ShareAccess.modify_share_access_for_user"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def modify_shares_access_for_group(self, group_id, shares_struct, __client__=None):
        params = dict()
        params['group_id'] = group_id
        params['shares_struct'] = shares_struct
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/user_group_share.ShareAccess.modify_shares_access_for_group"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['errors']

    def modify_shares_access_for_group_async(self, group_id, shares_struct, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['group_id'] = group_id
        params['shares_struct'] = shares_struct
        url = "api/external/5.0/user_group_share.ShareAccess.modify_shares_access_for_group"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def modify_shares_access_for_user(self, user_id, shares_struct, __client__=None):
        params = dict()
        params['user_id'] = user_id
        params['shares_struct'] = shares_struct
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/user_group_share.ShareAccess.modify_shares_access_for_user"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['errors']

    def modify_shares_access_for_user_async(self, user_id, shares_struct, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['user_id'] = user_id
        params['shares_struct'] = shares_struct
        url = "api/external/5.0/user_group_share.ShareAccess.modify_shares_access_for_user"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def modify_users_access_for_share(self, share_id, users_struct, __client__=None):
        params = dict()
        params['share_id'] = share_id
        params['users_struct'] = users_struct
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/user_group_share.ShareAccess.modify_users_access_for_share"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['errors']

    def modify_users_access_for_share_async(self, share_id, users_struct, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['share_id'] = share_id
        params['users_struct'] = users_struct
        url = "api/external/5.0/user_group_share.ShareAccess.modify_users_access_for_share"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def remove_group_from_shares(self, group_id, shares_id, __client__=None):
        params = dict()
        params['group_id'] = group_id
        params['shares_id'] = shares_id
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/user_group_share.ShareAccess.remove_group_from_shares"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['errors']

    def remove_group_from_shares_async(self, group_id, shares_id, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['group_id'] = group_id
        params['shares_id'] = shares_id
        url = "api/external/5.0/user_group_share.ShareAccess.remove_group_from_shares"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def remove_user_from_shares(self, user_id, shares_id, __client__=None):
        params = dict()
        params['user_id'] = user_id
        params['shares_id'] = shares_id
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/user_group_share.ShareAccess.remove_user_from_shares"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['errors']

    def remove_user_from_shares_async(self, user_id, shares_id, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['user_id'] = user_id
        params['shares_id'] = shares_id
        url = "api/external/5.0/user_group_share.ShareAccess.remove_user_from_shares"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def shares_accessed_by_user(self, user_id, list_info, __client__=None):
        params = dict()
        params['user_id'] = user_id
        params['list_info'] = list_info
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/user_group_share.ShareAccess.shares_accessed_by_user"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['throughs']

    def shares_accessed_by_user_async(self, user_id, list_info, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['user_id'] = user_id
        params['list_info'] = list_info
        url = "api/external/5.0/user_group_share.ShareAccess.shares_accessed_by_user"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def user_shares(self, user_id, list_info, __client__=None):
        params = dict()
        params['user_id'] = user_id
        params['list_info'] = list_info
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/user_group_share.ShareAccess.user_shares"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['share_access']

    def user_shares_async(self, user_id, list_info, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['user_id'] = user_id
        params['list_info'] = list_info
        url = "api/external/5.0/user_group_share.ShareAccess.user_shares"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def users_accessing_to_share(self, share_id, list_info, __client__=None):
        params = dict()
        params['share_id'] = share_id
        params['list_info'] = list_info
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/user_group_share.ShareAccess.users_accessing_to_share"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['throughs']

    def users_accessing_to_share_async(self, share_id, list_info, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['share_id'] = share_id
        params['list_info'] = list_info
        url = "api/external/5.0/user_group_share.ShareAccess.users_accessing_to_share"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def users_in_share(self, share_id, list_info, __client__=None):
        params = dict()
        params['share_id'] = share_id
        params['list_info'] = list_info
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/user_group_share.ShareAccess.users_in_share"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['share_access']

    def users_in_share_async(self, share_id, list_info, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['share_id'] = share_id
        params['list_info'] = list_info
        url = "api/external/5.0/user_group_share.ShareAccess.users_in_share"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')
