#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE May 14 2014 12:22:35
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v5.sv0.user_group_share import UserType


class UserInstantiator(Instantiator):
    version = 5
    sub_version = 0
    attributes = {
        'comment': Optional(unicode),
        'domain_name': unicode,
        'email': Optional(unicode),
        'group_count': int,
        'id': int,
        'is_admin': bool,
        'is_enabled': bool,
        'login': unicode,
        'password': Optional(unicode),
        'share_count': int,
        'sid': Optional(unicode),
        'type': UserType,
    }
    w_attributes = ["comment", "email", "is_admin", "login", "password", "sid", "type"]
    r_attributes = ["comment", "domain_name", "email", "group_count", "id", "is_admin", "is_enabled", "login", "share_count", "sid", "type"]
    h_attributes = ["group_count", "share_count"]
    op_values = {'comment': u"", 'password': None, 'email': u"", 'sid': u""}

    @classmethod
    def name(cls):
        return u'User'

    @classmethod
    def new_object(cls):
        return User()


class User(ClientObject):

    def setcomment(self, value):
        self.comment = value

    def setemail(self, value):
        self.email = value

    def setis_admin(self, value):
        self.is_admin = value

    def setlogin(self, value):
        self.login = value

    def setpassword(self, value):
        self.password = value

    def setsid(self, value):
        self.sid = value

    def settype(self, value):
        self.type = value

    def getcomment(self):
        return self.comment

    def getdomain_name(self):
        return self.domain_name

    def getemail(self):
        return self.email

    def getgroup_count(self):
        return self.group_count

    def getid(self):
        return self.id

    def getis_admin(self):
        return self.is_admin

    def getis_enabled(self):
        return self.is_enabled

    def getlogin(self):
        return self.login

    def getshare_count(self):
        return self.share_count

    def getsid(self):
        return self.sid

    def gettype(self):
        return self.type
    __instantiator__ = UserInstantiator
register_instantiator('unicorn_api', UserInstantiator, True)
