from argparse import ArgumentParser, Action
import sys
import os
from transformer.lib import ListInfo, Dict, List
from transformer.lib.errors import ClientError
from transformer.lib.cli import (cli_list_info, list_cli,              dict_cli, cli_int, cli_long, cli_unicode, cli_date, cli_bool)
import unicorn_api.errors
try:
	from transformer.plugins.lacie import LacieClientAuthentication
	lacie_auth = LacieClientAuthentication()
except:
	lacie_auth = None
try:
	from transformer.plugins.application import ApplicationClientAuthentication
	app_auth = ApplicationClientAuthentication()
except:
	app_auth = None
function = None
func_args = []
interactive = None
methods = {}
def main():
	global function, func_args
	parser = ArgumentParser(description='This cli is generated and will allow sending some requests to a given NAS.\nunicorn_api -i ipaddress -u user_name -p user_password --myrequest param1 param2\nIf the param expected is a list use the "," seperator\nIf the param expected is an object, separate the fieldname and the value by a ":" \nand separate the different fields with a ",". \nIf you want to provide an empty field, just add "" on the command line\nIf the field expected is a boolean values are 0 or 1\n', add_help=False)
	parser.add_argument("--all", action="store_true", dest="all", default=False, help="Return all the available requests")
	parser.add_argument("--interactive", action="store_true", dest="interactive", default=False, help="Interactive call. You'll be prompted for requiered fields")
	parser.add_argument("-i","--ip", action="store", dest="ip", type=unicode, default=None)
	parser.add_argument("-a", "--async", action="store", dest="async", type=int, default=None, help="Provided job id it will return current job status")
	parser.add_argument("-s", "--search", action="store", nargs='+', metavar='search_param ...', dest="search", default=None, help="Search for a strings in the available requests.")
	parser.add_argument("--port", action="store", dest="port", default=None, type=int)
	if lacie_auth is not None:
		parser.add_argument("-u","--user", action="store", dest="user", default=None)
		parser.add_argument("-p","--password", action="store", dest="password", type=unicode, default=None)
	if app_auth is not None:
		parser.add_argument("--app", action="store", dest="app", default=None, nargs=2, metavar=('app_id', 'app_token'))
		parser.add_argument("--app_token", action="store", dest="app_token", default=None, type=unicode)
		parser.add_argument("--app_session", action="store", dest="app_session", default=None, type=unicode)
		parser.add_argument("--app_user", action="store", dest="app_user", default=None, type=unicode)
		parser.add_argument("--register_app", action="store", dest="register_app", default=None, nargs=3, metavar=('app_id', 'mandatory_perms', 'optionals_perms'), help='Call the register app method')
		parser.add_argument("--unregister_app", action="store", dest="unregister_app", default=None, nargs=2, metavar=('app_id', 'app_token'), help='Call the unregister app method')
		parser.add_argument("--register_status", action="store", dest="register_status", default=None, type=int, help='Get current registration status')
		parser.add_argument("--open_session", action="store_true", dest="open_session", help='Get application session token', default=None)
	if len(sys.argv) == 2 and ("-h" in sys.argv or "--help" in sys.argv):
		parser.print_help()
		return
	(options, args) = parser.parse_known_args()
	search = False
	interactive_mode = options.interactive
	if options.search is not None:
		search = True
	subparsers = parser.add_subparsers()
	btsync_BtsyncAdministration = subparsers.add_parser('btsync_BtsyncAdministration', help="help btsync.BtsyncAdministration")
	class btsync_BtsyncAdministration_set_upload_limitAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.btsync.BtsyncConf import BtsyncConf
			from unicorn_api.v5.sv0.btsync.BtsyncShare import BtsyncShare

			from transformer.lib import List, ListInfo, ResultSet
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.btsync.BtsyncAdministration import BtsyncAdministration
			service = BtsyncAdministration()
			global function, interactive
			function = service.set_upload_limit
			interactive = []
			interactive.append(('ul_value', cli_int))
	methods['btsync.BtsyncAdministration.set_upload_limit'] = ('btsync_BtsyncAdministration', '--set_upload_limit')
	metavars = () if interactive_mode else ('ul_value')
	help = '' if interactive_mode else '%s ' % ('int')
	nargs = 0 if interactive_mode else 1
	btsync_BtsyncAdministration.add_argument("--set_upload_limit", action=btsync_BtsyncAdministration_set_upload_limitAction, nargs=nargs, metavar=metavars, help=help)
	class btsync_BtsyncAdministration_remove_btsyncAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.btsync.BtsyncConf import BtsyncConf
			from unicorn_api.v5.sv0.btsync.BtsyncShare import BtsyncShare

			from transformer.lib import List, ListInfo, ResultSet
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.btsync.BtsyncAdministration import BtsyncAdministration
			service = BtsyncAdministration()
			global function, interactive
			function = service.remove_btsync
			interactive = []
			interactive.append(('share_id', cli_int))
	methods['btsync.BtsyncAdministration.remove_btsync'] = ('btsync_BtsyncAdministration', '--remove_btsync')
	metavars = () if interactive_mode else ('share_id')
	help = '' if interactive_mode else '%s ' % ('int')
	nargs = 0 if interactive_mode else 1
	btsync_BtsyncAdministration.add_argument("--remove_btsync", action=btsync_BtsyncAdministration_remove_btsyncAction, nargs=nargs, metavar=metavars, help=help)
	class btsync_BtsyncAdministration_set_use_upnpAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.btsync.BtsyncConf import BtsyncConf
			from unicorn_api.v5.sv0.btsync.BtsyncShare import BtsyncShare

			from transformer.lib import List, ListInfo, ResultSet
			checker = [cli_bool]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.btsync.BtsyncAdministration import BtsyncAdministration
			service = BtsyncAdministration()
			global function, interactive
			function = service.set_use_upnp
			interactive = []
			interactive.append(('enabled', cli_bool))
	methods['btsync.BtsyncAdministration.set_use_upnp'] = ('btsync_BtsyncAdministration', '--set_use_upnp')
	metavars = () if interactive_mode else ('enabled')
	help = '' if interactive_mode else '%s ' % ('True|False')
	nargs = 0 if interactive_mode else 1
	btsync_BtsyncAdministration.add_argument("--set_use_upnp", action=btsync_BtsyncAdministration_set_use_upnpAction, nargs=nargs, metavar=metavars, help=help)
	class btsync_BtsyncAdministration_listAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.btsync.BtsyncConf import BtsyncConf
			from unicorn_api.v5.sv0.btsync.BtsyncShare import BtsyncShare

			from transformer.lib import List, ListInfo, ResultSet
			checker = [list_cli(unicode),cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.btsync.BtsyncAdministration import BtsyncAdministration
			service = BtsyncAdministration()
			global function, interactive
			function = service.list
			interactive = []
			interactive.append(('with_parameters', list_cli(unicode)))
			interactive.append(('list_info', cli_list_info))
	methods['btsync.BtsyncAdministration.list'] = ('btsync_BtsyncAdministration', '--list')
	metavars = () if interactive_mode else ('with_parameters','list_info')
	help = '' if interactive_mode else '%s %s ' % ('["text",...]', 'offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 2
	btsync_BtsyncAdministration.add_argument("--list", action=btsync_BtsyncAdministration_listAction, nargs=nargs, metavar=metavars, help=help)
	class btsync_BtsyncAdministration_update_btsyncAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.btsync.BtsyncConf import BtsyncConf
			from unicorn_api.v5.sv0.btsync.BtsyncShare import BtsyncShare

			from transformer.lib import List, ListInfo, ResultSet
			checker = [cli_int,BtsyncShare]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.btsync.BtsyncAdministration import BtsyncAdministration
			service = BtsyncAdministration()
			global function, interactive
			function = service.update_btsync
			interactive = []
			interactive.append(('share_id', cli_int))
			interactive.append(('new_btsync_share_conf', BtsyncShare))
	methods['btsync.BtsyncAdministration.update_btsync'] = ('btsync_BtsyncAdministration', '--update_btsync')
	metavars = () if interactive_mode else ('share_id','new_btsync_share_conf')
	help = '' if interactive_mode else '%s %s ' % ('int', '{"use_relay_server":True|False,"use_sync_trash":True|False,"enabled":True|False,"secret":text,"use_tracker":True|False,"use_dht":True|False,"search_lan":True|False}')
	nargs = 0 if interactive_mode else 2
	btsync_BtsyncAdministration.add_argument("--update_btsync", action=btsync_BtsyncAdministration_update_btsyncAction, nargs=nargs, metavar=metavars, help=help)
	class btsync_BtsyncAdministration_set_download_limitAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.btsync.BtsyncConf import BtsyncConf
			from unicorn_api.v5.sv0.btsync.BtsyncShare import BtsyncShare

			from transformer.lib import List, ListInfo, ResultSet
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.btsync.BtsyncAdministration import BtsyncAdministration
			service = BtsyncAdministration()
			global function, interactive
			function = service.set_download_limit
			interactive = []
			interactive.append(('dl_value', cli_int))
	methods['btsync.BtsyncAdministration.set_download_limit'] = ('btsync_BtsyncAdministration', '--set_download_limit')
	metavars = () if interactive_mode else ('dl_value')
	help = '' if interactive_mode else '%s ' % ('int')
	nargs = 0 if interactive_mode else 1
	btsync_BtsyncAdministration.add_argument("--set_download_limit", action=btsync_BtsyncAdministration_set_download_limitAction, nargs=nargs, metavar=metavars, help=help)
	class btsync_BtsyncAdministration_get_configAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.btsync.BtsyncConf import BtsyncConf
			from unicorn_api.v5.sv0.btsync.BtsyncShare import BtsyncShare

			from transformer.lib import List, ListInfo, ResultSet
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.btsync.BtsyncAdministration import BtsyncAdministration
			service = BtsyncAdministration()
			global function, interactive
			function = service.get_config
			interactive = []
	methods['btsync.BtsyncAdministration.get_config'] = ('btsync_BtsyncAdministration', '--get_config')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	btsync_BtsyncAdministration.add_argument("--get_config", action=btsync_BtsyncAdministration_get_configAction, nargs=nargs, metavar=metavars, help=help)
	class btsync_BtsyncAdministration_set_enabledAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.btsync.BtsyncConf import BtsyncConf
			from unicorn_api.v5.sv0.btsync.BtsyncShare import BtsyncShare

			from transformer.lib import List, ListInfo, ResultSet
			checker = [cli_bool]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.btsync.BtsyncAdministration import BtsyncAdministration
			service = BtsyncAdministration()
			global function, interactive
			function = service.set_enabled
			interactive = []
			interactive.append(('enabled', cli_bool))
	methods['btsync.BtsyncAdministration.set_enabled'] = ('btsync_BtsyncAdministration', '--set_enabled')
	metavars = () if interactive_mode else ('enabled')
	help = '' if interactive_mode else '%s ' % ('True|False')
	nargs = 0 if interactive_mode else 1
	btsync_BtsyncAdministration.add_argument("--set_enabled", action=btsync_BtsyncAdministration_set_enabledAction, nargs=nargs, metavar=metavars, help=help)
	class btsync_BtsyncAdministration_enable_btsyncAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.btsync.BtsyncConf import BtsyncConf
			from unicorn_api.v5.sv0.btsync.BtsyncShare import BtsyncShare

			from transformer.lib import List, ListInfo, ResultSet
			checker = [cli_int,cli_bool]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.btsync.BtsyncAdministration import BtsyncAdministration
			service = BtsyncAdministration()
			global function, interactive
			function = service.enable_btsync
			interactive = []
			interactive.append(('share_id', cli_int))
			interactive.append(('enable', cli_bool))
	methods['btsync.BtsyncAdministration.enable_btsync'] = ('btsync_BtsyncAdministration', '--enable_btsync')
	metavars = () if interactive_mode else ('share_id','enable')
	help = '' if interactive_mode else '%s %s ' % ('int', 'True|False')
	nargs = 0 if interactive_mode else 2
	btsync_BtsyncAdministration.add_argument("--enable_btsync", action=btsync_BtsyncAdministration_enable_btsyncAction, nargs=nargs, metavar=metavars, help=help)
	class btsync_BtsyncAdministration_generate_secretAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.btsync.BtsyncConf import BtsyncConf
			from unicorn_api.v5.sv0.btsync.BtsyncShare import BtsyncShare

			from transformer.lib import List, ListInfo, ResultSet
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.btsync.BtsyncAdministration import BtsyncAdministration
			service = BtsyncAdministration()
			global function, interactive
			function = service.generate_secret
			interactive = []
			interactive.append(('share_id', cli_int))
	methods['btsync.BtsyncAdministration.generate_secret'] = ('btsync_BtsyncAdministration', '--generate_secret')
	metavars = () if interactive_mode else ('share_id')
	help = '' if interactive_mode else '%s ' % ('int')
	nargs = 0 if interactive_mode else 1
	btsync_BtsyncAdministration.add_argument("--generate_secret", action=btsync_BtsyncAdministration_generate_secretAction, nargs=nargs, metavar=metavars, help=help)
	services_ItunesServiceAdministration = subparsers.add_parser('services_ItunesServiceAdministration', help="help services.ItunesServiceAdministration")
	class services_ItunesServiceAdministration_force_rescanAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.services.ItunesServiceAdministration import ItunesServiceAdministration
			service = ItunesServiceAdministration()
			global function, interactive
			function = service.force_rescan
			interactive = []
	methods['services.ItunesServiceAdministration.force_rescan'] = ('services_ItunesServiceAdministration', '--force_rescan')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	services_ItunesServiceAdministration.add_argument("--force_rescan", action=services_ItunesServiceAdministration_force_rescanAction, nargs=nargs, metavar=metavars, help=help)
	simple_sharing_SimpleSharing = subparsers.add_parser('simple_sharing_SimpleSharing', help="help simple_sharing.SimpleSharing")
	class simple_sharing_SimpleSharing_get_public_sharesAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.simple_sharing.SimpleUser import SimpleUser
			from unicorn_api.v5.sv0.sharing.Share import Share

			from transformer.lib import List, ListInfo, ResultSet
			checker = [list_cli(unicode),cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.simple_sharing.SimpleSharing import SimpleSharing
			service = SimpleSharing()
			global function, interactive
			function = service.get_public_shares
			interactive = []
			interactive.append(('with_parameters', list_cli(unicode)))
			interactive.append(('list_info', cli_list_info))
	methods['simple_sharing.SimpleSharing.get_public_shares'] = ('simple_sharing_SimpleSharing', '--get_public_shares')
	metavars = () if interactive_mode else ('with_parameters','list_info')
	help = '' if interactive_mode else '%s %s ' % ('["text",...]', 'offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 2
	simple_sharing_SimpleSharing.add_argument("--get_public_shares", action=simple_sharing_SimpleSharing_get_public_sharesAction, nargs=nargs, metavar=metavars, help=help)
	class simple_sharing_SimpleSharing_create_public_shareAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.simple_sharing.SimpleUser import SimpleUser
			from unicorn_api.v5.sv0.sharing.Share import Share

			from transformer.lib import List, ListInfo, ResultSet
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.simple_sharing.SimpleSharing import SimpleSharing
			service = SimpleSharing()
			global function, interactive
			function = service.create_public_share
			interactive = []
			interactive.append(('name', cli_unicode))
	methods['simple_sharing.SimpleSharing.create_public_share'] = ('simple_sharing_SimpleSharing', '--create_public_share')
	metavars = () if interactive_mode else ('name')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 1
	simple_sharing_SimpleSharing.add_argument("--create_public_share", action=simple_sharing_SimpleSharing_create_public_shareAction, nargs=nargs, metavar=metavars, help=help)
	class simple_sharing_SimpleSharing_delete_public_shareAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.simple_sharing.SimpleUser import SimpleUser
			from unicorn_api.v5.sv0.sharing.Share import Share

			from transformer.lib import List, ListInfo, ResultSet
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.simple_sharing.SimpleSharing import SimpleSharing
			service = SimpleSharing()
			global function, interactive
			function = service.delete_public_share
			interactive = []
			interactive.append(('id', cli_int))
	methods['simple_sharing.SimpleSharing.delete_public_share'] = ('simple_sharing_SimpleSharing', '--delete_public_share')
	metavars = () if interactive_mode else ('id')
	help = '' if interactive_mode else '%s ' % ('int')
	nargs = 0 if interactive_mode else 1
	simple_sharing_SimpleSharing.add_argument("--delete_public_share", action=simple_sharing_SimpleSharing_delete_public_shareAction, nargs=nargs, metavar=metavars, help=help)
	class simple_sharing_SimpleSharing_list_usersAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.simple_sharing.SimpleUser import SimpleUser
			from unicorn_api.v5.sv0.sharing.Share import Share

			from transformer.lib import List, ListInfo, ResultSet
			checker = [list_cli(unicode),cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.simple_sharing.SimpleSharing import SimpleSharing
			service = SimpleSharing()
			global function, interactive
			function = service.list_users
			interactive = []
			interactive.append(('with_parameters', list_cli(unicode)))
			interactive.append(('list_info', cli_list_info))
	methods['simple_sharing.SimpleSharing.list_users'] = ('simple_sharing_SimpleSharing', '--list_users')
	metavars = () if interactive_mode else ('with_parameters','list_info')
	help = '' if interactive_mode else '%s %s ' % ('["text",...]', 'offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 2
	simple_sharing_SimpleSharing.add_argument("--list_users", action=simple_sharing_SimpleSharing_list_usersAction, nargs=nargs, metavar=metavars, help=help)
	class simple_sharing_SimpleSharing_modifyAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.simple_sharing.SimpleUser import SimpleUser
			from unicorn_api.v5.sv0.sharing.Share import Share

			from transformer.lib import List, ListInfo, ResultSet
			checker = [cli_int,SimpleUser]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.simple_sharing.SimpleSharing import SimpleSharing
			service = SimpleSharing()
			global function, interactive
			function = service.modify
			interactive = []
			interactive.append(('user_id', cli_int))
			interactive.append(('user', SimpleUser))
	methods['simple_sharing.SimpleSharing.modify'] = ('simple_sharing_SimpleSharing', '--modify')
	metavars = () if interactive_mode else ('user_id','user')
	help = '' if interactive_mode else '%s %s ' % ('int', '{"is_admin":True|False,"login":text,#"comment":text#,#"quota":{"quota":long}#,#"password":text#,#"email":text#}')
	nargs = 0 if interactive_mode else 2
	simple_sharing_SimpleSharing.add_argument("--modify", action=simple_sharing_SimpleSharing_modifyAction, nargs=nargs, metavar=metavars, help=help)
	class simple_sharing_SimpleSharing_remove_userAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.simple_sharing.SimpleUser import SimpleUser
			from unicorn_api.v5.sv0.sharing.Share import Share

			from transformer.lib import List, ListInfo, ResultSet
			checker = [cli_int,cli_bool]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.simple_sharing.SimpleSharing import SimpleSharing
			service = SimpleSharing()
			global function, interactive
			function = service.remove_user
			interactive = []
			interactive.append(('user_id', cli_int))
			interactive.append(('remove_share', cli_bool))
	methods['simple_sharing.SimpleSharing.remove_user'] = ('simple_sharing_SimpleSharing', '--remove_user')
	metavars = () if interactive_mode else ('user_id','remove_share')
	help = '' if interactive_mode else '%s %s ' % ('int', 'True|False')
	nargs = 0 if interactive_mode else 2
	simple_sharing_SimpleSharing.add_argument("--remove_user", action=simple_sharing_SimpleSharing_remove_userAction, nargs=nargs, metavar=metavars, help=help)
	class simple_sharing_SimpleSharing_add_userAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.simple_sharing.SimpleUser import SimpleUser
			from unicorn_api.v5.sv0.sharing.Share import Share

			from transformer.lib import List, ListInfo, ResultSet
			checker = [SimpleUser]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.simple_sharing.SimpleSharing import SimpleSharing
			service = SimpleSharing()
			global function, interactive
			function = service.add_user
			interactive = []
			interactive.append(('user', SimpleUser))
	methods['simple_sharing.SimpleSharing.add_user'] = ('simple_sharing_SimpleSharing', '--add_user')
	metavars = () if interactive_mode else ('user')
	help = '' if interactive_mode else '%s ' % ('{"is_admin":True|False,"login":text,#"comment":text#,#"quota":{"quota":long}#,#"password":text#,#"email":text#}')
	nargs = 0 if interactive_mode else 1
	simple_sharing_SimpleSharing.add_argument("--add_user", action=simple_sharing_SimpleSharing_add_userAction, nargs=nargs, metavar=metavars, help=help)
	class simple_sharing_SimpleSharing_modify_public_shareAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.simple_sharing.SimpleUser import SimpleUser
			from unicorn_api.v5.sv0.sharing.Share import Share

			from transformer.lib import List, ListInfo, ResultSet
			checker = [cli_int,Share]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.simple_sharing.SimpleSharing import SimpleSharing
			service = SimpleSharing()
			global function, interactive
			function = service.modify_public_share
			interactive = []
			interactive.append(('id', cli_int))
			interactive.append(('share', Share))
	methods['simple_sharing.SimpleSharing.modify_public_share'] = ('simple_sharing_SimpleSharing', '--modify_public_share')
	metavars = () if interactive_mode else ('id','share')
	help = '' if interactive_mode else '%s %s ' % ('int', '{"comment":text,"name":text,#"quota":{"quota":long}#,#"public_access":read|none|write|full#}')
	nargs = 0 if interactive_mode else 2
	simple_sharing_SimpleSharing.add_argument("--modify_public_share", action=simple_sharing_SimpleSharing_modify_public_shareAction, nargs=nargs, metavar=metavars, help=help)
	appstore_AppstoreManager = subparsers.add_parser('appstore_AppstoreManager', help="help appstore.AppstoreManager")
	class appstore_AppstoreManager_cancel_operationAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.appstore.AppSimpleInfo import AppSimpleInfo
			from unicorn_api.v5.sv0.appstore import AppState
			from unicorn_api.v5.sv0.appstore.AppOnlineSimpleInfo import AppOnlineSimpleInfo
			from unicorn_api.v5.sv0.appstore.CategoryInfo import CategoryInfo
			from unicorn_api.v5.sv0.appstore.ServerStatus import ServerStatus
			from unicorn_api.v5.sv0.appstore.AppAccess import AppAccess
			from unicorn_api.v5.sv0.appstore.ServersStatus import ServersStatus
			from unicorn_api.v5.sv0.appstore.AppFullInfo import AppFullInfo

			from transformer.lib import List, ListInfo, ResultSet, Dict
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.appstore.AppstoreManager import AppstoreManager
			service = AppstoreManager()
			global function, interactive
			function = service.cancel_operation
			interactive = []
			interactive.append(('app_id', cli_unicode))
	methods['appstore.AppstoreManager.cancel_operation'] = ('appstore_AppstoreManager', '--cancel_operation')
	metavars = () if interactive_mode else ('app_id')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 1
	appstore_AppstoreManager.add_argument("--cancel_operation", action=appstore_AppstoreManager_cancel_operationAction, nargs=nargs, metavar=metavars, help=help)
	class appstore_AppstoreManager_install_appAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.appstore.AppSimpleInfo import AppSimpleInfo
			from unicorn_api.v5.sv0.appstore import AppState
			from unicorn_api.v5.sv0.appstore.AppOnlineSimpleInfo import AppOnlineSimpleInfo
			from unicorn_api.v5.sv0.appstore.CategoryInfo import CategoryInfo
			from unicorn_api.v5.sv0.appstore.ServerStatus import ServerStatus
			from unicorn_api.v5.sv0.appstore.AppAccess import AppAccess
			from unicorn_api.v5.sv0.appstore.ServersStatus import ServersStatus
			from unicorn_api.v5.sv0.appstore.AppFullInfo import AppFullInfo

			from transformer.lib import List, ListInfo, ResultSet, Dict
			checker = [cli_unicode,cli_unicode,cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.appstore.AppstoreManager import AppstoreManager
			service = AppstoreManager()
			global function, interactive
			function = service.install_app
			interactive = []
			interactive.append(('async_job_name', cli_unicode))
			interactive.append(('app_id', cli_unicode))
			interactive.append(('volume_id', cli_int))
	methods['appstore.AppstoreManager.install_app'] = ('appstore_AppstoreManager', '--install_app')
	metavars = () if interactive_mode else ('async_job_name','app_id','volume_id')
	help = '' if interactive_mode else '%s %s ' % ('text', 'int')
	nargs = 0 if interactive_mode else 3
	appstore_AppstoreManager.add_argument("--install_app", action=appstore_AppstoreManager_install_appAction, nargs=nargs, metavar=metavars, help=help)
	class appstore_AppstoreManager_install_appResultAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.appstore.AppstoreManager import AppstoreManager
			service = AppstoreManager()
			global function, interactive
			function = service.install_app_result
			interactive = []
			interactive.append(('async_job_id', cli_int))
	methods['appstore.AppstoreManager.install_app_result'] = ('appstore_AppstoreManager', '--install_app_result')
	metavars = () if interactive_mode else ('async_job_id')
	nargs = 0 if interactive_mode else 1
	appstore_AppstoreManager.add_argument("--install_app_result", action=appstore_AppstoreManager_install_appResultAction, nargs=nargs, metavar=metavars)
	class appstore_AppstoreManager_list_groups_accessAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.appstore.AppSimpleInfo import AppSimpleInfo
			from unicorn_api.v5.sv0.appstore import AppState
			from unicorn_api.v5.sv0.appstore.AppOnlineSimpleInfo import AppOnlineSimpleInfo
			from unicorn_api.v5.sv0.appstore.CategoryInfo import CategoryInfo
			from unicorn_api.v5.sv0.appstore.ServerStatus import ServerStatus
			from unicorn_api.v5.sv0.appstore.AppAccess import AppAccess
			from unicorn_api.v5.sv0.appstore.ServersStatus import ServersStatus
			from unicorn_api.v5.sv0.appstore.AppFullInfo import AppFullInfo

			from transformer.lib import List, ListInfo, ResultSet, Dict
			checker = [cli_unicode,cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.appstore.AppstoreManager import AppstoreManager
			service = AppstoreManager()
			global function, interactive
			function = service.list_groups_access
			interactive = []
			interactive.append(('app_id', cli_unicode))
			interactive.append(('list_info', cli_list_info))
	methods['appstore.AppstoreManager.list_groups_access'] = ('appstore_AppstoreManager', '--list_groups_access')
	metavars = () if interactive_mode else ('app_id','list_info')
	help = '' if interactive_mode else '%s %s ' % ('text', 'offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 2
	appstore_AppstoreManager.add_argument("--list_groups_access", action=appstore_AppstoreManager_list_groups_accessAction, nargs=nargs, metavar=metavars, help=help)
	class appstore_AppstoreManager_list_apps_accessAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.appstore.AppSimpleInfo import AppSimpleInfo
			from unicorn_api.v5.sv0.appstore import AppState
			from unicorn_api.v5.sv0.appstore.AppOnlineSimpleInfo import AppOnlineSimpleInfo
			from unicorn_api.v5.sv0.appstore.CategoryInfo import CategoryInfo
			from unicorn_api.v5.sv0.appstore.ServerStatus import ServerStatus
			from unicorn_api.v5.sv0.appstore.AppAccess import AppAccess
			from unicorn_api.v5.sv0.appstore.ServersStatus import ServersStatus
			from unicorn_api.v5.sv0.appstore.AppFullInfo import AppFullInfo

			from transformer.lib import List, ListInfo, ResultSet, Dict
			checker = [cli_int,cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.appstore.AppstoreManager import AppstoreManager
			service = AppstoreManager()
			global function, interactive
			function = service.list_apps_access
			interactive = []
			interactive.append(('group_id', cli_int))
			interactive.append(('list_info', cli_list_info))
	methods['appstore.AppstoreManager.list_apps_access'] = ('appstore_AppstoreManager', '--list_apps_access')
	metavars = () if interactive_mode else ('group_id','list_info')
	help = '' if interactive_mode else '%s %s ' % ('int', 'offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 2
	appstore_AppstoreManager.add_argument("--list_apps_access", action=appstore_AppstoreManager_list_apps_accessAction, nargs=nargs, metavar=metavars, help=help)
	class appstore_AppstoreManager_remove_apps_for_groupAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.appstore.AppSimpleInfo import AppSimpleInfo
			from unicorn_api.v5.sv0.appstore import AppState
			from unicorn_api.v5.sv0.appstore.AppOnlineSimpleInfo import AppOnlineSimpleInfo
			from unicorn_api.v5.sv0.appstore.CategoryInfo import CategoryInfo
			from unicorn_api.v5.sv0.appstore.ServerStatus import ServerStatus
			from unicorn_api.v5.sv0.appstore.AppAccess import AppAccess
			from unicorn_api.v5.sv0.appstore.ServersStatus import ServersStatus
			from unicorn_api.v5.sv0.appstore.AppFullInfo import AppFullInfo

			from transformer.lib import List, ListInfo, ResultSet, Dict
			checker = [cli_int,list_cli(unicode)]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.appstore.AppstoreManager import AppstoreManager
			service = AppstoreManager()
			global function, interactive
			function = service.remove_apps_for_group
			interactive = []
			interactive.append(('group_id', cli_int))
			interactive.append(('app_ids', list_cli(unicode)))
	methods['appstore.AppstoreManager.remove_apps_for_group'] = ('appstore_AppstoreManager', '--remove_apps_for_group')
	metavars = () if interactive_mode else ('group_id','app_ids')
	help = '' if interactive_mode else '%s %s ' % ('int', '["text",...]')
	nargs = 0 if interactive_mode else 2
	appstore_AppstoreManager.add_argument("--remove_apps_for_group", action=appstore_AppstoreManager_remove_apps_for_groupAction, nargs=nargs, metavar=metavars, help=help)
	class appstore_AppstoreManager_update_appAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.appstore.AppSimpleInfo import AppSimpleInfo
			from unicorn_api.v5.sv0.appstore import AppState
			from unicorn_api.v5.sv0.appstore.AppOnlineSimpleInfo import AppOnlineSimpleInfo
			from unicorn_api.v5.sv0.appstore.CategoryInfo import CategoryInfo
			from unicorn_api.v5.sv0.appstore.ServerStatus import ServerStatus
			from unicorn_api.v5.sv0.appstore.AppAccess import AppAccess
			from unicorn_api.v5.sv0.appstore.ServersStatus import ServersStatus
			from unicorn_api.v5.sv0.appstore.AppFullInfo import AppFullInfo

			from transformer.lib import List, ListInfo, ResultSet, Dict
			checker = [cli_unicode,cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.appstore.AppstoreManager import AppstoreManager
			service = AppstoreManager()
			global function, interactive
			function = service.update_app
			interactive = []
			interactive.append(('async_job_name', cli_unicode))
			interactive.append(('app_id', cli_unicode))
	methods['appstore.AppstoreManager.update_app'] = ('appstore_AppstoreManager', '--update_app')
	metavars = () if interactive_mode else ('async_job_name','app_id')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 2
	appstore_AppstoreManager.add_argument("--update_app", action=appstore_AppstoreManager_update_appAction, nargs=nargs, metavar=metavars, help=help)
	class appstore_AppstoreManager_update_appResultAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.appstore.AppstoreManager import AppstoreManager
			service = AppstoreManager()
			global function, interactive
			function = service.update_app_result
			interactive = []
			interactive.append(('async_job_id', cli_int))
	methods['appstore.AppstoreManager.update_app_result'] = ('appstore_AppstoreManager', '--update_app_result')
	metavars = () if interactive_mode else ('async_job_id')
	nargs = 0 if interactive_mode else 1
	appstore_AppstoreManager.add_argument("--update_app_result", action=appstore_AppstoreManager_update_appResultAction, nargs=nargs, metavar=metavars)
	class appstore_AppstoreManager_list_application_installedAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.appstore.AppSimpleInfo import AppSimpleInfo
			from unicorn_api.v5.sv0.appstore import AppState
			from unicorn_api.v5.sv0.appstore.AppOnlineSimpleInfo import AppOnlineSimpleInfo
			from unicorn_api.v5.sv0.appstore.CategoryInfo import CategoryInfo
			from unicorn_api.v5.sv0.appstore.ServerStatus import ServerStatus
			from unicorn_api.v5.sv0.appstore.AppAccess import AppAccess
			from unicorn_api.v5.sv0.appstore.ServersStatus import ServersStatus
			from unicorn_api.v5.sv0.appstore.AppFullInfo import AppFullInfo

			from transformer.lib import List, ListInfo, ResultSet, Dict
			checker = [list_cli(unicode),cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.appstore.AppstoreManager import AppstoreManager
			service = AppstoreManager()
			global function, interactive
			function = service.list_application_installed
			interactive = []
			interactive.append(('with_parameters', list_cli(unicode)))
			interactive.append(('list_info', cli_list_info))
	methods['appstore.AppstoreManager.list_application_installed'] = ('appstore_AppstoreManager', '--list_application_installed')
	metavars = () if interactive_mode else ('with_parameters','list_info')
	help = '' if interactive_mode else '%s %s ' % ('["text",...]', 'offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 2
	appstore_AppstoreManager.add_argument("--list_application_installed", action=appstore_AppstoreManager_list_application_installedAction, nargs=nargs, metavar=metavars, help=help)
	class appstore_AppstoreManager_get_manual_install_tokenAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.appstore.AppSimpleInfo import AppSimpleInfo
			from unicorn_api.v5.sv0.appstore import AppState
			from unicorn_api.v5.sv0.appstore.AppOnlineSimpleInfo import AppOnlineSimpleInfo
			from unicorn_api.v5.sv0.appstore.CategoryInfo import CategoryInfo
			from unicorn_api.v5.sv0.appstore.ServerStatus import ServerStatus
			from unicorn_api.v5.sv0.appstore.AppAccess import AppAccess
			from unicorn_api.v5.sv0.appstore.ServersStatus import ServersStatus
			from unicorn_api.v5.sv0.appstore.AppFullInfo import AppFullInfo

			from transformer.lib import List, ListInfo, ResultSet, Dict
			checker = [cli_unicode,cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.appstore.AppstoreManager import AppstoreManager
			service = AppstoreManager()
			global function, interactive
			function = service.get_manual_install_token
			interactive = []
			interactive.append(('package_name', cli_unicode))
			interactive.append(('volume_id', cli_int))
	methods['appstore.AppstoreManager.get_manual_install_token'] = ('appstore_AppstoreManager', '--get_manual_install_token')
	metavars = () if interactive_mode else ('package_name','volume_id')
	help = '' if interactive_mode else '%s %s ' % ('text', 'int')
	nargs = 0 if interactive_mode else 2
	appstore_AppstoreManager.add_argument("--get_manual_install_token", action=appstore_AppstoreManager_get_manual_install_tokenAction, nargs=nargs, metavar=metavars, help=help)
	class appstore_AppstoreManager_myAppsAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.appstore.AppSimpleInfo import AppSimpleInfo
			from unicorn_api.v5.sv0.appstore import AppState
			from unicorn_api.v5.sv0.appstore.AppOnlineSimpleInfo import AppOnlineSimpleInfo
			from unicorn_api.v5.sv0.appstore.CategoryInfo import CategoryInfo
			from unicorn_api.v5.sv0.appstore.ServerStatus import ServerStatus
			from unicorn_api.v5.sv0.appstore.AppAccess import AppAccess
			from unicorn_api.v5.sv0.appstore.ServersStatus import ServersStatus
			from unicorn_api.v5.sv0.appstore.AppFullInfo import AppFullInfo

			from transformer.lib import List, ListInfo, ResultSet, Dict
			checker = [list_cli(unicode),cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.appstore.AppstoreManager import AppstoreManager
			service = AppstoreManager()
			global function, interactive
			function = service.myApps
			interactive = []
			interactive.append(('with_parameters', list_cli(unicode)))
			interactive.append(('list_info', cli_list_info))
	methods['appstore.AppstoreManager.myApps'] = ('appstore_AppstoreManager', '--myApps')
	metavars = () if interactive_mode else ('with_parameters','list_info')
	help = '' if interactive_mode else '%s %s ' % ('["text",...]', 'offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 2
	appstore_AppstoreManager.add_argument("--myApps", action=appstore_AppstoreManager_myAppsAction, nargs=nargs, metavar=metavars, help=help)
	class appstore_AppstoreManager_remove_appAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.appstore.AppSimpleInfo import AppSimpleInfo
			from unicorn_api.v5.sv0.appstore import AppState
			from unicorn_api.v5.sv0.appstore.AppOnlineSimpleInfo import AppOnlineSimpleInfo
			from unicorn_api.v5.sv0.appstore.CategoryInfo import CategoryInfo
			from unicorn_api.v5.sv0.appstore.ServerStatus import ServerStatus
			from unicorn_api.v5.sv0.appstore.AppAccess import AppAccess
			from unicorn_api.v5.sv0.appstore.ServersStatus import ServersStatus
			from unicorn_api.v5.sv0.appstore.AppFullInfo import AppFullInfo

			from transformer.lib import List, ListInfo, ResultSet, Dict
			checker = [cli_unicode,cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.appstore.AppstoreManager import AppstoreManager
			service = AppstoreManager()
			global function, interactive
			function = service.remove_app
			interactive = []
			interactive.append(('async_job_name', cli_unicode))
			interactive.append(('app_id', cli_unicode))
	methods['appstore.AppstoreManager.remove_app'] = ('appstore_AppstoreManager', '--remove_app')
	metavars = () if interactive_mode else ('async_job_name','app_id')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 2
	appstore_AppstoreManager.add_argument("--remove_app", action=appstore_AppstoreManager_remove_appAction, nargs=nargs, metavar=metavars, help=help)
	class appstore_AppstoreManager_remove_appResultAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.appstore.AppstoreManager import AppstoreManager
			service = AppstoreManager()
			global function, interactive
			function = service.remove_app_result
			interactive = []
			interactive.append(('async_job_id', cli_int))
	methods['appstore.AppstoreManager.remove_app_result'] = ('appstore_AppstoreManager', '--remove_app_result')
	metavars = () if interactive_mode else ('async_job_id')
	nargs = 0 if interactive_mode else 1
	appstore_AppstoreManager.add_argument("--remove_app_result", action=appstore_AppstoreManager_remove_appResultAction, nargs=nargs, metavar=metavars)
	class appstore_AppstoreManager_get_server_urlsAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.appstore.AppSimpleInfo import AppSimpleInfo
			from unicorn_api.v5.sv0.appstore import AppState
			from unicorn_api.v5.sv0.appstore.AppOnlineSimpleInfo import AppOnlineSimpleInfo
			from unicorn_api.v5.sv0.appstore.CategoryInfo import CategoryInfo
			from unicorn_api.v5.sv0.appstore.ServerStatus import ServerStatus
			from unicorn_api.v5.sv0.appstore.AppAccess import AppAccess
			from unicorn_api.v5.sv0.appstore.ServersStatus import ServersStatus
			from unicorn_api.v5.sv0.appstore.AppFullInfo import AppFullInfo

			from transformer.lib import List, ListInfo, ResultSet, Dict
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.appstore.AppstoreManager import AppstoreManager
			service = AppstoreManager()
			global function, interactive
			function = service.get_server_urls
			interactive = []
	methods['appstore.AppstoreManager.get_server_urls'] = ('appstore_AppstoreManager', '--get_server_urls')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	appstore_AppstoreManager.add_argument("--get_server_urls", action=appstore_AppstoreManager_get_server_urlsAction, nargs=nargs, metavar=metavars, help=help)
	class appstore_AppstoreManager_start_applicationAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.appstore.AppSimpleInfo import AppSimpleInfo
			from unicorn_api.v5.sv0.appstore import AppState
			from unicorn_api.v5.sv0.appstore.AppOnlineSimpleInfo import AppOnlineSimpleInfo
			from unicorn_api.v5.sv0.appstore.CategoryInfo import CategoryInfo
			from unicorn_api.v5.sv0.appstore.ServerStatus import ServerStatus
			from unicorn_api.v5.sv0.appstore.AppAccess import AppAccess
			from unicorn_api.v5.sv0.appstore.ServersStatus import ServersStatus
			from unicorn_api.v5.sv0.appstore.AppFullInfo import AppFullInfo

			from transformer.lib import List, ListInfo, ResultSet, Dict
			checker = [cli_unicode,cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.appstore.AppstoreManager import AppstoreManager
			service = AppstoreManager()
			global function, interactive
			function = service.start_application
			interactive = []
			interactive.append(('async_job_name', cli_unicode))
			interactive.append(('app_id', cli_unicode))
	methods['appstore.AppstoreManager.start_application'] = ('appstore_AppstoreManager', '--start_application')
	metavars = () if interactive_mode else ('async_job_name','app_id')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 2
	appstore_AppstoreManager.add_argument("--start_application", action=appstore_AppstoreManager_start_applicationAction, nargs=nargs, metavar=metavars, help=help)
	class appstore_AppstoreManager_start_applicationResultAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.appstore.AppstoreManager import AppstoreManager
			service = AppstoreManager()
			global function, interactive
			function = service.start_application_result
			interactive = []
			interactive.append(('async_job_id', cli_int))
	methods['appstore.AppstoreManager.start_application_result'] = ('appstore_AppstoreManager', '--start_application_result')
	metavars = () if interactive_mode else ('async_job_id')
	nargs = 0 if interactive_mode else 1
	appstore_AppstoreManager.add_argument("--start_application_result", action=appstore_AppstoreManager_start_applicationResultAction, nargs=nargs, metavar=metavars)
	class appstore_AppstoreManager_get_iconsAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.appstore.AppSimpleInfo import AppSimpleInfo
			from unicorn_api.v5.sv0.appstore import AppState
			from unicorn_api.v5.sv0.appstore.AppOnlineSimpleInfo import AppOnlineSimpleInfo
			from unicorn_api.v5.sv0.appstore.CategoryInfo import CategoryInfo
			from unicorn_api.v5.sv0.appstore.ServerStatus import ServerStatus
			from unicorn_api.v5.sv0.appstore.AppAccess import AppAccess
			from unicorn_api.v5.sv0.appstore.ServersStatus import ServersStatus
			from unicorn_api.v5.sv0.appstore.AppFullInfo import AppFullInfo

			from transformer.lib import List, ListInfo, ResultSet, Dict
			checker = [cli_unicode,cli_bool]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.appstore.AppstoreManager import AppstoreManager
			service = AppstoreManager()
			global function, interactive
			function = service.get_icons
			interactive = []
			interactive.append(('app_id', cli_unicode))
			interactive.append(('latest', cli_bool))
	methods['appstore.AppstoreManager.get_icons'] = ('appstore_AppstoreManager', '--get_icons')
	metavars = () if interactive_mode else ('app_id','latest')
	help = '' if interactive_mode else '%s %s ' % ('text', 'True|False')
	nargs = 0 if interactive_mode else 2
	appstore_AppstoreManager.add_argument("--get_icons", action=appstore_AppstoreManager_get_iconsAction, nargs=nargs, metavar=metavars, help=help)
	class appstore_AppstoreManager_periodic_checkAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.appstore.AppSimpleInfo import AppSimpleInfo
			from unicorn_api.v5.sv0.appstore import AppState
			from unicorn_api.v5.sv0.appstore.AppOnlineSimpleInfo import AppOnlineSimpleInfo
			from unicorn_api.v5.sv0.appstore.CategoryInfo import CategoryInfo
			from unicorn_api.v5.sv0.appstore.ServerStatus import ServerStatus
			from unicorn_api.v5.sv0.appstore.AppAccess import AppAccess
			from unicorn_api.v5.sv0.appstore.ServersStatus import ServersStatus
			from unicorn_api.v5.sv0.appstore.AppFullInfo import AppFullInfo

			from transformer.lib import List, ListInfo, ResultSet, Dict
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.appstore.AppstoreManager import AppstoreManager
			service = AppstoreManager()
			global function, interactive
			function = service.periodic_check
			interactive = []
	methods['appstore.AppstoreManager.periodic_check'] = ('appstore_AppstoreManager', '--periodic_check')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	appstore_AppstoreManager.add_argument("--periodic_check", action=appstore_AppstoreManager_periodic_checkAction, nargs=nargs, metavar=metavars, help=help)
	class appstore_AppstoreManager_add_apps_for_groupAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.appstore.AppSimpleInfo import AppSimpleInfo
			from unicorn_api.v5.sv0.appstore import AppState
			from unicorn_api.v5.sv0.appstore.AppOnlineSimpleInfo import AppOnlineSimpleInfo
			from unicorn_api.v5.sv0.appstore.CategoryInfo import CategoryInfo
			from unicorn_api.v5.sv0.appstore.ServerStatus import ServerStatus
			from unicorn_api.v5.sv0.appstore.AppAccess import AppAccess
			from unicorn_api.v5.sv0.appstore.ServersStatus import ServersStatus
			from unicorn_api.v5.sv0.appstore.AppFullInfo import AppFullInfo

			from transformer.lib import List, ListInfo, ResultSet, Dict
			checker = [cli_int,list_cli(unicode)]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.appstore.AppstoreManager import AppstoreManager
			service = AppstoreManager()
			global function, interactive
			function = service.add_apps_for_group
			interactive = []
			interactive.append(('group_id', cli_int))
			interactive.append(('app_ids', list_cli(unicode)))
	methods['appstore.AppstoreManager.add_apps_for_group'] = ('appstore_AppstoreManager', '--add_apps_for_group')
	metavars = () if interactive_mode else ('group_id','app_ids')
	help = '' if interactive_mode else '%s %s ' % ('int', '["text",...]')
	nargs = 0 if interactive_mode else 2
	appstore_AppstoreManager.add_argument("--add_apps_for_group", action=appstore_AppstoreManager_add_apps_for_groupAction, nargs=nargs, metavar=metavars, help=help)
	class appstore_AppstoreManager_get_operations_tableAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.appstore.AppSimpleInfo import AppSimpleInfo
			from unicorn_api.v5.sv0.appstore import AppState
			from unicorn_api.v5.sv0.appstore.AppOnlineSimpleInfo import AppOnlineSimpleInfo
			from unicorn_api.v5.sv0.appstore.CategoryInfo import CategoryInfo
			from unicorn_api.v5.sv0.appstore.ServerStatus import ServerStatus
			from unicorn_api.v5.sv0.appstore.AppAccess import AppAccess
			from unicorn_api.v5.sv0.appstore.ServersStatus import ServersStatus
			from unicorn_api.v5.sv0.appstore.AppFullInfo import AppFullInfo

			from transformer.lib import List, ListInfo, ResultSet, Dict
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.appstore.AppstoreManager import AppstoreManager
			service = AppstoreManager()
			global function, interactive
			function = service.get_operations_table
			interactive = []
	methods['appstore.AppstoreManager.get_operations_table'] = ('appstore_AppstoreManager', '--get_operations_table')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	appstore_AppstoreManager.add_argument("--get_operations_table", action=appstore_AppstoreManager_get_operations_tableAction, nargs=nargs, metavar=metavars, help=help)
	class appstore_AppstoreManager_list_applicationAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.appstore.AppSimpleInfo import AppSimpleInfo
			from unicorn_api.v5.sv0.appstore import AppState
			from unicorn_api.v5.sv0.appstore.AppOnlineSimpleInfo import AppOnlineSimpleInfo
			from unicorn_api.v5.sv0.appstore.CategoryInfo import CategoryInfo
			from unicorn_api.v5.sv0.appstore.ServerStatus import ServerStatus
			from unicorn_api.v5.sv0.appstore.AppAccess import AppAccess
			from unicorn_api.v5.sv0.appstore.ServersStatus import ServersStatus
			from unicorn_api.v5.sv0.appstore.AppFullInfo import AppFullInfo

			from transformer.lib import List, ListInfo, ResultSet, Dict
			checker = [list_cli(unicode),cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.appstore.AppstoreManager import AppstoreManager
			service = AppstoreManager()
			global function, interactive
			function = service.list_application
			interactive = []
			interactive.append(('with_parameters', list_cli(unicode)))
			interactive.append(('list_info', cli_list_info))
	methods['appstore.AppstoreManager.list_application'] = ('appstore_AppstoreManager', '--list_application')
	metavars = () if interactive_mode else ('with_parameters','list_info')
	help = '' if interactive_mode else '%s %s ' % ('["text",...]', 'offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 2
	appstore_AppstoreManager.add_argument("--list_application", action=appstore_AppstoreManager_list_applicationAction, nargs=nargs, metavar=metavars, help=help)
	class appstore_AppstoreManager_get_app_full_infoAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.appstore.AppSimpleInfo import AppSimpleInfo
			from unicorn_api.v5.sv0.appstore import AppState
			from unicorn_api.v5.sv0.appstore.AppOnlineSimpleInfo import AppOnlineSimpleInfo
			from unicorn_api.v5.sv0.appstore.CategoryInfo import CategoryInfo
			from unicorn_api.v5.sv0.appstore.ServerStatus import ServerStatus
			from unicorn_api.v5.sv0.appstore.AppAccess import AppAccess
			from unicorn_api.v5.sv0.appstore.ServersStatus import ServersStatus
			from unicorn_api.v5.sv0.appstore.AppFullInfo import AppFullInfo

			from transformer.lib import List, ListInfo, ResultSet, Dict
			checker = [cli_unicode,cli_bool]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.appstore.AppstoreManager import AppstoreManager
			service = AppstoreManager()
			global function, interactive
			function = service.get_app_full_info
			interactive = []
			interactive.append(('app_id', cli_unicode))
			interactive.append(('latest', cli_bool))
	methods['appstore.AppstoreManager.get_app_full_info'] = ('appstore_AppstoreManager', '--get_app_full_info')
	metavars = () if interactive_mode else ('app_id','latest')
	help = '' if interactive_mode else '%s %s ' % ('text', 'True|False')
	nargs = 0 if interactive_mode else 2
	appstore_AppstoreManager.add_argument("--get_app_full_info", action=appstore_AppstoreManager_get_app_full_infoAction, nargs=nargs, metavar=metavars, help=help)
	class appstore_AppstoreManager_add_groupsAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.appstore.AppSimpleInfo import AppSimpleInfo
			from unicorn_api.v5.sv0.appstore import AppState
			from unicorn_api.v5.sv0.appstore.AppOnlineSimpleInfo import AppOnlineSimpleInfo
			from unicorn_api.v5.sv0.appstore.CategoryInfo import CategoryInfo
			from unicorn_api.v5.sv0.appstore.ServerStatus import ServerStatus
			from unicorn_api.v5.sv0.appstore.AppAccess import AppAccess
			from unicorn_api.v5.sv0.appstore.ServersStatus import ServersStatus
			from unicorn_api.v5.sv0.appstore.AppFullInfo import AppFullInfo

			from transformer.lib import List, ListInfo, ResultSet, Dict
			checker = [cli_unicode,list_cli(int)]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.appstore.AppstoreManager import AppstoreManager
			service = AppstoreManager()
			global function, interactive
			function = service.add_groups
			interactive = []
			interactive.append(('app_id', cli_unicode))
			interactive.append(('groups_id', list_cli(int)))
	methods['appstore.AppstoreManager.add_groups'] = ('appstore_AppstoreManager', '--add_groups')
	metavars = () if interactive_mode else ('app_id','groups_id')
	help = '' if interactive_mode else '%s %s ' % ('text', '["int",...]')
	nargs = 0 if interactive_mode else 2
	appstore_AppstoreManager.add_argument("--add_groups", action=appstore_AppstoreManager_add_groupsAction, nargs=nargs, metavar=metavars, help=help)
	class appstore_AppstoreManager_update_allAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.appstore.AppSimpleInfo import AppSimpleInfo
			from unicorn_api.v5.sv0.appstore import AppState
			from unicorn_api.v5.sv0.appstore.AppOnlineSimpleInfo import AppOnlineSimpleInfo
			from unicorn_api.v5.sv0.appstore.CategoryInfo import CategoryInfo
			from unicorn_api.v5.sv0.appstore.ServerStatus import ServerStatus
			from unicorn_api.v5.sv0.appstore.AppAccess import AppAccess
			from unicorn_api.v5.sv0.appstore.ServersStatus import ServersStatus
			from unicorn_api.v5.sv0.appstore.AppFullInfo import AppFullInfo

			from transformer.lib import List, ListInfo, ResultSet, Dict
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.appstore.AppstoreManager import AppstoreManager
			service = AppstoreManager()
			global function, interactive
			function = service.update_all
			interactive = []
	methods['appstore.AppstoreManager.update_all'] = ('appstore_AppstoreManager', '--update_all')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	appstore_AppstoreManager.add_argument("--update_all", action=appstore_AppstoreManager_update_allAction, nargs=nargs, metavar=metavars, help=help)
	class appstore_AppstoreManager_remove_groupsAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.appstore.AppSimpleInfo import AppSimpleInfo
			from unicorn_api.v5.sv0.appstore import AppState
			from unicorn_api.v5.sv0.appstore.AppOnlineSimpleInfo import AppOnlineSimpleInfo
			from unicorn_api.v5.sv0.appstore.CategoryInfo import CategoryInfo
			from unicorn_api.v5.sv0.appstore.ServerStatus import ServerStatus
			from unicorn_api.v5.sv0.appstore.AppAccess import AppAccess
			from unicorn_api.v5.sv0.appstore.ServersStatus import ServersStatus
			from unicorn_api.v5.sv0.appstore.AppFullInfo import AppFullInfo

			from transformer.lib import List, ListInfo, ResultSet, Dict
			checker = [cli_unicode,list_cli(int)]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.appstore.AppstoreManager import AppstoreManager
			service = AppstoreManager()
			global function, interactive
			function = service.remove_groups
			interactive = []
			interactive.append(('app_id', cli_unicode))
			interactive.append(('groups_id', list_cli(int)))
	methods['appstore.AppstoreManager.remove_groups'] = ('appstore_AppstoreManager', '--remove_groups')
	metavars = () if interactive_mode else ('app_id','groups_id')
	help = '' if interactive_mode else '%s %s ' % ('text', '["int",...]')
	nargs = 0 if interactive_mode else 2
	appstore_AppstoreManager.add_argument("--remove_groups", action=appstore_AppstoreManager_remove_groupsAction, nargs=nargs, metavar=metavars, help=help)
	class appstore_AppstoreManager_list_categoryAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.appstore.AppSimpleInfo import AppSimpleInfo
			from unicorn_api.v5.sv0.appstore import AppState
			from unicorn_api.v5.sv0.appstore.AppOnlineSimpleInfo import AppOnlineSimpleInfo
			from unicorn_api.v5.sv0.appstore.CategoryInfo import CategoryInfo
			from unicorn_api.v5.sv0.appstore.ServerStatus import ServerStatus
			from unicorn_api.v5.sv0.appstore.AppAccess import AppAccess
			from unicorn_api.v5.sv0.appstore.ServersStatus import ServersStatus
			from unicorn_api.v5.sv0.appstore.AppFullInfo import AppFullInfo

			from transformer.lib import List, ListInfo, ResultSet, Dict
			checker = [cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.appstore.AppstoreManager import AppstoreManager
			service = AppstoreManager()
			global function, interactive
			function = service.list_category
			interactive = []
			interactive.append(('list_info', cli_list_info))
	methods['appstore.AppstoreManager.list_category'] = ('appstore_AppstoreManager', '--list_category')
	metavars = () if interactive_mode else ('list_info')
	help = '' if interactive_mode else '%s ' % ('offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 1
	appstore_AppstoreManager.add_argument("--list_category", action=appstore_AppstoreManager_list_categoryAction, nargs=nargs, metavar=metavars, help=help)
	class appstore_AppstoreManager_stop_applicationAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.appstore.AppSimpleInfo import AppSimpleInfo
			from unicorn_api.v5.sv0.appstore import AppState
			from unicorn_api.v5.sv0.appstore.AppOnlineSimpleInfo import AppOnlineSimpleInfo
			from unicorn_api.v5.sv0.appstore.CategoryInfo import CategoryInfo
			from unicorn_api.v5.sv0.appstore.ServerStatus import ServerStatus
			from unicorn_api.v5.sv0.appstore.AppAccess import AppAccess
			from unicorn_api.v5.sv0.appstore.ServersStatus import ServersStatus
			from unicorn_api.v5.sv0.appstore.AppFullInfo import AppFullInfo

			from transformer.lib import List, ListInfo, ResultSet, Dict
			checker = [cli_unicode,cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.appstore.AppstoreManager import AppstoreManager
			service = AppstoreManager()
			global function, interactive
			function = service.stop_application
			interactive = []
			interactive.append(('async_job_name', cli_unicode))
			interactive.append(('app_id', cli_unicode))
	methods['appstore.AppstoreManager.stop_application'] = ('appstore_AppstoreManager', '--stop_application')
	metavars = () if interactive_mode else ('async_job_name','app_id')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 2
	appstore_AppstoreManager.add_argument("--stop_application", action=appstore_AppstoreManager_stop_applicationAction, nargs=nargs, metavar=metavars, help=help)
	class appstore_AppstoreManager_stop_applicationResultAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.appstore.AppstoreManager import AppstoreManager
			service = AppstoreManager()
			global function, interactive
			function = service.stop_application_result
			interactive = []
			interactive.append(('async_job_id', cli_int))
	methods['appstore.AppstoreManager.stop_application_result'] = ('appstore_AppstoreManager', '--stop_application_result')
	metavars = () if interactive_mode else ('async_job_id')
	nargs = 0 if interactive_mode else 1
	appstore_AppstoreManager.add_argument("--stop_application_result", action=appstore_AppstoreManager_stop_applicationResultAction, nargs=nargs, metavar=metavars)
	class appstore_AppstoreManager_clear_operation_errorsAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.appstore.AppSimpleInfo import AppSimpleInfo
			from unicorn_api.v5.sv0.appstore import AppState
			from unicorn_api.v5.sv0.appstore.AppOnlineSimpleInfo import AppOnlineSimpleInfo
			from unicorn_api.v5.sv0.appstore.CategoryInfo import CategoryInfo
			from unicorn_api.v5.sv0.appstore.ServerStatus import ServerStatus
			from unicorn_api.v5.sv0.appstore.AppAccess import AppAccess
			from unicorn_api.v5.sv0.appstore.ServersStatus import ServersStatus
			from unicorn_api.v5.sv0.appstore.AppFullInfo import AppFullInfo

			from transformer.lib import List, ListInfo, ResultSet, Dict
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.appstore.AppstoreManager import AppstoreManager
			service = AppstoreManager()
			global function, interactive
			function = service.clear_operation_errors
			interactive = []
			interactive.append(('app_id', cli_unicode))
	methods['appstore.AppstoreManager.clear_operation_errors'] = ('appstore_AppstoreManager', '--clear_operation_errors')
	metavars = () if interactive_mode else ('app_id')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 1
	appstore_AppstoreManager.add_argument("--clear_operation_errors", action=appstore_AppstoreManager_clear_operation_errorsAction, nargs=nargs, metavar=metavars, help=help)
	class appstore_AppstoreManager_set_server_urlsAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.appstore.AppSimpleInfo import AppSimpleInfo
			from unicorn_api.v5.sv0.appstore import AppState
			from unicorn_api.v5.sv0.appstore.AppOnlineSimpleInfo import AppOnlineSimpleInfo
			from unicorn_api.v5.sv0.appstore.CategoryInfo import CategoryInfo
			from unicorn_api.v5.sv0.appstore.ServerStatus import ServerStatus
			from unicorn_api.v5.sv0.appstore.AppAccess import AppAccess
			from unicorn_api.v5.sv0.appstore.ServersStatus import ServersStatus
			from unicorn_api.v5.sv0.appstore.AppFullInfo import AppFullInfo

			from transformer.lib import List, ListInfo, ResultSet, Dict
			checker = [list_cli(ServerStatus)]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.appstore.AppstoreManager import AppstoreManager
			service = AppstoreManager()
			global function, interactive
			function = service.set_server_urls
			interactive = []
			interactive.append(('list', list_cli(ServerStatus)))
	methods['appstore.AppstoreManager.set_server_urls'] = ('appstore_AppstoreManager', '--set_server_urls')
	metavars = () if interactive_mode else ('list')
	help = '' if interactive_mode else '%s ' % ('["{"url":text,"group":text}",...]')
	nargs = 0 if interactive_mode else 1
	appstore_AppstoreManager.add_argument("--set_server_urls", action=appstore_AppstoreManager_set_server_urlsAction, nargs=nargs, metavar=metavars, help=help)
	class appstore_AppstoreManager_check_default_appsAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.appstore.AppSimpleInfo import AppSimpleInfo
			from unicorn_api.v5.sv0.appstore import AppState
			from unicorn_api.v5.sv0.appstore.AppOnlineSimpleInfo import AppOnlineSimpleInfo
			from unicorn_api.v5.sv0.appstore.CategoryInfo import CategoryInfo
			from unicorn_api.v5.sv0.appstore.ServerStatus import ServerStatus
			from unicorn_api.v5.sv0.appstore.AppAccess import AppAccess
			from unicorn_api.v5.sv0.appstore.ServersStatus import ServersStatus
			from unicorn_api.v5.sv0.appstore.AppFullInfo import AppFullInfo

			from transformer.lib import List, ListInfo, ResultSet, Dict
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.appstore.AppstoreManager import AppstoreManager
			service = AppstoreManager()
			global function, interactive
			function = service.check_default_apps
			interactive = []
	methods['appstore.AppstoreManager.check_default_apps'] = ('appstore_AppstoreManager', '--check_default_apps')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	appstore_AppstoreManager.add_argument("--check_default_apps", action=appstore_AppstoreManager_check_default_appsAction, nargs=nargs, metavar=metavars, help=help)
	class appstore_AppstoreManager_get_servers_statusAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.appstore.AppSimpleInfo import AppSimpleInfo
			from unicorn_api.v5.sv0.appstore import AppState
			from unicorn_api.v5.sv0.appstore.AppOnlineSimpleInfo import AppOnlineSimpleInfo
			from unicorn_api.v5.sv0.appstore.CategoryInfo import CategoryInfo
			from unicorn_api.v5.sv0.appstore.ServerStatus import ServerStatus
			from unicorn_api.v5.sv0.appstore.AppAccess import AppAccess
			from unicorn_api.v5.sv0.appstore.ServersStatus import ServersStatus
			from unicorn_api.v5.sv0.appstore.AppFullInfo import AppFullInfo

			from transformer.lib import List, ListInfo, ResultSet, Dict
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.appstore.AppstoreManager import AppstoreManager
			service = AppstoreManager()
			global function, interactive
			function = service.get_servers_status
			interactive = []
	methods['appstore.AppstoreManager.get_servers_status'] = ('appstore_AppstoreManager', '--get_servers_status')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	appstore_AppstoreManager.add_argument("--get_servers_status", action=appstore_AppstoreManager_get_servers_statusAction, nargs=nargs, metavar=metavars, help=help)
	encryption_Encryption = subparsers.add_parser('encryption_Encryption', help="help encryption.Encryption")
	class encryption_Encryption_create_poolAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.raid import RaidMode
			from unicorn_api.v5.sv0.raid import RaidLevel
			from unicorn_api.v5.sv0.raid import RedundancyLevel
			from unicorn_api.v5.sv0.encryption.KeyFileStorage import KeyFileStorage

			from transformer.lib import Long, List, ListInfo, ResultSet
			checker = [cli_unicode,list_cli(int),RaidMode,RaidLevel,RedundancyLevel,cli_unicode,cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.encryption.Encryption import Encryption
			service = Encryption()
			global function, interactive
			function = service.create_pool
			interactive = []
			interactive.append(('async_job_name', cli_unicode))
			interactive.append(('list_of_slots', list_cli(int)))
			interactive.append(('raid_mode', RaidMode))
			interactive.append(('raid_level', RaidLevel))
			interactive.append(('redundancy_level', RedundancyLevel))
			interactive.append(('password', cli_unicode))
			interactive.append(('share_id', cli_int))
	methods['encryption.Encryption.create_pool'] = ('encryption_Encryption', '--create_pool')
	metavars = () if interactive_mode else ('async_job_name','list_of_slots','raid_mode','raid_level','redundancy_level','password','share_id')
	help = '' if interactive_mode else '%s %s %s %s %s %s ' % ('["int",...]', 'MANUAL|OPTIMUM', 'LINEAR|RAID5|RAID6|RAID1|RAID0|RAID10', 'NONE|TWO|ONE', 'text', 'int')
	nargs = 0 if interactive_mode else 7
	encryption_Encryption.add_argument("--create_pool", action=encryption_Encryption_create_poolAction, nargs=nargs, metavar=metavars, help=help)
	class encryption_Encryption_create_poolResultAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.encryption.Encryption import Encryption
			service = Encryption()
			global function, interactive
			function = service.create_pool_result
			interactive = []
			interactive.append(('async_job_id', cli_int))
	methods['encryption.Encryption.create_pool_result'] = ('encryption_Encryption', '--create_pool_result')
	metavars = () if interactive_mode else ('async_job_id')
	nargs = 0 if interactive_mode else 1
	encryption_Encryption.add_argument("--create_pool_result", action=encryption_Encryption_create_poolResultAction, nargs=nargs, metavar=metavars)
	class encryption_Encryption_list_keyfile_storageAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.raid import RaidMode
			from unicorn_api.v5.sv0.raid import RaidLevel
			from unicorn_api.v5.sv0.raid import RedundancyLevel
			from unicorn_api.v5.sv0.encryption.KeyFileStorage import KeyFileStorage

			from transformer.lib import Long, List, ListInfo, ResultSet
			checker = [cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.encryption.Encryption import Encryption
			service = Encryption()
			global function, interactive
			function = service.list_keyfile_storage
			interactive = []
			interactive.append(('list_info', cli_list_info))
	methods['encryption.Encryption.list_keyfile_storage'] = ('encryption_Encryption', '--list_keyfile_storage')
	metavars = () if interactive_mode else ('list_info')
	help = '' if interactive_mode else '%s ' % ('offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 1
	encryption_Encryption.add_argument("--list_keyfile_storage", action=encryption_Encryption_list_keyfile_storageAction, nargs=nargs, metavar=metavars, help=help)
	class encryption_Encryption_generate_keyfileAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.raid import RaidMode
			from unicorn_api.v5.sv0.raid import RaidLevel
			from unicorn_api.v5.sv0.raid import RedundancyLevel
			from unicorn_api.v5.sv0.encryption.KeyFileStorage import KeyFileStorage

			from transformer.lib import Long, List, ListInfo, ResultSet
			checker = [cli_unicode,cli_int,cli_unicode,cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.encryption.Encryption import Encryption
			service = Encryption()
			global function, interactive
			function = service.generate_keyfile
			interactive = []
			interactive.append(('async_job_name', cli_unicode))
			interactive.append(('volume_id', cli_int))
			interactive.append(('password', cli_unicode))
			interactive.append(('share_id', cli_int))
	methods['encryption.Encryption.generate_keyfile'] = ('encryption_Encryption', '--generate_keyfile')
	metavars = () if interactive_mode else ('async_job_name','volume_id','password','share_id')
	help = '' if interactive_mode else '%s %s %s ' % ('int', 'text', 'int')
	nargs = 0 if interactive_mode else 4
	encryption_Encryption.add_argument("--generate_keyfile", action=encryption_Encryption_generate_keyfileAction, nargs=nargs, metavar=metavars, help=help)
	class encryption_Encryption_generate_keyfileResultAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.encryption.Encryption import Encryption
			service = Encryption()
			global function, interactive
			function = service.generate_keyfile_result
			interactive = []
			interactive.append(('async_job_id', cli_int))
	methods['encryption.Encryption.generate_keyfile_result'] = ('encryption_Encryption', '--generate_keyfile_result')
	metavars = () if interactive_mode else ('async_job_id')
	nargs = 0 if interactive_mode else 1
	encryption_Encryption.add_argument("--generate_keyfile_result", action=encryption_Encryption_generate_keyfileResultAction, nargs=nargs, metavar=metavars)
	class encryption_Encryption_create_volumeAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.raid import RaidMode
			from unicorn_api.v5.sv0.raid import RaidLevel
			from unicorn_api.v5.sv0.raid import RedundancyLevel
			from unicorn_api.v5.sv0.encryption.KeyFileStorage import KeyFileStorage

			from transformer.lib import Long, List, ListInfo, ResultSet
			checker = [cli_unicode,cli_unicode,cli_long,cli_unicode,cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.encryption.Encryption import Encryption
			service = Encryption()
			global function, interactive
			function = service.create_volume
			interactive = []
			interactive.append(('async_job_name', cli_unicode))
			interactive.append(('storage_uid', cli_unicode))
			interactive.append(('size', cli_long))
			interactive.append(('password', cli_unicode))
			interactive.append(('share_id', cli_int))
	methods['encryption.Encryption.create_volume'] = ('encryption_Encryption', '--create_volume')
	metavars = () if interactive_mode else ('async_job_name','storage_uid','size','password','share_id')
	help = '' if interactive_mode else '%s %s %s %s ' % ('text', 'long', 'text', 'int')
	nargs = 0 if interactive_mode else 5
	encryption_Encryption.add_argument("--create_volume", action=encryption_Encryption_create_volumeAction, nargs=nargs, metavar=metavars, help=help)
	class encryption_Encryption_create_volumeResultAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.encryption.Encryption import Encryption
			service = Encryption()
			global function, interactive
			function = service.create_volume_result
			interactive = []
			interactive.append(('async_job_id', cli_int))
	methods['encryption.Encryption.create_volume_result'] = ('encryption_Encryption', '--create_volume_result')
	metavars = () if interactive_mode else ('async_job_id')
	nargs = 0 if interactive_mode else 1
	encryption_Encryption.add_argument("--create_volume_result", action=encryption_Encryption_create_volumeResultAction, nargs=nargs, metavar=metavars)
	class encryption_Encryption_lock_volumeAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.raid import RaidMode
			from unicorn_api.v5.sv0.raid import RaidLevel
			from unicorn_api.v5.sv0.raid import RedundancyLevel
			from unicorn_api.v5.sv0.encryption.KeyFileStorage import KeyFileStorage

			from transformer.lib import Long, List, ListInfo, ResultSet
			checker = [cli_unicode,cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.encryption.Encryption import Encryption
			service = Encryption()
			global function, interactive
			function = service.lock_volume
			interactive = []
			interactive.append(('async_job_name', cli_unicode))
			interactive.append(('volume_id', cli_int))
	methods['encryption.Encryption.lock_volume'] = ('encryption_Encryption', '--lock_volume')
	metavars = () if interactive_mode else ('async_job_name','volume_id')
	help = '' if interactive_mode else '%s ' % ('int')
	nargs = 0 if interactive_mode else 2
	encryption_Encryption.add_argument("--lock_volume", action=encryption_Encryption_lock_volumeAction, nargs=nargs, metavar=metavars, help=help)
	class encryption_Encryption_lock_volumeResultAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.encryption.Encryption import Encryption
			service = Encryption()
			global function, interactive
			function = service.lock_volume_result
			interactive = []
			interactive.append(('async_job_id', cli_int))
	methods['encryption.Encryption.lock_volume_result'] = ('encryption_Encryption', '--lock_volume_result')
	metavars = () if interactive_mode else ('async_job_id')
	nargs = 0 if interactive_mode else 1
	encryption_Encryption.add_argument("--lock_volume_result", action=encryption_Encryption_lock_volumeResultAction, nargs=nargs, metavar=metavars)
	class encryption_Encryption_change_passwordAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.raid import RaidMode
			from unicorn_api.v5.sv0.raid import RaidLevel
			from unicorn_api.v5.sv0.raid import RedundancyLevel
			from unicorn_api.v5.sv0.encryption.KeyFileStorage import KeyFileStorage

			from transformer.lib import Long, List, ListInfo, ResultSet
			checker = [cli_unicode,cli_int,cli_unicode,cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.encryption.Encryption import Encryption
			service = Encryption()
			global function, interactive
			function = service.change_password
			interactive = []
			interactive.append(('async_job_name', cli_unicode))
			interactive.append(('volume_id', cli_int))
			interactive.append(('old_password', cli_unicode))
			interactive.append(('new_password', cli_unicode))
	methods['encryption.Encryption.change_password'] = ('encryption_Encryption', '--change_password')
	metavars = () if interactive_mode else ('async_job_name','volume_id','old_password','new_password')
	help = '' if interactive_mode else '%s %s %s ' % ('int', 'text', 'text')
	nargs = 0 if interactive_mode else 4
	encryption_Encryption.add_argument("--change_password", action=encryption_Encryption_change_passwordAction, nargs=nargs, metavar=metavars, help=help)
	class encryption_Encryption_change_passwordResultAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.encryption.Encryption import Encryption
			service = Encryption()
			global function, interactive
			function = service.change_password_result
			interactive = []
			interactive.append(('async_job_id', cli_int))
	methods['encryption.Encryption.change_password_result'] = ('encryption_Encryption', '--change_password_result')
	metavars = () if interactive_mode else ('async_job_id')
	nargs = 0 if interactive_mode else 1
	encryption_Encryption.add_argument("--change_password_result", action=encryption_Encryption_change_passwordResultAction, nargs=nargs, metavar=metavars)
	class encryption_Encryption_unlock_volumeAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.raid import RaidMode
			from unicorn_api.v5.sv0.raid import RaidLevel
			from unicorn_api.v5.sv0.raid import RedundancyLevel
			from unicorn_api.v5.sv0.encryption.KeyFileStorage import KeyFileStorage

			from transformer.lib import Long, List, ListInfo, ResultSet
			checker = [cli_unicode,cli_int,cli_unicode,cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.encryption.Encryption import Encryption
			service = Encryption()
			global function, interactive
			function = service.unlock_volume
			interactive = []
			interactive.append(('async_job_name', cli_unicode))
			interactive.append(('volume_id', cli_int))
			interactive.append(('password', cli_unicode))
			interactive.append(('share_id', cli_int))
	methods['encryption.Encryption.unlock_volume'] = ('encryption_Encryption', '--unlock_volume')
	metavars = () if interactive_mode else ('async_job_name','volume_id','password','share_id')
	help = '' if interactive_mode else '%s %s %s ' % ('int', 'text', 'int')
	nargs = 0 if interactive_mode else 4
	encryption_Encryption.add_argument("--unlock_volume", action=encryption_Encryption_unlock_volumeAction, nargs=nargs, metavar=metavars, help=help)
	class encryption_Encryption_unlock_volumeResultAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.encryption.Encryption import Encryption
			service = Encryption()
			global function, interactive
			function = service.unlock_volume_result
			interactive = []
			interactive.append(('async_job_id', cli_int))
	methods['encryption.Encryption.unlock_volume_result'] = ('encryption_Encryption', '--unlock_volume_result')
	metavars = () if interactive_mode else ('async_job_id')
	nargs = 0 if interactive_mode else 1
	encryption_Encryption.add_argument("--unlock_volume_result", action=encryption_Encryption_unlock_volumeResultAction, nargs=nargs, metavar=metavars)
	cookies_CookieAdministraion = subparsers.add_parser('cookies_CookieAdministraion', help="help cookies.CookieAdministraion")
	class cookies_CookieAdministraion_list_cookiesAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.cookies.Cookie import Cookie

			from transformer.lib import List
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.cookies.CookieAdministraion import CookieAdministraion
			service = CookieAdministraion()
			global function, interactive
			function = service.list_cookies
			interactive = []
	methods['cookies.CookieAdministraion.list_cookies'] = ('cookies_CookieAdministraion', '--list_cookies')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	cookies_CookieAdministraion.add_argument("--list_cookies", action=cookies_CookieAdministraion_list_cookiesAction, nargs=nargs, metavar=metavars, help=help)
	class cookies_CookieAdministraion_set_global_cookieAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.cookies.Cookie import Cookie

			from transformer.lib import List
			checker = [Cookie]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.cookies.CookieAdministraion import CookieAdministraion
			service = CookieAdministraion()
			global function, interactive
			function = service.set_global_cookie
			interactive = []
			interactive.append(('cookie', Cookie))
	methods['cookies.CookieAdministraion.set_global_cookie'] = ('cookies_CookieAdministraion', '--set_global_cookie')
	metavars = () if interactive_mode else ('cookie')
	help = '' if interactive_mode else '%s ' % ('{"key":text,"value":text}')
	nargs = 0 if interactive_mode else 1
	cookies_CookieAdministraion.add_argument("--set_global_cookie", action=cookies_CookieAdministraion_set_global_cookieAction, nargs=nargs, metavar=metavars, help=help)
	class cookies_CookieAdministraion_set_cookieAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.cookies.Cookie import Cookie

			from transformer.lib import List
			checker = [Cookie]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.cookies.CookieAdministraion import CookieAdministraion
			service = CookieAdministraion()
			global function, interactive
			function = service.set_cookie
			interactive = []
			interactive.append(('cookie', Cookie))
	methods['cookies.CookieAdministraion.set_cookie'] = ('cookies_CookieAdministraion', '--set_cookie')
	metavars = () if interactive_mode else ('cookie')
	help = '' if interactive_mode else '%s ' % ('{"key":text,"value":text}')
	nargs = 0 if interactive_mode else 1
	cookies_CookieAdministraion.add_argument("--set_cookie", action=cookies_CookieAdministraion_set_cookieAction, nargs=nargs, metavar=metavars, help=help)
	hw_monitoring_Administration = subparsers.add_parser('hw_monitoring_Administration', help="help hw_monitoring.Administration")
	class hw_monitoring_Administration_uptimeAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.hw_monitoring.Fan import Fan
			from unicorn_api.v5.sv0.hw_monitoring.Temperature import Temperature
			from unicorn_api.v5.sv0.hw_monitoring.Statistics import Statistics
			from unicorn_api.v5.sv0.hw_monitoring.NetworkStatistics import NetworkStatistics
			from unicorn_api.v5.sv0.hw_monitoring.DriveInfo import DriveInfo
			from unicorn_api.v5.sv0.hw_monitoring.PowerSupply import PowerSupply
			from unicorn_api.v5.sv0.hw_monitoring.SmartInfo import SmartInfo
			from unicorn_api.v5.sv0.hw_monitoring import CasingState
			from unicorn_api.v5.sv0.hw_monitoring import HealthState

			from transformer.lib import ListInfo, ResultSet, List, Time
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.hw_monitoring.Administration import Administration
			service = Administration()
			global function, interactive
			function = service.uptime
			interactive = []
	methods['hw_monitoring.Administration.uptime'] = ('hw_monitoring_Administration', '--uptime')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	hw_monitoring_Administration.add_argument("--uptime", action=hw_monitoring_Administration_uptimeAction, nargs=nargs, metavar=metavars, help=help)
	class hw_monitoring_Administration_disk_infoAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.hw_monitoring.Fan import Fan
			from unicorn_api.v5.sv0.hw_monitoring.Temperature import Temperature
			from unicorn_api.v5.sv0.hw_monitoring.Statistics import Statistics
			from unicorn_api.v5.sv0.hw_monitoring.NetworkStatistics import NetworkStatistics
			from unicorn_api.v5.sv0.hw_monitoring.DriveInfo import DriveInfo
			from unicorn_api.v5.sv0.hw_monitoring.PowerSupply import PowerSupply
			from unicorn_api.v5.sv0.hw_monitoring.SmartInfo import SmartInfo
			from unicorn_api.v5.sv0.hw_monitoring import CasingState
			from unicorn_api.v5.sv0.hw_monitoring import HealthState

			from transformer.lib import ListInfo, ResultSet, List, Time
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.hw_monitoring.Administration import Administration
			service = Administration()
			global function, interactive
			function = service.disk_info
			interactive = []
			interactive.append(('slot', cli_int))
	methods['hw_monitoring.Administration.disk_info'] = ('hw_monitoring_Administration', '--disk_info')
	metavars = () if interactive_mode else ('slot')
	help = '' if interactive_mode else '%s ' % ('int')
	nargs = 0 if interactive_mode else 1
	hw_monitoring_Administration.add_argument("--disk_info", action=hw_monitoring_Administration_disk_infoAction, nargs=nargs, metavar=metavars, help=help)
	class hw_monitoring_Administration_list_temperaturesAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.hw_monitoring.Fan import Fan
			from unicorn_api.v5.sv0.hw_monitoring.Temperature import Temperature
			from unicorn_api.v5.sv0.hw_monitoring.Statistics import Statistics
			from unicorn_api.v5.sv0.hw_monitoring.NetworkStatistics import NetworkStatistics
			from unicorn_api.v5.sv0.hw_monitoring.DriveInfo import DriveInfo
			from unicorn_api.v5.sv0.hw_monitoring.PowerSupply import PowerSupply
			from unicorn_api.v5.sv0.hw_monitoring.SmartInfo import SmartInfo
			from unicorn_api.v5.sv0.hw_monitoring import CasingState
			from unicorn_api.v5.sv0.hw_monitoring import HealthState

			from transformer.lib import ListInfo, ResultSet, List, Time
			checker = [cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.hw_monitoring.Administration import Administration
			service = Administration()
			global function, interactive
			function = service.list_temperatures
			interactive = []
			interactive.append(('list_info', cli_list_info))
	methods['hw_monitoring.Administration.list_temperatures'] = ('hw_monitoring_Administration', '--list_temperatures')
	metavars = () if interactive_mode else ('list_info')
	help = '' if interactive_mode else '%s ' % ('offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 1
	hw_monitoring_Administration.add_argument("--list_temperatures", action=hw_monitoring_Administration_list_temperaturesAction, nargs=nargs, metavar=metavars, help=help)
	class hw_monitoring_Administration_list_fansAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.hw_monitoring.Fan import Fan
			from unicorn_api.v5.sv0.hw_monitoring.Temperature import Temperature
			from unicorn_api.v5.sv0.hw_monitoring.Statistics import Statistics
			from unicorn_api.v5.sv0.hw_monitoring.NetworkStatistics import NetworkStatistics
			from unicorn_api.v5.sv0.hw_monitoring.DriveInfo import DriveInfo
			from unicorn_api.v5.sv0.hw_monitoring.PowerSupply import PowerSupply
			from unicorn_api.v5.sv0.hw_monitoring.SmartInfo import SmartInfo
			from unicorn_api.v5.sv0.hw_monitoring import CasingState
			from unicorn_api.v5.sv0.hw_monitoring import HealthState

			from transformer.lib import ListInfo, ResultSet, List, Time
			checker = [cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.hw_monitoring.Administration import Administration
			service = Administration()
			global function, interactive
			function = service.list_fans
			interactive = []
			interactive.append(('list_info', cli_list_info))
	methods['hw_monitoring.Administration.list_fans'] = ('hw_monitoring_Administration', '--list_fans')
	metavars = () if interactive_mode else ('list_info')
	help = '' if interactive_mode else '%s ' % ('offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 1
	hw_monitoring_Administration.add_argument("--list_fans", action=hw_monitoring_Administration_list_fansAction, nargs=nargs, metavar=metavars, help=help)
	class hw_monitoring_Administration_is_buzzer_activeAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.hw_monitoring.Fan import Fan
			from unicorn_api.v5.sv0.hw_monitoring.Temperature import Temperature
			from unicorn_api.v5.sv0.hw_monitoring.Statistics import Statistics
			from unicorn_api.v5.sv0.hw_monitoring.NetworkStatistics import NetworkStatistics
			from unicorn_api.v5.sv0.hw_monitoring.DriveInfo import DriveInfo
			from unicorn_api.v5.sv0.hw_monitoring.PowerSupply import PowerSupply
			from unicorn_api.v5.sv0.hw_monitoring.SmartInfo import SmartInfo
			from unicorn_api.v5.sv0.hw_monitoring import CasingState
			from unicorn_api.v5.sv0.hw_monitoring import HealthState

			from transformer.lib import ListInfo, ResultSet, List, Time
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.hw_monitoring.Administration import Administration
			service = Administration()
			global function, interactive
			function = service.is_buzzer_active
			interactive = []
	methods['hw_monitoring.Administration.is_buzzer_active'] = ('hw_monitoring_Administration', '--is_buzzer_active')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	hw_monitoring_Administration.add_argument("--is_buzzer_active", action=hw_monitoring_Administration_is_buzzer_activeAction, nargs=nargs, metavar=metavars, help=help)
	class hw_monitoring_Administration_casing_stateAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.hw_monitoring.Fan import Fan
			from unicorn_api.v5.sv0.hw_monitoring.Temperature import Temperature
			from unicorn_api.v5.sv0.hw_monitoring.Statistics import Statistics
			from unicorn_api.v5.sv0.hw_monitoring.NetworkStatistics import NetworkStatistics
			from unicorn_api.v5.sv0.hw_monitoring.DriveInfo import DriveInfo
			from unicorn_api.v5.sv0.hw_monitoring.PowerSupply import PowerSupply
			from unicorn_api.v5.sv0.hw_monitoring.SmartInfo import SmartInfo
			from unicorn_api.v5.sv0.hw_monitoring import CasingState
			from unicorn_api.v5.sv0.hw_monitoring import HealthState

			from transformer.lib import ListInfo, ResultSet, List, Time
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.hw_monitoring.Administration import Administration
			service = Administration()
			global function, interactive
			function = service.casing_state
			interactive = []
	methods['hw_monitoring.Administration.casing_state'] = ('hw_monitoring_Administration', '--casing_state')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	hw_monitoring_Administration.add_argument("--casing_state", action=hw_monitoring_Administration_casing_stateAction, nargs=nargs, metavar=metavars, help=help)
	class hw_monitoring_Administration_abort_testAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.hw_monitoring.Fan import Fan
			from unicorn_api.v5.sv0.hw_monitoring.Temperature import Temperature
			from unicorn_api.v5.sv0.hw_monitoring.Statistics import Statistics
			from unicorn_api.v5.sv0.hw_monitoring.NetworkStatistics import NetworkStatistics
			from unicorn_api.v5.sv0.hw_monitoring.DriveInfo import DriveInfo
			from unicorn_api.v5.sv0.hw_monitoring.PowerSupply import PowerSupply
			from unicorn_api.v5.sv0.hw_monitoring.SmartInfo import SmartInfo
			from unicorn_api.v5.sv0.hw_monitoring import CasingState
			from unicorn_api.v5.sv0.hw_monitoring import HealthState

			from transformer.lib import ListInfo, ResultSet, List, Time
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.hw_monitoring.Administration import Administration
			service = Administration()
			global function, interactive
			function = service.abort_test
			interactive = []
			interactive.append(('slot', cli_int))
	methods['hw_monitoring.Administration.abort_test'] = ('hw_monitoring_Administration', '--abort_test')
	metavars = () if interactive_mode else ('slot')
	help = '' if interactive_mode else '%s ' % ('int')
	nargs = 0 if interactive_mode else 1
	hw_monitoring_Administration.add_argument("--abort_test", action=hw_monitoring_Administration_abort_testAction, nargs=nargs, metavar=metavars, help=help)
	class hw_monitoring_Administration_global_cpu_usageAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.hw_monitoring.Fan import Fan
			from unicorn_api.v5.sv0.hw_monitoring.Temperature import Temperature
			from unicorn_api.v5.sv0.hw_monitoring.Statistics import Statistics
			from unicorn_api.v5.sv0.hw_monitoring.NetworkStatistics import NetworkStatistics
			from unicorn_api.v5.sv0.hw_monitoring.DriveInfo import DriveInfo
			from unicorn_api.v5.sv0.hw_monitoring.PowerSupply import PowerSupply
			from unicorn_api.v5.sv0.hw_monitoring.SmartInfo import SmartInfo
			from unicorn_api.v5.sv0.hw_monitoring import CasingState
			from unicorn_api.v5.sv0.hw_monitoring import HealthState

			from transformer.lib import ListInfo, ResultSet, List, Time
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.hw_monitoring.Administration import Administration
			service = Administration()
			global function, interactive
			function = service.global_cpu_usage
			interactive = []
	methods['hw_monitoring.Administration.global_cpu_usage'] = ('hw_monitoring_Administration', '--global_cpu_usage')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	hw_monitoring_Administration.add_argument("--global_cpu_usage", action=hw_monitoring_Administration_global_cpu_usageAction, nargs=nargs, metavar=metavars, help=help)
	class hw_monitoring_Administration_is_buzzer_enabledAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.hw_monitoring.Fan import Fan
			from unicorn_api.v5.sv0.hw_monitoring.Temperature import Temperature
			from unicorn_api.v5.sv0.hw_monitoring.Statistics import Statistics
			from unicorn_api.v5.sv0.hw_monitoring.NetworkStatistics import NetworkStatistics
			from unicorn_api.v5.sv0.hw_monitoring.DriveInfo import DriveInfo
			from unicorn_api.v5.sv0.hw_monitoring.PowerSupply import PowerSupply
			from unicorn_api.v5.sv0.hw_monitoring.SmartInfo import SmartInfo
			from unicorn_api.v5.sv0.hw_monitoring import CasingState
			from unicorn_api.v5.sv0.hw_monitoring import HealthState

			from transformer.lib import ListInfo, ResultSet, List, Time
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.hw_monitoring.Administration import Administration
			service = Administration()
			global function, interactive
			function = service.is_buzzer_enabled
			interactive = []
	methods['hw_monitoring.Administration.is_buzzer_enabled'] = ('hw_monitoring_Administration', '--is_buzzer_enabled')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	hw_monitoring_Administration.add_argument("--is_buzzer_enabled", action=hw_monitoring_Administration_is_buzzer_enabledAction, nargs=nargs, metavar=metavars, help=help)
	class hw_monitoring_Administration_list_power_supplyAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.hw_monitoring.Fan import Fan
			from unicorn_api.v5.sv0.hw_monitoring.Temperature import Temperature
			from unicorn_api.v5.sv0.hw_monitoring.Statistics import Statistics
			from unicorn_api.v5.sv0.hw_monitoring.NetworkStatistics import NetworkStatistics
			from unicorn_api.v5.sv0.hw_monitoring.DriveInfo import DriveInfo
			from unicorn_api.v5.sv0.hw_monitoring.PowerSupply import PowerSupply
			from unicorn_api.v5.sv0.hw_monitoring.SmartInfo import SmartInfo
			from unicorn_api.v5.sv0.hw_monitoring import CasingState
			from unicorn_api.v5.sv0.hw_monitoring import HealthState

			from transformer.lib import ListInfo, ResultSet, List, Time
			checker = [cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.hw_monitoring.Administration import Administration
			service = Administration()
			global function, interactive
			function = service.list_power_supply
			interactive = []
			interactive.append(('list_info', cli_list_info))
	methods['hw_monitoring.Administration.list_power_supply'] = ('hw_monitoring_Administration', '--list_power_supply')
	metavars = () if interactive_mode else ('list_info')
	help = '' if interactive_mode else '%s ' % ('offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 1
	hw_monitoring_Administration.add_argument("--list_power_supply", action=hw_monitoring_Administration_list_power_supplyAction, nargs=nargs, metavar=metavars, help=help)
	class hw_monitoring_Administration_is_identify_enabledAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.hw_monitoring.Fan import Fan
			from unicorn_api.v5.sv0.hw_monitoring.Temperature import Temperature
			from unicorn_api.v5.sv0.hw_monitoring.Statistics import Statistics
			from unicorn_api.v5.sv0.hw_monitoring.NetworkStatistics import NetworkStatistics
			from unicorn_api.v5.sv0.hw_monitoring.DriveInfo import DriveInfo
			from unicorn_api.v5.sv0.hw_monitoring.PowerSupply import PowerSupply
			from unicorn_api.v5.sv0.hw_monitoring.SmartInfo import SmartInfo
			from unicorn_api.v5.sv0.hw_monitoring import CasingState
			from unicorn_api.v5.sv0.hw_monitoring import HealthState

			from transformer.lib import ListInfo, ResultSet, List, Time
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.hw_monitoring.Administration import Administration
			service = Administration()
			global function, interactive
			function = service.is_identify_enabled
			interactive = []
	methods['hw_monitoring.Administration.is_identify_enabled'] = ('hw_monitoring_Administration', '--is_identify_enabled')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	hw_monitoring_Administration.add_argument("--is_identify_enabled", action=hw_monitoring_Administration_is_identify_enabledAction, nargs=nargs, metavar=metavars, help=help)
	class hw_monitoring_Administration_list_cpus_infoAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.hw_monitoring.Fan import Fan
			from unicorn_api.v5.sv0.hw_monitoring.Temperature import Temperature
			from unicorn_api.v5.sv0.hw_monitoring.Statistics import Statistics
			from unicorn_api.v5.sv0.hw_monitoring.NetworkStatistics import NetworkStatistics
			from unicorn_api.v5.sv0.hw_monitoring.DriveInfo import DriveInfo
			from unicorn_api.v5.sv0.hw_monitoring.PowerSupply import PowerSupply
			from unicorn_api.v5.sv0.hw_monitoring.SmartInfo import SmartInfo
			from unicorn_api.v5.sv0.hw_monitoring import CasingState
			from unicorn_api.v5.sv0.hw_monitoring import HealthState

			from transformer.lib import ListInfo, ResultSet, List, Time
			checker = [cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.hw_monitoring.Administration import Administration
			service = Administration()
			global function, interactive
			function = service.list_cpus_info
			interactive = []
			interactive.append(('list_info', cli_list_info))
	methods['hw_monitoring.Administration.list_cpus_info'] = ('hw_monitoring_Administration', '--list_cpus_info')
	metavars = () if interactive_mode else ('list_info')
	help = '' if interactive_mode else '%s ' % ('offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 1
	hw_monitoring_Administration.add_argument("--list_cpus_info", action=hw_monitoring_Administration_list_cpus_infoAction, nargs=nargs, metavar=metavars, help=help)
	class hw_monitoring_Administration_identifyAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.hw_monitoring.Fan import Fan
			from unicorn_api.v5.sv0.hw_monitoring.Temperature import Temperature
			from unicorn_api.v5.sv0.hw_monitoring.Statistics import Statistics
			from unicorn_api.v5.sv0.hw_monitoring.NetworkStatistics import NetworkStatistics
			from unicorn_api.v5.sv0.hw_monitoring.DriveInfo import DriveInfo
			from unicorn_api.v5.sv0.hw_monitoring.PowerSupply import PowerSupply
			from unicorn_api.v5.sv0.hw_monitoring.SmartInfo import SmartInfo
			from unicorn_api.v5.sv0.hw_monitoring import CasingState
			from unicorn_api.v5.sv0.hw_monitoring import HealthState

			from transformer.lib import ListInfo, ResultSet, List, Time
			checker = [cli_bool]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.hw_monitoring.Administration import Administration
			service = Administration()
			global function, interactive
			function = service.identify
			interactive = []
			interactive.append(('enable', cli_bool))
	methods['hw_monitoring.Administration.identify'] = ('hw_monitoring_Administration', '--identify')
	metavars = () if interactive_mode else ('enable')
	help = '' if interactive_mode else '%s ' % ('True|False')
	nargs = 0 if interactive_mode else 1
	hw_monitoring_Administration.add_argument("--identify", action=hw_monitoring_Administration_identifyAction, nargs=nargs, metavar=metavars, help=help)
	class hw_monitoring_Administration_run_smart_testAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.hw_monitoring.Fan import Fan
			from unicorn_api.v5.sv0.hw_monitoring.Temperature import Temperature
			from unicorn_api.v5.sv0.hw_monitoring.Statistics import Statistics
			from unicorn_api.v5.sv0.hw_monitoring.NetworkStatistics import NetworkStatistics
			from unicorn_api.v5.sv0.hw_monitoring.DriveInfo import DriveInfo
			from unicorn_api.v5.sv0.hw_monitoring.PowerSupply import PowerSupply
			from unicorn_api.v5.sv0.hw_monitoring.SmartInfo import SmartInfo
			from unicorn_api.v5.sv0.hw_monitoring import CasingState
			from unicorn_api.v5.sv0.hw_monitoring import HealthState

			from transformer.lib import ListInfo, ResultSet, List, Time
			checker = [cli_unicode,cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.hw_monitoring.Administration import Administration
			service = Administration()
			global function, interactive
			function = service.run_smart_test
			interactive = []
			interactive.append(('async_job_name', cli_unicode))
			interactive.append(('slot', cli_int))
	methods['hw_monitoring.Administration.run_smart_test'] = ('hw_monitoring_Administration', '--run_smart_test')
	metavars = () if interactive_mode else ('async_job_name','slot')
	help = '' if interactive_mode else '%s ' % ('int')
	nargs = 0 if interactive_mode else 2
	hw_monitoring_Administration.add_argument("--run_smart_test", action=hw_monitoring_Administration_run_smart_testAction, nargs=nargs, metavar=metavars, help=help)
	class hw_monitoring_Administration_run_smart_testResultAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.hw_monitoring.Administration import Administration
			service = Administration()
			global function, interactive
			function = service.run_smart_test_result
			interactive = []
			interactive.append(('async_job_id', cli_int))
	methods['hw_monitoring.Administration.run_smart_test_result'] = ('hw_monitoring_Administration', '--run_smart_test_result')
	metavars = () if interactive_mode else ('async_job_id')
	nargs = 0 if interactive_mode else 1
	hw_monitoring_Administration.add_argument("--run_smart_test_result", action=hw_monitoring_Administration_run_smart_testResultAction, nargs=nargs, metavar=metavars)
	class hw_monitoring_Administration_list_networks_infoAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.hw_monitoring.Fan import Fan
			from unicorn_api.v5.sv0.hw_monitoring.Temperature import Temperature
			from unicorn_api.v5.sv0.hw_monitoring.Statistics import Statistics
			from unicorn_api.v5.sv0.hw_monitoring.NetworkStatistics import NetworkStatistics
			from unicorn_api.v5.sv0.hw_monitoring.DriveInfo import DriveInfo
			from unicorn_api.v5.sv0.hw_monitoring.PowerSupply import PowerSupply
			from unicorn_api.v5.sv0.hw_monitoring.SmartInfo import SmartInfo
			from unicorn_api.v5.sv0.hw_monitoring import CasingState
			from unicorn_api.v5.sv0.hw_monitoring import HealthState

			from transformer.lib import ListInfo, ResultSet, List, Time
			checker = [cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.hw_monitoring.Administration import Administration
			service = Administration()
			global function, interactive
			function = service.list_networks_info
			interactive = []
			interactive.append(('list_info', cli_list_info))
	methods['hw_monitoring.Administration.list_networks_info'] = ('hw_monitoring_Administration', '--list_networks_info')
	metavars = () if interactive_mode else ('list_info')
	help = '' if interactive_mode else '%s ' % ('offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 1
	hw_monitoring_Administration.add_argument("--list_networks_info", action=hw_monitoring_Administration_list_networks_infoAction, nargs=nargs, metavar=metavars, help=help)
	class hw_monitoring_Administration_list_drives_infoAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.hw_monitoring.Fan import Fan
			from unicorn_api.v5.sv0.hw_monitoring.Temperature import Temperature
			from unicorn_api.v5.sv0.hw_monitoring.Statistics import Statistics
			from unicorn_api.v5.sv0.hw_monitoring.NetworkStatistics import NetworkStatistics
			from unicorn_api.v5.sv0.hw_monitoring.DriveInfo import DriveInfo
			from unicorn_api.v5.sv0.hw_monitoring.PowerSupply import PowerSupply
			from unicorn_api.v5.sv0.hw_monitoring.SmartInfo import SmartInfo
			from unicorn_api.v5.sv0.hw_monitoring import CasingState
			from unicorn_api.v5.sv0.hw_monitoring import HealthState

			from transformer.lib import ListInfo, ResultSet, List, Time
			checker = [cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.hw_monitoring.Administration import Administration
			service = Administration()
			global function, interactive
			function = service.list_drives_info
			interactive = []
			interactive.append(('list_info', cli_list_info))
	methods['hw_monitoring.Administration.list_drives_info'] = ('hw_monitoring_Administration', '--list_drives_info')
	metavars = () if interactive_mode else ('list_info')
	help = '' if interactive_mode else '%s ' % ('offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 1
	hw_monitoring_Administration.add_argument("--list_drives_info", action=hw_monitoring_Administration_list_drives_infoAction, nargs=nargs, metavar=metavars, help=help)
	class hw_monitoring_Administration_clear_buzzerAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.hw_monitoring.Fan import Fan
			from unicorn_api.v5.sv0.hw_monitoring.Temperature import Temperature
			from unicorn_api.v5.sv0.hw_monitoring.Statistics import Statistics
			from unicorn_api.v5.sv0.hw_monitoring.NetworkStatistics import NetworkStatistics
			from unicorn_api.v5.sv0.hw_monitoring.DriveInfo import DriveInfo
			from unicorn_api.v5.sv0.hw_monitoring.PowerSupply import PowerSupply
			from unicorn_api.v5.sv0.hw_monitoring.SmartInfo import SmartInfo
			from unicorn_api.v5.sv0.hw_monitoring import CasingState
			from unicorn_api.v5.sv0.hw_monitoring import HealthState

			from transformer.lib import ListInfo, ResultSet, List, Time
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.hw_monitoring.Administration import Administration
			service = Administration()
			global function, interactive
			function = service.clear_buzzer
			interactive = []
	methods['hw_monitoring.Administration.clear_buzzer'] = ('hw_monitoring_Administration', '--clear_buzzer')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	hw_monitoring_Administration.add_argument("--clear_buzzer", action=hw_monitoring_Administration_clear_buzzerAction, nargs=nargs, metavar=metavars, help=help)
	class hw_monitoring_Administration_enable_buzzerAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.hw_monitoring.Fan import Fan
			from unicorn_api.v5.sv0.hw_monitoring.Temperature import Temperature
			from unicorn_api.v5.sv0.hw_monitoring.Statistics import Statistics
			from unicorn_api.v5.sv0.hw_monitoring.NetworkStatistics import NetworkStatistics
			from unicorn_api.v5.sv0.hw_monitoring.DriveInfo import DriveInfo
			from unicorn_api.v5.sv0.hw_monitoring.PowerSupply import PowerSupply
			from unicorn_api.v5.sv0.hw_monitoring.SmartInfo import SmartInfo
			from unicorn_api.v5.sv0.hw_monitoring import CasingState
			from unicorn_api.v5.sv0.hw_monitoring import HealthState

			from transformer.lib import ListInfo, ResultSet, List, Time
			checker = [cli_bool]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.hw_monitoring.Administration import Administration
			service = Administration()
			global function, interactive
			function = service.enable_buzzer
			interactive = []
			interactive.append(('enable', cli_bool))
	methods['hw_monitoring.Administration.enable_buzzer'] = ('hw_monitoring_Administration', '--enable_buzzer')
	metavars = () if interactive_mode else ('enable')
	help = '' if interactive_mode else '%s ' % ('True|False')
	nargs = 0 if interactive_mode else 1
	hw_monitoring_Administration.add_argument("--enable_buzzer", action=hw_monitoring_Administration_enable_buzzerAction, nargs=nargs, metavar=metavars, help=help)
	class hw_monitoring_Administration_health_stateAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.hw_monitoring.Fan import Fan
			from unicorn_api.v5.sv0.hw_monitoring.Temperature import Temperature
			from unicorn_api.v5.sv0.hw_monitoring.Statistics import Statistics
			from unicorn_api.v5.sv0.hw_monitoring.NetworkStatistics import NetworkStatistics
			from unicorn_api.v5.sv0.hw_monitoring.DriveInfo import DriveInfo
			from unicorn_api.v5.sv0.hw_monitoring.PowerSupply import PowerSupply
			from unicorn_api.v5.sv0.hw_monitoring.SmartInfo import SmartInfo
			from unicorn_api.v5.sv0.hw_monitoring import CasingState
			from unicorn_api.v5.sv0.hw_monitoring import HealthState

			from transformer.lib import ListInfo, ResultSet, List, Time
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.hw_monitoring.Administration import Administration
			service = Administration()
			global function, interactive
			function = service.health_state
			interactive = []
	methods['hw_monitoring.Administration.health_state'] = ('hw_monitoring_Administration', '--health_state')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	hw_monitoring_Administration.add_argument("--health_state", action=hw_monitoring_Administration_health_stateAction, nargs=nargs, metavar=metavars, help=help)
	class hw_monitoring_Administration_ram_infoAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.hw_monitoring.Fan import Fan
			from unicorn_api.v5.sv0.hw_monitoring.Temperature import Temperature
			from unicorn_api.v5.sv0.hw_monitoring.Statistics import Statistics
			from unicorn_api.v5.sv0.hw_monitoring.NetworkStatistics import NetworkStatistics
			from unicorn_api.v5.sv0.hw_monitoring.DriveInfo import DriveInfo
			from unicorn_api.v5.sv0.hw_monitoring.PowerSupply import PowerSupply
			from unicorn_api.v5.sv0.hw_monitoring.SmartInfo import SmartInfo
			from unicorn_api.v5.sv0.hw_monitoring import CasingState
			from unicorn_api.v5.sv0.hw_monitoring import HealthState

			from transformer.lib import ListInfo, ResultSet, List, Time
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.hw_monitoring.Administration import Administration
			service = Administration()
			global function, interactive
			function = service.ram_info
			interactive = []
	methods['hw_monitoring.Administration.ram_info'] = ('hw_monitoring_Administration', '--ram_info')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	hw_monitoring_Administration.add_argument("--ram_info", action=hw_monitoring_Administration_ram_infoAction, nargs=nargs, metavar=metavars, help=help)
	system_System = subparsers.add_parser('system_System', help="help system.System")
	class system_System_set_timezoneAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.system import ShutdownAction
			from unicorn_api.v5.sv0.system.NtpInfo import NtpInfo
			from unicorn_api.v5.sv0.system.GeneralInfo import GeneralInfo
			from unicorn_api.v5.sv0.system.BrandingInfo import BrandingInfo

			from transformer.lib import List, Date
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.system.System import System
			service = System()
			global function, interactive
			function = service.set_timezone
			interactive = []
			interactive.append(('timezone', cli_unicode))
	methods['system.System.set_timezone'] = ('system_System', '--set_timezone')
	metavars = () if interactive_mode else ('timezone')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 1
	system_System.add_argument("--set_timezone", action=system_System_set_timezoneAction, nargs=nargs, metavar=metavars, help=help)
	class system_System_get_timezones_listAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.system import ShutdownAction
			from unicorn_api.v5.sv0.system.NtpInfo import NtpInfo
			from unicorn_api.v5.sv0.system.GeneralInfo import GeneralInfo
			from unicorn_api.v5.sv0.system.BrandingInfo import BrandingInfo

			from transformer.lib import List, Date
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.system.System import System
			service = System()
			global function, interactive
			function = service.get_timezones_list
			interactive = []
	methods['system.System.get_timezones_list'] = ('system_System', '--get_timezones_list')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	system_System.add_argument("--get_timezones_list", action=system_System_get_timezones_listAction, nargs=nargs, metavar=metavars, help=help)
	class system_System_get_infosAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.system import ShutdownAction
			from unicorn_api.v5.sv0.system.NtpInfo import NtpInfo
			from unicorn_api.v5.sv0.system.GeneralInfo import GeneralInfo
			from unicorn_api.v5.sv0.system.BrandingInfo import BrandingInfo

			from transformer.lib import List, Date
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.system.System import System
			service = System()
			global function, interactive
			function = service.get_infos
			interactive = []
	methods['system.System.get_infos'] = ('system_System', '--get_infos')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	system_System.add_argument("--get_infos", action=system_System_get_infosAction, nargs=nargs, metavar=metavars, help=help)
	class system_System_get_branding_infoAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.system import ShutdownAction
			from unicorn_api.v5.sv0.system.NtpInfo import NtpInfo
			from unicorn_api.v5.sv0.system.GeneralInfo import GeneralInfo
			from unicorn_api.v5.sv0.system.BrandingInfo import BrandingInfo

			from transformer.lib import List, Date
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.system.System import System
			service = System()
			global function, interactive
			function = service.get_branding_info
			interactive = []
	methods['system.System.get_branding_info'] = ('system_System', '--get_branding_info')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	system_System.add_argument("--get_branding_info", action=system_System_get_branding_infoAction, nargs=nargs, metavar=metavars, help=help)
	class system_System_get_ntp_infoAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.system import ShutdownAction
			from unicorn_api.v5.sv0.system.NtpInfo import NtpInfo
			from unicorn_api.v5.sv0.system.GeneralInfo import GeneralInfo
			from unicorn_api.v5.sv0.system.BrandingInfo import BrandingInfo

			from transformer.lib import List, Date
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.system.System import System
			service = System()
			global function, interactive
			function = service.get_ntp_info
			interactive = []
	methods['system.System.get_ntp_info'] = ('system_System', '--get_ntp_info')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	system_System.add_argument("--get_ntp_info", action=system_System_get_ntp_infoAction, nargs=nargs, metavar=metavars, help=help)
	class system_System_get_dateAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.system import ShutdownAction
			from unicorn_api.v5.sv0.system.NtpInfo import NtpInfo
			from unicorn_api.v5.sv0.system.GeneralInfo import GeneralInfo
			from unicorn_api.v5.sv0.system.BrandingInfo import BrandingInfo

			from transformer.lib import List, Date
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.system.System import System
			service = System()
			global function, interactive
			function = service.get_date
			interactive = []
	methods['system.System.get_date'] = ('system_System', '--get_date')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	system_System.add_argument("--get_date", action=system_System_get_dateAction, nargs=nargs, metavar=metavars, help=help)
	class system_System_enable_ntp_serverAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.system import ShutdownAction
			from unicorn_api.v5.sv0.system.NtpInfo import NtpInfo
			from unicorn_api.v5.sv0.system.GeneralInfo import GeneralInfo
			from unicorn_api.v5.sv0.system.BrandingInfo import BrandingInfo

			from transformer.lib import List, Date
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.system.System import System
			service = System()
			global function, interactive
			function = service.enable_ntp_server
			interactive = []
			interactive.append(('name', cli_unicode))
	methods['system.System.enable_ntp_server'] = ('system_System', '--enable_ntp_server')
	metavars = () if interactive_mode else ('name')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 1
	system_System.add_argument("--enable_ntp_server", action=system_System_enable_ntp_serverAction, nargs=nargs, metavar=metavars, help=help)
	class system_System_set_dateAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.system import ShutdownAction
			from unicorn_api.v5.sv0.system.NtpInfo import NtpInfo
			from unicorn_api.v5.sv0.system.GeneralInfo import GeneralInfo
			from unicorn_api.v5.sv0.system.BrandingInfo import BrandingInfo

			from transformer.lib import List, Date
			checker = [cli_date]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.system.System import System
			service = System()
			global function, interactive
			function = service.set_date
			interactive = []
			interactive.append(('date', cli_date))
	methods['system.System.set_date'] = ('system_System', '--set_date')
	metavars = () if interactive_mode else ('date')
	help = '' if interactive_mode else '%s ' % ('long')
	nargs = 0 if interactive_mode else 1
	system_System.add_argument("--set_date", action=system_System_set_dateAction, nargs=nargs, metavar=metavars, help=help)
	class system_System_shutdownAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.system import ShutdownAction
			from unicorn_api.v5.sv0.system.NtpInfo import NtpInfo
			from unicorn_api.v5.sv0.system.GeneralInfo import GeneralInfo
			from unicorn_api.v5.sv0.system.BrandingInfo import BrandingInfo

			from transformer.lib import List, Date
			checker = [ShutdownAction]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.system.System import System
			service = System()
			global function, interactive
			function = service.shutdown
			interactive = []
			interactive.append(('shutdown_action', ShutdownAction))
	methods['system.System.shutdown'] = ('system_System', '--shutdown')
	metavars = () if interactive_mode else ('shutdown_action')
	help = '' if interactive_mode else '%s ' % ('SLEEP|REBOOT|SHUTDOWN')
	nargs = 0 if interactive_mode else 1
	system_System.add_argument("--shutdown", action=system_System_shutdownAction, nargs=nargs, metavar=metavars, help=help)
	class system_System_disable_ntpAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.system import ShutdownAction
			from unicorn_api.v5.sv0.system.NtpInfo import NtpInfo
			from unicorn_api.v5.sv0.system.GeneralInfo import GeneralInfo
			from unicorn_api.v5.sv0.system.BrandingInfo import BrandingInfo

			from transformer.lib import List, Date
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.system.System import System
			service = System()
			global function, interactive
			function = service.disable_ntp
			interactive = []
	methods['system.System.disable_ntp'] = ('system_System', '--disable_ntp')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	system_System.add_argument("--disable_ntp", action=system_System_disable_ntpAction, nargs=nargs, metavar=metavars, help=help)
	class system_System_get_timezoneAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.system import ShutdownAction
			from unicorn_api.v5.sv0.system.NtpInfo import NtpInfo
			from unicorn_api.v5.sv0.system.GeneralInfo import GeneralInfo
			from unicorn_api.v5.sv0.system.BrandingInfo import BrandingInfo

			from transformer.lib import List, Date
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.system.System import System
			service = System()
			global function, interactive
			function = service.get_timezone
			interactive = []
	methods['system.System.get_timezone'] = ('system_System', '--get_timezone')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	system_System.add_argument("--get_timezone", action=system_System_get_timezoneAction, nargs=nargs, metavar=metavars, help=help)
	authentication_groups_Administration = subparsers.add_parser('authentication_groups_Administration', help="help authentication.groups.Administration")
	class authentication_groups_Administration_add_local_groupAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.user_group_share.Group import Group
			from unicorn_api.v5.sv0.user_group_share import UserType
			from unicorn_api.v5.sv0.user_group_share.User import User
			from unicorn_api.v5.sv0.user_group_share.DomainGroup import DomainGroup
			from unicorn_api.v5.sv0.user_group_share.ImportGroupError import ImportGroupError

			from transformer.lib import List, ListInfo, ResultSet
			checker = [Group]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.GroupAdministration import GroupAdministration
			service = GroupAdministration()
			global function, interactive
			function = service.add_local_group
			interactive = []
			interactive.append(('group', Group))
	methods['authentication.groups.Administration.add_local_group'] = ('authentication_groups_Administration', '--add_local_group')
	metavars = () if interactive_mode else ('group')
	help = '' if interactive_mode else '%s ' % ('{"name":text,"type":domain|local,#"comment":text#,#"sid":text#}')
	nargs = 0 if interactive_mode else 1
	authentication_groups_Administration.add_argument("--add_local_group", action=authentication_groups_Administration_add_local_groupAction, nargs=nargs, metavar=metavars, help=help)
	class authentication_groups_Administration_import_from_domainAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.user_group_share.Group import Group
			from unicorn_api.v5.sv0.user_group_share import UserType
			from unicorn_api.v5.sv0.user_group_share.User import User
			from unicorn_api.v5.sv0.user_group_share.DomainGroup import DomainGroup
			from unicorn_api.v5.sv0.user_group_share.ImportGroupError import ImportGroupError

			from transformer.lib import List, ListInfo, ResultSet
			checker = [list_cli(DomainGroup)]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.GroupAdministration import GroupAdministration
			service = GroupAdministration()
			global function, interactive
			function = service.import_from_domain
			interactive = []
			interactive.append(('groups', list_cli(DomainGroup)))
	methods['authentication.groups.Administration.import_from_domain'] = ('authentication_groups_Administration', '--import_from_domain')
	metavars = () if interactive_mode else ('groups')
	help = '' if interactive_mode else '%s ' % ('["{"comment":text,"name":text,"sid":text}",...]')
	nargs = 0 if interactive_mode else 1
	authentication_groups_Administration.add_argument("--import_from_domain", action=authentication_groups_Administration_import_from_domainAction, nargs=nargs, metavar=metavars, help=help)
	class authentication_groups_Administration_listAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.user_group_share.Group import Group
			from unicorn_api.v5.sv0.user_group_share import UserType
			from unicorn_api.v5.sv0.user_group_share.User import User
			from unicorn_api.v5.sv0.user_group_share.DomainGroup import DomainGroup
			from unicorn_api.v5.sv0.user_group_share.ImportGroupError import ImportGroupError

			from transformer.lib import List, ListInfo, ResultSet
			checker = [list_cli(unicode),cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.GroupAdministration import GroupAdministration
			service = GroupAdministration()
			global function, interactive
			function = service.list
			interactive = []
			interactive.append(('with_parameters', list_cli(unicode)))
			interactive.append(('list_info', cli_list_info))
	methods['authentication.groups.Administration.list'] = ('authentication_groups_Administration', '--list')
	metavars = () if interactive_mode else ('with_parameters','list_info')
	help = '' if interactive_mode else '%s %s ' % ('["text",...]', 'offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 2
	authentication_groups_Administration.add_argument("--list", action=authentication_groups_Administration_listAction, nargs=nargs, metavar=metavars, help=help)
	class authentication_groups_Administration_remove_user_from_groupsAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.user_group_share.Group import Group
			from unicorn_api.v5.sv0.user_group_share import UserType
			from unicorn_api.v5.sv0.user_group_share.User import User
			from unicorn_api.v5.sv0.user_group_share.DomainGroup import DomainGroup
			from unicorn_api.v5.sv0.user_group_share.ImportGroupError import ImportGroupError

			from transformer.lib import List, ListInfo, ResultSet
			checker = [cli_int,list_cli(int)]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.GroupAdministration import GroupAdministration
			service = GroupAdministration()
			global function, interactive
			function = service.remove_user_from_groups
			interactive = []
			interactive.append(('user_id', cli_int))
			interactive.append(('groups_id', list_cli(int)))
	methods['authentication.groups.Administration.remove_user_from_groups'] = ('authentication_groups_Administration', '--remove_user_from_groups')
	metavars = () if interactive_mode else ('user_id','groups_id')
	help = '' if interactive_mode else '%s %s ' % ('int', '["int",...]')
	nargs = 0 if interactive_mode else 2
	authentication_groups_Administration.add_argument("--remove_user_from_groups", action=authentication_groups_Administration_remove_user_from_groupsAction, nargs=nargs, metavar=metavars, help=help)
	class authentication_groups_Administration_get_usersAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.user_group_share.Group import Group
			from unicorn_api.v5.sv0.user_group_share import UserType
			from unicorn_api.v5.sv0.user_group_share.User import User
			from unicorn_api.v5.sv0.user_group_share.DomainGroup import DomainGroup
			from unicorn_api.v5.sv0.user_group_share.ImportGroupError import ImportGroupError

			from transformer.lib import List, ListInfo, ResultSet
			checker = [cli_int,cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.GroupAdministration import GroupAdministration
			service = GroupAdministration()
			global function, interactive
			function = service.get_users
			interactive = []
			interactive.append(('group_id', cli_int))
			interactive.append(('list_info', cli_list_info))
	methods['authentication.groups.Administration.get_users'] = ('authentication_groups_Administration', '--get_users')
	metavars = () if interactive_mode else ('group_id','list_info')
	help = '' if interactive_mode else '%s %s ' % ('int', 'offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 2
	authentication_groups_Administration.add_argument("--get_users", action=authentication_groups_Administration_get_usersAction, nargs=nargs, metavar=metavars, help=help)
	class authentication_groups_Administration_add_usersAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.user_group_share.Group import Group
			from unicorn_api.v5.sv0.user_group_share import UserType
			from unicorn_api.v5.sv0.user_group_share.User import User
			from unicorn_api.v5.sv0.user_group_share.DomainGroup import DomainGroup
			from unicorn_api.v5.sv0.user_group_share.ImportGroupError import ImportGroupError

			from transformer.lib import List, ListInfo, ResultSet
			checker = [cli_int,list_cli(int)]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.GroupAdministration import GroupAdministration
			service = GroupAdministration()
			global function, interactive
			function = service.add_users
			interactive = []
			interactive.append(('group_id', cli_int))
			interactive.append(('users_id', list_cli(int)))
	methods['authentication.groups.Administration.add_users'] = ('authentication_groups_Administration', '--add_users')
	metavars = () if interactive_mode else ('group_id','users_id')
	help = '' if interactive_mode else '%s %s ' % ('int', '["int",...]')
	nargs = 0 if interactive_mode else 2
	authentication_groups_Administration.add_argument("--add_users", action=authentication_groups_Administration_add_usersAction, nargs=nargs, metavar=metavars, help=help)
	class authentication_groups_Administration_list_groups_from_domainAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.user_group_share.Group import Group
			from unicorn_api.v5.sv0.user_group_share import UserType
			from unicorn_api.v5.sv0.user_group_share.User import User
			from unicorn_api.v5.sv0.user_group_share.DomainGroup import DomainGroup
			from unicorn_api.v5.sv0.user_group_share.ImportGroupError import ImportGroupError

			from transformer.lib import List, ListInfo, ResultSet
			checker = [cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.GroupAdministration import GroupAdministration
			service = GroupAdministration()
			global function, interactive
			function = service.list_groups_from_domain
			interactive = []
			interactive.append(('list_info', cli_list_info))
	methods['authentication.groups.Administration.list_groups_from_domain'] = ('authentication_groups_Administration', '--list_groups_from_domain')
	metavars = () if interactive_mode else ('list_info')
	help = '' if interactive_mode else '%s ' % ('offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 1
	authentication_groups_Administration.add_argument("--list_groups_from_domain", action=authentication_groups_Administration_list_groups_from_domainAction, nargs=nargs, metavar=metavars, help=help)
	class authentication_groups_Administration_remove_usersAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.user_group_share.Group import Group
			from unicorn_api.v5.sv0.user_group_share import UserType
			from unicorn_api.v5.sv0.user_group_share.User import User
			from unicorn_api.v5.sv0.user_group_share.DomainGroup import DomainGroup
			from unicorn_api.v5.sv0.user_group_share.ImportGroupError import ImportGroupError

			from transformer.lib import List, ListInfo, ResultSet
			checker = [cli_int,list_cli(int)]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.GroupAdministration import GroupAdministration
			service = GroupAdministration()
			global function, interactive
			function = service.remove_users
			interactive = []
			interactive.append(('group_id', cli_int))
			interactive.append(('users_id', list_cli(int)))
	methods['authentication.groups.Administration.remove_users'] = ('authentication_groups_Administration', '--remove_users')
	metavars = () if interactive_mode else ('group_id','users_id')
	help = '' if interactive_mode else '%s %s ' % ('int', '["int",...]')
	nargs = 0 if interactive_mode else 2
	authentication_groups_Administration.add_argument("--remove_users", action=authentication_groups_Administration_remove_usersAction, nargs=nargs, metavar=metavars, help=help)
	class authentication_groups_Administration_check_name_availabilityAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.user_group_share.Group import Group
			from unicorn_api.v5.sv0.user_group_share import UserType
			from unicorn_api.v5.sv0.user_group_share.User import User
			from unicorn_api.v5.sv0.user_group_share.DomainGroup import DomainGroup
			from unicorn_api.v5.sv0.user_group_share.ImportGroupError import ImportGroupError

			from transformer.lib import List, ListInfo, ResultSet
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.GroupAdministration import GroupAdministration
			service = GroupAdministration()
			global function, interactive
			function = service.check_name_availability
			interactive = []
			interactive.append(('name', cli_unicode))
	methods['authentication.groups.Administration.check_name_availability'] = ('authentication_groups_Administration', '--check_name_availability')
	metavars = () if interactive_mode else ('name')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 1
	authentication_groups_Administration.add_argument("--check_name_availability", action=authentication_groups_Administration_check_name_availabilityAction, nargs=nargs, metavar=metavars, help=help)
	class authentication_groups_Administration_modifyAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.user_group_share.Group import Group
			from unicorn_api.v5.sv0.user_group_share import UserType
			from unicorn_api.v5.sv0.user_group_share.User import User
			from unicorn_api.v5.sv0.user_group_share.DomainGroup import DomainGroup
			from unicorn_api.v5.sv0.user_group_share.ImportGroupError import ImportGroupError

			from transformer.lib import List, ListInfo, ResultSet
			checker = [cli_int,Group]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.GroupAdministration import GroupAdministration
			service = GroupAdministration()
			global function, interactive
			function = service.modify
			interactive = []
			interactive.append(('group_id', cli_int))
			interactive.append(('group', Group))
	methods['authentication.groups.Administration.modify'] = ('authentication_groups_Administration', '--modify')
	metavars = () if interactive_mode else ('group_id','group')
	help = '' if interactive_mode else '%s %s ' % ('int', '{"name":text,"type":domain|local,#"comment":text#,#"sid":text#}')
	nargs = 0 if interactive_mode else 2
	authentication_groups_Administration.add_argument("--modify", action=authentication_groups_Administration_modifyAction, nargs=nargs, metavar=metavars, help=help)
	class authentication_groups_Administration_removeAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.user_group_share.Group import Group
			from unicorn_api.v5.sv0.user_group_share import UserType
			from unicorn_api.v5.sv0.user_group_share.User import User
			from unicorn_api.v5.sv0.user_group_share.DomainGroup import DomainGroup
			from unicorn_api.v5.sv0.user_group_share.ImportGroupError import ImportGroupError

			from transformer.lib import List, ListInfo, ResultSet
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.GroupAdministration import GroupAdministration
			service = GroupAdministration()
			global function, interactive
			function = service.remove
			interactive = []
			interactive.append(('group_id', cli_int))
	methods['authentication.groups.Administration.remove'] = ('authentication_groups_Administration', '--remove')
	metavars = () if interactive_mode else ('group_id')
	help = '' if interactive_mode else '%s ' % ('int')
	nargs = 0 if interactive_mode else 1
	authentication_groups_Administration.add_argument("--remove", action=authentication_groups_Administration_removeAction, nargs=nargs, metavar=metavars, help=help)
	class authentication_groups_Administration_myGroupsAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.user_group_share.Group import Group
			from unicorn_api.v5.sv0.user_group_share import UserType
			from unicorn_api.v5.sv0.user_group_share.User import User
			from unicorn_api.v5.sv0.user_group_share.DomainGroup import DomainGroup
			from unicorn_api.v5.sv0.user_group_share.ImportGroupError import ImportGroupError

			from transformer.lib import List, ListInfo, ResultSet
			checker = [cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.GroupAdministration import GroupAdministration
			service = GroupAdministration()
			global function, interactive
			function = service.myGroups
			interactive = []
			interactive.append(('list_info', cli_list_info))
	methods['authentication.groups.Administration.myGroups'] = ('authentication_groups_Administration', '--myGroups')
	metavars = () if interactive_mode else ('list_info')
	help = '' if interactive_mode else '%s ' % ('offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 1
	authentication_groups_Administration.add_argument("--myGroups", action=authentication_groups_Administration_myGroupsAction, nargs=nargs, metavar=metavars, help=help)
	class authentication_groups_Administration_get_group_by_nameAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.user_group_share.Group import Group
			from unicorn_api.v5.sv0.user_group_share import UserType
			from unicorn_api.v5.sv0.user_group_share.User import User
			from unicorn_api.v5.sv0.user_group_share.DomainGroup import DomainGroup
			from unicorn_api.v5.sv0.user_group_share.ImportGroupError import ImportGroupError

			from transformer.lib import List, ListInfo, ResultSet
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.GroupAdministration import GroupAdministration
			service = GroupAdministration()
			global function, interactive
			function = service.get_group_by_name
			interactive = []
			interactive.append(('name', cli_unicode))
	methods['authentication.groups.Administration.get_group_by_name'] = ('authentication_groups_Administration', '--get_group_by_name')
	metavars = () if interactive_mode else ('name')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 1
	authentication_groups_Administration.add_argument("--get_group_by_name", action=authentication_groups_Administration_get_group_by_nameAction, nargs=nargs, metavar=metavars, help=help)
	class authentication_groups_Administration_user_groupsAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.user_group_share.Group import Group
			from unicorn_api.v5.sv0.user_group_share import UserType
			from unicorn_api.v5.sv0.user_group_share.User import User
			from unicorn_api.v5.sv0.user_group_share.DomainGroup import DomainGroup
			from unicorn_api.v5.sv0.user_group_share.ImportGroupError import ImportGroupError

			from transformer.lib import List, ListInfo, ResultSet
			checker = [cli_int,cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.GroupAdministration import GroupAdministration
			service = GroupAdministration()
			global function, interactive
			function = service.user_groups
			interactive = []
			interactive.append(('user_id', cli_int))
			interactive.append(('list_info', cli_list_info))
	methods['authentication.groups.Administration.user_groups'] = ('authentication_groups_Administration', '--user_groups')
	metavars = () if interactive_mode else ('user_id','list_info')
	help = '' if interactive_mode else '%s %s ' % ('int', 'offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 2
	authentication_groups_Administration.add_argument("--user_groups", action=authentication_groups_Administration_user_groupsAction, nargs=nargs, metavar=metavars, help=help)
	class authentication_groups_Administration_add_user_to_groupsAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.user_group_share.Group import Group
			from unicorn_api.v5.sv0.user_group_share import UserType
			from unicorn_api.v5.sv0.user_group_share.User import User
			from unicorn_api.v5.sv0.user_group_share.DomainGroup import DomainGroup
			from unicorn_api.v5.sv0.user_group_share.ImportGroupError import ImportGroupError

			from transformer.lib import List, ListInfo, ResultSet
			checker = [cli_int,list_cli(int)]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.GroupAdministration import GroupAdministration
			service = GroupAdministration()
			global function, interactive
			function = service.add_user_to_groups
			interactive = []
			interactive.append(('user_id', cli_int))
			interactive.append(('groups_id', list_cli(int)))
	methods['authentication.groups.Administration.add_user_to_groups'] = ('authentication_groups_Administration', '--add_user_to_groups')
	metavars = () if interactive_mode else ('user_id','groups_id')
	help = '' if interactive_mode else '%s %s ' % ('int', '["int",...]')
	nargs = 0 if interactive_mode else 2
	authentication_groups_Administration.add_argument("--add_user_to_groups", action=authentication_groups_Administration_add_user_to_groupsAction, nargs=nargs, metavar=metavars, help=help)
	auto_update_administration_auto_update_service = subparsers.add_parser('auto_update_administration_auto_update_service', help="help auto_update.administration.auto_update_service")
	class auto_update_administration_auto_update_service_manual_get_updateAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.auto_update.AutoUpdateConfig import AutoUpdateConfig
			from unicorn_api.v5.sv0.auto_update.AutoUpdateStatus import AutoUpdateStatus

			from transformer.lib import List
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.auto_update.AutoUpdateService import AutoUpdateService
			service = AutoUpdateService()
			global function, interactive
			function = service.manual_get_update
			interactive = []
	methods['auto_update.administration.auto_update_service.manual_get_update'] = ('auto_update_administration_auto_update_service', '--manual_get_update')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	auto_update_administration_auto_update_service.add_argument("--manual_get_update", action=auto_update_administration_auto_update_service_manual_get_updateAction, nargs=nargs, metavar=metavars, help=help)
	class auto_update_administration_auto_update_service_install_update_capsuleAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.auto_update.AutoUpdateConfig import AutoUpdateConfig
			from unicorn_api.v5.sv0.auto_update.AutoUpdateStatus import AutoUpdateStatus

			from transformer.lib import List
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.auto_update.AutoUpdateService import AutoUpdateService
			service = AutoUpdateService()
			global function, interactive
			function = service.install_update_capsule
			interactive = []
	methods['auto_update.administration.auto_update_service.install_update_capsule'] = ('auto_update_administration_auto_update_service', '--install_update_capsule')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	auto_update_administration_auto_update_service.add_argument("--install_update_capsule", action=auto_update_administration_auto_update_service_install_update_capsuleAction, nargs=nargs, metavar=metavars, help=help)
	class auto_update_administration_auto_update_service_cancel_updateAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.auto_update.AutoUpdateConfig import AutoUpdateConfig
			from unicorn_api.v5.sv0.auto_update.AutoUpdateStatus import AutoUpdateStatus

			from transformer.lib import List
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.auto_update.AutoUpdateService import AutoUpdateService
			service = AutoUpdateService()
			global function, interactive
			function = service.cancel_update
			interactive = []
	methods['auto_update.administration.auto_update_service.cancel_update'] = ('auto_update_administration_auto_update_service', '--cancel_update')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	auto_update_administration_auto_update_service.add_argument("--cancel_update", action=auto_update_administration_auto_update_service_cancel_updateAction, nargs=nargs, metavar=metavars, help=help)
	class auto_update_administration_auto_update_service_manual_check_updateAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.auto_update.AutoUpdateConfig import AutoUpdateConfig
			from unicorn_api.v5.sv0.auto_update.AutoUpdateStatus import AutoUpdateStatus

			from transformer.lib import List
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.auto_update.AutoUpdateService import AutoUpdateService
			service = AutoUpdateService()
			global function, interactive
			function = service.manual_check_update
			interactive = []
	methods['auto_update.administration.auto_update_service.manual_check_update'] = ('auto_update_administration_auto_update_service', '--manual_check_update')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	auto_update_administration_auto_update_service.add_argument("--manual_check_update", action=auto_update_administration_auto_update_service_manual_check_updateAction, nargs=nargs, metavar=metavars, help=help)
	class auto_update_administration_auto_update_service_set_configAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.auto_update.AutoUpdateConfig import AutoUpdateConfig
			from unicorn_api.v5.sv0.auto_update.AutoUpdateStatus import AutoUpdateStatus

			from transformer.lib import List
			checker = [AutoUpdateConfig]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.auto_update.AutoUpdateService import AutoUpdateService
			service = AutoUpdateService()
			global function, interactive
			function = service.set_config
			interactive = []
			interactive.append(('config', AutoUpdateConfig))
	methods['auto_update.administration.auto_update_service.set_config'] = ('auto_update_administration_auto_update_service', '--set_config')
	metavars = () if interactive_mode else ('config')
	help = '' if interactive_mode else '%s ' % ('{"update_mode":AUTO_DOWNLOAD|AUTO_CHECK|GET_UPDATE_BRANCHES|DISABLE|AUTO_INSTALL,"schedule_hour":int,"schedule_minute":int,"schedule_period":int,"update_server_branch_path":text,"update_server_address":text}')
	nargs = 0 if interactive_mode else 1
	auto_update_administration_auto_update_service.add_argument("--set_config", action=auto_update_administration_auto_update_service_set_configAction, nargs=nargs, metavar=metavars, help=help)
	class auto_update_administration_auto_update_service_get_update_branchesAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.auto_update.AutoUpdateConfig import AutoUpdateConfig
			from unicorn_api.v5.sv0.auto_update.AutoUpdateStatus import AutoUpdateStatus

			from transformer.lib import List
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.auto_update.AutoUpdateService import AutoUpdateService
			service = AutoUpdateService()
			global function, interactive
			function = service.get_update_branches
			interactive = []
	methods['auto_update.administration.auto_update_service.get_update_branches'] = ('auto_update_administration_auto_update_service', '--get_update_branches')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	auto_update_administration_auto_update_service.add_argument("--get_update_branches", action=auto_update_administration_auto_update_service_get_update_branchesAction, nargs=nargs, metavar=metavars, help=help)
	class auto_update_administration_auto_update_service_get_configAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.auto_update.AutoUpdateConfig import AutoUpdateConfig
			from unicorn_api.v5.sv0.auto_update.AutoUpdateStatus import AutoUpdateStatus

			from transformer.lib import List
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.auto_update.AutoUpdateService import AutoUpdateService
			service = AutoUpdateService()
			global function, interactive
			function = service.get_config
			interactive = []
	methods['auto_update.administration.auto_update_service.get_config'] = ('auto_update_administration_auto_update_service', '--get_config')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	auto_update_administration_auto_update_service.add_argument("--get_config", action=auto_update_administration_auto_update_service_get_configAction, nargs=nargs, metavar=metavars, help=help)
	class auto_update_administration_auto_update_service_get_statusAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.auto_update.AutoUpdateConfig import AutoUpdateConfig
			from unicorn_api.v5.sv0.auto_update.AutoUpdateStatus import AutoUpdateStatus

			from transformer.lib import List
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.auto_update.AutoUpdateService import AutoUpdateService
			service = AutoUpdateService()
			global function, interactive
			function = service.get_status
			interactive = []
	methods['auto_update.administration.auto_update_service.get_status'] = ('auto_update_administration_auto_update_service', '--get_status')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	auto_update_administration_auto_update_service.add_argument("--get_status", action=auto_update_administration_auto_update_service_get_statusAction, nargs=nargs, metavar=metavars, help=help)
	services_ServiceAdministration = subparsers.add_parser('services_ServiceAdministration', help="help services.ServiceAdministration")
	class services_ServiceAdministration_get_services_on_shareAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.services.Service import Service
			from unicorn_api.v5.sv0.services.ShareService import ShareService

			from transformer.lib import List
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.services.ServiceAdministration import ServiceAdministration
			service = ServiceAdministration()
			global function, interactive
			function = service.get_services_on_share
			interactive = []
			interactive.append(('share_id', cli_int))
	methods['services.ServiceAdministration.get_services_on_share'] = ('services_ServiceAdministration', '--get_services_on_share')
	metavars = () if interactive_mode else ('share_id')
	help = '' if interactive_mode else '%s ' % ('int')
	nargs = 0 if interactive_mode else 1
	services_ServiceAdministration.add_argument("--get_services_on_share", action=services_ServiceAdministration_get_services_on_shareAction, nargs=nargs, metavar=metavars, help=help)
	class services_ServiceAdministration_listAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.services.Service import Service
			from unicorn_api.v5.sv0.services.ShareService import ShareService

			from transformer.lib import List
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.services.ServiceAdministration import ServiceAdministration
			service = ServiceAdministration()
			global function, interactive
			function = service.list
			interactive = []
	methods['services.ServiceAdministration.list'] = ('services_ServiceAdministration', '--list')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	services_ServiceAdministration.add_argument("--list", action=services_ServiceAdministration_listAction, nargs=nargs, metavar=metavars, help=help)
	class services_ServiceAdministration_modifyAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.services.Service import Service
			from unicorn_api.v5.sv0.services.ShareService import ShareService

			from transformer.lib import List
			checker = [cli_unicode,Service]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.services.ServiceAdministration import ServiceAdministration
			service = ServiceAdministration()
			global function, interactive
			function = service.modify
			interactive = []
			interactive.append(('service_name', cli_unicode))
			interactive.append(('service', Service))
	methods['services.ServiceAdministration.modify'] = ('services_ServiceAdministration', '--modify')
	metavars = () if interactive_mode else ('service_name','service')
	help = '' if interactive_mode else '%s %s ' % ('text', '{"enabled":True|False,"enabled_by_default_on_share":True|False}')
	nargs = 0 if interactive_mode else 2
	services_ServiceAdministration.add_argument("--modify", action=services_ServiceAdministration_modifyAction, nargs=nargs, metavar=metavars, help=help)
	class services_ServiceAdministration_set_service_on_shareAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.services.Service import Service
			from unicorn_api.v5.sv0.services.ShareService import ShareService

			from transformer.lib import List
			checker = [cli_int,cli_unicode,ShareService]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.services.ServiceAdministration import ServiceAdministration
			service = ServiceAdministration()
			global function, interactive
			function = service.set_service_on_share
			interactive = []
			interactive.append(('share_id', cli_int))
			interactive.append(('service_name', cli_unicode))
			interactive.append(('share_service', ShareService))
	methods['services.ServiceAdministration.set_service_on_share'] = ('services_ServiceAdministration', '--set_service_on_share')
	metavars = () if interactive_mode else ('share_id','service_name','share_service')
	help = '' if interactive_mode else '%s %s %s ' % ('int', 'text', '{"value":disabled|default|enabled}')
	nargs = 0 if interactive_mode else 3
	services_ServiceAdministration.add_argument("--set_service_on_share", action=services_ServiceAdministration_set_service_on_shareAction, nargs=nargs, metavar=metavars, help=help)
	services_ServiceListManager = subparsers.add_parser('services_ServiceListManager', help="help services.ServiceListManager")
	class services_ServiceListManager_get_listAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.services.ServiceInfo import ServiceInfo

			from transformer.lib import List
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.services.ServiceListManager import ServiceListManager
			service = ServiceListManager()
			global function, interactive
			function = service.get_list
			interactive = []
	methods['services.ServiceListManager.get_list'] = ('services_ServiceListManager', '--get_list')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	services_ServiceListManager.add_argument("--get_list", action=services_ServiceListManager_get_listAction, nargs=nargs, metavar=metavars, help=help)
	recovery_Recovery = subparsers.add_parser('recovery_Recovery', help="help recovery.Recovery")
	class recovery_Recovery_recreate_sharesAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.recovery.RecoveryInfo import RecoveryInfo
			checker = [cli_bool]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.recovery.Recovery import Recovery
			service = Recovery()
			global function, interactive
			function = service.recreate_shares
			interactive = []
			interactive.append(('recreate_share', cli_bool))
	methods['recovery.Recovery.recreate_shares'] = ('recovery_Recovery', '--recreate_shares')
	metavars = () if interactive_mode else ('recreate_share')
	help = '' if interactive_mode else '%s ' % ('True|False')
	nargs = 0 if interactive_mode else 1
	recovery_Recovery.add_argument("--recreate_shares", action=recovery_Recovery_recreate_sharesAction, nargs=nargs, metavar=metavars, help=help)
	class recovery_Recovery_get_share_recovery_infoAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.recovery.RecoveryInfo import RecoveryInfo
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.recovery.Recovery import Recovery
			service = Recovery()
			global function, interactive
			function = service.get_share_recovery_info
			interactive = []
	methods['recovery.Recovery.get_share_recovery_info'] = ('recovery_Recovery', '--get_share_recovery_info')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	recovery_Recovery.add_argument("--get_share_recovery_info", action=recovery_Recovery_get_share_recovery_infoAction, nargs=nargs, metavar=metavars, help=help)
	user_group_share_ShareAccess = subparsers.add_parser('user_group_share_ShareAccess', help="help user_group_share.ShareAccess")
	class user_group_share_ShareAccess_add_user_to_sharesAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.user_group_share.ShareUserAccess import ShareUserAccess
			from unicorn_api.v5.sv0.user_group_share.ShareGroupAccess import ShareGroupAccess
			from unicorn_api.v5.sv0.user_group_share.IDAccessStruct import IDAccessStruct
			from unicorn_api.v5.sv0.user_group_share.UserAccessThrough import UserAccessThrough
			from unicorn_api.v5.sv0.sharing.ShareAccessThrough import ShareAccessThrough

			from transformer.lib import ListInfo, ResultSet, List
			checker = [cli_int,list_cli(IDAccessStruct)]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.ShareAccess import ShareAccess
			service = ShareAccess()
			global function, interactive
			function = service.add_user_to_shares
			interactive = []
			interactive.append(('group_id', cli_int))
			interactive.append(('shares', list_cli(IDAccessStruct)))
	methods['user_group_share.ShareAccess.add_user_to_shares'] = ('user_group_share_ShareAccess', '--add_user_to_shares')
	metavars = () if interactive_mode else ('group_id','shares')
	help = '' if interactive_mode else '%s %s ' % ('int', '["{"access":read|none|write|full,"id":int}",...]')
	nargs = 0 if interactive_mode else 2
	user_group_share_ShareAccess.add_argument("--add_user_to_shares", action=user_group_share_ShareAccess_add_user_to_sharesAction, nargs=nargs, metavar=metavars, help=help)
	class user_group_share_ShareAccess_modify_shares_access_for_groupAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.user_group_share.ShareUserAccess import ShareUserAccess
			from unicorn_api.v5.sv0.user_group_share.ShareGroupAccess import ShareGroupAccess
			from unicorn_api.v5.sv0.user_group_share.IDAccessStruct import IDAccessStruct
			from unicorn_api.v5.sv0.user_group_share.UserAccessThrough import UserAccessThrough
			from unicorn_api.v5.sv0.sharing.ShareAccessThrough import ShareAccessThrough

			from transformer.lib import ListInfo, ResultSet, List
			checker = [cli_int,list_cli(IDAccessStruct)]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.ShareAccess import ShareAccess
			service = ShareAccess()
			global function, interactive
			function = service.modify_shares_access_for_group
			interactive = []
			interactive.append(('group_id', cli_int))
			interactive.append(('shares_struct', list_cli(IDAccessStruct)))
	methods['user_group_share.ShareAccess.modify_shares_access_for_group'] = ('user_group_share_ShareAccess', '--modify_shares_access_for_group')
	metavars = () if interactive_mode else ('group_id','shares_struct')
	help = '' if interactive_mode else '%s %s ' % ('int', '["{"access":read|none|write|full,"id":int}",...]')
	nargs = 0 if interactive_mode else 2
	user_group_share_ShareAccess.add_argument("--modify_shares_access_for_group", action=user_group_share_ShareAccess_modify_shares_access_for_groupAction, nargs=nargs, metavar=metavars, help=help)
	class user_group_share_ShareAccess_remove_user_from_sharesAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.user_group_share.ShareUserAccess import ShareUserAccess
			from unicorn_api.v5.sv0.user_group_share.ShareGroupAccess import ShareGroupAccess
			from unicorn_api.v5.sv0.user_group_share.IDAccessStruct import IDAccessStruct
			from unicorn_api.v5.sv0.user_group_share.UserAccessThrough import UserAccessThrough
			from unicorn_api.v5.sv0.sharing.ShareAccessThrough import ShareAccessThrough

			from transformer.lib import ListInfo, ResultSet, List
			checker = [cli_int,list_cli(int)]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.ShareAccess import ShareAccess
			service = ShareAccess()
			global function, interactive
			function = service.remove_user_from_shares
			interactive = []
			interactive.append(('user_id', cli_int))
			interactive.append(('shares_id', list_cli(int)))
	methods['user_group_share.ShareAccess.remove_user_from_shares'] = ('user_group_share_ShareAccess', '--remove_user_from_shares')
	metavars = () if interactive_mode else ('user_id','shares_id')
	help = '' if interactive_mode else '%s %s ' % ('int', '["int",...]')
	nargs = 0 if interactive_mode else 2
	user_group_share_ShareAccess.add_argument("--remove_user_from_shares", action=user_group_share_ShareAccess_remove_user_from_sharesAction, nargs=nargs, metavar=metavars, help=help)
	class user_group_share_ShareAccess_remove_group_from_sharesAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.user_group_share.ShareUserAccess import ShareUserAccess
			from unicorn_api.v5.sv0.user_group_share.ShareGroupAccess import ShareGroupAccess
			from unicorn_api.v5.sv0.user_group_share.IDAccessStruct import IDAccessStruct
			from unicorn_api.v5.sv0.user_group_share.UserAccessThrough import UserAccessThrough
			from unicorn_api.v5.sv0.sharing.ShareAccessThrough import ShareAccessThrough

			from transformer.lib import ListInfo, ResultSet, List
			checker = [cli_int,list_cli(int)]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.ShareAccess import ShareAccess
			service = ShareAccess()
			global function, interactive
			function = service.remove_group_from_shares
			interactive = []
			interactive.append(('group_id', cli_int))
			interactive.append(('shares_id', list_cli(int)))
	methods['user_group_share.ShareAccess.remove_group_from_shares'] = ('user_group_share_ShareAccess', '--remove_group_from_shares')
	metavars = () if interactive_mode else ('group_id','shares_id')
	help = '' if interactive_mode else '%s %s ' % ('int', '["int",...]')
	nargs = 0 if interactive_mode else 2
	user_group_share_ShareAccess.add_argument("--remove_group_from_shares", action=user_group_share_ShareAccess_remove_group_from_sharesAction, nargs=nargs, metavar=metavars, help=help)
	class user_group_share_ShareAccess_del_share_access_for_groupAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.user_group_share.ShareUserAccess import ShareUserAccess
			from unicorn_api.v5.sv0.user_group_share.ShareGroupAccess import ShareGroupAccess
			from unicorn_api.v5.sv0.user_group_share.IDAccessStruct import IDAccessStruct
			from unicorn_api.v5.sv0.user_group_share.UserAccessThrough import UserAccessThrough
			from unicorn_api.v5.sv0.sharing.ShareAccessThrough import ShareAccessThrough

			from transformer.lib import ListInfo, ResultSet, List
			checker = [cli_int,cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.ShareAccess import ShareAccess
			service = ShareAccess()
			global function, interactive
			function = service.del_share_access_for_group
			interactive = []
			interactive.append(('share_id', cli_int))
			interactive.append(('user_id', cli_int))
	methods['user_group_share.ShareAccess.del_share_access_for_group'] = ('user_group_share_ShareAccess', '--del_share_access_for_group')
	metavars = () if interactive_mode else ('share_id','user_id')
	help = '' if interactive_mode else '%s %s ' % ('int', 'int')
	nargs = 0 if interactive_mode else 2
	user_group_share_ShareAccess.add_argument("--del_share_access_for_group", action=user_group_share_ShareAccess_del_share_access_for_groupAction, nargs=nargs, metavar=metavars, help=help)
	class user_group_share_ShareAccess_users_accessing_to_shareAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.user_group_share.ShareUserAccess import ShareUserAccess
			from unicorn_api.v5.sv0.user_group_share.ShareGroupAccess import ShareGroupAccess
			from unicorn_api.v5.sv0.user_group_share.IDAccessStruct import IDAccessStruct
			from unicorn_api.v5.sv0.user_group_share.UserAccessThrough import UserAccessThrough
			from unicorn_api.v5.sv0.sharing.ShareAccessThrough import ShareAccessThrough

			from transformer.lib import ListInfo, ResultSet, List
			checker = [cli_int,cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.ShareAccess import ShareAccess
			service = ShareAccess()
			global function, interactive
			function = service.users_accessing_to_share
			interactive = []
			interactive.append(('share_id', cli_int))
			interactive.append(('list_info', cli_list_info))
	methods['user_group_share.ShareAccess.users_accessing_to_share'] = ('user_group_share_ShareAccess', '--users_accessing_to_share')
	metavars = () if interactive_mode else ('share_id','list_info')
	help = '' if interactive_mode else '%s %s ' % ('int', 'offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 2
	user_group_share_ShareAccess.add_argument("--users_accessing_to_share", action=user_group_share_ShareAccess_users_accessing_to_shareAction, nargs=nargs, metavar=metavars, help=help)
	class user_group_share_ShareAccess_add_share_access_for_groupAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.user_group_share.ShareUserAccess import ShareUserAccess
			from unicorn_api.v5.sv0.user_group_share.ShareGroupAccess import ShareGroupAccess
			from unicorn_api.v5.sv0.user_group_share.IDAccessStruct import IDAccessStruct
			from unicorn_api.v5.sv0.user_group_share.UserAccessThrough import UserAccessThrough
			from unicorn_api.v5.sv0.sharing.ShareAccessThrough import ShareAccessThrough

			from transformer.lib import ListInfo, ResultSet, List
			checker = [cli_int,IDAccessStruct]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.ShareAccess import ShareAccess
			service = ShareAccess()
			global function, interactive
			function = service.add_share_access_for_group
			interactive = []
			interactive.append(('share_id', cli_int))
			interactive.append(('group_struct', IDAccessStruct))
	methods['user_group_share.ShareAccess.add_share_access_for_group'] = ('user_group_share_ShareAccess', '--add_share_access_for_group')
	metavars = () if interactive_mode else ('share_id','group_struct')
	help = '' if interactive_mode else '%s %s ' % ('int', '{"access":read|none|write|full,"id":int}')
	nargs = 0 if interactive_mode else 2
	user_group_share_ShareAccess.add_argument("--add_share_access_for_group", action=user_group_share_ShareAccess_add_share_access_for_groupAction, nargs=nargs, metavar=metavars, help=help)
	class user_group_share_ShareAccess_add_group_to_sharesAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.user_group_share.ShareUserAccess import ShareUserAccess
			from unicorn_api.v5.sv0.user_group_share.ShareGroupAccess import ShareGroupAccess
			from unicorn_api.v5.sv0.user_group_share.IDAccessStruct import IDAccessStruct
			from unicorn_api.v5.sv0.user_group_share.UserAccessThrough import UserAccessThrough
			from unicorn_api.v5.sv0.sharing.ShareAccessThrough import ShareAccessThrough

			from transformer.lib import ListInfo, ResultSet, List
			checker = [cli_int,list_cli(IDAccessStruct)]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.ShareAccess import ShareAccess
			service = ShareAccess()
			global function, interactive
			function = service.add_group_to_shares
			interactive = []
			interactive.append(('group_id', cli_int))
			interactive.append(('shares', list_cli(IDAccessStruct)))
	methods['user_group_share.ShareAccess.add_group_to_shares'] = ('user_group_share_ShareAccess', '--add_group_to_shares')
	metavars = () if interactive_mode else ('group_id','shares')
	help = '' if interactive_mode else '%s %s ' % ('int', '["{"access":read|none|write|full,"id":int}",...]')
	nargs = 0 if interactive_mode else 2
	user_group_share_ShareAccess.add_argument("--add_group_to_shares", action=user_group_share_ShareAccess_add_group_to_sharesAction, nargs=nargs, metavar=metavars, help=help)
	class user_group_share_ShareAccess_del_share_access_for_usersAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.user_group_share.ShareUserAccess import ShareUserAccess
			from unicorn_api.v5.sv0.user_group_share.ShareGroupAccess import ShareGroupAccess
			from unicorn_api.v5.sv0.user_group_share.IDAccessStruct import IDAccessStruct
			from unicorn_api.v5.sv0.user_group_share.UserAccessThrough import UserAccessThrough
			from unicorn_api.v5.sv0.sharing.ShareAccessThrough import ShareAccessThrough

			from transformer.lib import ListInfo, ResultSet, List
			checker = [cli_int,list_cli(int)]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.ShareAccess import ShareAccess
			service = ShareAccess()
			global function, interactive
			function = service.del_share_access_for_users
			interactive = []
			interactive.append(('share_id', cli_int))
			interactive.append(('users_id', list_cli(int)))
	methods['user_group_share.ShareAccess.del_share_access_for_users'] = ('user_group_share_ShareAccess', '--del_share_access_for_users')
	metavars = () if interactive_mode else ('share_id','users_id')
	help = '' if interactive_mode else '%s %s ' % ('int', '["int",...]')
	nargs = 0 if interactive_mode else 2
	user_group_share_ShareAccess.add_argument("--del_share_access_for_users", action=user_group_share_ShareAccess_del_share_access_for_usersAction, nargs=nargs, metavar=metavars, help=help)
	class user_group_share_ShareAccess_add_share_access_for_userAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.user_group_share.ShareUserAccess import ShareUserAccess
			from unicorn_api.v5.sv0.user_group_share.ShareGroupAccess import ShareGroupAccess
			from unicorn_api.v5.sv0.user_group_share.IDAccessStruct import IDAccessStruct
			from unicorn_api.v5.sv0.user_group_share.UserAccessThrough import UserAccessThrough
			from unicorn_api.v5.sv0.sharing.ShareAccessThrough import ShareAccessThrough

			from transformer.lib import ListInfo, ResultSet, List
			checker = [cli_int,IDAccessStruct]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.ShareAccess import ShareAccess
			service = ShareAccess()
			global function, interactive
			function = service.add_share_access_for_user
			interactive = []
			interactive.append(('share_id', cli_int))
			interactive.append(('user_struct', IDAccessStruct))
	methods['user_group_share.ShareAccess.add_share_access_for_user'] = ('user_group_share_ShareAccess', '--add_share_access_for_user')
	metavars = () if interactive_mode else ('share_id','user_struct')
	help = '' if interactive_mode else '%s %s ' % ('int', '{"access":read|none|write|full,"id":int}')
	nargs = 0 if interactive_mode else 2
	user_group_share_ShareAccess.add_argument("--add_share_access_for_user", action=user_group_share_ShareAccess_add_share_access_for_userAction, nargs=nargs, metavar=metavars, help=help)
	class user_group_share_ShareAccess_users_in_shareAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.user_group_share.ShareUserAccess import ShareUserAccess
			from unicorn_api.v5.sv0.user_group_share.ShareGroupAccess import ShareGroupAccess
			from unicorn_api.v5.sv0.user_group_share.IDAccessStruct import IDAccessStruct
			from unicorn_api.v5.sv0.user_group_share.UserAccessThrough import UserAccessThrough
			from unicorn_api.v5.sv0.sharing.ShareAccessThrough import ShareAccessThrough

			from transformer.lib import ListInfo, ResultSet, List
			checker = [cli_int,cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.ShareAccess import ShareAccess
			service = ShareAccess()
			global function, interactive
			function = service.users_in_share
			interactive = []
			interactive.append(('share_id', cli_int))
			interactive.append(('list_info', cli_list_info))
	methods['user_group_share.ShareAccess.users_in_share'] = ('user_group_share_ShareAccess', '--users_in_share')
	metavars = () if interactive_mode else ('share_id','list_info')
	help = '' if interactive_mode else '%s %s ' % ('int', 'offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 2
	user_group_share_ShareAccess.add_argument("--users_in_share", action=user_group_share_ShareAccess_users_in_shareAction, nargs=nargs, metavar=metavars, help=help)
	class user_group_share_ShareAccess_modify_shares_access_for_userAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.user_group_share.ShareUserAccess import ShareUserAccess
			from unicorn_api.v5.sv0.user_group_share.ShareGroupAccess import ShareGroupAccess
			from unicorn_api.v5.sv0.user_group_share.IDAccessStruct import IDAccessStruct
			from unicorn_api.v5.sv0.user_group_share.UserAccessThrough import UserAccessThrough
			from unicorn_api.v5.sv0.sharing.ShareAccessThrough import ShareAccessThrough

			from transformer.lib import ListInfo, ResultSet, List
			checker = [cli_int,list_cli(IDAccessStruct)]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.ShareAccess import ShareAccess
			service = ShareAccess()
			global function, interactive
			function = service.modify_shares_access_for_user
			interactive = []
			interactive.append(('user_id', cli_int))
			interactive.append(('shares_struct', list_cli(IDAccessStruct)))
	methods['user_group_share.ShareAccess.modify_shares_access_for_user'] = ('user_group_share_ShareAccess', '--modify_shares_access_for_user')
	metavars = () if interactive_mode else ('user_id','shares_struct')
	help = '' if interactive_mode else '%s %s ' % ('int', '["{"access":read|none|write|full,"id":int}",...]')
	nargs = 0 if interactive_mode else 2
	user_group_share_ShareAccess.add_argument("--modify_shares_access_for_user", action=user_group_share_ShareAccess_modify_shares_access_for_userAction, nargs=nargs, metavar=metavars, help=help)
	class user_group_share_ShareAccess_modify_groups_access_for_shareAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.user_group_share.ShareUserAccess import ShareUserAccess
			from unicorn_api.v5.sv0.user_group_share.ShareGroupAccess import ShareGroupAccess
			from unicorn_api.v5.sv0.user_group_share.IDAccessStruct import IDAccessStruct
			from unicorn_api.v5.sv0.user_group_share.UserAccessThrough import UserAccessThrough
			from unicorn_api.v5.sv0.sharing.ShareAccessThrough import ShareAccessThrough

			from transformer.lib import ListInfo, ResultSet, List
			checker = [cli_int,list_cli(IDAccessStruct)]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.ShareAccess import ShareAccess
			service = ShareAccess()
			global function, interactive
			function = service.modify_groups_access_for_share
			interactive = []
			interactive.append(('share_id', cli_int))
			interactive.append(('groups_struct', list_cli(IDAccessStruct)))
	methods['user_group_share.ShareAccess.modify_groups_access_for_share'] = ('user_group_share_ShareAccess', '--modify_groups_access_for_share')
	metavars = () if interactive_mode else ('share_id','groups_struct')
	help = '' if interactive_mode else '%s %s ' % ('int', '["{"access":read|none|write|full,"id":int}",...]')
	nargs = 0 if interactive_mode else 2
	user_group_share_ShareAccess.add_argument("--modify_groups_access_for_share", action=user_group_share_ShareAccess_modify_groups_access_for_shareAction, nargs=nargs, metavar=metavars, help=help)
	class user_group_share_ShareAccess_add_share_access_for_groupsAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.user_group_share.ShareUserAccess import ShareUserAccess
			from unicorn_api.v5.sv0.user_group_share.ShareGroupAccess import ShareGroupAccess
			from unicorn_api.v5.sv0.user_group_share.IDAccessStruct import IDAccessStruct
			from unicorn_api.v5.sv0.user_group_share.UserAccessThrough import UserAccessThrough
			from unicorn_api.v5.sv0.sharing.ShareAccessThrough import ShareAccessThrough

			from transformer.lib import ListInfo, ResultSet, List
			checker = [cli_int,list_cli(IDAccessStruct)]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.ShareAccess import ShareAccess
			service = ShareAccess()
			global function, interactive
			function = service.add_share_access_for_groups
			interactive = []
			interactive.append(('share_id', cli_int))
			interactive.append(('groups', list_cli(IDAccessStruct)))
	methods['user_group_share.ShareAccess.add_share_access_for_groups'] = ('user_group_share_ShareAccess', '--add_share_access_for_groups')
	metavars = () if interactive_mode else ('share_id','groups')
	help = '' if interactive_mode else '%s %s ' % ('int', '["{"access":read|none|write|full,"id":int}",...]')
	nargs = 0 if interactive_mode else 2
	user_group_share_ShareAccess.add_argument("--add_share_access_for_groups", action=user_group_share_ShareAccess_add_share_access_for_groupsAction, nargs=nargs, metavar=metavars, help=help)
	class user_group_share_ShareAccess_del_share_access_for_userAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.user_group_share.ShareUserAccess import ShareUserAccess
			from unicorn_api.v5.sv0.user_group_share.ShareGroupAccess import ShareGroupAccess
			from unicorn_api.v5.sv0.user_group_share.IDAccessStruct import IDAccessStruct
			from unicorn_api.v5.sv0.user_group_share.UserAccessThrough import UserAccessThrough
			from unicorn_api.v5.sv0.sharing.ShareAccessThrough import ShareAccessThrough

			from transformer.lib import ListInfo, ResultSet, List
			checker = [cli_int,cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.ShareAccess import ShareAccess
			service = ShareAccess()
			global function, interactive
			function = service.del_share_access_for_user
			interactive = []
			interactive.append(('share_id', cli_int))
			interactive.append(('user_id', cli_int))
	methods['user_group_share.ShareAccess.del_share_access_for_user'] = ('user_group_share_ShareAccess', '--del_share_access_for_user')
	metavars = () if interactive_mode else ('share_id','user_id')
	help = '' if interactive_mode else '%s %s ' % ('int', 'int')
	nargs = 0 if interactive_mode else 2
	user_group_share_ShareAccess.add_argument("--del_share_access_for_user", action=user_group_share_ShareAccess_del_share_access_for_userAction, nargs=nargs, metavar=metavars, help=help)
	class user_group_share_ShareAccess_del_share_access_for_groupsAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.user_group_share.ShareUserAccess import ShareUserAccess
			from unicorn_api.v5.sv0.user_group_share.ShareGroupAccess import ShareGroupAccess
			from unicorn_api.v5.sv0.user_group_share.IDAccessStruct import IDAccessStruct
			from unicorn_api.v5.sv0.user_group_share.UserAccessThrough import UserAccessThrough
			from unicorn_api.v5.sv0.sharing.ShareAccessThrough import ShareAccessThrough

			from transformer.lib import ListInfo, ResultSet, List
			checker = [cli_int,list_cli(int)]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.ShareAccess import ShareAccess
			service = ShareAccess()
			global function, interactive
			function = service.del_share_access_for_groups
			interactive = []
			interactive.append(('share_id', cli_int))
			interactive.append(('groups_id', list_cli(int)))
	methods['user_group_share.ShareAccess.del_share_access_for_groups'] = ('user_group_share_ShareAccess', '--del_share_access_for_groups')
	metavars = () if interactive_mode else ('share_id','groups_id')
	help = '' if interactive_mode else '%s %s ' % ('int', '["int",...]')
	nargs = 0 if interactive_mode else 2
	user_group_share_ShareAccess.add_argument("--del_share_access_for_groups", action=user_group_share_ShareAccess_del_share_access_for_groupsAction, nargs=nargs, metavar=metavars, help=help)
	class user_group_share_ShareAccess_modify_share_access_for_userAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.user_group_share.ShareUserAccess import ShareUserAccess
			from unicorn_api.v5.sv0.user_group_share.ShareGroupAccess import ShareGroupAccess
			from unicorn_api.v5.sv0.user_group_share.IDAccessStruct import IDAccessStruct
			from unicorn_api.v5.sv0.user_group_share.UserAccessThrough import UserAccessThrough
			from unicorn_api.v5.sv0.sharing.ShareAccessThrough import ShareAccessThrough

			from transformer.lib import ListInfo, ResultSet, List
			checker = [cli_int,IDAccessStruct]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.ShareAccess import ShareAccess
			service = ShareAccess()
			global function, interactive
			function = service.modify_share_access_for_user
			interactive = []
			interactive.append(('share_id', cli_int))
			interactive.append(('user_struct', IDAccessStruct))
	methods['user_group_share.ShareAccess.modify_share_access_for_user'] = ('user_group_share_ShareAccess', '--modify_share_access_for_user')
	metavars = () if interactive_mode else ('share_id','user_struct')
	help = '' if interactive_mode else '%s %s ' % ('int', '{"access":read|none|write|full,"id":int}')
	nargs = 0 if interactive_mode else 2
	user_group_share_ShareAccess.add_argument("--modify_share_access_for_user", action=user_group_share_ShareAccess_modify_share_access_for_userAction, nargs=nargs, metavar=metavars, help=help)
	class user_group_share_ShareAccess_shares_accessed_by_userAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.user_group_share.ShareUserAccess import ShareUserAccess
			from unicorn_api.v5.sv0.user_group_share.ShareGroupAccess import ShareGroupAccess
			from unicorn_api.v5.sv0.user_group_share.IDAccessStruct import IDAccessStruct
			from unicorn_api.v5.sv0.user_group_share.UserAccessThrough import UserAccessThrough
			from unicorn_api.v5.sv0.sharing.ShareAccessThrough import ShareAccessThrough

			from transformer.lib import ListInfo, ResultSet, List
			checker = [cli_int,cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.ShareAccess import ShareAccess
			service = ShareAccess()
			global function, interactive
			function = service.shares_accessed_by_user
			interactive = []
			interactive.append(('user_id', cli_int))
			interactive.append(('list_info', cli_list_info))
	methods['user_group_share.ShareAccess.shares_accessed_by_user'] = ('user_group_share_ShareAccess', '--shares_accessed_by_user')
	metavars = () if interactive_mode else ('user_id','list_info')
	help = '' if interactive_mode else '%s %s ' % ('int', 'offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 2
	user_group_share_ShareAccess.add_argument("--shares_accessed_by_user", action=user_group_share_ShareAccess_shares_accessed_by_userAction, nargs=nargs, metavar=metavars, help=help)
	class user_group_share_ShareAccess_groups_in_shareAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.user_group_share.ShareUserAccess import ShareUserAccess
			from unicorn_api.v5.sv0.user_group_share.ShareGroupAccess import ShareGroupAccess
			from unicorn_api.v5.sv0.user_group_share.IDAccessStruct import IDAccessStruct
			from unicorn_api.v5.sv0.user_group_share.UserAccessThrough import UserAccessThrough
			from unicorn_api.v5.sv0.sharing.ShareAccessThrough import ShareAccessThrough

			from transformer.lib import ListInfo, ResultSet, List
			checker = [cli_int,cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.ShareAccess import ShareAccess
			service = ShareAccess()
			global function, interactive
			function = service.groups_in_share
			interactive = []
			interactive.append(('share_id', cli_int))
			interactive.append(('list_info', cli_list_info))
	methods['user_group_share.ShareAccess.groups_in_share'] = ('user_group_share_ShareAccess', '--groups_in_share')
	metavars = () if interactive_mode else ('share_id','list_info')
	help = '' if interactive_mode else '%s %s ' % ('int', 'offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 2
	user_group_share_ShareAccess.add_argument("--groups_in_share", action=user_group_share_ShareAccess_groups_in_shareAction, nargs=nargs, metavar=metavars, help=help)
	class user_group_share_ShareAccess_add_share_access_for_usersAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.user_group_share.ShareUserAccess import ShareUserAccess
			from unicorn_api.v5.sv0.user_group_share.ShareGroupAccess import ShareGroupAccess
			from unicorn_api.v5.sv0.user_group_share.IDAccessStruct import IDAccessStruct
			from unicorn_api.v5.sv0.user_group_share.UserAccessThrough import UserAccessThrough
			from unicorn_api.v5.sv0.sharing.ShareAccessThrough import ShareAccessThrough

			from transformer.lib import ListInfo, ResultSet, List
			checker = [cli_int,list_cli(IDAccessStruct)]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.ShareAccess import ShareAccess
			service = ShareAccess()
			global function, interactive
			function = service.add_share_access_for_users
			interactive = []
			interactive.append(('share_id', cli_int))
			interactive.append(('users', list_cli(IDAccessStruct)))
	methods['user_group_share.ShareAccess.add_share_access_for_users'] = ('user_group_share_ShareAccess', '--add_share_access_for_users')
	metavars = () if interactive_mode else ('share_id','users')
	help = '' if interactive_mode else '%s %s ' % ('int', '["{"access":read|none|write|full,"id":int}",...]')
	nargs = 0 if interactive_mode else 2
	user_group_share_ShareAccess.add_argument("--add_share_access_for_users", action=user_group_share_ShareAccess_add_share_access_for_usersAction, nargs=nargs, metavar=metavars, help=help)
	class user_group_share_ShareAccess_group_sharesAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.user_group_share.ShareUserAccess import ShareUserAccess
			from unicorn_api.v5.sv0.user_group_share.ShareGroupAccess import ShareGroupAccess
			from unicorn_api.v5.sv0.user_group_share.IDAccessStruct import IDAccessStruct
			from unicorn_api.v5.sv0.user_group_share.UserAccessThrough import UserAccessThrough
			from unicorn_api.v5.sv0.sharing.ShareAccessThrough import ShareAccessThrough

			from transformer.lib import ListInfo, ResultSet, List
			checker = [cli_int,cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.ShareAccess import ShareAccess
			service = ShareAccess()
			global function, interactive
			function = service.group_shares
			interactive = []
			interactive.append(('group_id', cli_int))
			interactive.append(('list_info', cli_list_info))
	methods['user_group_share.ShareAccess.group_shares'] = ('user_group_share_ShareAccess', '--group_shares')
	metavars = () if interactive_mode else ('group_id','list_info')
	help = '' if interactive_mode else '%s %s ' % ('int', 'offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 2
	user_group_share_ShareAccess.add_argument("--group_shares", action=user_group_share_ShareAccess_group_sharesAction, nargs=nargs, metavar=metavars, help=help)
	class user_group_share_ShareAccess_modify_users_access_for_shareAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.user_group_share.ShareUserAccess import ShareUserAccess
			from unicorn_api.v5.sv0.user_group_share.ShareGroupAccess import ShareGroupAccess
			from unicorn_api.v5.sv0.user_group_share.IDAccessStruct import IDAccessStruct
			from unicorn_api.v5.sv0.user_group_share.UserAccessThrough import UserAccessThrough
			from unicorn_api.v5.sv0.sharing.ShareAccessThrough import ShareAccessThrough

			from transformer.lib import ListInfo, ResultSet, List
			checker = [cli_int,list_cli(IDAccessStruct)]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.ShareAccess import ShareAccess
			service = ShareAccess()
			global function, interactive
			function = service.modify_users_access_for_share
			interactive = []
			interactive.append(('share_id', cli_int))
			interactive.append(('users_struct', list_cli(IDAccessStruct)))
	methods['user_group_share.ShareAccess.modify_users_access_for_share'] = ('user_group_share_ShareAccess', '--modify_users_access_for_share')
	metavars = () if interactive_mode else ('share_id','users_struct')
	help = '' if interactive_mode else '%s %s ' % ('int', '["{"access":read|none|write|full,"id":int}",...]')
	nargs = 0 if interactive_mode else 2
	user_group_share_ShareAccess.add_argument("--modify_users_access_for_share", action=user_group_share_ShareAccess_modify_users_access_for_shareAction, nargs=nargs, metavar=metavars, help=help)
	class user_group_share_ShareAccess_user_sharesAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.user_group_share.ShareUserAccess import ShareUserAccess
			from unicorn_api.v5.sv0.user_group_share.ShareGroupAccess import ShareGroupAccess
			from unicorn_api.v5.sv0.user_group_share.IDAccessStruct import IDAccessStruct
			from unicorn_api.v5.sv0.user_group_share.UserAccessThrough import UserAccessThrough
			from unicorn_api.v5.sv0.sharing.ShareAccessThrough import ShareAccessThrough

			from transformer.lib import ListInfo, ResultSet, List
			checker = [cli_int,cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.ShareAccess import ShareAccess
			service = ShareAccess()
			global function, interactive
			function = service.user_shares
			interactive = []
			interactive.append(('user_id', cli_int))
			interactive.append(('list_info', cli_list_info))
	methods['user_group_share.ShareAccess.user_shares'] = ('user_group_share_ShareAccess', '--user_shares')
	metavars = () if interactive_mode else ('user_id','list_info')
	help = '' if interactive_mode else '%s %s ' % ('int', 'offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 2
	user_group_share_ShareAccess.add_argument("--user_shares", action=user_group_share_ShareAccess_user_sharesAction, nargs=nargs, metavar=metavars, help=help)
	class user_group_share_ShareAccess_modify_share_access_for_groupAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.user_group_share.ShareUserAccess import ShareUserAccess
			from unicorn_api.v5.sv0.user_group_share.ShareGroupAccess import ShareGroupAccess
			from unicorn_api.v5.sv0.user_group_share.IDAccessStruct import IDAccessStruct
			from unicorn_api.v5.sv0.user_group_share.UserAccessThrough import UserAccessThrough
			from unicorn_api.v5.sv0.sharing.ShareAccessThrough import ShareAccessThrough

			from transformer.lib import ListInfo, ResultSet, List
			checker = [cli_int,IDAccessStruct]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.ShareAccess import ShareAccess
			service = ShareAccess()
			global function, interactive
			function = service.modify_share_access_for_group
			interactive = []
			interactive.append(('share_id', cli_int))
			interactive.append(('group_struct', IDAccessStruct))
	methods['user_group_share.ShareAccess.modify_share_access_for_group'] = ('user_group_share_ShareAccess', '--modify_share_access_for_group')
	metavars = () if interactive_mode else ('share_id','group_struct')
	help = '' if interactive_mode else '%s %s ' % ('int', '{"access":read|none|write|full,"id":int}')
	nargs = 0 if interactive_mode else 2
	user_group_share_ShareAccess.add_argument("--modify_share_access_for_group", action=user_group_share_ShareAccess_modify_share_access_for_groupAction, nargs=nargs, metavar=metavars, help=help)
	sharing_shares_Administration = subparsers.add_parser('sharing_shares_Administration', help="help sharing.shares.Administration")
	class sharing_shares_Administration_modifyAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.sharing.Share import Share
			from unicorn_api.v5.sv0.sharing import Access

			from transformer.lib import List, ListInfo, ResultSet
			checker = [cli_int,Share]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.Sharing import Sharing
			service = Sharing()
			global function, interactive
			function = service.modify
			interactive = []
			interactive.append(('share_id', cli_int))
			interactive.append(('share', Share))
	methods['sharing.shares.Administration.modify'] = ('sharing_shares_Administration', '--modify')
	metavars = () if interactive_mode else ('share_id','share')
	help = '' if interactive_mode else '%s %s ' % ('int', '{"comment":text,"name":text,#"quota":{"quota":long}#,#"public_access":read|none|write|full#}')
	nargs = 0 if interactive_mode else 2
	sharing_shares_Administration.add_argument("--modify", action=sharing_shares_Administration_modifyAction, nargs=nargs, metavar=metavars, help=help)
	class sharing_shares_Administration_listAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.sharing.Share import Share
			from unicorn_api.v5.sv0.sharing import Access

			from transformer.lib import List, ListInfo, ResultSet
			checker = [list_cli(unicode),cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.Sharing import Sharing
			service = Sharing()
			global function, interactive
			function = service.list
			interactive = []
			interactive.append(('with_parameters', list_cli(unicode)))
			interactive.append(('list_info', cli_list_info))
	methods['sharing.shares.Administration.list'] = ('sharing_shares_Administration', '--list')
	metavars = () if interactive_mode else ('with_parameters','list_info')
	help = '' if interactive_mode else '%s %s ' % ('["text",...]', 'offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 2
	sharing_shares_Administration.add_argument("--list", action=sharing_shares_Administration_listAction, nargs=nargs, metavar=metavars, help=help)
	class sharing_shares_Administration_removeAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.sharing.Share import Share
			from unicorn_api.v5.sv0.sharing import Access

			from transformer.lib import List, ListInfo, ResultSet
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.Sharing import Sharing
			service = Sharing()
			global function, interactive
			function = service.remove
			interactive = []
			interactive.append(('share_id', cli_int))
	methods['sharing.shares.Administration.remove'] = ('sharing_shares_Administration', '--remove')
	metavars = () if interactive_mode else ('share_id')
	help = '' if interactive_mode else '%s ' % ('int')
	nargs = 0 if interactive_mode else 1
	sharing_shares_Administration.add_argument("--remove", action=sharing_shares_Administration_removeAction, nargs=nargs, metavar=metavars, help=help)
	class sharing_shares_Administration_addAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.sharing.Share import Share
			from unicorn_api.v5.sv0.sharing import Access

			from transformer.lib import List, ListInfo, ResultSet
			checker = [Share,cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.Sharing import Sharing
			service = Sharing()
			global function, interactive
			function = service.add
			interactive = []
			interactive.append(('share', Share))
			interactive.append(('volume_id', cli_int))
	methods['sharing.shares.Administration.add'] = ('sharing_shares_Administration', '--add')
	metavars = () if interactive_mode else ('share','volume_id')
	help = '' if interactive_mode else '%s %s ' % ('{"comment":text,"name":text,#"quota":{"quota":long}#,#"public_access":read|none|write|full#}', 'int')
	nargs = 0 if interactive_mode else 2
	sharing_shares_Administration.add_argument("--add", action=sharing_shares_Administration_addAction, nargs=nargs, metavar=metavars, help=help)
	class sharing_shares_Administration_check_name_availabilityAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.sharing.Share import Share
			from unicorn_api.v5.sv0.sharing import Access

			from transformer.lib import List, ListInfo, ResultSet
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.Sharing import Sharing
			service = Sharing()
			global function, interactive
			function = service.check_name_availability
			interactive = []
			interactive.append(('name', cli_unicode))
	methods['sharing.shares.Administration.check_name_availability'] = ('sharing_shares_Administration', '--check_name_availability')
	metavars = () if interactive_mode else ('name')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 1
	sharing_shares_Administration.add_argument("--check_name_availability", action=sharing_shares_Administration_check_name_availabilityAction, nargs=nargs, metavar=metavars, help=help)
	class sharing_shares_Administration_get_share_by_nameAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.sharing.Share import Share
			from unicorn_api.v5.sv0.sharing import Access

			from transformer.lib import List, ListInfo, ResultSet
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.Sharing import Sharing
			service = Sharing()
			global function, interactive
			function = service.get_share_by_name
			interactive = []
			interactive.append(('name', cli_unicode))
	methods['sharing.shares.Administration.get_share_by_name'] = ('sharing_shares_Administration', '--get_share_by_name')
	metavars = () if interactive_mode else ('name')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 1
	sharing_shares_Administration.add_argument("--get_share_by_name", action=sharing_shares_Administration_get_share_by_nameAction, nargs=nargs, metavar=metavars, help=help)
	oauth2_OAuth2Authentication = subparsers.add_parser('oauth2_OAuth2Authentication', help="help oauth2.OAuth2Authentication")
	class oauth2_OAuth2Authentication_get_auth_tokenAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.oauth2 import OAuth2Service
			from unicorn_api.v5.sv0.oauth2.OAuth2UserInfo import OAuth2UserInfo
			checker = [OAuth2Service,cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.oauth2.OAuth2Authentication import OAuth2Authentication
			service = OAuth2Authentication()
			global function, interactive
			function = service.get_auth_token
			interactive = []
			interactive.append(('service', OAuth2Service))
			interactive.append(('code', cli_unicode))
	methods['oauth2.OAuth2Authentication.get_auth_token'] = ('oauth2_OAuth2Authentication', '--get_auth_token')
	metavars = () if interactive_mode else ('service','code')
	help = '' if interactive_mode else '%s %s ' % ('GoogleDrive|BaiduPCS|Dropbox', 'text')
	nargs = 0 if interactive_mode else 2
	oauth2_OAuth2Authentication.add_argument("--get_auth_token", action=oauth2_OAuth2Authentication_get_auth_tokenAction, nargs=nargs, metavar=metavars, help=help)
	class oauth2_OAuth2Authentication_refresh_auth_tokenAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.oauth2 import OAuth2Service
			from unicorn_api.v5.sv0.oauth2.OAuth2UserInfo import OAuth2UserInfo
			checker = [OAuth2Service,cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.oauth2.OAuth2Authentication import OAuth2Authentication
			service = OAuth2Authentication()
			global function, interactive
			function = service.refresh_auth_token
			interactive = []
			interactive.append(('service', OAuth2Service))
			interactive.append(('old_auth_token', cli_unicode))
	methods['oauth2.OAuth2Authentication.refresh_auth_token'] = ('oauth2_OAuth2Authentication', '--refresh_auth_token')
	metavars = () if interactive_mode else ('service','old_auth_token')
	help = '' if interactive_mode else '%s %s ' % ('GoogleDrive|BaiduPCS|Dropbox', 'text')
	nargs = 0 if interactive_mode else 2
	oauth2_OAuth2Authentication.add_argument("--refresh_auth_token", action=oauth2_OAuth2Authentication_refresh_auth_tokenAction, nargs=nargs, metavar=metavars, help=help)
	class oauth2_OAuth2Authentication_get_access_tokenAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.oauth2 import OAuth2Service
			from unicorn_api.v5.sv0.oauth2.OAuth2UserInfo import OAuth2UserInfo
			checker = [OAuth2Service,cli_unicode,cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.oauth2.OAuth2Authentication import OAuth2Authentication
			service = OAuth2Authentication()
			global function, interactive
			function = service.get_access_token
			interactive = []
			interactive.append(('service', OAuth2Service))
			interactive.append(('code', cli_unicode))
			interactive.append(('state', cli_unicode))
	methods['oauth2.OAuth2Authentication.get_access_token'] = ('oauth2_OAuth2Authentication', '--get_access_token')
	metavars = () if interactive_mode else ('service','code','state')
	help = '' if interactive_mode else '%s %s %s ' % ('GoogleDrive|BaiduPCS|Dropbox', 'text', 'text')
	nargs = 0 if interactive_mode else 3
	oauth2_OAuth2Authentication.add_argument("--get_access_token", action=oauth2_OAuth2Authentication_get_access_tokenAction, nargs=nargs, metavar=metavars, help=help)
	class oauth2_OAuth2Authentication_get_auth_urlAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.oauth2 import OAuth2Service
			from unicorn_api.v5.sv0.oauth2.OAuth2UserInfo import OAuth2UserInfo
			checker = [OAuth2Service,cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.oauth2.OAuth2Authentication import OAuth2Authentication
			service = OAuth2Authentication()
			global function, interactive
			function = service.get_auth_url
			interactive = []
			interactive.append(('service', OAuth2Service))
			interactive.append(('state', cli_unicode))
	methods['oauth2.OAuth2Authentication.get_auth_url'] = ('oauth2_OAuth2Authentication', '--get_auth_url')
	metavars = () if interactive_mode else ('service','state')
	help = '' if interactive_mode else '%s %s ' % ('GoogleDrive|BaiduPCS|Dropbox', 'text')
	nargs = 0 if interactive_mode else 2
	oauth2_OAuth2Authentication.add_argument("--get_auth_url", action=oauth2_OAuth2Authentication_get_auth_urlAction, nargs=nargs, metavar=metavars, help=help)
	class oauth2_OAuth2Authentication_get_infoAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.oauth2 import OAuth2Service
			from unicorn_api.v5.sv0.oauth2.OAuth2UserInfo import OAuth2UserInfo
			checker = [OAuth2Service,cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.oauth2.OAuth2Authentication import OAuth2Authentication
			service = OAuth2Authentication()
			global function, interactive
			function = service.get_info
			interactive = []
			interactive.append(('service', OAuth2Service))
			interactive.append(('auth_token', cli_unicode))
	methods['oauth2.OAuth2Authentication.get_info'] = ('oauth2_OAuth2Authentication', '--get_info')
	metavars = () if interactive_mode else ('service','auth_token')
	help = '' if interactive_mode else '%s %s ' % ('GoogleDrive|BaiduPCS|Dropbox', 'text')
	nargs = 0 if interactive_mode else 2
	oauth2_OAuth2Authentication.add_argument("--get_info", action=oauth2_OAuth2Authentication_get_infoAction, nargs=nargs, metavar=metavars, help=help)
	class oauth2_OAuth2Authentication_refresh_access_tokenAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.oauth2 import OAuth2Service
			from unicorn_api.v5.sv0.oauth2.OAuth2UserInfo import OAuth2UserInfo
			checker = [OAuth2Service,cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.oauth2.OAuth2Authentication import OAuth2Authentication
			service = OAuth2Authentication()
			global function, interactive
			function = service.refresh_access_token
			interactive = []
			interactive.append(('service', OAuth2Service))
			interactive.append(('refresh_token', cli_unicode))
	methods['oauth2.OAuth2Authentication.refresh_access_token'] = ('oauth2_OAuth2Authentication', '--refresh_access_token')
	metavars = () if interactive_mode else ('service','refresh_token')
	help = '' if interactive_mode else '%s %s ' % ('GoogleDrive|BaiduPCS|Dropbox', 'text')
	nargs = 0 if interactive_mode else 2
	oauth2_OAuth2Authentication.add_argument("--refresh_access_token", action=oauth2_OAuth2Authentication_refresh_access_tokenAction, nargs=nargs, metavar=metavars, help=help)
	volume_quotas_QuotaAdministration = subparsers.add_parser('volume_quotas_QuotaAdministration', help="help volume_quotas.QuotaAdministration")
	class volume_quotas_QuotaAdministration_list_for_groupAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.volume_quotas.VolumeQuota import VolumeQuota
			from unicorn_api.v5.sv0.volume_quotas import QuotaKind

			from transformer.lib import ListInfo, ResultSet, Dict, Long
			checker = [cli_int,cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.volume_quotas.QuotaAdministration import QuotaAdministration
			service = QuotaAdministration()
			global function, interactive
			function = service.list_for_group
			interactive = []
			interactive.append(('group_id', cli_int))
			interactive.append(('list_info', cli_list_info))
	methods['volume_quotas.QuotaAdministration.list_for_group'] = ('volume_quotas_QuotaAdministration', '--list_for_group')
	metavars = () if interactive_mode else ('group_id','list_info')
	help = '' if interactive_mode else '%s %s ' % ('int', 'offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 2
	volume_quotas_QuotaAdministration.add_argument("--list_for_group", action=volume_quotas_QuotaAdministration_list_for_groupAction, nargs=nargs, metavar=metavars, help=help)
	class volume_quotas_QuotaAdministration_list_for_userAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.volume_quotas.VolumeQuota import VolumeQuota
			from unicorn_api.v5.sv0.volume_quotas import QuotaKind

			from transformer.lib import ListInfo, ResultSet, Dict, Long
			checker = [cli_int,cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.volume_quotas.QuotaAdministration import QuotaAdministration
			service = QuotaAdministration()
			global function, interactive
			function = service.list_for_user
			interactive = []
			interactive.append(('user_id', cli_int))
			interactive.append(('list_info', cli_list_info))
	methods['volume_quotas.QuotaAdministration.list_for_user'] = ('volume_quotas_QuotaAdministration', '--list_for_user')
	metavars = () if interactive_mode else ('user_id','list_info')
	help = '' if interactive_mode else '%s %s ' % ('int', 'offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 2
	volume_quotas_QuotaAdministration.add_argument("--list_for_user", action=volume_quotas_QuotaAdministration_list_for_userAction, nargs=nargs, metavar=metavars, help=help)
	class volume_quotas_QuotaAdministration_get_quota_capabilitiesAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.volume_quotas.VolumeQuota import VolumeQuota
			from unicorn_api.v5.sv0.volume_quotas import QuotaKind

			from transformer.lib import ListInfo, ResultSet, Dict, Long
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.volume_quotas.QuotaAdministration import QuotaAdministration
			service = QuotaAdministration()
			global function, interactive
			function = service.get_quota_capabilities
			interactive = []
	methods['volume_quotas.QuotaAdministration.get_quota_capabilities'] = ('volume_quotas_QuotaAdministration', '--get_quota_capabilities')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	volume_quotas_QuotaAdministration.add_argument("--get_quota_capabilities", action=volume_quotas_QuotaAdministration_get_quota_capabilitiesAction, nargs=nargs, metavar=metavars, help=help)
	class volume_quotas_QuotaAdministration_set_quotaAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.volume_quotas.VolumeQuota import VolumeQuota
			from unicorn_api.v5.sv0.volume_quotas import QuotaKind

			from transformer.lib import ListInfo, ResultSet, Dict, Long
			checker = [VolumeQuota]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.volume_quotas.QuotaAdministration import QuotaAdministration
			service = QuotaAdministration()
			global function, interactive
			function = service.set_quota
			interactive = []
			interactive.append(('quota', VolumeQuota))
	methods['volume_quotas.QuotaAdministration.set_quota'] = ('volume_quotas_QuotaAdministration', '--set_quota')
	metavars = () if interactive_mode else ('quota')
	help = '' if interactive_mode else '%s ' % ('{"kind":GROUP|USER,"generic_id":int,"quota":{"quota":long},"volume_id":int}')
	nargs = 0 if interactive_mode else 1
	volume_quotas_QuotaAdministration.add_argument("--set_quota", action=volume_quotas_QuotaAdministration_set_quotaAction, nargs=nargs, metavar=metavars, help=help)
	class volume_quotas_QuotaAdministration_myQuotasAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.volume_quotas.VolumeQuota import VolumeQuota
			from unicorn_api.v5.sv0.volume_quotas import QuotaKind

			from transformer.lib import ListInfo, ResultSet, Dict, Long
			checker = [cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.volume_quotas.QuotaAdministration import QuotaAdministration
			service = QuotaAdministration()
			global function, interactive
			function = service.myQuotas
			interactive = []
			interactive.append(('list_info', cli_list_info))
	methods['volume_quotas.QuotaAdministration.myQuotas'] = ('volume_quotas_QuotaAdministration', '--myQuotas')
	metavars = () if interactive_mode else ('list_info')
	help = '' if interactive_mode else '%s ' % ('offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 1
	volume_quotas_QuotaAdministration.add_argument("--myQuotas", action=volume_quotas_QuotaAdministration_myQuotasAction, nargs=nargs, metavar=metavars, help=help)
	class volume_quotas_QuotaAdministration_list_for_volumeAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.volume_quotas.VolumeQuota import VolumeQuota
			from unicorn_api.v5.sv0.volume_quotas import QuotaKind

			from transformer.lib import ListInfo, ResultSet, Dict, Long
			checker = [cli_int,cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.volume_quotas.QuotaAdministration import QuotaAdministration
			service = QuotaAdministration()
			global function, interactive
			function = service.list_for_volume
			interactive = []
			interactive.append(('volume_id', cli_int))
			interactive.append(('list_info', cli_list_info))
	methods['volume_quotas.QuotaAdministration.list_for_volume'] = ('volume_quotas_QuotaAdministration', '--list_for_volume')
	metavars = () if interactive_mode else ('volume_id','list_info')
	help = '' if interactive_mode else '%s %s ' % ('int', 'offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 2
	volume_quotas_QuotaAdministration.add_argument("--list_for_volume", action=volume_quotas_QuotaAdministration_list_for_volumeAction, nargs=nargs, metavar=metavars, help=help)
	class volume_quotas_QuotaAdministration_listAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.volume_quotas.VolumeQuota import VolumeQuota
			from unicorn_api.v5.sv0.volume_quotas import QuotaKind

			from transformer.lib import ListInfo, ResultSet, Dict, Long
			checker = [cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.volume_quotas.QuotaAdministration import QuotaAdministration
			service = QuotaAdministration()
			global function, interactive
			function = service.list
			interactive = []
			interactive.append(('list_info', cli_list_info))
	methods['volume_quotas.QuotaAdministration.list'] = ('volume_quotas_QuotaAdministration', '--list')
	metavars = () if interactive_mode else ('list_info')
	help = '' if interactive_mode else '%s ' % ('offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 1
	volume_quotas_QuotaAdministration.add_argument("--list", action=volume_quotas_QuotaAdministration_listAction, nargs=nargs, metavar=metavars, help=help)
	class volume_quotas_QuotaAdministration_user_space_leftAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.volume_quotas.VolumeQuota import VolumeQuota
			from unicorn_api.v5.sv0.volume_quotas import QuotaKind

			from transformer.lib import ListInfo, ResultSet, Dict, Long
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.volume_quotas.QuotaAdministration import QuotaAdministration
			service = QuotaAdministration()
			global function, interactive
			function = service.user_space_left
			interactive = []
			interactive.append(('user_id', cli_int))
	methods['volume_quotas.QuotaAdministration.user_space_left'] = ('volume_quotas_QuotaAdministration', '--user_space_left')
	metavars = () if interactive_mode else ('user_id')
	help = '' if interactive_mode else '%s ' % ('int')
	nargs = 0 if interactive_mode else 1
	volume_quotas_QuotaAdministration.add_argument("--user_space_left", action=volume_quotas_QuotaAdministration_user_space_leftAction, nargs=nargs, metavar=metavars, help=help)
	class volume_quotas_QuotaAdministration_mySpaceLeftAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.volume_quotas.VolumeQuota import VolumeQuota
			from unicorn_api.v5.sv0.volume_quotas import QuotaKind

			from transformer.lib import ListInfo, ResultSet, Dict, Long
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.volume_quotas.QuotaAdministration import QuotaAdministration
			service = QuotaAdministration()
			global function, interactive
			function = service.mySpaceLeft
			interactive = []
	methods['volume_quotas.QuotaAdministration.mySpaceLeft'] = ('volume_quotas_QuotaAdministration', '--mySpaceLeft')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	volume_quotas_QuotaAdministration.add_argument("--mySpaceLeft", action=volume_quotas_QuotaAdministration_mySpaceLeftAction, nargs=nargs, metavar=metavars, help=help)
	class volume_quotas_QuotaAdministration_user_quotasAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.volume_quotas.VolumeQuota import VolumeQuota
			from unicorn_api.v5.sv0.volume_quotas import QuotaKind

			from transformer.lib import ListInfo, ResultSet, Dict, Long
			checker = [cli_int,cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.volume_quotas.QuotaAdministration import QuotaAdministration
			service = QuotaAdministration()
			global function, interactive
			function = service.user_quotas
			interactive = []
			interactive.append(('user_id', cli_int))
			interactive.append(('list_info', cli_list_info))
	methods['volume_quotas.QuotaAdministration.user_quotas'] = ('volume_quotas_QuotaAdministration', '--user_quotas')
	metavars = () if interactive_mode else ('user_id','list_info')
	help = '' if interactive_mode else '%s %s ' % ('int', 'offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 2
	volume_quotas_QuotaAdministration.add_argument("--user_quotas", action=volume_quotas_QuotaAdministration_user_quotasAction, nargs=nargs, metavar=metavars, help=help)
	class volume_quotas_QuotaAdministration_deleteAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.volume_quotas.VolumeQuota import VolumeQuota
			from unicorn_api.v5.sv0.volume_quotas import QuotaKind

			from transformer.lib import ListInfo, ResultSet, Dict, Long
			checker = [QuotaKind,cli_int,cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.volume_quotas.QuotaAdministration import QuotaAdministration
			service = QuotaAdministration()
			global function, interactive
			function = service.delete
			interactive = []
			interactive.append(('kind', QuotaKind))
			interactive.append(('generic_id', cli_int))
			interactive.append(('volume_id', cli_int))
	methods['volume_quotas.QuotaAdministration.delete'] = ('volume_quotas_QuotaAdministration', '--delete')
	metavars = () if interactive_mode else ('kind','generic_id','volume_id')
	help = '' if interactive_mode else '%s %s %s ' % ('GROUP|USER', 'int', 'int')
	nargs = 0 if interactive_mode else 3
	volume_quotas_QuotaAdministration.add_argument("--delete", action=volume_quotas_QuotaAdministration_deleteAction, nargs=nargs, metavar=metavars, help=help)
	printer_PrinterAdministration = subparsers.add_parser('printer_PrinterAdministration', help="help printer.PrinterAdministration")
	class printer_PrinterAdministration_renameAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.printer.PrinterModel import PrinterModel

			from transformer.lib import List
			checker = [cli_int,cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.printer.PrinterAdministration import PrinterAdministration
			service = PrinterAdministration()
			global function, interactive
			function = service.rename
			interactive = []
			interactive.append(('id', cli_int))
			interactive.append(('name', cli_unicode))
	methods['printer.PrinterAdministration.rename'] = ('printer_PrinterAdministration', '--rename')
	metavars = () if interactive_mode else ('id','name')
	help = '' if interactive_mode else '%s %s ' % ('int', 'text')
	nargs = 0 if interactive_mode else 2
	printer_PrinterAdministration.add_argument("--rename", action=printer_PrinterAdministration_renameAction, nargs=nargs, metavar=metavars, help=help)
	class printer_PrinterAdministration_set_enabledAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.printer.PrinterModel import PrinterModel

			from transformer.lib import List
			checker = [cli_bool]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.printer.PrinterAdministration import PrinterAdministration
			service = PrinterAdministration()
			global function, interactive
			function = service.set_enabled
			interactive = []
			interactive.append(('enabled', cli_bool))
	methods['printer.PrinterAdministration.set_enabled'] = ('printer_PrinterAdministration', '--set_enabled')
	metavars = () if interactive_mode else ('enabled')
	help = '' if interactive_mode else '%s ' % ('True|False')
	nargs = 0 if interactive_mode else 1
	printer_PrinterAdministration.add_argument("--set_enabled", action=printer_PrinterAdministration_set_enabledAction, nargs=nargs, metavar=metavars, help=help)
	class printer_PrinterAdministration_listAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.printer.PrinterModel import PrinterModel

			from transformer.lib import List
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.printer.PrinterAdministration import PrinterAdministration
			service = PrinterAdministration()
			global function, interactive
			function = service.list
			interactive = []
	methods['printer.PrinterAdministration.list'] = ('printer_PrinterAdministration', '--list')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	printer_PrinterAdministration.add_argument("--list", action=printer_PrinterAdministration_listAction, nargs=nargs, metavar=metavars, help=help)
	class printer_PrinterAdministration_get_enabledAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.printer.PrinterModel import PrinterModel

			from transformer.lib import List
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.printer.PrinterAdministration import PrinterAdministration
			service = PrinterAdministration()
			global function, interactive
			function = service.get_enabled
			interactive = []
	methods['printer.PrinterAdministration.get_enabled'] = ('printer_PrinterAdministration', '--get_enabled')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	printer_PrinterAdministration.add_argument("--get_enabled", action=printer_PrinterAdministration_get_enabledAction, nargs=nargs, metavar=metavars, help=help)
	big_wuala_Management = subparsers.add_parser('big_wuala_Management', help="help big_wuala.Management")
	class big_wuala_Management_get_wuala_accountAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.big_wuala.BWRemoteConfig import BWRemoteConfig
			from unicorn_api.v5.sv0.big_wuala.LoginPasswordTuple import LoginPasswordTuple

			from transformer.lib import Blob
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.big_wuala.BigWualaManagement import BigWualaManagement
			service = BigWualaManagement()
			global function, interactive
			function = service.get_wuala_account
			interactive = []
			interactive.append(('user_id', cli_int))
	methods['big_wuala.Management.get_wuala_account'] = ('big_wuala_Management', '--get_wuala_account')
	metavars = () if interactive_mode else ('user_id')
	help = '' if interactive_mode else '%s ' % ('int')
	nargs = 0 if interactive_mode else 1
	big_wuala_Management.add_argument("--get_wuala_account", action=big_wuala_Management_get_wuala_accountAction, nargs=nargs, metavar=metavars, help=help)
	class big_wuala_Management_set_remote_config_autoAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.big_wuala.BWRemoteConfig import BWRemoteConfig
			from unicorn_api.v5.sv0.big_wuala.LoginPasswordTuple import LoginPasswordTuple

			from transformer.lib import Blob
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.big_wuala.BigWualaManagement import BigWualaManagement
			service = BigWualaManagement()
			global function, interactive
			function = service.set_remote_config_auto
			interactive = []
	methods['big_wuala.Management.set_remote_config_auto'] = ('big_wuala_Management', '--set_remote_config_auto')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	big_wuala_Management.add_argument("--set_remote_config_auto", action=big_wuala_Management_set_remote_config_autoAction, nargs=nargs, metavar=metavars, help=help)
	class big_wuala_Management_set_remote_accessAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.big_wuala.BWRemoteConfig import BWRemoteConfig
			from unicorn_api.v5.sv0.big_wuala.LoginPasswordTuple import LoginPasswordTuple

			from transformer.lib import Blob
			checker = [cli_bool]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.big_wuala.BigWualaManagement import BigWualaManagement
			service = BigWualaManagement()
			global function, interactive
			function = service.set_remote_access
			interactive = []
			interactive.append(('enabled', cli_bool))
	methods['big_wuala.Management.set_remote_access'] = ('big_wuala_Management', '--set_remote_access')
	metavars = () if interactive_mode else ('enabled')
	help = '' if interactive_mode else '%s ' % ('True|False')
	nargs = 0 if interactive_mode else 1
	big_wuala_Management.add_argument("--set_remote_access", action=big_wuala_Management_set_remote_accessAction, nargs=nargs, metavar=metavars, help=help)
	class big_wuala_Management_disassociateAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.big_wuala.BWRemoteConfig import BWRemoteConfig
			from unicorn_api.v5.sv0.big_wuala.LoginPasswordTuple import LoginPasswordTuple

			from transformer.lib import Blob
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.big_wuala.BigWualaManagement import BigWualaManagement
			service = BigWualaManagement()
			global function, interactive
			function = service.disassociate
			interactive = []
			interactive.append(('user_id', cli_int))
	methods['big_wuala.Management.disassociate'] = ('big_wuala_Management', '--disassociate')
	metavars = () if interactive_mode else ('user_id')
	help = '' if interactive_mode else '%s ' % ('int')
	nargs = 0 if interactive_mode else 1
	big_wuala_Management.add_argument("--disassociate", action=big_wuala_Management_disassociateAction, nargs=nargs, metavar=metavars, help=help)
	class big_wuala_Management_get_device_private_keyAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.big_wuala.BWRemoteConfig import BWRemoteConfig
			from unicorn_api.v5.sv0.big_wuala.LoginPasswordTuple import LoginPasswordTuple

			from transformer.lib import Blob
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.big_wuala.BigWualaManagement import BigWualaManagement
			service = BigWualaManagement()
			global function, interactive
			function = service.get_device_private_key
			interactive = []
	methods['big_wuala.Management.get_device_private_key'] = ('big_wuala_Management', '--get_device_private_key')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	big_wuala_Management.add_argument("--get_device_private_key", action=big_wuala_Management_get_device_private_keyAction, nargs=nargs, metavar=metavars, help=help)
	class big_wuala_Management_set_device_certificate_and_private_keyAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.big_wuala.BWRemoteConfig import BWRemoteConfig
			from unicorn_api.v5.sv0.big_wuala.LoginPasswordTuple import LoginPasswordTuple

			from transformer.lib import Blob
			checker = [Blob,Blob]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.big_wuala.BigWualaManagement import BigWualaManagement
			service = BigWualaManagement()
			global function, interactive
			function = service.set_device_certificate_and_private_key
			interactive = []
			interactive.append(('certificate', Blob))
			interactive.append(('key', Blob))
	methods['big_wuala.Management.set_device_certificate_and_private_key'] = ('big_wuala_Management', '--set_device_certificate_and_private_key')
	metavars = () if interactive_mode else ('certificate','key')
	help = '' if interactive_mode else '%s %s ' % ('somestuff', 'somestuff')
	nargs = 0 if interactive_mode else 2
	big_wuala_Management.add_argument("--set_device_certificate_and_private_key", action=big_wuala_Management_set_device_certificate_and_private_keyAction, nargs=nargs, metavar=metavars, help=help)
	class big_wuala_Management_get_remote_accessAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.big_wuala.BWRemoteConfig import BWRemoteConfig
			from unicorn_api.v5.sv0.big_wuala.LoginPasswordTuple import LoginPasswordTuple

			from transformer.lib import Blob
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.big_wuala.BigWualaManagement import BigWualaManagement
			service = BigWualaManagement()
			global function, interactive
			function = service.get_remote_access
			interactive = []
	methods['big_wuala.Management.get_remote_access'] = ('big_wuala_Management', '--get_remote_access')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	big_wuala_Management.add_argument("--get_remote_access", action=big_wuala_Management_get_remote_accessAction, nargs=nargs, metavar=metavars, help=help)
	class big_wuala_Management_get_user_from_wuala_idAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.big_wuala.BWRemoteConfig import BWRemoteConfig
			from unicorn_api.v5.sv0.big_wuala.LoginPasswordTuple import LoginPasswordTuple

			from transformer.lib import Blob
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.big_wuala.BigWualaManagement import BigWualaManagement
			service = BigWualaManagement()
			global function, interactive
			function = service.get_user_from_wuala_id
			interactive = []
			interactive.append(('wuala_id', cli_unicode))
	methods['big_wuala.Management.get_user_from_wuala_id'] = ('big_wuala_Management', '--get_user_from_wuala_id')
	metavars = () if interactive_mode else ('wuala_id')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 1
	big_wuala_Management.add_argument("--get_user_from_wuala_id", action=big_wuala_Management_get_user_from_wuala_idAction, nargs=nargs, metavar=metavars, help=help)
	class big_wuala_Management_set_device_wuala_idAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.big_wuala.BWRemoteConfig import BWRemoteConfig
			from unicorn_api.v5.sv0.big_wuala.LoginPasswordTuple import LoginPasswordTuple

			from transformer.lib import Blob
			checker = [Blob]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.big_wuala.BigWualaManagement import BigWualaManagement
			service = BigWualaManagement()
			global function, interactive
			function = service.set_device_wuala_id
			interactive = []
			interactive.append(('id', Blob))
	methods['big_wuala.Management.set_device_wuala_id'] = ('big_wuala_Management', '--set_device_wuala_id')
	metavars = () if interactive_mode else ('id')
	help = '' if interactive_mode else '%s ' % ('somestuff')
	nargs = 0 if interactive_mode else 1
	big_wuala_Management.add_argument("--set_device_wuala_id", action=big_wuala_Management_set_device_wuala_idAction, nargs=nargs, metavar=metavars, help=help)
	class big_wuala_Management_is_registration_doneAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.big_wuala.BWRemoteConfig import BWRemoteConfig
			from unicorn_api.v5.sv0.big_wuala.LoginPasswordTuple import LoginPasswordTuple

			from transformer.lib import Blob
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.big_wuala.BigWualaManagement import BigWualaManagement
			service = BigWualaManagement()
			global function, interactive
			function = service.is_registration_done
			interactive = []
	methods['big_wuala.Management.is_registration_done'] = ('big_wuala_Management', '--is_registration_done')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	big_wuala_Management.add_argument("--is_registration_done", action=big_wuala_Management_is_registration_doneAction, nargs=nargs, metavar=metavars, help=help)
	class big_wuala_Management_purgeAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.big_wuala.BWRemoteConfig import BWRemoteConfig
			from unicorn_api.v5.sv0.big_wuala.LoginPasswordTuple import LoginPasswordTuple

			from transformer.lib import Blob
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.big_wuala.BigWualaManagement import BigWualaManagement
			service = BigWualaManagement()
			global function, interactive
			function = service.purge
			interactive = []
	methods['big_wuala.Management.purge'] = ('big_wuala_Management', '--purge')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	big_wuala_Management.add_argument("--purge", action=big_wuala_Management_purgeAction, nargs=nargs, metavar=metavars, help=help)
	class big_wuala_Management_is_id_in_associated_listAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.big_wuala.BWRemoteConfig import BWRemoteConfig
			from unicorn_api.v5.sv0.big_wuala.LoginPasswordTuple import LoginPasswordTuple

			from transformer.lib import Blob
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.big_wuala.BigWualaManagement import BigWualaManagement
			service = BigWualaManagement()
			global function, interactive
			function = service.is_id_in_associated_list
			interactive = []
			interactive.append(('id', cli_unicode))
	methods['big_wuala.Management.is_id_in_associated_list'] = ('big_wuala_Management', '--is_id_in_associated_list')
	metavars = () if interactive_mode else ('id')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 1
	big_wuala_Management.add_argument("--is_id_in_associated_list", action=big_wuala_Management_is_id_in_associated_listAction, nargs=nargs, metavar=metavars, help=help)
	class big_wuala_Management_get_device_certificateAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.big_wuala.BWRemoteConfig import BWRemoteConfig
			from unicorn_api.v5.sv0.big_wuala.LoginPasswordTuple import LoginPasswordTuple

			from transformer.lib import Blob
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.big_wuala.BigWualaManagement import BigWualaManagement
			service = BigWualaManagement()
			global function, interactive
			function = service.get_device_certificate
			interactive = []
	methods['big_wuala.Management.get_device_certificate'] = ('big_wuala_Management', '--get_device_certificate')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	big_wuala_Management.add_argument("--get_device_certificate", action=big_wuala_Management_get_device_certificateAction, nargs=nargs, metavar=metavars, help=help)
	class big_wuala_Management_set_remote_portsAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.big_wuala.BWRemoteConfig import BWRemoteConfig
			from unicorn_api.v5.sv0.big_wuala.LoginPasswordTuple import LoginPasswordTuple

			from transformer.lib import Blob
			checker = [cli_int,cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.big_wuala.BigWualaManagement import BigWualaManagement
			service = BigWualaManagement()
			global function, interactive
			function = service.set_remote_ports
			interactive = []
			interactive.append(('local_port', cli_int))
			interactive.append(('remote_port', cli_int))
	methods['big_wuala.Management.set_remote_ports'] = ('big_wuala_Management', '--set_remote_ports')
	metavars = () if interactive_mode else ('local_port','remote_port')
	help = '' if interactive_mode else '%s %s ' % ('int', 'int')
	nargs = 0 if interactive_mode else 2
	big_wuala_Management.add_argument("--set_remote_ports", action=big_wuala_Management_set_remote_portsAction, nargs=nargs, metavar=metavars, help=help)
	class big_wuala_Management_set_remote_statusAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.big_wuala.BWRemoteConfig import BWRemoteConfig
			from unicorn_api.v5.sv0.big_wuala.LoginPasswordTuple import LoginPasswordTuple

			from transformer.lib import Blob
			checker = [cli_bool]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.big_wuala.BigWualaManagement import BigWualaManagement
			service = BigWualaManagement()
			global function, interactive
			function = service.set_remote_status
			interactive = []
			interactive.append(('status', cli_bool))
	methods['big_wuala.Management.set_remote_status'] = ('big_wuala_Management', '--set_remote_status')
	metavars = () if interactive_mode else ('status')
	help = '' if interactive_mode else '%s ' % ('True|False')
	nargs = 0 if interactive_mode else 1
	big_wuala_Management.add_argument("--set_remote_status", action=big_wuala_Management_set_remote_statusAction, nargs=nargs, metavar=metavars, help=help)
	class big_wuala_Management_get_server_statusAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.big_wuala.BWRemoteConfig import BWRemoteConfig
			from unicorn_api.v5.sv0.big_wuala.LoginPasswordTuple import LoginPasswordTuple

			from transformer.lib import Blob
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.big_wuala.BigWualaManagement import BigWualaManagement
			service = BigWualaManagement()
			global function, interactive
			function = service.get_server_status
			interactive = []
	methods['big_wuala.Management.get_server_status'] = ('big_wuala_Management', '--get_server_status')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	big_wuala_Management.add_argument("--get_server_status", action=big_wuala_Management_get_server_statusAction, nargs=nargs, metavar=metavars, help=help)
	class big_wuala_Management_get_remote_statusAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.big_wuala.BWRemoteConfig import BWRemoteConfig
			from unicorn_api.v5.sv0.big_wuala.LoginPasswordTuple import LoginPasswordTuple

			from transformer.lib import Blob
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.big_wuala.BigWualaManagement import BigWualaManagement
			service = BigWualaManagement()
			global function, interactive
			function = service.get_remote_status
			interactive = []
	methods['big_wuala.Management.get_remote_status'] = ('big_wuala_Management', '--get_remote_status')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	big_wuala_Management.add_argument("--get_remote_status", action=big_wuala_Management_get_remote_statusAction, nargs=nargs, metavar=metavars, help=help)
	class big_wuala_Management_get_device_wuala_idAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.big_wuala.BWRemoteConfig import BWRemoteConfig
			from unicorn_api.v5.sv0.big_wuala.LoginPasswordTuple import LoginPasswordTuple

			from transformer.lib import Blob
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.big_wuala.BigWualaManagement import BigWualaManagement
			service = BigWualaManagement()
			global function, interactive
			function = service.get_device_wuala_id
			interactive = []
	methods['big_wuala.Management.get_device_wuala_id'] = ('big_wuala_Management', '--get_device_wuala_id')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	big_wuala_Management.add_argument("--get_device_wuala_id", action=big_wuala_Management_get_device_wuala_idAction, nargs=nargs, metavar=metavars, help=help)
	class big_wuala_Management_associate_userAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.big_wuala.BWRemoteConfig import BWRemoteConfig
			from unicorn_api.v5.sv0.big_wuala.LoginPasswordTuple import LoginPasswordTuple

			from transformer.lib import Blob
			checker = [cli_int,cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.big_wuala.BigWualaManagement import BigWualaManagement
			service = BigWualaManagement()
			global function, interactive
			function = service.associate_user
			interactive = []
			interactive.append(('user_id', cli_int))
			interactive.append(('wuala_account', cli_unicode))
	methods['big_wuala.Management.associate_user'] = ('big_wuala_Management', '--associate_user')
	metavars = () if interactive_mode else ('user_id','wuala_account')
	help = '' if interactive_mode else '%s %s ' % ('int', 'text')
	nargs = 0 if interactive_mode else 2
	big_wuala_Management.add_argument("--associate_user", action=big_wuala_Management_associate_userAction, nargs=nargs, metavar=metavars, help=help)
	class big_wuala_Management_get_remote_configAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.big_wuala.BWRemoteConfig import BWRemoteConfig
			from unicorn_api.v5.sv0.big_wuala.LoginPasswordTuple import LoginPasswordTuple

			from transformer.lib import Blob
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.big_wuala.BigWualaManagement import BigWualaManagement
			service = BigWualaManagement()
			global function, interactive
			function = service.get_remote_config
			interactive = []
	methods['big_wuala.Management.get_remote_config'] = ('big_wuala_Management', '--get_remote_config')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	big_wuala_Management.add_argument("--get_remote_config", action=big_wuala_Management_get_remote_configAction, nargs=nargs, metavar=metavars, help=help)
	class big_wuala_Management_associate_user_with_wuala_idAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.big_wuala.BWRemoteConfig import BWRemoteConfig
			from unicorn_api.v5.sv0.big_wuala.LoginPasswordTuple import LoginPasswordTuple

			from transformer.lib import Blob
			checker = [cli_int,cli_unicode,cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.big_wuala.BigWualaManagement import BigWualaManagement
			service = BigWualaManagement()
			global function, interactive
			function = service.associate_user_with_wuala_id
			interactive = []
			interactive.append(('user_id', cli_int))
			interactive.append(('wuala_id', cli_unicode))
			interactive.append(('wuala_account', cli_unicode))
	methods['big_wuala.Management.associate_user_with_wuala_id'] = ('big_wuala_Management', '--associate_user_with_wuala_id')
	metavars = () if interactive_mode else ('user_id','wuala_id','wuala_account')
	help = '' if interactive_mode else '%s %s %s ' % ('int', 'text', 'text')
	nargs = 0 if interactive_mode else 3
	big_wuala_Management.add_argument("--associate_user_with_wuala_id", action=big_wuala_Management_associate_user_with_wuala_idAction, nargs=nargs, metavar=metavars, help=help)
	port_mapping_administration_port_mapping_service = subparsers.add_parser('port_mapping_administration_port_mapping_service', help="help port_mapping.administration.port_mapping_service")
	class port_mapping_administration_port_mapping_service_get_all_port_mappingsAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.port_mapping.PortMapping import PortMapping

			from transformer.lib import List
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.port_mapping.PortMappingService import PortMappingService
			service = PortMappingService()
			global function, interactive
			function = service.get_all_port_mappings
			interactive = []
	methods['port_mapping.administration.port_mapping_service.get_all_port_mappings'] = ('port_mapping_administration_port_mapping_service', '--get_all_port_mappings')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	port_mapping_administration_port_mapping_service.add_argument("--get_all_port_mappings", action=port_mapping_administration_port_mapping_service_get_all_port_mappingsAction, nargs=nargs, metavar=metavars, help=help)
	class port_mapping_administration_port_mapping_service_set_global_enabledAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.port_mapping.PortMapping import PortMapping

			from transformer.lib import List
			checker = [cli_bool]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.port_mapping.PortMappingService import PortMappingService
			service = PortMappingService()
			global function, interactive
			function = service.set_global_enabled
			interactive = []
			interactive.append(('enabled', cli_bool))
	methods['port_mapping.administration.port_mapping_service.set_global_enabled'] = ('port_mapping_administration_port_mapping_service', '--set_global_enabled')
	metavars = () if interactive_mode else ('enabled')
	help = '' if interactive_mode else '%s ' % ('True|False')
	nargs = 0 if interactive_mode else 1
	port_mapping_administration_port_mapping_service.add_argument("--set_global_enabled", action=port_mapping_administration_port_mapping_service_set_global_enabledAction, nargs=nargs, metavar=metavars, help=help)
	class port_mapping_administration_port_mapping_service_get_port_mappingAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.port_mapping.PortMapping import PortMapping

			from transformer.lib import List
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.port_mapping.PortMappingService import PortMappingService
			service = PortMappingService()
			global function, interactive
			function = service.get_port_mapping
			interactive = []
			interactive.append(('pm_id', cli_int))
	methods['port_mapping.administration.port_mapping_service.get_port_mapping'] = ('port_mapping_administration_port_mapping_service', '--get_port_mapping')
	metavars = () if interactive_mode else ('pm_id')
	help = '' if interactive_mode else '%s ' % ('int')
	nargs = 0 if interactive_mode else 1
	port_mapping_administration_port_mapping_service.add_argument("--get_port_mapping", action=port_mapping_administration_port_mapping_service_get_port_mappingAction, nargs=nargs, metavar=metavars, help=help)
	class port_mapping_administration_port_mapping_service_set_external_portAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.port_mapping.PortMapping import PortMapping

			from transformer.lib import List
			checker = [cli_int,cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.port_mapping.PortMappingService import PortMappingService
			service = PortMappingService()
			global function, interactive
			function = service.set_external_port
			interactive = []
			interactive.append(('pm_id', cli_int))
			interactive.append(('port', cli_int))
	methods['port_mapping.administration.port_mapping_service.set_external_port'] = ('port_mapping_administration_port_mapping_service', '--set_external_port')
	metavars = () if interactive_mode else ('pm_id','port')
	help = '' if interactive_mode else '%s %s ' % ('int', 'int')
	nargs = 0 if interactive_mode else 2
	port_mapping_administration_port_mapping_service.add_argument("--set_external_port", action=port_mapping_administration_port_mapping_service_set_external_portAction, nargs=nargs, metavar=metavars, help=help)
	class port_mapping_administration_port_mapping_service_get_global_enabledAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.port_mapping.PortMapping import PortMapping

			from transformer.lib import List
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.port_mapping.PortMappingService import PortMappingService
			service = PortMappingService()
			global function, interactive
			function = service.get_global_enabled
			interactive = []
	methods['port_mapping.administration.port_mapping_service.get_global_enabled'] = ('port_mapping_administration_port_mapping_service', '--get_global_enabled')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	port_mapping_administration_port_mapping_service.add_argument("--get_global_enabled", action=port_mapping_administration_port_mapping_service_get_global_enabledAction, nargs=nargs, metavar=metavars, help=help)
	class port_mapping_administration_port_mapping_service_set_enabledAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.port_mapping.PortMapping import PortMapping

			from transformer.lib import List
			checker = [cli_int,cli_bool]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.port_mapping.PortMappingService import PortMappingService
			service = PortMappingService()
			global function, interactive
			function = service.set_enabled
			interactive = []
			interactive.append(('pm_id', cli_int))
			interactive.append(('enabled', cli_bool))
	methods['port_mapping.administration.port_mapping_service.set_enabled'] = ('port_mapping_administration_port_mapping_service', '--set_enabled')
	metavars = () if interactive_mode else ('pm_id','enabled')
	help = '' if interactive_mode else '%s %s ' % ('int', 'True|False')
	nargs = 0 if interactive_mode else 2
	port_mapping_administration_port_mapping_service.add_argument("--set_enabled", action=port_mapping_administration_port_mapping_service_set_enabledAction, nargs=nargs, metavar=metavars, help=help)
	services_AutoMountAdministration = subparsers.add_parser('services_AutoMountAdministration', help="help services.AutoMountAdministration")
	class services_AutoMountAdministration_addAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.services.AutoMount import AutoMount
			checker = [AutoMount]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.services.AutoMountAdministration import AutoMountAdministration
			service = AutoMountAdministration()
			global function, interactive
			function = service.add
			interactive = []
			interactive.append(('automount', AutoMount))
	methods['services.AutoMountAdministration.add'] = ('services_AutoMountAdministration', '--add')
	metavars = () if interactive_mode else ('automount')
	help = '' if interactive_mode else '%s ' % ('{"auto_mount_path":text,"share_id":int,"user_id":int,"auto_mount":True|False}')
	nargs = 0 if interactive_mode else 1
	services_AutoMountAdministration.add_argument("--add", action=services_AutoMountAdministration_addAction, nargs=nargs, metavar=metavars, help=help)
	class services_AutoMountAdministration_getAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.services.AutoMount import AutoMount
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.services.AutoMountAdministration import AutoMountAdministration
			service = AutoMountAdministration()
			global function, interactive
			function = service.get
			interactive = []
			interactive.append(('share_id', cli_int))
	methods['services.AutoMountAdministration.get'] = ('services_AutoMountAdministration', '--get')
	metavars = () if interactive_mode else ('share_id')
	help = '' if interactive_mode else '%s ' % ('int')
	nargs = 0 if interactive_mode else 1
	services_AutoMountAdministration.add_argument("--get", action=services_AutoMountAdministration_getAction, nargs=nargs, metavar=metavars, help=help)
	class services_AutoMountAdministration_modifyAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.services.AutoMount import AutoMount
			checker = [cli_int,AutoMount]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.services.AutoMountAdministration import AutoMountAdministration
			service = AutoMountAdministration()
			global function, interactive
			function = service.modify
			interactive = []
			interactive.append(('share_id', cli_int))
			interactive.append(('automount', AutoMount))
	methods['services.AutoMountAdministration.modify'] = ('services_AutoMountAdministration', '--modify')
	metavars = () if interactive_mode else ('share_id','automount')
	help = '' if interactive_mode else '%s %s ' % ('int', '{"auto_mount_path":text,"share_id":int,"user_id":int,"auto_mount":True|False}')
	nargs = 0 if interactive_mode else 2
	services_AutoMountAdministration.add_argument("--modify", action=services_AutoMountAdministration_modifyAction, nargs=nargs, metavar=metavars, help=help)
	class services_AutoMountAdministration_getByNameAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.services.AutoMount import AutoMount
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.services.AutoMountAdministration import AutoMountAdministration
			service = AutoMountAdministration()
			global function, interactive
			function = service.getByName
			interactive = []
			interactive.append(('share_name', cli_unicode))
	methods['services.AutoMountAdministration.getByName'] = ('services_AutoMountAdministration', '--getByName')
	metavars = () if interactive_mode else ('share_name')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 1
	services_AutoMountAdministration.add_argument("--getByName", action=services_AutoMountAdministration_getByNameAction, nargs=nargs, metavar=metavars, help=help)
	filebrowser_FileBrowsing = subparsers.add_parser('filebrowser_FileBrowsing', help="help filebrowser.FileBrowsing")
	class filebrowser_FileBrowsing_renameAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.filebrowser.ShareLink import ShareLink
			from unicorn_api.v5.sv0.sharing import Access
			from unicorn_api.v5.sv0.filebrowser.FileIOResource import FileIOResource
			from unicorn_api.v5.sv0.filebrowser import OpenMode
			from unicorn_api.v5.sv0.filebrowser.FileIOProperty import FileIOProperty
			from unicorn_api.v5.sv0.filebrowser import UploadBehavior

			from transformer.lib import ListInfo, ResultSet, List, Long, Blob, Date
			checker = [cli_unicode,cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.filebrowser.FileBrowsing import FileBrowsing
			service = FileBrowsing()
			global function, interactive
			function = service.rename
			interactive = []
			interactive.append(('resource_id', cli_unicode))
			interactive.append(('new_name', cli_unicode))
	methods['filebrowser.FileBrowsing.rename'] = ('filebrowser_FileBrowsing', '--rename')
	metavars = () if interactive_mode else ('resource_id','new_name')
	help = '' if interactive_mode else '%s %s ' % ('text', 'text')
	nargs = 0 if interactive_mode else 2
	filebrowser_FileBrowsing.add_argument("--rename", action=filebrowser_FileBrowsing_renameAction, nargs=nargs, metavar=metavars, help=help)
	class filebrowser_FileBrowsing_moveAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.filebrowser.ShareLink import ShareLink
			from unicorn_api.v5.sv0.sharing import Access
			from unicorn_api.v5.sv0.filebrowser.FileIOResource import FileIOResource
			from unicorn_api.v5.sv0.filebrowser import OpenMode
			from unicorn_api.v5.sv0.filebrowser.FileIOProperty import FileIOProperty
			from unicorn_api.v5.sv0.filebrowser import UploadBehavior

			from transformer.lib import ListInfo, ResultSet, List, Long, Blob, Date
			checker = [cli_unicode,cli_unicode,cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.filebrowser.FileBrowsing import FileBrowsing
			service = FileBrowsing()
			global function, interactive
			function = service.move
			interactive = []
			interactive.append(('async_job_name', cli_unicode))
			interactive.append(('resource_id', cli_unicode))
			interactive.append(('destination_id', cli_unicode))
	methods['filebrowser.FileBrowsing.move'] = ('filebrowser_FileBrowsing', '--move')
	metavars = () if interactive_mode else ('async_job_name','resource_id','destination_id')
	help = '' if interactive_mode else '%s %s ' % ('text', 'text')
	nargs = 0 if interactive_mode else 3
	filebrowser_FileBrowsing.add_argument("--move", action=filebrowser_FileBrowsing_moveAction, nargs=nargs, metavar=metavars, help=help)
	class filebrowser_FileBrowsing_moveResultAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.filebrowser.FileBrowsing import FileBrowsing
			service = FileBrowsing()
			global function, interactive
			function = service.move_result
			interactive = []
			interactive.append(('async_job_id', cli_int))
	methods['filebrowser.FileBrowsing.move_result'] = ('filebrowser_FileBrowsing', '--move_result')
	metavars = () if interactive_mode else ('async_job_id')
	nargs = 0 if interactive_mode else 1
	filebrowser_FileBrowsing.add_argument("--move_result", action=filebrowser_FileBrowsing_moveResultAction, nargs=nargs, metavar=metavars)
	class filebrowser_FileBrowsing_shareAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.filebrowser.ShareLink import ShareLink
			from unicorn_api.v5.sv0.sharing import Access
			from unicorn_api.v5.sv0.filebrowser.FileIOResource import FileIOResource
			from unicorn_api.v5.sv0.filebrowser import OpenMode
			from unicorn_api.v5.sv0.filebrowser.FileIOProperty import FileIOProperty
			from unicorn_api.v5.sv0.filebrowser import UploadBehavior

			from transformer.lib import ListInfo, ResultSet, List, Long, Blob, Date
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.filebrowser.FileBrowsing import FileBrowsing
			service = FileBrowsing()
			global function, interactive
			function = service.share
			interactive = []
			interactive.append(('file_id', cli_unicode))
	methods['filebrowser.FileBrowsing.share'] = ('filebrowser_FileBrowsing', '--share')
	metavars = () if interactive_mode else ('file_id')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 1
	filebrowser_FileBrowsing.add_argument("--share", action=filebrowser_FileBrowsing_shareAction, nargs=nargs, metavar=metavars, help=help)
	class filebrowser_FileBrowsing_closeAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.filebrowser.ShareLink import ShareLink
			from unicorn_api.v5.sv0.sharing import Access
			from unicorn_api.v5.sv0.filebrowser.FileIOResource import FileIOResource
			from unicorn_api.v5.sv0.filebrowser import OpenMode
			from unicorn_api.v5.sv0.filebrowser.FileIOProperty import FileIOProperty
			from unicorn_api.v5.sv0.filebrowser import UploadBehavior

			from transformer.lib import ListInfo, ResultSet, List, Long, Blob, Date
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.filebrowser.FileBrowsing import FileBrowsing
			service = FileBrowsing()
			global function, interactive
			function = service.close
			interactive = []
			interactive.append(('file_id', cli_int))
	methods['filebrowser.FileBrowsing.close'] = ('filebrowser_FileBrowsing', '--close')
	metavars = () if interactive_mode else ('file_id')
	help = '' if interactive_mode else '%s ' % ('int')
	nargs = 0 if interactive_mode else 1
	filebrowser_FileBrowsing.add_argument("--close", action=filebrowser_FileBrowsing_closeAction, nargs=nargs, metavar=metavars, help=help)
	class filebrowser_FileBrowsing_openAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.filebrowser.ShareLink import ShareLink
			from unicorn_api.v5.sv0.sharing import Access
			from unicorn_api.v5.sv0.filebrowser.FileIOResource import FileIOResource
			from unicorn_api.v5.sv0.filebrowser import OpenMode
			from unicorn_api.v5.sv0.filebrowser.FileIOProperty import FileIOProperty
			from unicorn_api.v5.sv0.filebrowser import UploadBehavior

			from transformer.lib import ListInfo, ResultSet, List, Long, Blob, Date
			checker = [cli_unicode,OpenMode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.filebrowser.FileBrowsing import FileBrowsing
			service = FileBrowsing()
			global function, interactive
			function = service.open
			interactive = []
			interactive.append(('file_id', cli_unicode))
			interactive.append(('mode', OpenMode))
	methods['filebrowser.FileBrowsing.open'] = ('filebrowser_FileBrowsing', '--open')
	metavars = () if interactive_mode else ('file_id','mode')
	help = '' if interactive_mode else '%s %s ' % ('text', 'READ|WRITE|READ_BINARY|WRITE_BINARY')
	nargs = 0 if interactive_mode else 2
	filebrowser_FileBrowsing.add_argument("--open", action=filebrowser_FileBrowsing_openAction, nargs=nargs, metavar=metavars, help=help)
	class filebrowser_FileBrowsing_upload_doneAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.filebrowser.ShareLink import ShareLink
			from unicorn_api.v5.sv0.sharing import Access
			from unicorn_api.v5.sv0.filebrowser.FileIOResource import FileIOResource
			from unicorn_api.v5.sv0.filebrowser import OpenMode
			from unicorn_api.v5.sv0.filebrowser.FileIOProperty import FileIOProperty
			from unicorn_api.v5.sv0.filebrowser import UploadBehavior

			from transformer.lib import ListInfo, ResultSet, List, Long, Blob, Date
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.filebrowser.FileBrowsing import FileBrowsing
			service = FileBrowsing()
			global function, interactive
			function = service.upload_done
			interactive = []
			interactive.append(('token', cli_unicode))
	methods['filebrowser.FileBrowsing.upload_done'] = ('filebrowser_FileBrowsing', '--upload_done')
	metavars = () if interactive_mode else ('token')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 1
	filebrowser_FileBrowsing.add_argument("--upload_done", action=filebrowser_FileBrowsing_upload_doneAction, nargs=nargs, metavar=metavars, help=help)
	class filebrowser_FileBrowsing_add_commentAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.filebrowser.ShareLink import ShareLink
			from unicorn_api.v5.sv0.sharing import Access
			from unicorn_api.v5.sv0.filebrowser.FileIOResource import FileIOResource
			from unicorn_api.v5.sv0.filebrowser import OpenMode
			from unicorn_api.v5.sv0.filebrowser.FileIOProperty import FileIOProperty
			from unicorn_api.v5.sv0.filebrowser import UploadBehavior

			from transformer.lib import ListInfo, ResultSet, List, Long, Blob, Date
			checker = [cli_unicode,cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.filebrowser.FileBrowsing import FileBrowsing
			service = FileBrowsing()
			global function, interactive
			function = service.add_comment
			interactive = []
			interactive.append(('resource_id', cli_unicode))
			interactive.append(('comment', cli_unicode))
	methods['filebrowser.FileBrowsing.add_comment'] = ('filebrowser_FileBrowsing', '--add_comment')
	metavars = () if interactive_mode else ('resource_id','comment')
	help = '' if interactive_mode else '%s %s ' % ('text', 'text')
	nargs = 0 if interactive_mode else 2
	filebrowser_FileBrowsing.add_argument("--add_comment", action=filebrowser_FileBrowsing_add_commentAction, nargs=nargs, metavar=metavars, help=help)
	class filebrowser_FileBrowsing_seekAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.filebrowser.ShareLink import ShareLink
			from unicorn_api.v5.sv0.sharing import Access
			from unicorn_api.v5.sv0.filebrowser.FileIOResource import FileIOResource
			from unicorn_api.v5.sv0.filebrowser import OpenMode
			from unicorn_api.v5.sv0.filebrowser.FileIOProperty import FileIOProperty
			from unicorn_api.v5.sv0.filebrowser import UploadBehavior

			from transformer.lib import ListInfo, ResultSet, List, Long, Blob, Date
			checker = [cli_int,cli_long]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.filebrowser.FileBrowsing import FileBrowsing
			service = FileBrowsing()
			global function, interactive
			function = service.seek
			interactive = []
			interactive.append(('file_id', cli_int))
			interactive.append(('position', cli_long))
	methods['filebrowser.FileBrowsing.seek'] = ('filebrowser_FileBrowsing', '--seek')
	metavars = () if interactive_mode else ('file_id','position')
	help = '' if interactive_mode else '%s %s ' % ('int', 'long')
	nargs = 0 if interactive_mode else 2
	filebrowser_FileBrowsing.add_argument("--seek", action=filebrowser_FileBrowsing_seekAction, nargs=nargs, metavar=metavars, help=help)
	class filebrowser_FileBrowsing_list_share_linksAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.filebrowser.ShareLink import ShareLink
			from unicorn_api.v5.sv0.sharing import Access
			from unicorn_api.v5.sv0.filebrowser.FileIOResource import FileIOResource
			from unicorn_api.v5.sv0.filebrowser import OpenMode
			from unicorn_api.v5.sv0.filebrowser.FileIOProperty import FileIOProperty
			from unicorn_api.v5.sv0.filebrowser import UploadBehavior

			from transformer.lib import ListInfo, ResultSet, List, Long, Blob, Date
			checker = [cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.filebrowser.FileBrowsing import FileBrowsing
			service = FileBrowsing()
			global function, interactive
			function = service.list_share_links
			interactive = []
			interactive.append(('list_info', cli_list_info))
	methods['filebrowser.FileBrowsing.list_share_links'] = ('filebrowser_FileBrowsing', '--list_share_links')
	metavars = () if interactive_mode else ('list_info')
	help = '' if interactive_mode else '%s ' % ('offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 1
	filebrowser_FileBrowsing.add_argument("--list_share_links", action=filebrowser_FileBrowsing_list_share_linksAction, nargs=nargs, metavar=metavars, help=help)
	class filebrowser_FileBrowsing_get_share_link_pathAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.filebrowser.ShareLink import ShareLink
			from unicorn_api.v5.sv0.sharing import Access
			from unicorn_api.v5.sv0.filebrowser.FileIOResource import FileIOResource
			from unicorn_api.v5.sv0.filebrowser import OpenMode
			from unicorn_api.v5.sv0.filebrowser.FileIOProperty import FileIOProperty
			from unicorn_api.v5.sv0.filebrowser import UploadBehavior

			from transformer.lib import ListInfo, ResultSet, List, Long, Blob, Date
			checker = [cli_unicode,cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.filebrowser.FileBrowsing import FileBrowsing
			service = FileBrowsing()
			global function, interactive
			function = service.get_share_link_path
			interactive = []
			interactive.append(('uri', cli_unicode))
			interactive.append(('password', cli_unicode))
	methods['filebrowser.FileBrowsing.get_share_link_path'] = ('filebrowser_FileBrowsing', '--get_share_link_path')
	metavars = () if interactive_mode else ('uri','password')
	help = '' if interactive_mode else '%s %s ' % ('text', 'text')
	nargs = 0 if interactive_mode else 2
	filebrowser_FileBrowsing.add_argument("--get_share_link_path", action=filebrowser_FileBrowsing_get_share_link_pathAction, nargs=nargs, metavar=metavars, help=help)
	class filebrowser_FileBrowsing_get_propertiesAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.filebrowser.ShareLink import ShareLink
			from unicorn_api.v5.sv0.sharing import Access
			from unicorn_api.v5.sv0.filebrowser.FileIOResource import FileIOResource
			from unicorn_api.v5.sv0.filebrowser import OpenMode
			from unicorn_api.v5.sv0.filebrowser.FileIOProperty import FileIOProperty
			from unicorn_api.v5.sv0.filebrowser import UploadBehavior

			from transformer.lib import ListInfo, ResultSet, List, Long, Blob, Date
			checker = [cli_unicode,list_cli(unicode)]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.filebrowser.FileBrowsing import FileBrowsing
			service = FileBrowsing()
			global function, interactive
			function = service.get_properties
			interactive = []
			interactive.append(('resource_id', cli_unicode))
			interactive.append(('properties_list', list_cli(unicode)))
	methods['filebrowser.FileBrowsing.get_properties'] = ('filebrowser_FileBrowsing', '--get_properties')
	metavars = () if interactive_mode else ('resource_id','properties_list')
	help = '' if interactive_mode else '%s %s ' % ('text', '["text",...]')
	nargs = 0 if interactive_mode else 2
	filebrowser_FileBrowsing.add_argument("--get_properties", action=filebrowser_FileBrowsing_get_propertiesAction, nargs=nargs, metavar=metavars, help=help)
	class filebrowser_FileBrowsing_writeAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.filebrowser.ShareLink import ShareLink
			from unicorn_api.v5.sv0.sharing import Access
			from unicorn_api.v5.sv0.filebrowser.FileIOResource import FileIOResource
			from unicorn_api.v5.sv0.filebrowser import OpenMode
			from unicorn_api.v5.sv0.filebrowser.FileIOProperty import FileIOProperty
			from unicorn_api.v5.sv0.filebrowser import UploadBehavior

			from transformer.lib import ListInfo, ResultSet, List, Long, Blob, Date
			checker = [cli_int,Blob]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.filebrowser.FileBrowsing import FileBrowsing
			service = FileBrowsing()
			global function, interactive
			function = service.write
			interactive = []
			interactive.append(('file_id', cli_int))
			interactive.append(('data', Blob))
	methods['filebrowser.FileBrowsing.write'] = ('filebrowser_FileBrowsing', '--write')
	metavars = () if interactive_mode else ('file_id','data')
	help = '' if interactive_mode else '%s %s ' % ('int', 'somestuff')
	nargs = 0 if interactive_mode else 2
	filebrowser_FileBrowsing.add_argument("--write", action=filebrowser_FileBrowsing_writeAction, nargs=nargs, metavar=metavars, help=help)
	class filebrowser_FileBrowsing_my_share_linksAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.filebrowser.ShareLink import ShareLink
			from unicorn_api.v5.sv0.sharing import Access
			from unicorn_api.v5.sv0.filebrowser.FileIOResource import FileIOResource
			from unicorn_api.v5.sv0.filebrowser import OpenMode
			from unicorn_api.v5.sv0.filebrowser.FileIOProperty import FileIOProperty
			from unicorn_api.v5.sv0.filebrowser import UploadBehavior

			from transformer.lib import ListInfo, ResultSet, List, Long, Blob, Date
			checker = [cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.filebrowser.FileBrowsing import FileBrowsing
			service = FileBrowsing()
			global function, interactive
			function = service.my_share_links
			interactive = []
			interactive.append(('list_info', cli_list_info))
	methods['filebrowser.FileBrowsing.my_share_links'] = ('filebrowser_FileBrowsing', '--my_share_links')
	metavars = () if interactive_mode else ('list_info')
	help = '' if interactive_mode else '%s ' % ('offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 1
	filebrowser_FileBrowsing.add_argument("--my_share_links", action=filebrowser_FileBrowsing_my_share_linksAction, nargs=nargs, metavar=metavars, help=help)
	class filebrowser_FileBrowsing_get_thumbnailAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.filebrowser.ShareLink import ShareLink
			from unicorn_api.v5.sv0.sharing import Access
			from unicorn_api.v5.sv0.filebrowser.FileIOResource import FileIOResource
			from unicorn_api.v5.sv0.filebrowser import OpenMode
			from unicorn_api.v5.sv0.filebrowser.FileIOProperty import FileIOProperty
			from unicorn_api.v5.sv0.filebrowser import UploadBehavior

			from transformer.lib import ListInfo, ResultSet, List, Long, Blob, Date
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.filebrowser.FileBrowsing import FileBrowsing
			service = FileBrowsing()
			global function, interactive
			function = service.get_thumbnail
			interactive = []
			interactive.append(('file_id', cli_unicode))
	methods['filebrowser.FileBrowsing.get_thumbnail'] = ('filebrowser_FileBrowsing', '--get_thumbnail')
	metavars = () if interactive_mode else ('file_id')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 1
	filebrowser_FileBrowsing.add_argument("--get_thumbnail", action=filebrowser_FileBrowsing_get_thumbnailAction, nargs=nargs, metavar=metavars, help=help)
	class filebrowser_FileBrowsing_download_completedAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.filebrowser.ShareLink import ShareLink
			from unicorn_api.v5.sv0.sharing import Access
			from unicorn_api.v5.sv0.filebrowser.FileIOResource import FileIOResource
			from unicorn_api.v5.sv0.filebrowser import OpenMode
			from unicorn_api.v5.sv0.filebrowser.FileIOProperty import FileIOProperty
			from unicorn_api.v5.sv0.filebrowser import UploadBehavior

			from transformer.lib import ListInfo, ResultSet, List, Long, Blob, Date
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.filebrowser.FileBrowsing import FileBrowsing
			service = FileBrowsing()
			global function, interactive
			function = service.download_completed
			interactive = []
			interactive.append(('uri', cli_unicode))
	methods['filebrowser.FileBrowsing.download_completed'] = ('filebrowser_FileBrowsing', '--download_completed')
	metavars = () if interactive_mode else ('uri')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 1
	filebrowser_FileBrowsing.add_argument("--download_completed", action=filebrowser_FileBrowsing_download_completedAction, nargs=nargs, metavar=metavars, help=help)
	class filebrowser_FileBrowsing_set_enabled_share_linkAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.filebrowser.ShareLink import ShareLink
			from unicorn_api.v5.sv0.sharing import Access
			from unicorn_api.v5.sv0.filebrowser.FileIOResource import FileIOResource
			from unicorn_api.v5.sv0.filebrowser import OpenMode
			from unicorn_api.v5.sv0.filebrowser.FileIOProperty import FileIOProperty
			from unicorn_api.v5.sv0.filebrowser import UploadBehavior

			from transformer.lib import ListInfo, ResultSet, List, Long, Blob, Date
			checker = [cli_unicode,cli_bool]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.filebrowser.FileBrowsing import FileBrowsing
			service = FileBrowsing()
			global function, interactive
			function = service.set_enabled_share_link
			interactive = []
			interactive.append(('URI', cli_unicode))
			interactive.append(('enabled', cli_bool))
	methods['filebrowser.FileBrowsing.set_enabled_share_link'] = ('filebrowser_FileBrowsing', '--set_enabled_share_link')
	metavars = () if interactive_mode else ('URI','enabled')
	help = '' if interactive_mode else '%s %s ' % ('text', 'True|False')
	nargs = 0 if interactive_mode else 2
	filebrowser_FileBrowsing.add_argument("--set_enabled_share_link", action=filebrowser_FileBrowsing_set_enabled_share_linkAction, nargs=nargs, metavar=metavars, help=help)
	class filebrowser_FileBrowsing_close_enumerationAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.filebrowser.ShareLink import ShareLink
			from unicorn_api.v5.sv0.sharing import Access
			from unicorn_api.v5.sv0.filebrowser.FileIOResource import FileIOResource
			from unicorn_api.v5.sv0.filebrowser import OpenMode
			from unicorn_api.v5.sv0.filebrowser.FileIOProperty import FileIOProperty
			from unicorn_api.v5.sv0.filebrowser import UploadBehavior

			from transformer.lib import ListInfo, ResultSet, List, Long, Blob, Date
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.filebrowser.FileBrowsing import FileBrowsing
			service = FileBrowsing()
			global function, interactive
			function = service.close_enumeration
			interactive = []
			interactive.append(('enumeration_id', cli_int))
	methods['filebrowser.FileBrowsing.close_enumeration'] = ('filebrowser_FileBrowsing', '--close_enumeration')
	metavars = () if interactive_mode else ('enumeration_id')
	help = '' if interactive_mode else '%s ' % ('int')
	nargs = 0 if interactive_mode else 1
	filebrowser_FileBrowsing.add_argument("--close_enumeration", action=filebrowser_FileBrowsing_close_enumerationAction, nargs=nargs, metavar=metavars, help=help)
	class filebrowser_FileBrowsing_get_upload_pathAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.filebrowser.ShareLink import ShareLink
			from unicorn_api.v5.sv0.sharing import Access
			from unicorn_api.v5.sv0.filebrowser.FileIOResource import FileIOResource
			from unicorn_api.v5.sv0.filebrowser import OpenMode
			from unicorn_api.v5.sv0.filebrowser.FileIOProperty import FileIOProperty
			from unicorn_api.v5.sv0.filebrowser import UploadBehavior

			from transformer.lib import ListInfo, ResultSet, List, Long, Blob, Date
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.filebrowser.FileBrowsing import FileBrowsing
			service = FileBrowsing()
			global function, interactive
			function = service.get_upload_path
			interactive = []
			interactive.append(('token', cli_unicode))
	methods['filebrowser.FileBrowsing.get_upload_path'] = ('filebrowser_FileBrowsing', '--get_upload_path')
	metavars = () if interactive_mode else ('token')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 1
	filebrowser_FileBrowsing.add_argument("--get_upload_path", action=filebrowser_FileBrowsing_get_upload_pathAction, nargs=nargs, metavar=metavars, help=help)
	class filebrowser_FileBrowsing_readAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.filebrowser.ShareLink import ShareLink
			from unicorn_api.v5.sv0.sharing import Access
			from unicorn_api.v5.sv0.filebrowser.FileIOResource import FileIOResource
			from unicorn_api.v5.sv0.filebrowser import OpenMode
			from unicorn_api.v5.sv0.filebrowser.FileIOProperty import FileIOProperty
			from unicorn_api.v5.sv0.filebrowser import UploadBehavior

			from transformer.lib import ListInfo, ResultSet, List, Long, Blob, Date
			checker = [cli_int,cli_long]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.filebrowser.FileBrowsing import FileBrowsing
			service = FileBrowsing()
			global function, interactive
			function = service.read
			interactive = []
			interactive.append(('file_id', cli_int))
			interactive.append(('size', cli_long))
	methods['filebrowser.FileBrowsing.read'] = ('filebrowser_FileBrowsing', '--read')
	metavars = () if interactive_mode else ('file_id','size')
	help = '' if interactive_mode else '%s %s ' % ('int', 'long')
	nargs = 0 if interactive_mode else 2
	filebrowser_FileBrowsing.add_argument("--read", action=filebrowser_FileBrowsing_readAction, nargs=nargs, metavar=metavars, help=help)
	class filebrowser_FileBrowsing_update_modify_dateAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.filebrowser.ShareLink import ShareLink
			from unicorn_api.v5.sv0.sharing import Access
			from unicorn_api.v5.sv0.filebrowser.FileIOResource import FileIOResource
			from unicorn_api.v5.sv0.filebrowser import OpenMode
			from unicorn_api.v5.sv0.filebrowser.FileIOProperty import FileIOProperty
			from unicorn_api.v5.sv0.filebrowser import UploadBehavior

			from transformer.lib import ListInfo, ResultSet, List, Long, Blob, Date
			checker = [cli_unicode,cli_date]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.filebrowser.FileBrowsing import FileBrowsing
			service = FileBrowsing()
			global function, interactive
			function = service.update_modify_date
			interactive = []
			interactive.append(('resource_id', cli_unicode))
			interactive.append(('modify_date', cli_date))
	methods['filebrowser.FileBrowsing.update_modify_date'] = ('filebrowser_FileBrowsing', '--update_modify_date')
	metavars = () if interactive_mode else ('resource_id','modify_date')
	help = '' if interactive_mode else '%s %s ' % ('text', 'long')
	nargs = 0 if interactive_mode else 2
	filebrowser_FileBrowsing.add_argument("--update_modify_date", action=filebrowser_FileBrowsing_update_modify_dateAction, nargs=nargs, metavar=metavars, help=help)
	class filebrowser_FileBrowsing_get_upload_tokenAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.filebrowser.ShareLink import ShareLink
			from unicorn_api.v5.sv0.sharing import Access
			from unicorn_api.v5.sv0.filebrowser.FileIOResource import FileIOResource
			from unicorn_api.v5.sv0.filebrowser import OpenMode
			from unicorn_api.v5.sv0.filebrowser.FileIOProperty import FileIOProperty
			from unicorn_api.v5.sv0.filebrowser import UploadBehavior

			from transformer.lib import ListInfo, ResultSet, List, Long, Blob, Date
			checker = [cli_unicode,UploadBehavior]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.filebrowser.FileBrowsing import FileBrowsing
			service = FileBrowsing()
			global function, interactive
			function = service.get_upload_token
			interactive = []
			interactive.append(('destination', cli_unicode))
			interactive.append(('behavior', UploadBehavior))
	methods['filebrowser.FileBrowsing.get_upload_token'] = ('filebrowser_FileBrowsing', '--get_upload_token')
	metavars = () if interactive_mode else ('destination','behavior')
	help = '' if interactive_mode else '%s %s ' % ('text', 'RENAME|OVERRIDE|SKIP')
	nargs = 0 if interactive_mode else 2
	filebrowser_FileBrowsing.add_argument("--get_upload_token", action=filebrowser_FileBrowsing_get_upload_tokenAction, nargs=nargs, metavar=metavars, help=help)
	class filebrowser_FileBrowsing_delete_share_linkAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.filebrowser.ShareLink import ShareLink
			from unicorn_api.v5.sv0.sharing import Access
			from unicorn_api.v5.sv0.filebrowser.FileIOResource import FileIOResource
			from unicorn_api.v5.sv0.filebrowser import OpenMode
			from unicorn_api.v5.sv0.filebrowser.FileIOProperty import FileIOProperty
			from unicorn_api.v5.sv0.filebrowser import UploadBehavior

			from transformer.lib import ListInfo, ResultSet, List, Long, Blob, Date
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.filebrowser.FileBrowsing import FileBrowsing
			service = FileBrowsing()
			global function, interactive
			function = service.delete_share_link
			interactive = []
			interactive.append(('uri', cli_unicode))
	methods['filebrowser.FileBrowsing.delete_share_link'] = ('filebrowser_FileBrowsing', '--delete_share_link')
	metavars = () if interactive_mode else ('uri')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 1
	filebrowser_FileBrowsing.add_argument("--delete_share_link", action=filebrowser_FileBrowsing_delete_share_linkAction, nargs=nargs, metavar=metavars, help=help)
	class filebrowser_FileBrowsing_list_childrenAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.filebrowser.ShareLink import ShareLink
			from unicorn_api.v5.sv0.sharing import Access
			from unicorn_api.v5.sv0.filebrowser.FileIOResource import FileIOResource
			from unicorn_api.v5.sv0.filebrowser import OpenMode
			from unicorn_api.v5.sv0.filebrowser.FileIOProperty import FileIOProperty
			from unicorn_api.v5.sv0.filebrowser import UploadBehavior

			from transformer.lib import ListInfo, ResultSet, List, Long, Blob, Date
			checker = [cli_int,cli_list_info,list_cli(unicode)]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.filebrowser.FileBrowsing import FileBrowsing
			service = FileBrowsing()
			global function, interactive
			function = service.list_children
			interactive = []
			interactive.append(('enumeration_id', cli_int))
			interactive.append(('list_info', cli_list_info))
			interactive.append(('with_properties', list_cli(unicode)))
	methods['filebrowser.FileBrowsing.list_children'] = ('filebrowser_FileBrowsing', '--list_children')
	metavars = () if interactive_mode else ('enumeration_id','list_info','with_properties')
	help = '' if interactive_mode else '%s %s %s ' % ('int', 'offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}', '["text",...]')
	nargs = 0 if interactive_mode else 3
	filebrowser_FileBrowsing.add_argument("--list_children", action=filebrowser_FileBrowsing_list_childrenAction, nargs=nargs, metavar=metavars, help=help)
	class filebrowser_FileBrowsing_resizeAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.filebrowser.ShareLink import ShareLink
			from unicorn_api.v5.sv0.sharing import Access
			from unicorn_api.v5.sv0.filebrowser.FileIOResource import FileIOResource
			from unicorn_api.v5.sv0.filebrowser import OpenMode
			from unicorn_api.v5.sv0.filebrowser.FileIOProperty import FileIOProperty
			from unicorn_api.v5.sv0.filebrowser import UploadBehavior

			from transformer.lib import ListInfo, ResultSet, List, Long, Blob, Date
			checker = [cli_int,cli_long]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.filebrowser.FileBrowsing import FileBrowsing
			service = FileBrowsing()
			global function, interactive
			function = service.resize
			interactive = []
			interactive.append(('file_id', cli_int))
			interactive.append(('new_size', cli_long))
	methods['filebrowser.FileBrowsing.resize'] = ('filebrowser_FileBrowsing', '--resize')
	metavars = () if interactive_mode else ('file_id','new_size')
	help = '' if interactive_mode else '%s %s ' % ('int', 'long')
	nargs = 0 if interactive_mode else 2
	filebrowser_FileBrowsing.add_argument("--resize", action=filebrowser_FileBrowsing_resizeAction, nargs=nargs, metavar=metavars, help=help)
	class filebrowser_FileBrowsing_get_resourceAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.filebrowser.ShareLink import ShareLink
			from unicorn_api.v5.sv0.sharing import Access
			from unicorn_api.v5.sv0.filebrowser.FileIOResource import FileIOResource
			from unicorn_api.v5.sv0.filebrowser import OpenMode
			from unicorn_api.v5.sv0.filebrowser.FileIOProperty import FileIOProperty
			from unicorn_api.v5.sv0.filebrowser import UploadBehavior

			from transformer.lib import ListInfo, ResultSet, List, Long, Blob, Date
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.filebrowser.FileBrowsing import FileBrowsing
			service = FileBrowsing()
			global function, interactive
			function = service.get_resource
			interactive = []
			interactive.append(('file_id', cli_unicode))
	methods['filebrowser.FileBrowsing.get_resource'] = ('filebrowser_FileBrowsing', '--get_resource')
	metavars = () if interactive_mode else ('file_id')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 1
	filebrowser_FileBrowsing.add_argument("--get_resource", action=filebrowser_FileBrowsing_get_resourceAction, nargs=nargs, metavar=metavars, help=help)
	class filebrowser_FileBrowsing_create_folderAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.filebrowser.ShareLink import ShareLink
			from unicorn_api.v5.sv0.sharing import Access
			from unicorn_api.v5.sv0.filebrowser.FileIOResource import FileIOResource
			from unicorn_api.v5.sv0.filebrowser import OpenMode
			from unicorn_api.v5.sv0.filebrowser.FileIOProperty import FileIOProperty
			from unicorn_api.v5.sv0.filebrowser import UploadBehavior

			from transformer.lib import ListInfo, ResultSet, List, Long, Blob, Date
			checker = [cli_unicode,cli_bool]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.filebrowser.FileBrowsing import FileBrowsing
			service = FileBrowsing()
			global function, interactive
			function = service.create_folder
			interactive = []
			interactive.append(('folder_id', cli_unicode))
			interactive.append(('recursive', cli_bool))
	methods['filebrowser.FileBrowsing.create_folder'] = ('filebrowser_FileBrowsing', '--create_folder')
	metavars = () if interactive_mode else ('folder_id','recursive')
	help = '' if interactive_mode else '%s %s ' % ('text', 'True|False')
	nargs = 0 if interactive_mode else 2
	filebrowser_FileBrowsing.add_argument("--create_folder", action=filebrowser_FileBrowsing_create_folderAction, nargs=nargs, metavar=metavars, help=help)
	class filebrowser_FileBrowsing_enumerate_folderAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.filebrowser.ShareLink import ShareLink
			from unicorn_api.v5.sv0.sharing import Access
			from unicorn_api.v5.sv0.filebrowser.FileIOResource import FileIOResource
			from unicorn_api.v5.sv0.filebrowser import OpenMode
			from unicorn_api.v5.sv0.filebrowser.FileIOProperty import FileIOProperty
			from unicorn_api.v5.sv0.filebrowser import UploadBehavior

			from transformer.lib import ListInfo, ResultSet, List, Long, Blob, Date
			checker = [cli_unicode,cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.filebrowser.FileBrowsing import FileBrowsing
			service = FileBrowsing()
			global function, interactive
			function = service.enumerate_folder
			interactive = []
			interactive.append(('folder_id', cli_unicode))
			interactive.append(('list_info', cli_list_info))
	methods['filebrowser.FileBrowsing.enumerate_folder'] = ('filebrowser_FileBrowsing', '--enumerate_folder')
	metavars = () if interactive_mode else ('folder_id','list_info')
	help = '' if interactive_mode else '%s %s ' % ('text', 'offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 2
	filebrowser_FileBrowsing.add_argument("--enumerate_folder", action=filebrowser_FileBrowsing_enumerate_folderAction, nargs=nargs, metavar=metavars, help=help)
	class filebrowser_FileBrowsing_list_commentsAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.filebrowser.ShareLink import ShareLink
			from unicorn_api.v5.sv0.sharing import Access
			from unicorn_api.v5.sv0.filebrowser.FileIOResource import FileIOResource
			from unicorn_api.v5.sv0.filebrowser import OpenMode
			from unicorn_api.v5.sv0.filebrowser.FileIOProperty import FileIOProperty
			from unicorn_api.v5.sv0.filebrowser import UploadBehavior

			from transformer.lib import ListInfo, ResultSet, List, Long, Blob, Date
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.filebrowser.FileBrowsing import FileBrowsing
			service = FileBrowsing()
			global function, interactive
			function = service.list_comments
			interactive = []
			interactive.append(('resource_id', cli_unicode))
	methods['filebrowser.FileBrowsing.list_comments'] = ('filebrowser_FileBrowsing', '--list_comments')
	metavars = () if interactive_mode else ('resource_id')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 1
	filebrowser_FileBrowsing.add_argument("--list_comments", action=filebrowser_FileBrowsing_list_commentsAction, nargs=nargs, metavar=metavars, help=help)
	class filebrowser_FileBrowsing_create_share_linkAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.filebrowser.ShareLink import ShareLink
			from unicorn_api.v5.sv0.sharing import Access
			from unicorn_api.v5.sv0.filebrowser.FileIOResource import FileIOResource
			from unicorn_api.v5.sv0.filebrowser import OpenMode
			from unicorn_api.v5.sv0.filebrowser.FileIOProperty import FileIOProperty
			from unicorn_api.v5.sv0.filebrowser import UploadBehavior

			from transformer.lib import ListInfo, ResultSet, List, Long, Blob, Date
			checker = [ShareLink]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.filebrowser.FileBrowsing import FileBrowsing
			service = FileBrowsing()
			global function, interactive
			function = service.create_share_link
			interactive = []
			interactive.append(('share_link', ShareLink))
	methods['filebrowser.FileBrowsing.create_share_link'] = ('filebrowser_FileBrowsing', '--create_share_link')
	metavars = () if interactive_mode else ('share_link')
	help = '' if interactive_mode else '%s ' % ('{"path":text,#"expires":long#,#"filename":text#,#"token":text#,#"share_count":int#,#"password":text#}')
	nargs = 0 if interactive_mode else 1
	filebrowser_FileBrowsing.add_argument("--create_share_link", action=filebrowser_FileBrowsing_create_share_linkAction, nargs=nargs, metavar=metavars, help=help)
	class filebrowser_FileBrowsing_set_propertyAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.filebrowser.ShareLink import ShareLink
			from unicorn_api.v5.sv0.sharing import Access
			from unicorn_api.v5.sv0.filebrowser.FileIOResource import FileIOResource
			from unicorn_api.v5.sv0.filebrowser import OpenMode
			from unicorn_api.v5.sv0.filebrowser.FileIOProperty import FileIOProperty
			from unicorn_api.v5.sv0.filebrowser import UploadBehavior

			from transformer.lib import ListInfo, ResultSet, List, Long, Blob, Date
			checker = [cli_unicode,FileIOProperty]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.filebrowser.FileBrowsing import FileBrowsing
			service = FileBrowsing()
			global function, interactive
			function = service.set_property
			interactive = []
			interactive.append(('resource_id', cli_unicode))
			interactive.append(('property', FileIOProperty))
	methods['filebrowser.FileBrowsing.set_property'] = ('filebrowser_FileBrowsing', '--set_property')
	metavars = () if interactive_mode else ('resource_id','property')
	help = '' if interactive_mode else '%s %s ' % ('text', '{"type":UNICODE|INTEGER,"name":text,"value":text}')
	nargs = 0 if interactive_mode else 2
	filebrowser_FileBrowsing.add_argument("--set_property", action=filebrowser_FileBrowsing_set_propertyAction, nargs=nargs, metavar=metavars, help=help)
	class filebrowser_FileBrowsing_deleteAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.filebrowser.ShareLink import ShareLink
			from unicorn_api.v5.sv0.sharing import Access
			from unicorn_api.v5.sv0.filebrowser.FileIOResource import FileIOResource
			from unicorn_api.v5.sv0.filebrowser import OpenMode
			from unicorn_api.v5.sv0.filebrowser.FileIOProperty import FileIOProperty
			from unicorn_api.v5.sv0.filebrowser import UploadBehavior

			from transformer.lib import ListInfo, ResultSet, List, Long, Blob, Date
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.filebrowser.FileBrowsing import FileBrowsing
			service = FileBrowsing()
			global function, interactive
			function = service.delete
			interactive = []
			interactive.append(('resource_id', cli_unicode))
	methods['filebrowser.FileBrowsing.delete'] = ('filebrowser_FileBrowsing', '--delete')
	metavars = () if interactive_mode else ('resource_id')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 1
	filebrowser_FileBrowsing.add_argument("--delete", action=filebrowser_FileBrowsing_deleteAction, nargs=nargs, metavar=metavars, help=help)
	ups_UpsAdministration = subparsers.add_parser('ups_UpsAdministration', help="help ups.UpsAdministration")
	class ups_UpsAdministration_netups_scanAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.ups.UpsModel import UpsModel
			from unicorn_api.v5.sv0.ups.NetUpsInfo import NetUpsInfo

			from transformer.lib import List
			checker = [cli_unicode,cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.ups.UpsAdministration import UpsAdministration
			service = UpsAdministration()
			global function, interactive
			function = service.netups_scan
			interactive = []
			interactive.append(('start_ip', cli_unicode))
			interactive.append(('end_ip', cli_unicode))
	methods['ups.UpsAdministration.netups_scan'] = ('ups_UpsAdministration', '--netups_scan')
	metavars = () if interactive_mode else ('start_ip','end_ip')
	help = '' if interactive_mode else '%s %s ' % ('text', 'text')
	nargs = 0 if interactive_mode else 2
	ups_UpsAdministration.add_argument("--netups_scan", action=ups_UpsAdministration_netups_scanAction, nargs=nargs, metavar=metavars, help=help)
	class ups_UpsAdministration_set_server_onAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.ups.UpsModel import UpsModel
			from unicorn_api.v5.sv0.ups.NetUpsInfo import NetUpsInfo

			from transformer.lib import List
			checker = [cli_int,cli_bool]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.ups.UpsAdministration import UpsAdministration
			service = UpsAdministration()
			global function, interactive
			function = service.set_server_on
			interactive = []
			interactive.append(('ups_id', cli_int))
			interactive.append(('enabled', cli_bool))
	methods['ups.UpsAdministration.set_server_on'] = ('ups_UpsAdministration', '--set_server_on')
	metavars = () if interactive_mode else ('ups_id','enabled')
	help = '' if interactive_mode else '%s %s ' % ('int', 'True|False')
	nargs = 0 if interactive_mode else 2
	ups_UpsAdministration.add_argument("--set_server_on", action=ups_UpsAdministration_set_server_onAction, nargs=nargs, metavar=metavars, help=help)
	class ups_UpsAdministration_listAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.ups.UpsModel import UpsModel
			from unicorn_api.v5.sv0.ups.NetUpsInfo import NetUpsInfo

			from transformer.lib import List
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.ups.UpsAdministration import UpsAdministration
			service = UpsAdministration()
			global function, interactive
			function = service.list
			interactive = []
	methods['ups.UpsAdministration.list'] = ('ups_UpsAdministration', '--list')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	ups_UpsAdministration.add_argument("--list", action=ups_UpsAdministration_listAction, nargs=nargs, metavar=metavars, help=help)
	class ups_UpsAdministration_removeAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.ups.UpsModel import UpsModel
			from unicorn_api.v5.sv0.ups.NetUpsInfo import NetUpsInfo

			from transformer.lib import List
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.ups.UpsAdministration import UpsAdministration
			service = UpsAdministration()
			global function, interactive
			function = service.remove
			interactive = []
			interactive.append(('ups_id', cli_int))
	methods['ups.UpsAdministration.remove'] = ('ups_UpsAdministration', '--remove')
	metavars = () if interactive_mode else ('ups_id')
	help = '' if interactive_mode else '%s ' % ('int')
	nargs = 0 if interactive_mode else 1
	ups_UpsAdministration.add_argument("--remove", action=ups_UpsAdministration_removeAction, nargs=nargs, metavar=metavars, help=help)
	class ups_UpsAdministration_get_enabledAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.ups.UpsModel import UpsModel
			from unicorn_api.v5.sv0.ups.NetUpsInfo import NetUpsInfo

			from transformer.lib import List
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.ups.UpsAdministration import UpsAdministration
			service = UpsAdministration()
			global function, interactive
			function = service.get_enabled
			interactive = []
	methods['ups.UpsAdministration.get_enabled'] = ('ups_UpsAdministration', '--get_enabled')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	ups_UpsAdministration.add_argument("--get_enabled", action=ups_UpsAdministration_get_enabledAction, nargs=nargs, metavar=metavars, help=help)
	class ups_UpsAdministration_set_slave_modeAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.ups.UpsModel import UpsModel
			from unicorn_api.v5.sv0.ups.NetUpsInfo import NetUpsInfo

			from transformer.lib import List
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.ups.UpsAdministration import UpsAdministration
			service = UpsAdministration()
			global function, interactive
			function = service.set_slave_mode
			interactive = []
			interactive.append(('master_ip_or_hostname', cli_unicode))
	methods['ups.UpsAdministration.set_slave_mode'] = ('ups_UpsAdministration', '--set_slave_mode')
	metavars = () if interactive_mode else ('master_ip_or_hostname')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 1
	ups_UpsAdministration.add_argument("--set_slave_mode", action=ups_UpsAdministration_set_slave_modeAction, nargs=nargs, metavar=metavars, help=help)
	class ups_UpsAdministration_set_enabledAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.ups.UpsModel import UpsModel
			from unicorn_api.v5.sv0.ups.NetUpsInfo import NetUpsInfo

			from transformer.lib import List
			checker = [cli_bool]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.ups.UpsAdministration import UpsAdministration
			service = UpsAdministration()
			global function, interactive
			function = service.set_enabled
			interactive = []
			interactive.append(('enabled', cli_bool))
	methods['ups.UpsAdministration.set_enabled'] = ('ups_UpsAdministration', '--set_enabled')
	metavars = () if interactive_mode else ('enabled')
	help = '' if interactive_mode else '%s ' % ('True|False')
	nargs = 0 if interactive_mode else 1
	ups_UpsAdministration.add_argument("--set_enabled", action=ups_UpsAdministration_set_enabledAction, nargs=nargs, metavar=metavars, help=help)
	class ups_UpsAdministration_set_thresholdAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.ups.UpsModel import UpsModel
			from unicorn_api.v5.sv0.ups.NetUpsInfo import NetUpsInfo

			from transformer.lib import List
			checker = [cli_int,cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.ups.UpsAdministration import UpsAdministration
			service = UpsAdministration()
			global function, interactive
			function = service.set_threshold
			interactive = []
			interactive.append(('ups_id', cli_int))
			interactive.append(('threshold', cli_int))
	methods['ups.UpsAdministration.set_threshold'] = ('ups_UpsAdministration', '--set_threshold')
	metavars = () if interactive_mode else ('ups_id','threshold')
	help = '' if interactive_mode else '%s %s ' % ('int', 'int')
	nargs = 0 if interactive_mode else 2
	ups_UpsAdministration.add_argument("--set_threshold", action=ups_UpsAdministration_set_thresholdAction, nargs=nargs, metavar=metavars, help=help)
	class ups_UpsAdministration_set_snmp_modeAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.ups.UpsModel import UpsModel
			from unicorn_api.v5.sv0.ups.NetUpsInfo import NetUpsInfo

			from transformer.lib import List
			checker = [cli_unicode,cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.ups.UpsAdministration import UpsAdministration
			service = UpsAdministration()
			global function, interactive
			function = service.set_snmp_mode
			interactive = []
			interactive.append(('device_ip', cli_unicode))
			interactive.append(('snmp_community', cli_unicode))
	methods['ups.UpsAdministration.set_snmp_mode'] = ('ups_UpsAdministration', '--set_snmp_mode')
	metavars = () if interactive_mode else ('device_ip','snmp_community')
	help = '' if interactive_mode else '%s %s ' % ('text', 'text')
	nargs = 0 if interactive_mode else 2
	ups_UpsAdministration.add_argument("--set_snmp_mode", action=ups_UpsAdministration_set_snmp_modeAction, nargs=nargs, metavar=metavars, help=help)
	sharing_remote_RemoteShareManager = subparsers.add_parser('sharing_remote_RemoteShareManager', help="help sharing.remote.RemoteShareManager")
	class sharing_remote_RemoteShareManager_isDFSEnabledAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.sharing.remote.RemoteShare import RemoteShare

			from transformer.lib import ListInfo, ResultSet
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.sharing.remote.RemoteShareManager import RemoteShareManager
			service = RemoteShareManager()
			global function, interactive
			function = service.isDFSEnabled
			interactive = []
	methods['sharing.remote.RemoteShareManager.isDFSEnabled'] = ('sharing_remote_RemoteShareManager', '--isDFSEnabled')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	sharing_remote_RemoteShareManager.add_argument("--isDFSEnabled", action=sharing_remote_RemoteShareManager_isDFSEnabledAction, nargs=nargs, metavar=metavars, help=help)
	class sharing_remote_RemoteShareManager_createRemoteShareAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.sharing.remote.RemoteShare import RemoteShare

			from transformer.lib import ListInfo, ResultSet
			checker = [RemoteShare]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.sharing.remote.RemoteShareManager import RemoteShareManager
			service = RemoteShareManager()
			global function, interactive
			function = service.createRemoteShare
			interactive = []
			interactive.append(('remote_share', RemoteShare))
	methods['sharing.remote.RemoteShareManager.createRemoteShare'] = ('sharing_remote_RemoteShareManager', '--createRemoteShare')
	metavars = () if interactive_mode else ('remote_share')
	help = '' if interactive_mode else '%s ' % ('{"description":text,"enabled":True|False,"remote_name":text,"remote_host":text,"name":text}')
	nargs = 0 if interactive_mode else 1
	sharing_remote_RemoteShareManager.add_argument("--createRemoteShare", action=sharing_remote_RemoteShareManager_createRemoteShareAction, nargs=nargs, metavar=metavars, help=help)
	class sharing_remote_RemoteShareManager_listAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.sharing.remote.RemoteShare import RemoteShare

			from transformer.lib import ListInfo, ResultSet
			checker = [cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.sharing.remote.RemoteShareManager import RemoteShareManager
			service = RemoteShareManager()
			global function, interactive
			function = service.list
			interactive = []
			interactive.append(('list_info', cli_list_info))
	methods['sharing.remote.RemoteShareManager.list'] = ('sharing_remote_RemoteShareManager', '--list')
	metavars = () if interactive_mode else ('list_info')
	help = '' if interactive_mode else '%s ' % ('offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 1
	sharing_remote_RemoteShareManager.add_argument("--list", action=sharing_remote_RemoteShareManager_listAction, nargs=nargs, metavar=metavars, help=help)
	class sharing_remote_RemoteShareManager_enableDFSAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.sharing.remote.RemoteShare import RemoteShare

			from transformer.lib import ListInfo, ResultSet
			checker = [cli_bool]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.sharing.remote.RemoteShareManager import RemoteShareManager
			service = RemoteShareManager()
			global function, interactive
			function = service.enableDFS
			interactive = []
			interactive.append(('enable', cli_bool))
	methods['sharing.remote.RemoteShareManager.enableDFS'] = ('sharing_remote_RemoteShareManager', '--enableDFS')
	metavars = () if interactive_mode else ('enable')
	help = '' if interactive_mode else '%s ' % ('True|False')
	nargs = 0 if interactive_mode else 1
	sharing_remote_RemoteShareManager.add_argument("--enableDFS", action=sharing_remote_RemoteShareManager_enableDFSAction, nargs=nargs, metavar=metavars, help=help)
	class sharing_remote_RemoteShareManager_getSharesFromHostAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.sharing.remote.RemoteShare import RemoteShare

			from transformer.lib import ListInfo, ResultSet
			checker = [cli_list_info,cli_unicode,cli_unicode,cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.sharing.remote.RemoteShareManager import RemoteShareManager
			service = RemoteShareManager()
			global function, interactive
			function = service.getSharesFromHost
			interactive = []
			interactive.append(('list_info', cli_list_info))
			interactive.append(('host_name_or_ip', cli_unicode))
			interactive.append(('login', cli_unicode))
			interactive.append(('password', cli_unicode))
	methods['sharing.remote.RemoteShareManager.getSharesFromHost'] = ('sharing_remote_RemoteShareManager', '--getSharesFromHost')
	metavars = () if interactive_mode else ('list_info','host_name_or_ip','login','password')
	help = '' if interactive_mode else '%s %s %s %s ' % ('offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}', 'text', 'text', 'text')
	nargs = 0 if interactive_mode else 4
	sharing_remote_RemoteShareManager.add_argument("--getSharesFromHost", action=sharing_remote_RemoteShareManager_getSharesFromHostAction, nargs=nargs, metavar=metavars, help=help)
	class sharing_remote_RemoteShareManager_removeRemoteShareAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.sharing.remote.RemoteShare import RemoteShare

			from transformer.lib import ListInfo, ResultSet
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.sharing.remote.RemoteShareManager import RemoteShareManager
			service = RemoteShareManager()
			global function, interactive
			function = service.removeRemoteShare
			interactive = []
			interactive.append(('share_id', cli_int))
	methods['sharing.remote.RemoteShareManager.removeRemoteShare'] = ('sharing_remote_RemoteShareManager', '--removeRemoteShare')
	metavars = () if interactive_mode else ('share_id')
	help = '' if interactive_mode else '%s ' % ('int')
	nargs = 0 if interactive_mode else 1
	sharing_remote_RemoteShareManager.add_argument("--removeRemoteShare", action=sharing_remote_RemoteShareManager_removeRemoteShareAction, nargs=nargs, metavar=metavars, help=help)
	class sharing_remote_RemoteShareManager_updateRemoteShareAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.sharing.remote.RemoteShare import RemoteShare

			from transformer.lib import ListInfo, ResultSet
			checker = [cli_int,RemoteShare]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.sharing.remote.RemoteShareManager import RemoteShareManager
			service = RemoteShareManager()
			global function, interactive
			function = service.updateRemoteShare
			interactive = []
			interactive.append(('share_local_id', cli_int))
			interactive.append(('remote_share', RemoteShare))
	methods['sharing.remote.RemoteShareManager.updateRemoteShare'] = ('sharing_remote_RemoteShareManager', '--updateRemoteShare')
	metavars = () if interactive_mode else ('share_local_id','remote_share')
	help = '' if interactive_mode else '%s %s ' % ('int', '{"description":text,"enabled":True|False,"remote_name":text,"remote_host":text,"name":text}')
	nargs = 0 if interactive_mode else 2
	sharing_remote_RemoteShareManager.add_argument("--updateRemoteShare", action=sharing_remote_RemoteShareManager_updateRemoteShareAction, nargs=nargs, metavar=metavars, help=help)
	class sharing_remote_RemoteShareManager_isRemoteShareNameValidAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.sharing.remote.RemoteShare import RemoteShare

			from transformer.lib import ListInfo, ResultSet
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.sharing.remote.RemoteShareManager import RemoteShareManager
			service = RemoteShareManager()
			global function, interactive
			function = service.isRemoteShareNameValid
			interactive = []
			interactive.append(('share_name', cli_unicode))
	methods['sharing.remote.RemoteShareManager.isRemoteShareNameValid'] = ('sharing_remote_RemoteShareManager', '--isRemoteShareNameValid')
	metavars = () if interactive_mode else ('share_name')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 1
	sharing_remote_RemoteShareManager.add_argument("--isRemoteShareNameValid", action=sharing_remote_RemoteShareManager_isRemoteShareNameValidAction, nargs=nargs, metavar=metavars, help=help)
	support_ps_monitoring_Info = subparsers.add_parser('support_ps_monitoring_Info', help="help support.ps_monitoring.Info")
	class support_ps_monitoring_Info_getAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.support.ps_monitoring.ProcessInfo import ProcessInfo

			from transformer.lib import List, ListInfo, ResultSet
			checker = [list_cli(unicode),cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.support.ps_monitoring.Info import Info
			service = Info()
			global function, interactive
			function = service.get
			interactive = []
			interactive.append(('with_parameters', list_cli(unicode)))
			interactive.append(('list_info', cli_list_info))
	methods['support.ps_monitoring.Info.get'] = ('support_ps_monitoring_Info', '--get')
	metavars = () if interactive_mode else ('with_parameters','list_info')
	help = '' if interactive_mode else '%s %s ' % ('["text",...]', 'offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 2
	support_ps_monitoring_Info.add_argument("--get", action=support_ps_monitoring_Info_getAction, nargs=nargs, metavar=metavars, help=help)
	multi_nic_administration_interface_service = subparsers.add_parser('multi_nic_administration_interface_service', help="help multi_nic.administration.interface_service")
	class multi_nic_administration_interface_service_set_interfaceAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.multi_nic.Interface import Interface
			from unicorn_api.v5.sv0.multi_nic.Bonding import Bonding
			from unicorn_api.v5.sv0.multi_nic.IPConfig import IPConfig
			from unicorn_api.v5.sv0.multi_nic.Ethernet import Ethernet

			from transformer.lib import List
			checker = [cli_int,Interface]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.multi_nic.InterfaceService import InterfaceService
			service = InterfaceService()
			global function, interactive
			function = service.set_interface
			interactive = []
			interactive.append(('if_id', cli_int))
			interactive.append(('interface', Interface))
	methods['multi_nic.administration.interface_service.set_interface'] = ('multi_nic_administration_interface_service', '--set_interface')
	metavars = () if interactive_mode else ('if_id','interface')
	help = '' if interactive_mode else '%s %s ' % ('int', '{"enabled":True|False,"friendly_name":text,"type":BONDING|ETHERNET,#"bonding_config":{"primary_id":int,"mode":ACTIVE_BACKUP_LINK|ACTIVE_BACKUP_ARP|LINK_AGGREGATION,#"arp_ip_target":www.xxx.yyy.zzz#,#"monitor_interval":int#}#,#"ip_config":{"mode":STATIC|DHCP,"ipv6_mode":DISABLED|MANUAL|LOCAL|AUTO,#"ipv6_public_ip":text#,#"dns_servers":["www.xxx.yyy.zzz",...]#,#"dns_suffix":text#,#"gateway":www.xxx.yyy.zzz#,#"netmask":www.xxx.yyy.zzz#,#"ipv6_gateway":text#,#"ipv4":www.xxx.yyy.zzz#}#,#"ethernet_config":{"mtu":int}#}')
	nargs = 0 if interactive_mode else 2
	multi_nic_administration_interface_service.add_argument("--set_interface", action=multi_nic_administration_interface_service_set_interfaceAction, nargs=nargs, metavar=metavars, help=help)
	class multi_nic_administration_interface_service_set_dhcpAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.multi_nic.Interface import Interface
			from unicorn_api.v5.sv0.multi_nic.Bonding import Bonding
			from unicorn_api.v5.sv0.multi_nic.IPConfig import IPConfig
			from unicorn_api.v5.sv0.multi_nic.Ethernet import Ethernet

			from transformer.lib import List
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.multi_nic.InterfaceService import InterfaceService
			service = InterfaceService()
			global function, interactive
			function = service.set_dhcp
			interactive = []
			interactive.append(('if_id', cli_int))
	methods['multi_nic.administration.interface_service.set_dhcp'] = ('multi_nic_administration_interface_service', '--set_dhcp')
	metavars = () if interactive_mode else ('if_id')
	help = '' if interactive_mode else '%s ' % ('int')
	nargs = 0 if interactive_mode else 1
	multi_nic_administration_interface_service.add_argument("--set_dhcp", action=multi_nic_administration_interface_service_set_dhcpAction, nargs=nargs, metavar=metavars, help=help)
	class multi_nic_administration_interface_service_create_bonding_interfaceAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.multi_nic.Interface import Interface
			from unicorn_api.v5.sv0.multi_nic.Bonding import Bonding
			from unicorn_api.v5.sv0.multi_nic.IPConfig import IPConfig
			from unicorn_api.v5.sv0.multi_nic.Ethernet import Ethernet

			from transformer.lib import List
			checker = [cli_unicode,list_cli(int),Bonding,IPConfig]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.multi_nic.InterfaceService import InterfaceService
			service = InterfaceService()
			global function, interactive
			function = service.create_bonding_interface
			interactive = []
			interactive.append(('friendly_name', cli_unicode))
			interactive.append(('slaves', list_cli(int)))
			interactive.append(('bonding_config', Bonding))
			interactive.append(('ip_config', IPConfig))
	methods['multi_nic.administration.interface_service.create_bonding_interface'] = ('multi_nic_administration_interface_service', '--create_bonding_interface')
	metavars = () if interactive_mode else ('friendly_name','slaves','bonding_config','ip_config')
	help = '' if interactive_mode else '%s %s %s %s ' % ('text', '["int",...]', '{"primary_id":int,"mode":ACTIVE_BACKUP_LINK|ACTIVE_BACKUP_ARP|LINK_AGGREGATION,#"arp_ip_target":www.xxx.yyy.zzz#,#"monitor_interval":int#}', '{"mode":STATIC|DHCP,"ipv6_mode":DISABLED|MANUAL|LOCAL|AUTO,#"ipv6_public_ip":text#,#"dns_servers":["www.xxx.yyy.zzz",...]#,#"dns_suffix":text#,#"gateway":www.xxx.yyy.zzz#,#"netmask":www.xxx.yyy.zzz#,#"ipv6_gateway":text#,#"ipv4":www.xxx.yyy.zzz#}')
	nargs = 0 if interactive_mode else 4
	multi_nic_administration_interface_service.add_argument("--create_bonding_interface", action=multi_nic_administration_interface_service_create_bonding_interfaceAction, nargs=nargs, metavar=metavars, help=help)
	class multi_nic_administration_interface_service_get_interfaceAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.multi_nic.Interface import Interface
			from unicorn_api.v5.sv0.multi_nic.Bonding import Bonding
			from unicorn_api.v5.sv0.multi_nic.IPConfig import IPConfig
			from unicorn_api.v5.sv0.multi_nic.Ethernet import Ethernet

			from transformer.lib import List
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.multi_nic.InterfaceService import InterfaceService
			service = InterfaceService()
			global function, interactive
			function = service.get_interface
			interactive = []
			interactive.append(('if_id', cli_int))
	methods['multi_nic.administration.interface_service.get_interface'] = ('multi_nic_administration_interface_service', '--get_interface')
	metavars = () if interactive_mode else ('if_id')
	help = '' if interactive_mode else '%s ' % ('int')
	nargs = 0 if interactive_mode else 1
	multi_nic_administration_interface_service.add_argument("--get_interface", action=multi_nic_administration_interface_service_get_interfaceAction, nargs=nargs, metavar=metavars, help=help)
	class multi_nic_administration_interface_service_get_all_interfacesAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.multi_nic.Interface import Interface
			from unicorn_api.v5.sv0.multi_nic.Bonding import Bonding
			from unicorn_api.v5.sv0.multi_nic.IPConfig import IPConfig
			from unicorn_api.v5.sv0.multi_nic.Ethernet import Ethernet

			from transformer.lib import List
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.multi_nic.InterfaceService import InterfaceService
			service = InterfaceService()
			global function, interactive
			function = service.get_all_interfaces
			interactive = []
	methods['multi_nic.administration.interface_service.get_all_interfaces'] = ('multi_nic_administration_interface_service', '--get_all_interfaces')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	multi_nic_administration_interface_service.add_argument("--get_all_interfaces", action=multi_nic_administration_interface_service_get_all_interfacesAction, nargs=nargs, metavar=metavars, help=help)
	class multi_nic_administration_interface_service_set_ipconfigAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.multi_nic.Interface import Interface
			from unicorn_api.v5.sv0.multi_nic.Bonding import Bonding
			from unicorn_api.v5.sv0.multi_nic.IPConfig import IPConfig
			from unicorn_api.v5.sv0.multi_nic.Ethernet import Ethernet

			from transformer.lib import List
			checker = [cli_int,IPConfig]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.multi_nic.InterfaceService import InterfaceService
			service = InterfaceService()
			global function, interactive
			function = service.set_ipconfig
			interactive = []
			interactive.append(('if_id', cli_int))
			interactive.append(('ip_config', IPConfig))
	methods['multi_nic.administration.interface_service.set_ipconfig'] = ('multi_nic_administration_interface_service', '--set_ipconfig')
	metavars = () if interactive_mode else ('if_id','ip_config')
	help = '' if interactive_mode else '%s %s ' % ('int', '{"mode":STATIC|DHCP,"ipv6_mode":DISABLED|MANUAL|LOCAL|AUTO,#"ipv6_public_ip":text#,#"dns_servers":["www.xxx.yyy.zzz",...]#,#"dns_suffix":text#,#"gateway":www.xxx.yyy.zzz#,#"netmask":www.xxx.yyy.zzz#,#"ipv6_gateway":text#,#"ipv4":www.xxx.yyy.zzz#}')
	nargs = 0 if interactive_mode else 2
	multi_nic_administration_interface_service.add_argument("--set_ipconfig", action=multi_nic_administration_interface_service_set_ipconfigAction, nargs=nargs, metavar=metavars, help=help)
	class multi_nic_administration_interface_service_delete_bonding_interfaceAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.multi_nic.Interface import Interface
			from unicorn_api.v5.sv0.multi_nic.Bonding import Bonding
			from unicorn_api.v5.sv0.multi_nic.IPConfig import IPConfig
			from unicorn_api.v5.sv0.multi_nic.Ethernet import Ethernet

			from transformer.lib import List
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.multi_nic.InterfaceService import InterfaceService
			service = InterfaceService()
			global function, interactive
			function = service.delete_bonding_interface
			interactive = []
			interactive.append(('if_id', cli_int))
	methods['multi_nic.administration.interface_service.delete_bonding_interface'] = ('multi_nic_administration_interface_service', '--delete_bonding_interface')
	metavars = () if interactive_mode else ('if_id')
	help = '' if interactive_mode else '%s ' % ('int')
	nargs = 0 if interactive_mode else 1
	multi_nic_administration_interface_service.add_argument("--delete_bonding_interface", action=multi_nic_administration_interface_service_delete_bonding_interfaceAction, nargs=nargs, metavar=metavars, help=help)
	class multi_nic_administration_interface_service_set_ethernetAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.multi_nic.Interface import Interface
			from unicorn_api.v5.sv0.multi_nic.Bonding import Bonding
			from unicorn_api.v5.sv0.multi_nic.IPConfig import IPConfig
			from unicorn_api.v5.sv0.multi_nic.Ethernet import Ethernet

			from transformer.lib import List
			checker = [cli_int,Ethernet]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.multi_nic.InterfaceService import InterfaceService
			service = InterfaceService()
			global function, interactive
			function = service.set_ethernet
			interactive = []
			interactive.append(('if_id', cli_int))
			interactive.append(('ethernet_config', Ethernet))
	methods['multi_nic.administration.interface_service.set_ethernet'] = ('multi_nic_administration_interface_service', '--set_ethernet')
	metavars = () if interactive_mode else ('if_id','ethernet_config')
	help = '' if interactive_mode else '%s %s ' % ('int', '{"mtu":int}')
	nargs = 0 if interactive_mode else 2
	multi_nic_administration_interface_service.add_argument("--set_ethernet", action=multi_nic_administration_interface_service_set_ethernetAction, nargs=nargs, metavar=metavars, help=help)
	snmp_SnmpAdministration = subparsers.add_parser('snmp_SnmpAdministration', help="help snmp.SnmpAdministration")
	class snmp_SnmpAdministration_set_trapsAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.snmp.SnmpConfig import SnmpConfig
			from unicorn_api.v5.sv0.snmp import SnmpVersion
			from unicorn_api.v5.sv0.snmp.AvailableTrap import AvailableTrap
			from unicorn_api.v5.sv0.snmp.TrapTarget import TrapTarget
			from unicorn_api.v5.sv0.snmp.MibDownloadLink import MibDownloadLink

			from transformer.lib import List, ListInfo, ResultSet
			checker = [list_cli(AvailableTrap)]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.snmp.SnmpAdministration import SnmpAdministration
			service = SnmpAdministration()
			global function, interactive
			function = service.set_traps
			interactive = []
			interactive.append(('trap_list', list_cli(AvailableTrap)))
	methods['snmp.SnmpAdministration.set_traps'] = ('snmp_SnmpAdministration', '--set_traps')
	metavars = () if interactive_mode else ('trap_list')
	help = '' if interactive_mode else '%s ' % ('["{"enabled":True|False,"id":text,"name":text}",...]')
	nargs = 0 if interactive_mode else 1
	snmp_SnmpAdministration.add_argument("--set_traps", action=snmp_SnmpAdministration_set_trapsAction, nargs=nargs, metavar=metavars, help=help)
	class snmp_SnmpAdministration_get_traps_enabledAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.snmp.SnmpConfig import SnmpConfig
			from unicorn_api.v5.sv0.snmp import SnmpVersion
			from unicorn_api.v5.sv0.snmp.AvailableTrap import AvailableTrap
			from unicorn_api.v5.sv0.snmp.TrapTarget import TrapTarget
			from unicorn_api.v5.sv0.snmp.MibDownloadLink import MibDownloadLink

			from transformer.lib import List, ListInfo, ResultSet
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.snmp.SnmpAdministration import SnmpAdministration
			service = SnmpAdministration()
			global function, interactive
			function = service.get_traps_enabled
			interactive = []
	methods['snmp.SnmpAdministration.get_traps_enabled'] = ('snmp_SnmpAdministration', '--get_traps_enabled')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	snmp_SnmpAdministration.add_argument("--get_traps_enabled", action=snmp_SnmpAdministration_get_traps_enabledAction, nargs=nargs, metavar=metavars, help=help)
	class snmp_SnmpAdministration_get_trapsAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.snmp.SnmpConfig import SnmpConfig
			from unicorn_api.v5.sv0.snmp import SnmpVersion
			from unicorn_api.v5.sv0.snmp.AvailableTrap import AvailableTrap
			from unicorn_api.v5.sv0.snmp.TrapTarget import TrapTarget
			from unicorn_api.v5.sv0.snmp.MibDownloadLink import MibDownloadLink

			from transformer.lib import List, ListInfo, ResultSet
			checker = [cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.snmp.SnmpAdministration import SnmpAdministration
			service = SnmpAdministration()
			global function, interactive
			function = service.get_traps
			interactive = []
			interactive.append(('listInfo', cli_list_info))
	methods['snmp.SnmpAdministration.get_traps'] = ('snmp_SnmpAdministration', '--get_traps')
	metavars = () if interactive_mode else ('listInfo')
	help = '' if interactive_mode else '%s ' % ('offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 1
	snmp_SnmpAdministration.add_argument("--get_traps", action=snmp_SnmpAdministration_get_trapsAction, nargs=nargs, metavar=metavars, help=help)
	class snmp_SnmpAdministration_delete_trap_addressAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.snmp.SnmpConfig import SnmpConfig
			from unicorn_api.v5.sv0.snmp import SnmpVersion
			from unicorn_api.v5.sv0.snmp.AvailableTrap import AvailableTrap
			from unicorn_api.v5.sv0.snmp.TrapTarget import TrapTarget
			from unicorn_api.v5.sv0.snmp.MibDownloadLink import MibDownloadLink

			from transformer.lib import List, ListInfo, ResultSet
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.snmp.SnmpAdministration import SnmpAdministration
			service = SnmpAdministration()
			global function, interactive
			function = service.delete_trap_address
			interactive = []
			interactive.append(('hostname', cli_unicode))
	methods['snmp.SnmpAdministration.delete_trap_address'] = ('snmp_SnmpAdministration', '--delete_trap_address')
	metavars = () if interactive_mode else ('hostname')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 1
	snmp_SnmpAdministration.add_argument("--delete_trap_address", action=snmp_SnmpAdministration_delete_trap_addressAction, nargs=nargs, metavar=metavars, help=help)
	class snmp_SnmpAdministration_set_traps_enabledAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.snmp.SnmpConfig import SnmpConfig
			from unicorn_api.v5.sv0.snmp import SnmpVersion
			from unicorn_api.v5.sv0.snmp.AvailableTrap import AvailableTrap
			from unicorn_api.v5.sv0.snmp.TrapTarget import TrapTarget
			from unicorn_api.v5.sv0.snmp.MibDownloadLink import MibDownloadLink

			from transformer.lib import List, ListInfo, ResultSet
			checker = [cli_bool]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.snmp.SnmpAdministration import SnmpAdministration
			service = SnmpAdministration()
			global function, interactive
			function = service.set_traps_enabled
			interactive = []
			interactive.append(('enabled', cli_bool))
	methods['snmp.SnmpAdministration.set_traps_enabled'] = ('snmp_SnmpAdministration', '--set_traps_enabled')
	metavars = () if interactive_mode else ('enabled')
	help = '' if interactive_mode else '%s ' % ('True|False')
	nargs = 0 if interactive_mode else 1
	snmp_SnmpAdministration.add_argument("--set_traps_enabled", action=snmp_SnmpAdministration_set_traps_enabledAction, nargs=nargs, metavar=metavars, help=help)
	class snmp_SnmpAdministration_set_configAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.snmp.SnmpConfig import SnmpConfig
			from unicorn_api.v5.sv0.snmp import SnmpVersion
			from unicorn_api.v5.sv0.snmp.AvailableTrap import AvailableTrap
			from unicorn_api.v5.sv0.snmp.TrapTarget import TrapTarget
			from unicorn_api.v5.sv0.snmp.MibDownloadLink import MibDownloadLink

			from transformer.lib import List, ListInfo, ResultSet
			checker = [SnmpConfig]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.snmp.SnmpAdministration import SnmpAdministration
			service = SnmpAdministration()
			global function, interactive
			function = service.set_config
			interactive = []
			interactive.append(('config', SnmpConfig))
	methods['snmp.SnmpAdministration.set_config'] = ('snmp_SnmpAdministration', '--set_config')
	metavars = () if interactive_mode else ('config')
	help = '' if interactive_mode else '%s ' % ('{"contact":text,"enabled":True|False,"port":int,"version":V1V2C|V3,"location":text,#"v1_config":{"community":text}#,#"v3_config":{"authEnable":True|False,"privacyEnable":True|False,"v3UserName":text,#"authProtocol":SHA|MD5#,#"privPassword":text#,#"authPassword":text#}#}')
	nargs = 0 if interactive_mode else 1
	snmp_SnmpAdministration.add_argument("--set_config", action=snmp_SnmpAdministration_set_configAction, nargs=nargs, metavar=metavars, help=help)
	class snmp_SnmpAdministration_add_trap_addressAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.snmp.SnmpConfig import SnmpConfig
			from unicorn_api.v5.sv0.snmp import SnmpVersion
			from unicorn_api.v5.sv0.snmp.AvailableTrap import AvailableTrap
			from unicorn_api.v5.sv0.snmp.TrapTarget import TrapTarget
			from unicorn_api.v5.sv0.snmp.MibDownloadLink import MibDownloadLink

			from transformer.lib import List, ListInfo, ResultSet
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.snmp.SnmpAdministration import SnmpAdministration
			service = SnmpAdministration()
			global function, interactive
			function = service.add_trap_address
			interactive = []
			interactive.append(('hostname', cli_unicode))
	methods['snmp.SnmpAdministration.add_trap_address'] = ('snmp_SnmpAdministration', '--add_trap_address')
	metavars = () if interactive_mode else ('hostname')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 1
	snmp_SnmpAdministration.add_argument("--add_trap_address", action=snmp_SnmpAdministration_add_trap_addressAction, nargs=nargs, metavar=metavars, help=help)
	class snmp_SnmpAdministration_get_configAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.snmp.SnmpConfig import SnmpConfig
			from unicorn_api.v5.sv0.snmp import SnmpVersion
			from unicorn_api.v5.sv0.snmp.AvailableTrap import AvailableTrap
			from unicorn_api.v5.sv0.snmp.TrapTarget import TrapTarget
			from unicorn_api.v5.sv0.snmp.MibDownloadLink import MibDownloadLink

			from transformer.lib import List, ListInfo, ResultSet
			checker = [list_cli(unicode)]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.snmp.SnmpAdministration import SnmpAdministration
			service = SnmpAdministration()
			global function, interactive
			function = service.get_config
			interactive = []
			interactive.append(('with_parameters', list_cli(unicode)))
	methods['snmp.SnmpAdministration.get_config'] = ('snmp_SnmpAdministration', '--get_config')
	metavars = () if interactive_mode else ('with_parameters')
	help = '' if interactive_mode else '%s ' % ('["text",...]')
	nargs = 0 if interactive_mode else 1
	snmp_SnmpAdministration.add_argument("--get_config", action=snmp_SnmpAdministration_get_configAction, nargs=nargs, metavar=metavars, help=help)
	class snmp_SnmpAdministration_set_versionAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.snmp.SnmpConfig import SnmpConfig
			from unicorn_api.v5.sv0.snmp import SnmpVersion
			from unicorn_api.v5.sv0.snmp.AvailableTrap import AvailableTrap
			from unicorn_api.v5.sv0.snmp.TrapTarget import TrapTarget
			from unicorn_api.v5.sv0.snmp.MibDownloadLink import MibDownloadLink

			from transformer.lib import List, ListInfo, ResultSet
			checker = [SnmpVersion,list_cli(unicode)]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.snmp.SnmpAdministration import SnmpAdministration
			service = SnmpAdministration()
			global function, interactive
			function = service.set_version
			interactive = []
			interactive.append(('version', SnmpVersion))
			interactive.append(('with_parameters', list_cli(unicode)))
	methods['snmp.SnmpAdministration.set_version'] = ('snmp_SnmpAdministration', '--set_version')
	metavars = () if interactive_mode else ('version','with_parameters')
	help = '' if interactive_mode else '%s %s ' % ('V1V2C|V3', '["text",...]')
	nargs = 0 if interactive_mode else 2
	snmp_SnmpAdministration.add_argument("--set_version", action=snmp_SnmpAdministration_set_versionAction, nargs=nargs, metavar=metavars, help=help)
	class snmp_SnmpAdministration_set_enabledAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.snmp.SnmpConfig import SnmpConfig
			from unicorn_api.v5.sv0.snmp import SnmpVersion
			from unicorn_api.v5.sv0.snmp.AvailableTrap import AvailableTrap
			from unicorn_api.v5.sv0.snmp.TrapTarget import TrapTarget
			from unicorn_api.v5.sv0.snmp.MibDownloadLink import MibDownloadLink

			from transformer.lib import List, ListInfo, ResultSet
			checker = [cli_bool]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.snmp.SnmpAdministration import SnmpAdministration
			service = SnmpAdministration()
			global function, interactive
			function = service.set_enabled
			interactive = []
			interactive.append(('enabled', cli_bool))
	methods['snmp.SnmpAdministration.set_enabled'] = ('snmp_SnmpAdministration', '--set_enabled')
	metavars = () if interactive_mode else ('enabled')
	help = '' if interactive_mode else '%s ' % ('True|False')
	nargs = 0 if interactive_mode else 1
	snmp_SnmpAdministration.add_argument("--set_enabled", action=snmp_SnmpAdministration_set_enabledAction, nargs=nargs, metavar=metavars, help=help)
	class snmp_SnmpAdministration_get_trap_addressesAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.snmp.SnmpConfig import SnmpConfig
			from unicorn_api.v5.sv0.snmp import SnmpVersion
			from unicorn_api.v5.sv0.snmp.AvailableTrap import AvailableTrap
			from unicorn_api.v5.sv0.snmp.TrapTarget import TrapTarget
			from unicorn_api.v5.sv0.snmp.MibDownloadLink import MibDownloadLink

			from transformer.lib import List, ListInfo, ResultSet
			checker = [cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.snmp.SnmpAdministration import SnmpAdministration
			service = SnmpAdministration()
			global function, interactive
			function = service.get_trap_addresses
			interactive = []
			interactive.append(('listInfo', cli_list_info))
	methods['snmp.SnmpAdministration.get_trap_addresses'] = ('snmp_SnmpAdministration', '--get_trap_addresses')
	metavars = () if interactive_mode else ('listInfo')
	help = '' if interactive_mode else '%s ' % ('offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 1
	snmp_SnmpAdministration.add_argument("--get_trap_addresses", action=snmp_SnmpAdministration_get_trap_addressesAction, nargs=nargs, metavar=metavars, help=help)
	class snmp_SnmpAdministration_download_mibAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.snmp.SnmpConfig import SnmpConfig
			from unicorn_api.v5.sv0.snmp import SnmpVersion
			from unicorn_api.v5.sv0.snmp.AvailableTrap import AvailableTrap
			from unicorn_api.v5.sv0.snmp.TrapTarget import TrapTarget
			from unicorn_api.v5.sv0.snmp.MibDownloadLink import MibDownloadLink

			from transformer.lib import List, ListInfo, ResultSet
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.snmp.SnmpAdministration import SnmpAdministration
			service = SnmpAdministration()
			global function, interactive
			function = service.download_mib
			interactive = []
			interactive.append(('async_job_name', cli_unicode))
	methods['snmp.SnmpAdministration.download_mib'] = ('snmp_SnmpAdministration', '--download_mib')
	metavars = () if interactive_mode else ('async_job_name')
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 1
	snmp_SnmpAdministration.add_argument("--download_mib", action=snmp_SnmpAdministration_download_mibAction, nargs=nargs, metavar=metavars, help=help)
	class snmp_SnmpAdministration_download_mibResultAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.snmp.SnmpAdministration import SnmpAdministration
			service = SnmpAdministration()
			global function, interactive
			function = service.download_mib_result
			interactive = []
			interactive.append(('async_job_id', cli_int))
	methods['snmp.SnmpAdministration.download_mib_result'] = ('snmp_SnmpAdministration', '--download_mib_result')
	metavars = () if interactive_mode else ('async_job_id')
	nargs = 0 if interactive_mode else 1
	snmp_SnmpAdministration.add_argument("--download_mib_result", action=snmp_SnmpAdministration_download_mibResultAction, nargs=nargs, metavar=metavars)
	services_NfsServiceAdministration = subparsers.add_parser('services_NfsServiceAdministration', help="help services.NfsServiceAdministration")
	class services_NfsServiceAdministration_get_sync_modeAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.services.NfsServiceAdministration import NfsServiceAdministration
			service = NfsServiceAdministration()
			global function, interactive
			function = service.get_sync_mode
			interactive = []
	methods['services.NfsServiceAdministration.get_sync_mode'] = ('services_NfsServiceAdministration', '--get_sync_mode')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	services_NfsServiceAdministration.add_argument("--get_sync_mode", action=services_NfsServiceAdministration_get_sync_modeAction, nargs=nargs, metavar=metavars, help=help)
	class services_NfsServiceAdministration_set_sync_modeAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = [cli_bool]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.services.NfsServiceAdministration import NfsServiceAdministration
			service = NfsServiceAdministration()
			global function, interactive
			function = service.set_sync_mode
			interactive = []
			interactive.append(('is_sync', cli_bool))
	methods['services.NfsServiceAdministration.set_sync_mode'] = ('services_NfsServiceAdministration', '--set_sync_mode')
	metavars = () if interactive_mode else ('is_sync')
	help = '' if interactive_mode else '%s ' % ('True|False')
	nargs = 0 if interactive_mode else 1
	services_NfsServiceAdministration.add_argument("--set_sync_mode", action=services_NfsServiceAdministration_set_sync_modeAction, nargs=nargs, metavar=metavars, help=help)
	tools_TaskManager = subparsers.add_parser('tools_TaskManager', help="help tools.TaskManager")
	class tools_TaskManager_get_taskAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.tools.Task import Task

			from transformer.lib import List
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.tools.TaskManager import TaskManager
			service = TaskManager()
			global function, interactive
			function = service.get_task
			interactive = []
			interactive.append(('id', cli_int))
	methods['tools.TaskManager.get_task'] = ('tools_TaskManager', '--get_task')
	metavars = () if interactive_mode else ('id')
	help = '' if interactive_mode else '%s ' % ('int')
	nargs = 0 if interactive_mode else 1
	tools_TaskManager.add_argument("--get_task", action=tools_TaskManager_get_taskAction, nargs=nargs, metavar=metavars, help=help)
	class tools_TaskManager_listAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.tools.Task import Task

			from transformer.lib import List
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.tools.TaskManager import TaskManager
			service = TaskManager()
			global function, interactive
			function = service.list
			interactive = []
	methods['tools.TaskManager.list'] = ('tools_TaskManager', '--list')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	tools_TaskManager.add_argument("--list", action=tools_TaskManager_listAction, nargs=nargs, metavar=metavars, help=help)
	services_SshAccessAdministration = subparsers.add_parser('services_SshAccessAdministration', help="help services.SshAccessAdministration")
	class services_SshAccessAdministration_set_enabledAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = [cli_bool]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.services.SshAccessAdministration import SshAccessAdministration
			service = SshAccessAdministration()
			global function, interactive
			function = service.set_enabled
			interactive = []
			interactive.append(('enabled', cli_bool))
	methods['services.SshAccessAdministration.set_enabled'] = ('services_SshAccessAdministration', '--set_enabled')
	metavars = () if interactive_mode else ('enabled')
	help = '' if interactive_mode else '%s ' % ('True|False')
	nargs = 0 if interactive_mode else 1
	services_SshAccessAdministration.add_argument("--set_enabled", action=services_SshAccessAdministration_set_enabledAction, nargs=nargs, metavar=metavars, help=help)
	class services_SshAccessAdministration_set_portAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.services.SshAccessAdministration import SshAccessAdministration
			service = SshAccessAdministration()
			global function, interactive
			function = service.set_port
			interactive = []
			interactive.append(('port', cli_int))
	methods['services.SshAccessAdministration.set_port'] = ('services_SshAccessAdministration', '--set_port')
	metavars = () if interactive_mode else ('port')
	help = '' if interactive_mode else '%s ' % ('int')
	nargs = 0 if interactive_mode else 1
	services_SshAccessAdministration.add_argument("--set_port", action=services_SshAccessAdministration_set_portAction, nargs=nargs, metavar=metavars, help=help)
	class services_SshAccessAdministration_get_enabledAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.services.SshAccessAdministration import SshAccessAdministration
			service = SshAccessAdministration()
			global function, interactive
			function = service.get_enabled
			interactive = []
	methods['services.SshAccessAdministration.get_enabled'] = ('services_SshAccessAdministration', '--get_enabled')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	services_SshAccessAdministration.add_argument("--get_enabled", action=services_SshAccessAdministration_get_enabledAction, nargs=nargs, metavar=metavars, help=help)
	class services_SshAccessAdministration_get_portAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.services.SshAccessAdministration import SshAccessAdministration
			service = SshAccessAdministration()
			global function, interactive
			function = service.get_port
			interactive = []
	methods['services.SshAccessAdministration.get_port'] = ('services_SshAccessAdministration', '--get_port')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	services_SshAccessAdministration.add_argument("--get_port", action=services_SshAccessAdministration_get_portAction, nargs=nargs, metavar=metavars, help=help)
	time_machine_TimeMachineAdministration = subparsers.add_parser('time_machine_TimeMachineAdministration', help="help time_machine.TimeMachineAdministration")
	class time_machine_TimeMachineAdministration_listAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.time_machine.TimeMachineInfo import TimeMachineInfo

			from transformer.lib import List
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.time_machine.TimeMachineAdministration import TimeMachineAdministration
			service = TimeMachineAdministration()
			global function, interactive
			function = service.list
			interactive = []
			interactive.append(('share_id', cli_int))
	methods['time_machine.TimeMachineAdministration.list'] = ('time_machine_TimeMachineAdministration', '--list')
	metavars = () if interactive_mode else ('share_id')
	help = '' if interactive_mode else '%s ' % ('int')
	nargs = 0 if interactive_mode else 1
	time_machine_TimeMachineAdministration.add_argument("--list", action=time_machine_TimeMachineAdministration_listAction, nargs=nargs, metavar=metavars, help=help)
	email_EmailAdministration = subparsers.add_parser('email_EmailAdministration', help="help email.EmailAdministration")
	class email_EmailAdministration_send_admins_emailAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.email.EmailConfig import EmailConfig

			from transformer.lib import Dict
			checker = [dict_cli(unicode),dict_cli(unicode)]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.email.EmailAdministration import EmailAdministration
			service = EmailAdministration()
			global function, interactive
			function = service.send_admins_email
			interactive = []
			interactive.append(('title', dict_cli(unicode)))
			interactive.append(('body', dict_cli(unicode)))
	methods['email.EmailAdministration.send_admins_email'] = ('email_EmailAdministration', '--send_admins_email')
	metavars = () if interactive_mode else ('title','body')
	help = '' if interactive_mode else '%s %s ' % ('{"key":text,...}', '{"key":text,...}')
	nargs = 0 if interactive_mode else 2
	email_EmailAdministration.add_argument("--send_admins_email", action=email_EmailAdministration_send_admins_emailAction, nargs=nargs, metavar=metavars, help=help)
	class email_EmailAdministration_sendMeAnEmailAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.email.EmailConfig import EmailConfig

			from transformer.lib import Dict
			checker = [dict_cli(unicode),dict_cli(unicode)]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.email.EmailAdministration import EmailAdministration
			service = EmailAdministration()
			global function, interactive
			function = service.sendMeAnEmail
			interactive = []
			interactive.append(('title', dict_cli(unicode)))
			interactive.append(('body', dict_cli(unicode)))
	methods['email.EmailAdministration.sendMeAnEmail'] = ('email_EmailAdministration', '--sendMeAnEmail')
	metavars = () if interactive_mode else ('title','body')
	help = '' if interactive_mode else '%s %s ' % ('{"key":text,...}', '{"key":text,...}')
	nargs = 0 if interactive_mode else 2
	email_EmailAdministration.add_argument("--sendMeAnEmail", action=email_EmailAdministration_sendMeAnEmailAction, nargs=nargs, metavar=metavars, help=help)
	class email_EmailAdministration_use_smtpAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.email.EmailConfig import EmailConfig

			from transformer.lib import Dict
			checker = [cli_bool]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.email.EmailAdministration import EmailAdministration
			service = EmailAdministration()
			global function, interactive
			function = service.use_smtp
			interactive = []
			interactive.append(('use_smtp', cli_bool))
	methods['email.EmailAdministration.use_smtp'] = ('email_EmailAdministration', '--use_smtp')
	metavars = () if interactive_mode else ('use_smtp')
	help = '' if interactive_mode else '%s ' % ('True|False')
	nargs = 0 if interactive_mode else 1
	email_EmailAdministration.add_argument("--use_smtp", action=email_EmailAdministration_use_smtpAction, nargs=nargs, metavar=metavars, help=help)
	class email_EmailAdministration_set_configAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.email.EmailConfig import EmailConfig

			from transformer.lib import Dict
			checker = [EmailConfig]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.email.EmailAdministration import EmailAdministration
			service = EmailAdministration()
			global function, interactive
			function = service.set_config
			interactive = []
			interactive.append(('config', EmailConfig))
	methods['email.EmailAdministration.set_config'] = ('email_EmailAdministration', '--set_config')
	metavars = () if interactive_mode else ('config')
	help = '' if interactive_mode else '%s ' % ('{"use_smtp":True|False,"smtp_need_auth":True|False,"smtp_port":int,"smtp_server":text,"smtp_secure_connection":True|False,#"smtp_auth_pwd":text#,#"smtp_auth_user":text#}')
	nargs = 0 if interactive_mode else 1
	email_EmailAdministration.add_argument("--set_config", action=email_EmailAdministration_set_configAction, nargs=nargs, metavar=metavars, help=help)
	class email_EmailAdministration_get_configAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.email.EmailConfig import EmailConfig

			from transformer.lib import Dict
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.email.EmailAdministration import EmailAdministration
			service = EmailAdministration()
			global function, interactive
			function = service.get_config
			interactive = []
	methods['email.EmailAdministration.get_config'] = ('email_EmailAdministration', '--get_config')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	email_EmailAdministration.add_argument("--get_config", action=email_EmailAdministration_get_configAction, nargs=nargs, metavar=metavars, help=help)
	class email_EmailAdministration_can_send_mailAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.email.EmailConfig import EmailConfig

			from transformer.lib import Dict
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.email.EmailAdministration import EmailAdministration
			service = EmailAdministration()
			global function, interactive
			function = service.can_send_mail
			interactive = []
	methods['email.EmailAdministration.can_send_mail'] = ('email_EmailAdministration', '--can_send_mail')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	email_EmailAdministration.add_argument("--can_send_mail", action=email_EmailAdministration_can_send_mailAction, nargs=nargs, metavar=metavars, help=help)
	class email_EmailAdministration_send_test_emailAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.email.EmailConfig import EmailConfig

			from transformer.lib import Dict
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.email.EmailAdministration import EmailAdministration
			service = EmailAdministration()
			global function, interactive
			function = service.send_test_email
			interactive = []
			interactive.append(('email_address', cli_unicode))
	methods['email.EmailAdministration.send_test_email'] = ('email_EmailAdministration', '--send_test_email')
	metavars = () if interactive_mode else ('email_address')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 1
	email_EmailAdministration.add_argument("--send_test_email", action=email_EmailAdministration_send_test_emailAction, nargs=nargs, metavar=metavars, help=help)
	multi_nic_administration_host_service = subparsers.add_parser('multi_nic_administration_host_service', help="help multi_nic.administration.host_service")
	class multi_nic_administration_host_service_get_workgroupAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.multi_nic.ProxyConfig import ProxyConfig
			from unicorn_api.v5.sv0.multi_nic import InternetStatus
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.multi_nic.HostService import HostService
			service = HostService()
			global function, interactive
			function = service.get_workgroup
			interactive = []
	methods['multi_nic.administration.host_service.get_workgroup'] = ('multi_nic_administration_host_service', '--get_workgroup')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	multi_nic_administration_host_service.add_argument("--get_workgroup", action=multi_nic_administration_host_service_get_workgroupAction, nargs=nargs, metavar=metavars, help=help)
	class multi_nic_administration_host_service_set_ipv6_enabledAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.multi_nic.ProxyConfig import ProxyConfig
			from unicorn_api.v5.sv0.multi_nic import InternetStatus
			checker = [cli_bool]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.multi_nic.HostService import HostService
			service = HostService()
			global function, interactive
			function = service.set_ipv6_enabled
			interactive = []
			interactive.append(('enabled', cli_bool))
	methods['multi_nic.administration.host_service.set_ipv6_enabled'] = ('multi_nic_administration_host_service', '--set_ipv6_enabled')
	metavars = () if interactive_mode else ('enabled')
	help = '' if interactive_mode else '%s ' % ('True|False')
	nargs = 0 if interactive_mode else 1
	multi_nic_administration_host_service.add_argument("--set_ipv6_enabled", action=multi_nic_administration_host_service_set_ipv6_enabledAction, nargs=nargs, metavar=metavars, help=help)
	class multi_nic_administration_host_service_set_workgroupAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.multi_nic.ProxyConfig import ProxyConfig
			from unicorn_api.v5.sv0.multi_nic import InternetStatus
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.multi_nic.HostService import HostService
			service = HostService()
			global function, interactive
			function = service.set_workgroup
			interactive = []
			interactive.append(('workgroup', cli_unicode))
	methods['multi_nic.administration.host_service.set_workgroup'] = ('multi_nic_administration_host_service', '--set_workgroup')
	metavars = () if interactive_mode else ('workgroup')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 1
	multi_nic_administration_host_service.add_argument("--set_workgroup", action=multi_nic_administration_host_service_set_workgroupAction, nargs=nargs, metavar=metavars, help=help)
	class multi_nic_administration_host_service_set_proxy_configAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.multi_nic.ProxyConfig import ProxyConfig
			from unicorn_api.v5.sv0.multi_nic import InternetStatus
			checker = [ProxyConfig]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.multi_nic.HostService import HostService
			service = HostService()
			global function, interactive
			function = service.set_proxy_config
			interactive = []
			interactive.append(('config', ProxyConfig))
	methods['multi_nic.administration.host_service.set_proxy_config'] = ('multi_nic_administration_host_service', '--set_proxy_config')
	metavars = () if interactive_mode else ('config')
	help = '' if interactive_mode else '%s ' % ('{"login":text,"password":text,"enabled":True|False,"server_addr":www.xxx.yyy.zzz,"server_port":int}')
	nargs = 0 if interactive_mode else 1
	multi_nic_administration_host_service.add_argument("--set_proxy_config", action=multi_nic_administration_host_service_set_proxy_configAction, nargs=nargs, metavar=metavars, help=help)
	class multi_nic_administration_host_service_is_internet_availableAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.multi_nic.ProxyConfig import ProxyConfig
			from unicorn_api.v5.sv0.multi_nic import InternetStatus
			checker = [cli_bool]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.multi_nic.HostService import HostService
			service = HostService()
			global function, interactive
			function = service.is_internet_available
			interactive = []
			interactive.append(('force_check', cli_bool))
	methods['multi_nic.administration.host_service.is_internet_available'] = ('multi_nic_administration_host_service', '--is_internet_available')
	metavars = () if interactive_mode else ('force_check')
	help = '' if interactive_mode else '%s ' % ('True|False')
	nargs = 0 if interactive_mode else 1
	multi_nic_administration_host_service.add_argument("--is_internet_available", action=multi_nic_administration_host_service_is_internet_availableAction, nargs=nargs, metavar=metavars, help=help)
	class multi_nic_administration_host_service_get_proxy_configAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.multi_nic.ProxyConfig import ProxyConfig
			from unicorn_api.v5.sv0.multi_nic import InternetStatus
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.multi_nic.HostService import HostService
			service = HostService()
			global function, interactive
			function = service.get_proxy_config
			interactive = []
	methods['multi_nic.administration.host_service.get_proxy_config'] = ('multi_nic_administration_host_service', '--get_proxy_config')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	multi_nic_administration_host_service.add_argument("--get_proxy_config", action=multi_nic_administration_host_service_get_proxy_configAction, nargs=nargs, metavar=metavars, help=help)
	class multi_nic_administration_host_service_set_hostnameAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.multi_nic.ProxyConfig import ProxyConfig
			from unicorn_api.v5.sv0.multi_nic import InternetStatus
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.multi_nic.HostService import HostService
			service = HostService()
			global function, interactive
			function = service.set_hostname
			interactive = []
			interactive.append(('hostname', cli_unicode))
	methods['multi_nic.administration.host_service.set_hostname'] = ('multi_nic_administration_host_service', '--set_hostname')
	metavars = () if interactive_mode else ('hostname')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 1
	multi_nic_administration_host_service.add_argument("--set_hostname", action=multi_nic_administration_host_service_set_hostnameAction, nargs=nargs, metavar=metavars, help=help)
	class multi_nic_administration_host_service_get_primary_interface_idAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.multi_nic.ProxyConfig import ProxyConfig
			from unicorn_api.v5.sv0.multi_nic import InternetStatus
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.multi_nic.HostService import HostService
			service = HostService()
			global function, interactive
			function = service.get_primary_interface_id
			interactive = []
	methods['multi_nic.administration.host_service.get_primary_interface_id'] = ('multi_nic_administration_host_service', '--get_primary_interface_id')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	multi_nic_administration_host_service.add_argument("--get_primary_interface_id", action=multi_nic_administration_host_service_get_primary_interface_idAction, nargs=nargs, metavar=metavars, help=help)
	class multi_nic_administration_host_service_get_hostnameAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.multi_nic.ProxyConfig import ProxyConfig
			from unicorn_api.v5.sv0.multi_nic import InternetStatus
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.multi_nic.HostService import HostService
			service = HostService()
			global function, interactive
			function = service.get_hostname
			interactive = []
	methods['multi_nic.administration.host_service.get_hostname'] = ('multi_nic_administration_host_service', '--get_hostname')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	multi_nic_administration_host_service.add_argument("--get_hostname", action=multi_nic_administration_host_service_get_hostnameAction, nargs=nargs, metavar=metavars, help=help)
	class multi_nic_administration_host_service_get_ipv6_enabledAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.multi_nic.ProxyConfig import ProxyConfig
			from unicorn_api.v5.sv0.multi_nic import InternetStatus
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.multi_nic.HostService import HostService
			service = HostService()
			global function, interactive
			function = service.get_ipv6_enabled
			interactive = []
	methods['multi_nic.administration.host_service.get_ipv6_enabled'] = ('multi_nic_administration_host_service', '--get_ipv6_enabled')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	multi_nic_administration_host_service.add_argument("--get_ipv6_enabled", action=multi_nic_administration_host_service_get_ipv6_enabledAction, nargs=nargs, metavar=metavars, help=help)
	class multi_nic_administration_host_service_set_primary_interface_idAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.multi_nic.ProxyConfig import ProxyConfig
			from unicorn_api.v5.sv0.multi_nic import InternetStatus
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.multi_nic.HostService import HostService
			service = HostService()
			global function, interactive
			function = service.set_primary_interface_id
			interactive = []
			interactive.append(('if_id', cli_int))
	methods['multi_nic.administration.host_service.set_primary_interface_id'] = ('multi_nic_administration_host_service', '--set_primary_interface_id')
	metavars = () if interactive_mode else ('if_id')
	help = '' if interactive_mode else '%s ' % ('int')
	nargs = 0 if interactive_mode else 1
	multi_nic_administration_host_service.add_argument("--set_primary_interface_id", action=multi_nic_administration_host_service_set_primary_interface_idAction, nargs=nargs, metavar=metavars, help=help)
	job_button_JobButtonAdministration = subparsers.add_parser('job_button_JobButtonAdministration', help="help job_button.JobButtonAdministration")
	class job_button_JobButtonAdministration_start_jobsAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):

			from transformer.lib import List
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.job_button.JobButtonAdministration import JobButtonAdministration
			service = JobButtonAdministration()
			global function, interactive
			function = service.start_jobs
			interactive = []
	methods['job_button.JobButtonAdministration.start_jobs'] = ('job_button_JobButtonAdministration', '--start_jobs')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	job_button_JobButtonAdministration.add_argument("--start_jobs", action=job_button_JobButtonAdministration_start_jobsAction, nargs=nargs, metavar=metavars, help=help)
	class job_button_JobButtonAdministration_set_job_listAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):

			from transformer.lib import List
			checker = [list_cli(int)]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.job_button.JobButtonAdministration import JobButtonAdministration
			service = JobButtonAdministration()
			global function, interactive
			function = service.set_job_list
			interactive = []
			interactive.append(('list_of_id', list_cli(int)))
	methods['job_button.JobButtonAdministration.set_job_list'] = ('job_button_JobButtonAdministration', '--set_job_list')
	metavars = () if interactive_mode else ('list_of_id')
	help = '' if interactive_mode else '%s ' % ('["int",...]')
	nargs = 0 if interactive_mode else 1
	job_button_JobButtonAdministration.add_argument("--set_job_list", action=job_button_JobButtonAdministration_set_job_listAction, nargs=nargs, metavar=metavars, help=help)
	class job_button_JobButtonAdministration_listAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):

			from transformer.lib import List
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.job_button.JobButtonAdministration import JobButtonAdministration
			service = JobButtonAdministration()
			global function, interactive
			function = service.list
			interactive = []
	methods['job_button.JobButtonAdministration.list'] = ('job_button_JobButtonAdministration', '--list')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	job_button_JobButtonAdministration.add_argument("--list", action=job_button_JobButtonAdministration_listAction, nargs=nargs, metavar=metavars, help=help)
	class job_button_JobButtonAdministration_start_jobs_localAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):

			from transformer.lib import List
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.job_button.JobButtonAdministration import JobButtonAdministration
			service = JobButtonAdministration()
			global function, interactive
			function = service.start_jobs_local
			interactive = []
	methods['job_button.JobButtonAdministration.start_jobs_local'] = ('job_button_JobButtonAdministration', '--start_jobs_local')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	job_button_JobButtonAdministration.add_argument("--start_jobs_local", action=job_button_JobButtonAdministration_start_jobs_localAction, nargs=nargs, metavar=metavars, help=help)
	volumes_VolumeAdministration = subparsers.add_parser('volumes_VolumeAdministration', help="help volumes.VolumeAdministration")
	class volumes_VolumeAdministration_formatAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.volumes.Volume import Volume
			from unicorn_api.v5.sv0.volumes import FS_TYPE

			from transformer.lib import ListInfo, ResultSet, Long
			checker = [cli_unicode,cli_int,FS_TYPE]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.volumes.VolumeAdministration import VolumeAdministration
			service = VolumeAdministration()
			global function, interactive
			function = service.format
			interactive = []
			interactive.append(('async_job_name', cli_unicode))
			interactive.append(('volume_id', cli_int))
			interactive.append(('fstype', FS_TYPE))
	methods['volumes.VolumeAdministration.format'] = ('volumes_VolumeAdministration', '--format')
	metavars = () if interactive_mode else ('async_job_name','volume_id','fstype')
	help = '' if interactive_mode else '%s %s ' % ('int', 'EXT4')
	nargs = 0 if interactive_mode else 3
	volumes_VolumeAdministration.add_argument("--format", action=volumes_VolumeAdministration_formatAction, nargs=nargs, metavar=metavars, help=help)
	class volumes_VolumeAdministration_formatResultAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.volumes.VolumeAdministration import VolumeAdministration
			service = VolumeAdministration()
			global function, interactive
			function = service.format_result
			interactive = []
			interactive.append(('async_job_id', cli_int))
	methods['volumes.VolumeAdministration.format_result'] = ('volumes_VolumeAdministration', '--format_result')
	metavars = () if interactive_mode else ('async_job_id')
	nargs = 0 if interactive_mode else 1
	volumes_VolumeAdministration.add_argument("--format_result", action=volumes_VolumeAdministration_formatResultAction, nargs=nargs, metavar=metavars)
	class volumes_VolumeAdministration_change_nameAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.volumes.Volume import Volume
			from unicorn_api.v5.sv0.volumes import FS_TYPE

			from transformer.lib import ListInfo, ResultSet, Long
			checker = [cli_int,cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.volumes.VolumeAdministration import VolumeAdministration
			service = VolumeAdministration()
			global function, interactive
			function = service.change_name
			interactive = []
			interactive.append(('volume_id', cli_int))
			interactive.append(('volume_name', cli_unicode))
	methods['volumes.VolumeAdministration.change_name'] = ('volumes_VolumeAdministration', '--change_name')
	metavars = () if interactive_mode else ('volume_id','volume_name')
	help = '' if interactive_mode else '%s %s ' % ('int', 'text')
	nargs = 0 if interactive_mode else 2
	volumes_VolumeAdministration.add_argument("--change_name", action=volumes_VolumeAdministration_change_nameAction, nargs=nargs, metavar=metavars, help=help)
	class volumes_VolumeAdministration_createAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.volumes.Volume import Volume
			from unicorn_api.v5.sv0.volumes import FS_TYPE

			from transformer.lib import ListInfo, ResultSet, Long
			checker = [cli_unicode,cli_unicode,cli_long]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.volumes.VolumeAdministration import VolumeAdministration
			service = VolumeAdministration()
			global function, interactive
			function = service.create
			interactive = []
			interactive.append(('async_job_name', cli_unicode))
			interactive.append(('storage_uid', cli_unicode))
			interactive.append(('size', cli_long))
	methods['volumes.VolumeAdministration.create'] = ('volumes_VolumeAdministration', '--create')
	metavars = () if interactive_mode else ('async_job_name','storage_uid','size')
	help = '' if interactive_mode else '%s %s ' % ('text', 'long')
	nargs = 0 if interactive_mode else 3
	volumes_VolumeAdministration.add_argument("--create", action=volumes_VolumeAdministration_createAction, nargs=nargs, metavar=metavars, help=help)
	class volumes_VolumeAdministration_createResultAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.volumes.VolumeAdministration import VolumeAdministration
			service = VolumeAdministration()
			global function, interactive
			function = service.create_result
			interactive = []
			interactive.append(('async_job_id', cli_int))
	methods['volumes.VolumeAdministration.create_result'] = ('volumes_VolumeAdministration', '--create_result')
	metavars = () if interactive_mode else ('async_job_id')
	nargs = 0 if interactive_mode else 1
	volumes_VolumeAdministration.add_argument("--create_result", action=volumes_VolumeAdministration_createResultAction, nargs=nargs, metavar=metavars)
	class volumes_VolumeAdministration_list_volumesAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.volumes.Volume import Volume
			from unicorn_api.v5.sv0.volumes import FS_TYPE

			from transformer.lib import ListInfo, ResultSet, Long
			checker = [cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.volumes.VolumeAdministration import VolumeAdministration
			service = VolumeAdministration()
			global function, interactive
			function = service.list_volumes
			interactive = []
			interactive.append(('list_info', cli_list_info))
	methods['volumes.VolumeAdministration.list_volumes'] = ('volumes_VolumeAdministration', '--list_volumes')
	metavars = () if interactive_mode else ('list_info')
	help = '' if interactive_mode else '%s ' % ('offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 1
	volumes_VolumeAdministration.add_argument("--list_volumes", action=volumes_VolumeAdministration_list_volumesAction, nargs=nargs, metavar=metavars, help=help)
	class volumes_VolumeAdministration_resizeAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.volumes.Volume import Volume
			from unicorn_api.v5.sv0.volumes import FS_TYPE

			from transformer.lib import ListInfo, ResultSet, Long
			checker = [cli_int,cli_long]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.volumes.VolumeAdministration import VolumeAdministration
			service = VolumeAdministration()
			global function, interactive
			function = service.resize
			interactive = []
			interactive.append(('volume_id', cli_int))
			interactive.append(('size', cli_long))
	methods['volumes.VolumeAdministration.resize'] = ('volumes_VolumeAdministration', '--resize')
	metavars = () if interactive_mode else ('volume_id','size')
	help = '' if interactive_mode else '%s %s ' % ('int', 'long')
	nargs = 0 if interactive_mode else 2
	volumes_VolumeAdministration.add_argument("--resize", action=volumes_VolumeAdministration_resizeAction, nargs=nargs, metavar=metavars, help=help)
	class volumes_VolumeAdministration_deleteAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.volumes.Volume import Volume
			from unicorn_api.v5.sv0.volumes import FS_TYPE

			from transformer.lib import ListInfo, ResultSet, Long
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.volumes.VolumeAdministration import VolumeAdministration
			service = VolumeAdministration()
			global function, interactive
			function = service.delete
			interactive = []
			interactive.append(('volume', cli_int))
	methods['volumes.VolumeAdministration.delete'] = ('volumes_VolumeAdministration', '--delete')
	metavars = () if interactive_mode else ('volume')
	help = '' if interactive_mode else '%s ' % ('int')
	nargs = 0 if interactive_mode else 1
	volumes_VolumeAdministration.add_argument("--delete", action=volumes_VolumeAdministration_deleteAction, nargs=nargs, metavar=metavars, help=help)
	authentication_users_Administration = subparsers.add_parser('authentication_users_Administration', help="help authentication.users.Administration")
	class authentication_users_Administration_modifyAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.user_group_share.User import User
			from unicorn_api.v5.sv0.user_group_share import UserType
			from unicorn_api.v5.sv0.user_group_share.DomainUser import DomainUser
			from unicorn_api.v5.sv0.user_group_share.ImportUserError import ImportUserError

			from transformer.lib import List, ListInfo, ResultSet
			checker = [cli_int,User]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.UserAdministration import UserAdministration
			service = UserAdministration()
			global function, interactive
			function = service.modify
			interactive = []
			interactive.append(('user_id', cli_int))
			interactive.append(('user', User))
	methods['authentication.users.Administration.modify'] = ('authentication_users_Administration', '--modify')
	metavars = () if interactive_mode else ('user_id','user')
	help = '' if interactive_mode else '%s %s ' % ('int', '{"is_admin":True|False,"login":text,"type":domain|local,#"comment":text#,#"sid":text#,#"password":text#,#"email":text#}')
	nargs = 0 if interactive_mode else 2
	authentication_users_Administration.add_argument("--modify", action=authentication_users_Administration_modifyAction, nargs=nargs, metavar=metavars, help=help)
	class authentication_users_Administration_import_from_domainAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.user_group_share.User import User
			from unicorn_api.v5.sv0.user_group_share import UserType
			from unicorn_api.v5.sv0.user_group_share.DomainUser import DomainUser
			from unicorn_api.v5.sv0.user_group_share.ImportUserError import ImportUserError

			from transformer.lib import List, ListInfo, ResultSet
			checker = [list_cli(DomainUser)]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.UserAdministration import UserAdministration
			service = UserAdministration()
			global function, interactive
			function = service.import_from_domain
			interactive = []
			interactive.append(('users', list_cli(DomainUser)))
	methods['authentication.users.Administration.import_from_domain'] = ('authentication_users_Administration', '--import_from_domain')
	metavars = () if interactive_mode else ('users')
	help = '' if interactive_mode else '%s ' % ('["{"lastname":text,"login":text,"email":text,"firstname":text,"sid":text}",...]')
	nargs = 0 if interactive_mode else 1
	authentication_users_Administration.add_argument("--import_from_domain", action=authentication_users_Administration_import_from_domainAction, nargs=nargs, metavar=metavars, help=help)
	class authentication_users_Administration_listAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.user_group_share.User import User
			from unicorn_api.v5.sv0.user_group_share import UserType
			from unicorn_api.v5.sv0.user_group_share.DomainUser import DomainUser
			from unicorn_api.v5.sv0.user_group_share.ImportUserError import ImportUserError

			from transformer.lib import List, ListInfo, ResultSet
			checker = [list_cli(unicode),cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.UserAdministration import UserAdministration
			service = UserAdministration()
			global function, interactive
			function = service.list
			interactive = []
			interactive.append(('with_parameters', list_cli(unicode)))
			interactive.append(('list_info', cli_list_info))
	methods['authentication.users.Administration.list'] = ('authentication_users_Administration', '--list')
	metavars = () if interactive_mode else ('with_parameters','list_info')
	help = '' if interactive_mode else '%s %s ' % ('["text",...]', 'offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 2
	authentication_users_Administration.add_argument("--list", action=authentication_users_Administration_listAction, nargs=nargs, metavar=metavars, help=help)
	class authentication_users_Administration_removeAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.user_group_share.User import User
			from unicorn_api.v5.sv0.user_group_share import UserType
			from unicorn_api.v5.sv0.user_group_share.DomainUser import DomainUser
			from unicorn_api.v5.sv0.user_group_share.ImportUserError import ImportUserError

			from transformer.lib import List, ListInfo, ResultSet
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.UserAdministration import UserAdministration
			service = UserAdministration()
			global function, interactive
			function = service.remove
			interactive = []
			interactive.append(('user_id', cli_int))
	methods['authentication.users.Administration.remove'] = ('authentication_users_Administration', '--remove')
	metavars = () if interactive_mode else ('user_id')
	help = '' if interactive_mode else '%s ' % ('int')
	nargs = 0 if interactive_mode else 1
	authentication_users_Administration.add_argument("--remove", action=authentication_users_Administration_removeAction, nargs=nargs, metavar=metavars, help=help)
	class authentication_users_Administration_list_users_from_domainAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.user_group_share.User import User
			from unicorn_api.v5.sv0.user_group_share import UserType
			from unicorn_api.v5.sv0.user_group_share.DomainUser import DomainUser
			from unicorn_api.v5.sv0.user_group_share.ImportUserError import ImportUserError

			from transformer.lib import List, ListInfo, ResultSet
			checker = [list_cli(unicode),cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.UserAdministration import UserAdministration
			service = UserAdministration()
			global function, interactive
			function = service.list_users_from_domain
			interactive = []
			interactive.append(('with_parameters', list_cli(unicode)))
			interactive.append(('list_info', cli_list_info))
	methods['authentication.users.Administration.list_users_from_domain'] = ('authentication_users_Administration', '--list_users_from_domain')
	metavars = () if interactive_mode else ('with_parameters','list_info')
	help = '' if interactive_mode else '%s %s ' % ('["text",...]', 'offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 2
	authentication_users_Administration.add_argument("--list_users_from_domain", action=authentication_users_Administration_list_users_from_domainAction, nargs=nargs, metavar=metavars, help=help)
	class authentication_users_Administration_check_name_availabilityAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.user_group_share.User import User
			from unicorn_api.v5.sv0.user_group_share import UserType
			from unicorn_api.v5.sv0.user_group_share.DomainUser import DomainUser
			from unicorn_api.v5.sv0.user_group_share.ImportUserError import ImportUserError

			from transformer.lib import List, ListInfo, ResultSet
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.UserAdministration import UserAdministration
			service = UserAdministration()
			global function, interactive
			function = service.check_name_availability
			interactive = []
			interactive.append(('name', cli_unicode))
	methods['authentication.users.Administration.check_name_availability'] = ('authentication_users_Administration', '--check_name_availability')
	metavars = () if interactive_mode else ('name')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 1
	authentication_users_Administration.add_argument("--check_name_availability", action=authentication_users_Administration_check_name_availabilityAction, nargs=nargs, metavar=metavars, help=help)
	class authentication_users_Administration_change_passwordAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.user_group_share.User import User
			from unicorn_api.v5.sv0.user_group_share import UserType
			from unicorn_api.v5.sv0.user_group_share.DomainUser import DomainUser
			from unicorn_api.v5.sv0.user_group_share.ImportUserError import ImportUserError

			from transformer.lib import List, ListInfo, ResultSet
			checker = [cli_int,cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.UserAdministration import UserAdministration
			service = UserAdministration()
			global function, interactive
			function = service.change_password
			interactive = []
			interactive.append(('user_id', cli_int))
			interactive.append(('password', cli_unicode))
	methods['authentication.users.Administration.change_password'] = ('authentication_users_Administration', '--change_password')
	metavars = () if interactive_mode else ('user_id','password')
	help = '' if interactive_mode else '%s %s ' % ('int', 'text')
	nargs = 0 if interactive_mode else 2
	authentication_users_Administration.add_argument("--change_password", action=authentication_users_Administration_change_passwordAction, nargs=nargs, metavar=metavars, help=help)
	class authentication_users_Administration_get_user_by_loginAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.user_group_share.User import User
			from unicorn_api.v5.sv0.user_group_share import UserType
			from unicorn_api.v5.sv0.user_group_share.DomainUser import DomainUser
			from unicorn_api.v5.sv0.user_group_share.ImportUserError import ImportUserError

			from transformer.lib import List, ListInfo, ResultSet
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.UserAdministration import UserAdministration
			service = UserAdministration()
			global function, interactive
			function = service.get_user_by_login
			interactive = []
			interactive.append(('login', cli_unicode))
	methods['authentication.users.Administration.get_user_by_login'] = ('authentication_users_Administration', '--get_user_by_login')
	metavars = () if interactive_mode else ('login')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 1
	authentication_users_Administration.add_argument("--get_user_by_login", action=authentication_users_Administration_get_user_by_loginAction, nargs=nargs, metavar=metavars, help=help)
	class authentication_users_Administration_add_local_userAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.user_group_share.User import User
			from unicorn_api.v5.sv0.user_group_share import UserType
			from unicorn_api.v5.sv0.user_group_share.DomainUser import DomainUser
			from unicorn_api.v5.sv0.user_group_share.ImportUserError import ImportUserError

			from transformer.lib import List, ListInfo, ResultSet
			checker = [User]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.user_group_share.UserAdministration import UserAdministration
			service = UserAdministration()
			global function, interactive
			function = service.add_local_user
			interactive = []
			interactive.append(('user', User))
	methods['authentication.users.Administration.add_local_user'] = ('authentication_users_Administration', '--add_local_user')
	metavars = () if interactive_mode else ('user')
	help = '' if interactive_mode else '%s ' % ('{"is_admin":True|False,"login":text,"type":domain|local,#"comment":text#,#"sid":text#,#"password":text#,#"email":text#}')
	nargs = 0 if interactive_mode else 1
	authentication_users_Administration.add_argument("--add_local_user", action=authentication_users_Administration_add_local_userAction, nargs=nargs, metavar=metavars, help=help)
	disks_ExternalDiskAdministration = subparsers.add_parser('disks_ExternalDiskAdministration', help="help disks.ExternalDiskAdministration")
	class disks_ExternalDiskAdministration_listAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.disks.ExternalDisk import ExternalDisk

			from transformer.lib import ListInfo, ResultSet
			checker = [cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.disks.ExternalDiskAdministration import ExternalDiskAdministration
			service = ExternalDiskAdministration()
			global function, interactive
			function = service.list
			interactive = []
			interactive.append(('list_info', cli_list_info))
	methods['disks.ExternalDiskAdministration.list'] = ('disks_ExternalDiskAdministration', '--list')
	metavars = () if interactive_mode else ('list_info')
	help = '' if interactive_mode else '%s ' % ('offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 1
	disks_ExternalDiskAdministration.add_argument("--list", action=disks_ExternalDiskAdministration_listAction, nargs=nargs, metavar=metavars, help=help)
	class disks_ExternalDiskAdministration_ejectAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.disks.ExternalDisk import ExternalDisk

			from transformer.lib import ListInfo, ResultSet
			checker = [cli_unicode,cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.disks.ExternalDiskAdministration import ExternalDiskAdministration
			service = ExternalDiskAdministration()
			global function, interactive
			function = service.eject
			interactive = []
			interactive.append(('async_job_name', cli_unicode))
			interactive.append(('disk_id', cli_int))
	methods['disks.ExternalDiskAdministration.eject'] = ('disks_ExternalDiskAdministration', '--eject')
	metavars = () if interactive_mode else ('async_job_name','disk_id')
	help = '' if interactive_mode else '%s ' % ('int')
	nargs = 0 if interactive_mode else 2
	disks_ExternalDiskAdministration.add_argument("--eject", action=disks_ExternalDiskAdministration_ejectAction, nargs=nargs, metavar=metavars, help=help)
	class disks_ExternalDiskAdministration_ejectResultAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.disks.ExternalDiskAdministration import ExternalDiskAdministration
			service = ExternalDiskAdministration()
			global function, interactive
			function = service.eject_result
			interactive = []
			interactive.append(('async_job_id', cli_int))
	methods['disks.ExternalDiskAdministration.eject_result'] = ('disks_ExternalDiskAdministration', '--eject_result')
	metavars = () if interactive_mode else ('async_job_id')
	nargs = 0 if interactive_mode else 1
	disks_ExternalDiskAdministration.add_argument("--eject_result", action=disks_ExternalDiskAdministration_ejectResultAction, nargs=nargs, metavar=metavars)
	nas_authentication_NasAuth = subparsers.add_parser('nas_authentication_NasAuth', help="help nas_authentication.NasAuth")
	class nas_authentication_NasAuth_get_authentication_tokenAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.nas_authentication.MySelf import MySelf
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.nas_authentication.NasAuth import NasAuth
			service = NasAuth()
			global function, interactive
			function = service.get_authentication_token
			interactive = []
	methods['nas_authentication.NasAuth.get_authentication_token'] = ('nas_authentication_NasAuth', '--get_authentication_token')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	nas_authentication_NasAuth.add_argument("--get_authentication_token", action=nas_authentication_NasAuth_get_authentication_tokenAction, nargs=nargs, metavar=metavars, help=help)
	class nas_authentication_NasAuth_mySelfAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.nas_authentication.MySelf import MySelf
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.nas_authentication.NasAuth import NasAuth
			service = NasAuth()
			global function, interactive
			function = service.mySelf
			interactive = []
	methods['nas_authentication.NasAuth.mySelf'] = ('nas_authentication_NasAuth', '--mySelf')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	nas_authentication_NasAuth.add_argument("--mySelf", action=nas_authentication_NasAuth_mySelfAction, nargs=nargs, metavar=metavars, help=help)
	class nas_authentication_NasAuth_invalidate_tokenAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.nas_authentication.MySelf import MySelf
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.nas_authentication.NasAuth import NasAuth
			service = NasAuth()
			global function, interactive
			function = service.invalidate_token
			interactive = []
			interactive.append(('token', cli_unicode))
	methods['nas_authentication.NasAuth.invalidate_token'] = ('nas_authentication_NasAuth', '--invalidate_token')
	metavars = () if interactive_mode else ('token')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 1
	nas_authentication_NasAuth.add_argument("--invalidate_token", action=nas_authentication_NasAuth_invalidate_tokenAction, nargs=nargs, metavar=metavars, help=help)
	class nas_authentication_NasAuth_change_passwordAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.nas_authentication.MySelf import MySelf
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.nas_authentication.NasAuth import NasAuth
			service = NasAuth()
			global function, interactive
			function = service.change_password
			interactive = []
			interactive.append(('password', cli_unicode))
	methods['nas_authentication.NasAuth.change_password'] = ('nas_authentication_NasAuth', '--change_password')
	metavars = () if interactive_mode else ('password')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 1
	nas_authentication_NasAuth.add_argument("--change_password", action=nas_authentication_NasAuth_change_passwordAction, nargs=nargs, metavar=metavars, help=help)
	class nas_authentication_NasAuth_retrieve_user_from_idAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.nas_authentication.MySelf import MySelf
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.nas_authentication.NasAuth import NasAuth
			service = NasAuth()
			global function, interactive
			function = service.retrieve_user_from_id
			interactive = []
			interactive.append(('id', cli_int))
	methods['nas_authentication.NasAuth.retrieve_user_from_id'] = ('nas_authentication_NasAuth', '--retrieve_user_from_id')
	metavars = () if interactive_mode else ('id')
	help = '' if interactive_mode else '%s ' % ('int')
	nargs = 0 if interactive_mode else 1
	nas_authentication_NasAuth.add_argument("--retrieve_user_from_id", action=nas_authentication_NasAuth_retrieve_user_from_idAction, nargs=nargs, metavar=metavars, help=help)
	class nas_authentication_NasAuth_mySharesAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.nas_authentication.MySelf import MySelf
			checker = [cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.nas_authentication.NasAuth import NasAuth
			service = NasAuth()
			global function, interactive
			function = service.myShares
			interactive = []
			interactive.append(('list_info', cli_list_info))
	methods['nas_authentication.NasAuth.myShares'] = ('nas_authentication_NasAuth', '--myShares')
	metavars = () if interactive_mode else ('list_info')
	help = '' if interactive_mode else '%s ' % ('offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 1
	nas_authentication_NasAuth.add_argument("--myShares", action=nas_authentication_NasAuth_mySharesAction, nargs=nargs, metavar=metavars, help=help)
	app_manager_AppManager = subparsers.add_parser('app_manager_AppManager', help="help app_manager.AppManager")
	class app_manager_AppManager_app_startedAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.app_manager.RegisteredApp import RegisteredApp
			from unicorn_api.v5.sv0.app_manager import RegisteredAppStatus

			from transformer.lib import ListInfo, ResultSet, List, Dict
			checker = [cli_unicode,dict_cli(unicode)]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.app_manager.AppManager import AppManager
			service = AppManager()
			global function, interactive
			function = service.app_started
			interactive = []
			interactive.append(('install_id', cli_unicode))
			interactive.append(('infos', dict_cli(unicode)))
	methods['app_manager.AppManager.app_started'] = ('app_manager_AppManager', '--app_started')
	metavars = () if interactive_mode else ('install_id','infos')
	help = '' if interactive_mode else '%s %s ' % ('text', '{"key":text,...}')
	nargs = 0 if interactive_mode else 2
	app_manager_AppManager.add_argument("--app_started", action=app_manager_AppManager_app_startedAction, nargs=nargs, metavar=metavars, help=help)
	class app_manager_AppManager_get_portsAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.app_manager.RegisteredApp import RegisteredApp
			from unicorn_api.v5.sv0.app_manager import RegisteredAppStatus

			from transformer.lib import ListInfo, ResultSet, List, Dict
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.app_manager.AppManager import AppManager
			service = AppManager()
			global function, interactive
			function = service.get_ports
			interactive = []
	methods['app_manager.AppManager.get_ports'] = ('app_manager_AppManager', '--get_ports')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	app_manager_AppManager.add_argument("--get_ports", action=app_manager_AppManager_get_portsAction, nargs=nargs, metavar=metavars, help=help)
	class app_manager_AppManager_allow_appAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.app_manager.RegisteredApp import RegisteredApp
			from unicorn_api.v5.sv0.app_manager import RegisteredAppStatus

			from transformer.lib import ListInfo, ResultSet, List, Dict
			checker = [cli_unicode,list_cli(unicode),cli_bool]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.app_manager.AppManager import AppManager
			service = AppManager()
			global function, interactive
			function = service.allow_app
			interactive = []
			interactive.append(('app_id', cli_unicode))
			interactive.append(('allowed_optional_permissions', list_cli(unicode)))
			interactive.append(('allow', cli_bool))
	methods['app_manager.AppManager.allow_app'] = ('app_manager_AppManager', '--allow_app')
	metavars = () if interactive_mode else ('app_id','allowed_optional_permissions','allow')
	help = '' if interactive_mode else '%s %s %s ' % ('text', '["text",...]', 'True|False')
	nargs = 0 if interactive_mode else 3
	app_manager_AppManager.add_argument("--allow_app", action=app_manager_AppManager_allow_appAction, nargs=nargs, metavar=metavars, help=help)
	class app_manager_AppManager_app_removedAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.app_manager.RegisteredApp import RegisteredApp
			from unicorn_api.v5.sv0.app_manager import RegisteredAppStatus

			from transformer.lib import ListInfo, ResultSet, List, Dict
			checker = [cli_unicode,dict_cli(unicode)]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.app_manager.AppManager import AppManager
			service = AppManager()
			global function, interactive
			function = service.app_removed
			interactive = []
			interactive.append(('install_id', cli_unicode))
			interactive.append(('infos', dict_cli(unicode)))
	methods['app_manager.AppManager.app_removed'] = ('app_manager_AppManager', '--app_removed')
	metavars = () if interactive_mode else ('install_id','infos')
	help = '' if interactive_mode else '%s %s ' % ('text', '{"key":text,...}')
	nargs = 0 if interactive_mode else 2
	app_manager_AppManager.add_argument("--app_removed", action=app_manager_AppManager_app_removedAction, nargs=nargs, metavar=metavars, help=help)
	class app_manager_AppManager_app_stoppedAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.app_manager.RegisteredApp import RegisteredApp
			from unicorn_api.v5.sv0.app_manager import RegisteredAppStatus

			from transformer.lib import ListInfo, ResultSet, List, Dict
			checker = [cli_unicode,dict_cli(unicode)]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.app_manager.AppManager import AppManager
			service = AppManager()
			global function, interactive
			function = service.app_stopped
			interactive = []
			interactive.append(('install_id', cli_unicode))
			interactive.append(('infos', dict_cli(unicode)))
	methods['app_manager.AppManager.app_stopped'] = ('app_manager_AppManager', '--app_stopped')
	metavars = () if interactive_mode else ('install_id','infos')
	help = '' if interactive_mode else '%s %s ' % ('text', '{"key":text,...}')
	nargs = 0 if interactive_mode else 2
	app_manager_AppManager.add_argument("--app_stopped", action=app_manager_AppManager_app_stoppedAction, nargs=nargs, metavar=metavars, help=help)
	class app_manager_AppManager_release_portAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.app_manager.RegisteredApp import RegisteredApp
			from unicorn_api.v5.sv0.app_manager import RegisteredAppStatus

			from transformer.lib import ListInfo, ResultSet, List, Dict
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.app_manager.AppManager import AppManager
			service = AppManager()
			global function, interactive
			function = service.release_port
			interactive = []
			interactive.append(('port_name', cli_unicode))
	methods['app_manager.AppManager.release_port'] = ('app_manager_AppManager', '--release_port')
	metavars = () if interactive_mode else ('port_name')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 1
	app_manager_AppManager.add_argument("--release_port", action=app_manager_AppManager_release_portAction, nargs=nargs, metavar=metavars, help=help)
	class app_manager_AppManager_open_portAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.app_manager.RegisteredApp import RegisteredApp
			from unicorn_api.v5.sv0.app_manager import RegisteredAppStatus

			from transformer.lib import ListInfo, ResultSet, List, Dict
			checker = [cli_unicode,cli_bool]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.app_manager.AppManager import AppManager
			service = AppManager()
			global function, interactive
			function = service.open_port
			interactive = []
			interactive.append(('port_name', cli_unicode))
			interactive.append(('external', cli_bool))
	methods['app_manager.AppManager.open_port'] = ('app_manager_AppManager', '--open_port')
	metavars = () if interactive_mode else ('port_name','external')
	help = '' if interactive_mode else '%s %s ' % ('text', 'True|False')
	nargs = 0 if interactive_mode else 2
	app_manager_AppManager.add_argument("--open_port", action=app_manager_AppManager_open_portAction, nargs=nargs, metavar=metavars, help=help)
	class app_manager_AppManager_authenticate_userAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.app_manager.RegisteredApp import RegisteredApp
			from unicorn_api.v5.sv0.app_manager import RegisteredAppStatus

			from transformer.lib import ListInfo, ResultSet, List, Dict
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.app_manager.AppManager import AppManager
			service = AppManager()
			global function, interactive
			function = service.authenticate_user
			interactive = []
			interactive.append(('app_session', cli_unicode))
	methods['app_manager.AppManager.authenticate_user'] = ('app_manager_AppManager', '--authenticate_user')
	metavars = () if interactive_mode else ('app_session')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 1
	app_manager_AppManager.add_argument("--authenticate_user", action=app_manager_AppManager_authenticate_userAction, nargs=nargs, metavar=metavars, help=help)
	class app_manager_AppManager_list_registered_appsAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.app_manager.RegisteredApp import RegisteredApp
			from unicorn_api.v5.sv0.app_manager import RegisteredAppStatus

			from transformer.lib import ListInfo, ResultSet, List, Dict
			checker = [cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.app_manager.AppManager import AppManager
			service = AppManager()
			global function, interactive
			function = service.list_registered_apps
			interactive = []
			interactive.append(('list_info', cli_list_info))
	methods['app_manager.AppManager.list_registered_apps'] = ('app_manager_AppManager', '--list_registered_apps')
	metavars = () if interactive_mode else ('list_info')
	help = '' if interactive_mode else '%s ' % ('offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 1
	app_manager_AppManager.add_argument("--list_registered_apps", action=app_manager_AppManager_list_registered_appsAction, nargs=nargs, metavar=metavars, help=help)
	class app_manager_AppManager_remove_announcementAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.app_manager.RegisteredApp import RegisteredApp
			from unicorn_api.v5.sv0.app_manager import RegisteredAppStatus

			from transformer.lib import ListInfo, ResultSet, List, Dict
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.app_manager.AppManager import AppManager
			service = AppManager()
			global function, interactive
			function = service.remove_announcement
			interactive = []
	methods['app_manager.AppManager.remove_announcement'] = ('app_manager_AppManager', '--remove_announcement')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	app_manager_AppManager.add_argument("--remove_announcement", action=app_manager_AppManager_remove_announcementAction, nargs=nargs, metavar=metavars, help=help)
	class app_manager_AppManager_create_announcementAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.app_manager.RegisteredApp import RegisteredApp
			from unicorn_api.v5.sv0.app_manager import RegisteredAppStatus

			from transformer.lib import ListInfo, ResultSet, List, Dict
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.app_manager.AppManager import AppManager
			service = AppManager()
			global function, interactive
			function = service.create_announcement
			interactive = []
			interactive.append(('announcement', cli_unicode))
	methods['app_manager.AppManager.create_announcement'] = ('app_manager_AppManager', '--create_announcement')
	metavars = () if interactive_mode else ('announcement')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 1
	app_manager_AppManager.add_argument("--create_announcement", action=app_manager_AppManager_create_announcementAction, nargs=nargs, metavar=metavars, help=help)
	class app_manager_AppManager_app_updatedAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.app_manager.RegisteredApp import RegisteredApp
			from unicorn_api.v5.sv0.app_manager import RegisteredAppStatus

			from transformer.lib import ListInfo, ResultSet, List, Dict
			checker = [cli_unicode,dict_cli(unicode)]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.app_manager.AppManager import AppManager
			service = AppManager()
			global function, interactive
			function = service.app_updated
			interactive = []
			interactive.append(('install_id', cli_unicode))
			interactive.append(('infos', dict_cli(unicode)))
	methods['app_manager.AppManager.app_updated'] = ('app_manager_AppManager', '--app_updated')
	metavars = () if interactive_mode else ('install_id','infos')
	help = '' if interactive_mode else '%s %s ' % ('text', '{"key":text,...}')
	nargs = 0 if interactive_mode else 2
	app_manager_AppManager.add_argument("--app_updated", action=app_manager_AppManager_app_updatedAction, nargs=nargs, metavar=metavars, help=help)
	class app_manager_AppManager_app_installedAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.app_manager.RegisteredApp import RegisteredApp
			from unicorn_api.v5.sv0.app_manager import RegisteredAppStatus

			from transformer.lib import ListInfo, ResultSet, List, Dict
			checker = [cli_unicode,dict_cli(unicode)]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.app_manager.AppManager import AppManager
			service = AppManager()
			global function, interactive
			function = service.app_installed
			interactive = []
			interactive.append(('install_id', cli_unicode))
			interactive.append(('infos', dict_cli(unicode)))
	methods['app_manager.AppManager.app_installed'] = ('app_manager_AppManager', '--app_installed')
	metavars = () if interactive_mode else ('install_id','infos')
	help = '' if interactive_mode else '%s %s ' % ('text', '{"key":text,...}')
	nargs = 0 if interactive_mode else 2
	app_manager_AppManager.add_argument("--app_installed", action=app_manager_AppManager_app_installedAction, nargs=nargs, metavar=metavars, help=help)
	iscsi_SimpleIscsiAdministration = subparsers.add_parser('iscsi_SimpleIscsiAdministration', help="help iscsi.SimpleIscsiAdministration")
	class iscsi_SimpleIscsiAdministration_remove_iqnAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiTarget import SimpleIscsiTarget

			from transformer.lib import ListInfo, ResultSet, Long
			checker = [cli_int,cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiAdministration import SimpleIscsiAdministration
			service = SimpleIscsiAdministration()
			global function, interactive
			function = service.remove_iqn
			interactive = []
			interactive.append(('target_id', cli_int))
			interactive.append(('iqn', cli_unicode))
	methods['iscsi.SimpleIscsiAdministration.remove_iqn'] = ('iscsi_SimpleIscsiAdministration', '--remove_iqn')
	metavars = () if interactive_mode else ('target_id','iqn')
	help = '' if interactive_mode else '%s %s ' % ('int', 'text')
	nargs = 0 if interactive_mode else 2
	iscsi_SimpleIscsiAdministration.add_argument("--remove_iqn", action=iscsi_SimpleIscsiAdministration_remove_iqnAction, nargs=nargs, metavar=metavars, help=help)
	class iscsi_SimpleIscsiAdministration_import_lunAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiTarget import SimpleIscsiTarget

			from transformer.lib import ListInfo, ResultSet, Long
			checker = [cli_unicode,cli_int,cli_unicode,cli_unicode,SimpleIscsiTarget]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiAdministration import SimpleIscsiAdministration
			service = SimpleIscsiAdministration()
			global function, interactive
			function = service.import_lun
			interactive = []
			interactive.append(('async_job_name', cli_unicode))
			interactive.append(('volume_id', cli_int))
			interactive.append(('lun_src_file', cli_unicode))
			interactive.append(('lun_description', cli_unicode))
			interactive.append(('iscsi', SimpleIscsiTarget))
	methods['iscsi.SimpleIscsiAdministration.import_lun'] = ('iscsi_SimpleIscsiAdministration', '--import_lun')
	metavars = () if interactive_mode else ('async_job_name','volume_id','lun_src_file','lun_description','iscsi')
	help = '' if interactive_mode else '%s %s %s %s ' % ('int', 'text', 'text', '{"multiple_session":True|False,"name":text,"iqn_suffix":text,"data_digest":True|False,"header_digest":True|False,#"chap_user":{"login":text,#"password":text#,#"mutual_chap_user":{"login":text,#"password":text#}#}#,#"lun":{"kind":BLOCK_LEVEL|FILE_LEVEL,"description":text,"id":int}#,#"initiator_iqns":["text",...]#}')
	nargs = 0 if interactive_mode else 5
	iscsi_SimpleIscsiAdministration.add_argument("--import_lun", action=iscsi_SimpleIscsiAdministration_import_lunAction, nargs=nargs, metavar=metavars, help=help)
	class iscsi_SimpleIscsiAdministration_import_lunResultAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiAdministration import SimpleIscsiAdministration
			service = SimpleIscsiAdministration()
			global function, interactive
			function = service.import_lun_result
			interactive = []
			interactive.append(('async_job_id', cli_int))
	methods['iscsi.SimpleIscsiAdministration.import_lun_result'] = ('iscsi_SimpleIscsiAdministration', '--import_lun_result')
	metavars = () if interactive_mode else ('async_job_id')
	nargs = 0 if interactive_mode else 1
	iscsi_SimpleIscsiAdministration.add_argument("--import_lun_result", action=iscsi_SimpleIscsiAdministration_import_lunResultAction, nargs=nargs, metavar=metavars)
	class iscsi_SimpleIscsiAdministration_listAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiTarget import SimpleIscsiTarget

			from transformer.lib import ListInfo, ResultSet, Long
			checker = [cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiAdministration import SimpleIscsiAdministration
			service = SimpleIscsiAdministration()
			global function, interactive
			function = service.list
			interactive = []
			interactive.append(('listInfo', cli_list_info))
	methods['iscsi.SimpleIscsiAdministration.list'] = ('iscsi_SimpleIscsiAdministration', '--list')
	metavars = () if interactive_mode else ('listInfo')
	help = '' if interactive_mode else '%s ' % ('offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 1
	iscsi_SimpleIscsiAdministration.add_argument("--list", action=iscsi_SimpleIscsiAdministration_listAction, nargs=nargs, metavar=metavars, help=help)
	class iscsi_SimpleIscsiAdministration_createAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiTarget import SimpleIscsiTarget

			from transformer.lib import ListInfo, ResultSet, Long
			checker = [cli_unicode,cli_int,cli_long,cli_unicode,SimpleIscsiTarget]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiAdministration import SimpleIscsiAdministration
			service = SimpleIscsiAdministration()
			global function, interactive
			function = service.create
			interactive = []
			interactive.append(('async_job_name', cli_unicode))
			interactive.append(('volume_id', cli_int))
			interactive.append(('size', cli_long))
			interactive.append(('lun_description', cli_unicode))
			interactive.append(('iscsi', SimpleIscsiTarget))
	methods['iscsi.SimpleIscsiAdministration.create'] = ('iscsi_SimpleIscsiAdministration', '--create')
	metavars = () if interactive_mode else ('async_job_name','volume_id','size','lun_description','iscsi')
	help = '' if interactive_mode else '%s %s %s %s ' % ('int', 'long', 'text', '{"multiple_session":True|False,"name":text,"iqn_suffix":text,"data_digest":True|False,"header_digest":True|False,#"chap_user":{"login":text,#"password":text#,#"mutual_chap_user":{"login":text,#"password":text#}#}#,#"lun":{"kind":BLOCK_LEVEL|FILE_LEVEL,"description":text,"id":int}#,#"initiator_iqns":["text",...]#}')
	nargs = 0 if interactive_mode else 5
	iscsi_SimpleIscsiAdministration.add_argument("--create", action=iscsi_SimpleIscsiAdministration_createAction, nargs=nargs, metavar=metavars, help=help)
	class iscsi_SimpleIscsiAdministration_createResultAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiAdministration import SimpleIscsiAdministration
			service = SimpleIscsiAdministration()
			global function, interactive
			function = service.create_result
			interactive = []
			interactive.append(('async_job_id', cli_int))
	methods['iscsi.SimpleIscsiAdministration.create_result'] = ('iscsi_SimpleIscsiAdministration', '--create_result')
	metavars = () if interactive_mode else ('async_job_id')
	nargs = 0 if interactive_mode else 1
	iscsi_SimpleIscsiAdministration.add_argument("--create_result", action=iscsi_SimpleIscsiAdministration_createResultAction, nargs=nargs, metavar=metavars)
	class iscsi_SimpleIscsiAdministration_add_iqnAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiTarget import SimpleIscsiTarget

			from transformer.lib import ListInfo, ResultSet, Long
			checker = [cli_int,cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiAdministration import SimpleIscsiAdministration
			service = SimpleIscsiAdministration()
			global function, interactive
			function = service.add_iqn
			interactive = []
			interactive.append(('target_id', cli_int))
			interactive.append(('iqn', cli_unicode))
	methods['iscsi.SimpleIscsiAdministration.add_iqn'] = ('iscsi_SimpleIscsiAdministration', '--add_iqn')
	metavars = () if interactive_mode else ('target_id','iqn')
	help = '' if interactive_mode else '%s %s ' % ('int', 'text')
	nargs = 0 if interactive_mode else 2
	iscsi_SimpleIscsiAdministration.add_argument("--add_iqn", action=iscsi_SimpleIscsiAdministration_add_iqnAction, nargs=nargs, metavar=metavars, help=help)
	class iscsi_SimpleIscsiAdministration_modifyAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiTarget import SimpleIscsiTarget

			from transformer.lib import ListInfo, ResultSet, Long
			checker = [cli_int,SimpleIscsiTarget]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiAdministration import SimpleIscsiAdministration
			service = SimpleIscsiAdministration()
			global function, interactive
			function = service.modify
			interactive = []
			interactive.append(('id', cli_int))
			interactive.append(('isci', SimpleIscsiTarget))
	methods['iscsi.SimpleIscsiAdministration.modify'] = ('iscsi_SimpleIscsiAdministration', '--modify')
	metavars = () if interactive_mode else ('id','isci')
	help = '' if interactive_mode else '%s %s ' % ('int', '{"multiple_session":True|False,"name":text,"iqn_suffix":text,"data_digest":True|False,"header_digest":True|False,#"chap_user":{"login":text,#"password":text#,#"mutual_chap_user":{"login":text,#"password":text#}#}#,#"lun":{"kind":BLOCK_LEVEL|FILE_LEVEL,"description":text,"id":int}#,#"initiator_iqns":["text",...]#}')
	nargs = 0 if interactive_mode else 2
	iscsi_SimpleIscsiAdministration.add_argument("--modify", action=iscsi_SimpleIscsiAdministration_modifyAction, nargs=nargs, metavar=metavars, help=help)
	class iscsi_SimpleIscsiAdministration_cancel_export_lunAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiTarget import SimpleIscsiTarget

			from transformer.lib import ListInfo, ResultSet, Long
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiAdministration import SimpleIscsiAdministration
			service = SimpleIscsiAdministration()
			global function, interactive
			function = service.cancel_export_lun
			interactive = []
			interactive.append(('target_id', cli_int))
	methods['iscsi.SimpleIscsiAdministration.cancel_export_lun'] = ('iscsi_SimpleIscsiAdministration', '--cancel_export_lun')
	metavars = () if interactive_mode else ('target_id')
	help = '' if interactive_mode else '%s ' % ('int')
	nargs = 0 if interactive_mode else 1
	iscsi_SimpleIscsiAdministration.add_argument("--cancel_export_lun", action=iscsi_SimpleIscsiAdministration_cancel_export_lunAction, nargs=nargs, metavar=metavars, help=help)
	class iscsi_SimpleIscsiAdministration_cancel_duplicate_lunAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiTarget import SimpleIscsiTarget

			from transformer.lib import ListInfo, ResultSet, Long
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiAdministration import SimpleIscsiAdministration
			service = SimpleIscsiAdministration()
			global function, interactive
			function = service.cancel_duplicate_lun
			interactive = []
			interactive.append(('target_id', cli_int))
	methods['iscsi.SimpleIscsiAdministration.cancel_duplicate_lun'] = ('iscsi_SimpleIscsiAdministration', '--cancel_duplicate_lun')
	metavars = () if interactive_mode else ('target_id')
	help = '' if interactive_mode else '%s ' % ('int')
	nargs = 0 if interactive_mode else 1
	iscsi_SimpleIscsiAdministration.add_argument("--cancel_duplicate_lun", action=iscsi_SimpleIscsiAdministration_cancel_duplicate_lunAction, nargs=nargs, metavar=metavars, help=help)
	class iscsi_SimpleIscsiAdministration_export_lunAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiTarget import SimpleIscsiTarget

			from transformer.lib import ListInfo, ResultSet, Long
			checker = [cli_unicode,cli_int,cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiAdministration import SimpleIscsiAdministration
			service = SimpleIscsiAdministration()
			global function, interactive
			function = service.export_lun
			interactive = []
			interactive.append(('async_job_name', cli_unicode))
			interactive.append(('target_id', cli_int))
			interactive.append(('lun_dest_file', cli_unicode))
	methods['iscsi.SimpleIscsiAdministration.export_lun'] = ('iscsi_SimpleIscsiAdministration', '--export_lun')
	metavars = () if interactive_mode else ('async_job_name','target_id','lun_dest_file')
	help = '' if interactive_mode else '%s %s ' % ('int', 'text')
	nargs = 0 if interactive_mode else 3
	iscsi_SimpleIscsiAdministration.add_argument("--export_lun", action=iscsi_SimpleIscsiAdministration_export_lunAction, nargs=nargs, metavar=metavars, help=help)
	class iscsi_SimpleIscsiAdministration_export_lunResultAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiAdministration import SimpleIscsiAdministration
			service = SimpleIscsiAdministration()
			global function, interactive
			function = service.export_lun_result
			interactive = []
			interactive.append(('async_job_id', cli_int))
	methods['iscsi.SimpleIscsiAdministration.export_lun_result'] = ('iscsi_SimpleIscsiAdministration', '--export_lun_result')
	metavars = () if interactive_mode else ('async_job_id')
	nargs = 0 if interactive_mode else 1
	iscsi_SimpleIscsiAdministration.add_argument("--export_lun_result", action=iscsi_SimpleIscsiAdministration_export_lunResultAction, nargs=nargs, metavar=metavars)
	class iscsi_SimpleIscsiAdministration_duplicate_lunAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiTarget import SimpleIscsiTarget

			from transformer.lib import ListInfo, ResultSet, Long
			checker = [cli_unicode,cli_int,cli_int,cli_unicode,SimpleIscsiTarget]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiAdministration import SimpleIscsiAdministration
			service = SimpleIscsiAdministration()
			global function, interactive
			function = service.duplicate_lun
			interactive = []
			interactive.append(('async_job_name', cli_unicode))
			interactive.append(('volume_id', cli_int))
			interactive.append(('target_id', cli_int))
			interactive.append(('lun_description', cli_unicode))
			interactive.append(('iscsi', SimpleIscsiTarget))
	methods['iscsi.SimpleIscsiAdministration.duplicate_lun'] = ('iscsi_SimpleIscsiAdministration', '--duplicate_lun')
	metavars = () if interactive_mode else ('async_job_name','volume_id','target_id','lun_description','iscsi')
	help = '' if interactive_mode else '%s %s %s %s ' % ('int', 'int', 'text', '{"multiple_session":True|False,"name":text,"iqn_suffix":text,"data_digest":True|False,"header_digest":True|False,#"chap_user":{"login":text,#"password":text#,#"mutual_chap_user":{"login":text,#"password":text#}#}#,#"lun":{"kind":BLOCK_LEVEL|FILE_LEVEL,"description":text,"id":int}#,#"initiator_iqns":["text",...]#}')
	nargs = 0 if interactive_mode else 5
	iscsi_SimpleIscsiAdministration.add_argument("--duplicate_lun", action=iscsi_SimpleIscsiAdministration_duplicate_lunAction, nargs=nargs, metavar=metavars, help=help)
	class iscsi_SimpleIscsiAdministration_duplicate_lunResultAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiAdministration import SimpleIscsiAdministration
			service = SimpleIscsiAdministration()
			global function, interactive
			function = service.duplicate_lun_result
			interactive = []
			interactive.append(('async_job_id', cli_int))
	methods['iscsi.SimpleIscsiAdministration.duplicate_lun_result'] = ('iscsi_SimpleIscsiAdministration', '--duplicate_lun_result')
	metavars = () if interactive_mode else ('async_job_id')
	nargs = 0 if interactive_mode else 1
	iscsi_SimpleIscsiAdministration.add_argument("--duplicate_lun_result", action=iscsi_SimpleIscsiAdministration_duplicate_lunResultAction, nargs=nargs, metavar=metavars)
	class iscsi_SimpleIscsiAdministration_cancel_import_lunAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiTarget import SimpleIscsiTarget

			from transformer.lib import ListInfo, ResultSet, Long
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiAdministration import SimpleIscsiAdministration
			service = SimpleIscsiAdministration()
			global function, interactive
			function = service.cancel_import_lun
			interactive = []
			interactive.append(('target_id', cli_int))
	methods['iscsi.SimpleIscsiAdministration.cancel_import_lun'] = ('iscsi_SimpleIscsiAdministration', '--cancel_import_lun')
	metavars = () if interactive_mode else ('target_id')
	help = '' if interactive_mode else '%s ' % ('int')
	nargs = 0 if interactive_mode else 1
	iscsi_SimpleIscsiAdministration.add_argument("--cancel_import_lun", action=iscsi_SimpleIscsiAdministration_cancel_import_lunAction, nargs=nargs, metavar=metavars, help=help)
	class iscsi_SimpleIscsiAdministration_check_iqnAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiTarget import SimpleIscsiTarget

			from transformer.lib import ListInfo, ResultSet, Long
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiAdministration import SimpleIscsiAdministration
			service = SimpleIscsiAdministration()
			global function, interactive
			function = service.check_iqn
			interactive = []
			interactive.append(('iqn', cli_unicode))
	methods['iscsi.SimpleIscsiAdministration.check_iqn'] = ('iscsi_SimpleIscsiAdministration', '--check_iqn')
	metavars = () if interactive_mode else ('iqn')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 1
	iscsi_SimpleIscsiAdministration.add_argument("--check_iqn", action=iscsi_SimpleIscsiAdministration_check_iqnAction, nargs=nargs, metavar=metavars, help=help)
	class iscsi_SimpleIscsiAdministration_clear_errorAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiTarget import SimpleIscsiTarget

			from transformer.lib import ListInfo, ResultSet, Long
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiAdministration import SimpleIscsiAdministration
			service = SimpleIscsiAdministration()
			global function, interactive
			function = service.clear_error
			interactive = []
			interactive.append(('target_id', cli_int))
	methods['iscsi.SimpleIscsiAdministration.clear_error'] = ('iscsi_SimpleIscsiAdministration', '--clear_error')
	metavars = () if interactive_mode else ('target_id')
	help = '' if interactive_mode else '%s ' % ('int')
	nargs = 0 if interactive_mode else 1
	iscsi_SimpleIscsiAdministration.add_argument("--clear_error", action=iscsi_SimpleIscsiAdministration_clear_errorAction, nargs=nargs, metavar=metavars, help=help)
	class iscsi_SimpleIscsiAdministration_deleteAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiTarget import SimpleIscsiTarget

			from transformer.lib import ListInfo, ResultSet, Long
			checker = [cli_unicode,cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiAdministration import SimpleIscsiAdministration
			service = SimpleIscsiAdministration()
			global function, interactive
			function = service.delete
			interactive = []
			interactive.append(('async_job_name', cli_unicode))
			interactive.append(('id', cli_int))
	methods['iscsi.SimpleIscsiAdministration.delete'] = ('iscsi_SimpleIscsiAdministration', '--delete')
	metavars = () if interactive_mode else ('async_job_name','id')
	help = '' if interactive_mode else '%s ' % ('int')
	nargs = 0 if interactive_mode else 2
	iscsi_SimpleIscsiAdministration.add_argument("--delete", action=iscsi_SimpleIscsiAdministration_deleteAction, nargs=nargs, metavar=metavars, help=help)
	class iscsi_SimpleIscsiAdministration_deleteResultAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiAdministration import SimpleIscsiAdministration
			service = SimpleIscsiAdministration()
			global function, interactive
			function = service.delete_result
			interactive = []
			interactive.append(('async_job_id', cli_int))
	methods['iscsi.SimpleIscsiAdministration.delete_result'] = ('iscsi_SimpleIscsiAdministration', '--delete_result')
	metavars = () if interactive_mode else ('async_job_id')
	nargs = 0 if interactive_mode else 1
	iscsi_SimpleIscsiAdministration.add_argument("--delete_result", action=iscsi_SimpleIscsiAdministration_deleteResultAction, nargs=nargs, metavar=metavars)
	raid_RaidManagement = subparsers.add_parser('raid_RaidManagement', help="help raid.RaidManagement")
	class raid_RaidManagement_get_migration_planAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.raid.Pool import Pool
			from unicorn_api.v5.sv0.raid.Slot import Slot
			from unicorn_api.v5.sv0.raid.RaidLevelInfo import RaidLevelInfo
			from unicorn_api.v5.sv0.raid import RaidMode
			from unicorn_api.v5.sv0.raid import RaidLevel
			from unicorn_api.v5.sv0.raid import RedundancyLevel
			from unicorn_api.v5.sv0.raid import LvManagement
			from unicorn_api.v5.sv0.raid.LevelInfo import LevelInfo
			from unicorn_api.v5.sv0.raid.MigrationStatusInfo import MigrationStatusInfo
			from unicorn_api.v5.sv0.raid.AnyRaidSizeInfo import AnyRaidSizeInfo
			from unicorn_api.v5.sv0.raid.SlotInError import SlotInError

			from transformer.lib import List
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.raid.RaidManagement import RaidManagement
			service = RaidManagement()
			global function, interactive
			function = service.get_migration_plan
			interactive = []
			interactive.append(('pool_name', cli_unicode))
	methods['raid.RaidManagement.get_migration_plan'] = ('raid_RaidManagement', '--get_migration_plan')
	metavars = () if interactive_mode else ('pool_name')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 1
	raid_RaidManagement.add_argument("--get_migration_plan", action=raid_RaidManagement_get_migration_planAction, nargs=nargs, metavar=metavars, help=help)
	class raid_RaidManagement_create_poolAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.raid.Pool import Pool
			from unicorn_api.v5.sv0.raid.Slot import Slot
			from unicorn_api.v5.sv0.raid.RaidLevelInfo import RaidLevelInfo
			from unicorn_api.v5.sv0.raid import RaidMode
			from unicorn_api.v5.sv0.raid import RaidLevel
			from unicorn_api.v5.sv0.raid import RedundancyLevel
			from unicorn_api.v5.sv0.raid import LvManagement
			from unicorn_api.v5.sv0.raid.LevelInfo import LevelInfo
			from unicorn_api.v5.sv0.raid.MigrationStatusInfo import MigrationStatusInfo
			from unicorn_api.v5.sv0.raid.AnyRaidSizeInfo import AnyRaidSizeInfo
			from unicorn_api.v5.sv0.raid.SlotInError import SlotInError

			from transformer.lib import List
			checker = [cli_unicode,list_cli(int),RaidMode,RaidLevel,RedundancyLevel,LvManagement]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.raid.RaidManagement import RaidManagement
			service = RaidManagement()
			global function, interactive
			function = service.create_pool
			interactive = []
			interactive.append(('async_job_name', cli_unicode))
			interactive.append(('list_of_slots', list_cli(int)))
			interactive.append(('raid_mode', RaidMode))
			interactive.append(('raid_level', RaidLevel))
			interactive.append(('redundancy_level', RedundancyLevel))
			interactive.append(('lv_management', LvManagement))
	methods['raid.RaidManagement.create_pool'] = ('raid_RaidManagement', '--create_pool')
	metavars = () if interactive_mode else ('async_job_name','list_of_slots','raid_mode','raid_level','redundancy_level','lv_management')
	help = '' if interactive_mode else '%s %s %s %s %s ' % ('["int",...]', 'MANUAL|OPTIMUM', 'LINEAR|RAID5|RAID6|RAID1|RAID0|RAID10', 'NONE|TWO|ONE', 'MANUAL|AUTO')
	nargs = 0 if interactive_mode else 6
	raid_RaidManagement.add_argument("--create_pool", action=raid_RaidManagement_create_poolAction, nargs=nargs, metavar=metavars, help=help)
	class raid_RaidManagement_create_poolResultAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.raid.RaidManagement import RaidManagement
			service = RaidManagement()
			global function, interactive
			function = service.create_pool_result
			interactive = []
			interactive.append(('async_job_id', cli_int))
	methods['raid.RaidManagement.create_pool_result'] = ('raid_RaidManagement', '--create_pool_result')
	metavars = () if interactive_mode else ('async_job_id')
	nargs = 0 if interactive_mode else 1
	raid_RaidManagement.add_argument("--create_pool_result", action=raid_RaidManagement_create_poolResultAction, nargs=nargs, metavar=metavars)
	class raid_RaidManagement_list_subsitute_slotsAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.raid.Pool import Pool
			from unicorn_api.v5.sv0.raid.Slot import Slot
			from unicorn_api.v5.sv0.raid.RaidLevelInfo import RaidLevelInfo
			from unicorn_api.v5.sv0.raid import RaidMode
			from unicorn_api.v5.sv0.raid import RaidLevel
			from unicorn_api.v5.sv0.raid import RedundancyLevel
			from unicorn_api.v5.sv0.raid import LvManagement
			from unicorn_api.v5.sv0.raid.LevelInfo import LevelInfo
			from unicorn_api.v5.sv0.raid.MigrationStatusInfo import MigrationStatusInfo
			from unicorn_api.v5.sv0.raid.AnyRaidSizeInfo import AnyRaidSizeInfo
			from unicorn_api.v5.sv0.raid.SlotInError import SlotInError

			from transformer.lib import List
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.raid.RaidManagement import RaidManagement
			service = RaidManagement()
			global function, interactive
			function = service.list_subsitute_slots
			interactive = []
			interactive.append(('pool_name', cli_unicode))
	methods['raid.RaidManagement.list_subsitute_slots'] = ('raid_RaidManagement', '--list_subsitute_slots')
	metavars = () if interactive_mode else ('pool_name')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 1
	raid_RaidManagement.add_argument("--list_subsitute_slots", action=raid_RaidManagement_list_subsitute_slotsAction, nargs=nargs, metavar=metavars, help=help)
	class raid_RaidManagement_destroy_poolAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.raid.Pool import Pool
			from unicorn_api.v5.sv0.raid.Slot import Slot
			from unicorn_api.v5.sv0.raid.RaidLevelInfo import RaidLevelInfo
			from unicorn_api.v5.sv0.raid import RaidMode
			from unicorn_api.v5.sv0.raid import RaidLevel
			from unicorn_api.v5.sv0.raid import RedundancyLevel
			from unicorn_api.v5.sv0.raid import LvManagement
			from unicorn_api.v5.sv0.raid.LevelInfo import LevelInfo
			from unicorn_api.v5.sv0.raid.MigrationStatusInfo import MigrationStatusInfo
			from unicorn_api.v5.sv0.raid.AnyRaidSizeInfo import AnyRaidSizeInfo
			from unicorn_api.v5.sv0.raid.SlotInError import SlotInError

			from transformer.lib import List
			checker = [cli_unicode,cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.raid.RaidManagement import RaidManagement
			service = RaidManagement()
			global function, interactive
			function = service.destroy_pool
			interactive = []
			interactive.append(('async_job_name', cli_unicode))
			interactive.append(('pool_name', cli_unicode))
	methods['raid.RaidManagement.destroy_pool'] = ('raid_RaidManagement', '--destroy_pool')
	metavars = () if interactive_mode else ('async_job_name','pool_name')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 2
	raid_RaidManagement.add_argument("--destroy_pool", action=raid_RaidManagement_destroy_poolAction, nargs=nargs, metavar=metavars, help=help)
	class raid_RaidManagement_destroy_poolResultAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.raid.RaidManagement import RaidManagement
			service = RaidManagement()
			global function, interactive
			function = service.destroy_pool_result
			interactive = []
			interactive.append(('async_job_id', cli_int))
	methods['raid.RaidManagement.destroy_pool_result'] = ('raid_RaidManagement', '--destroy_pool_result')
	metavars = () if interactive_mode else ('async_job_id')
	nargs = 0 if interactive_mode else 1
	raid_RaidManagement.add_argument("--destroy_pool_result", action=raid_RaidManagement_destroy_poolResultAction, nargs=nargs, metavar=metavars)
	class raid_RaidManagement_change_modeAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.raid.Pool import Pool
			from unicorn_api.v5.sv0.raid.Slot import Slot
			from unicorn_api.v5.sv0.raid.RaidLevelInfo import RaidLevelInfo
			from unicorn_api.v5.sv0.raid import RaidMode
			from unicorn_api.v5.sv0.raid import RaidLevel
			from unicorn_api.v5.sv0.raid import RedundancyLevel
			from unicorn_api.v5.sv0.raid import LvManagement
			from unicorn_api.v5.sv0.raid.LevelInfo import LevelInfo
			from unicorn_api.v5.sv0.raid.MigrationStatusInfo import MigrationStatusInfo
			from unicorn_api.v5.sv0.raid.AnyRaidSizeInfo import AnyRaidSizeInfo
			from unicorn_api.v5.sv0.raid.SlotInError import SlotInError

			from transformer.lib import List
			checker = [cli_unicode,cli_unicode,LevelInfo]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.raid.RaidManagement import RaidManagement
			service = RaidManagement()
			global function, interactive
			function = service.change_mode
			interactive = []
			interactive.append(('async_job_name', cli_unicode))
			interactive.append(('pool_name', cli_unicode))
			interactive.append(('future_mode', LevelInfo))
	methods['raid.RaidManagement.change_mode'] = ('raid_RaidManagement', '--change_mode')
	metavars = () if interactive_mode else ('async_job_name','pool_name','future_mode')
	help = '' if interactive_mode else '%s %s ' % ('text', '{"mode":MANUAL|OPTIMUM,#"redundancy":NONE|TWO|ONE#,#"level":LINEAR|RAID5|RAID6|RAID1|RAID0|RAID10#}')
	nargs = 0 if interactive_mode else 3
	raid_RaidManagement.add_argument("--change_mode", action=raid_RaidManagement_change_modeAction, nargs=nargs, metavar=metavars, help=help)
	class raid_RaidManagement_change_modeResultAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.raid.RaidManagement import RaidManagement
			service = RaidManagement()
			global function, interactive
			function = service.change_mode_result
			interactive = []
			interactive.append(('async_job_id', cli_int))
	methods['raid.RaidManagement.change_mode_result'] = ('raid_RaidManagement', '--change_mode_result')
	metavars = () if interactive_mode else ('async_job_id')
	nargs = 0 if interactive_mode else 1
	raid_RaidManagement.add_argument("--change_mode_result", action=raid_RaidManagement_change_modeResultAction, nargs=nargs, metavar=metavars)
	class raid_RaidManagement_add_sparesAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.raid.Pool import Pool
			from unicorn_api.v5.sv0.raid.Slot import Slot
			from unicorn_api.v5.sv0.raid.RaidLevelInfo import RaidLevelInfo
			from unicorn_api.v5.sv0.raid import RaidMode
			from unicorn_api.v5.sv0.raid import RaidLevel
			from unicorn_api.v5.sv0.raid import RedundancyLevel
			from unicorn_api.v5.sv0.raid import LvManagement
			from unicorn_api.v5.sv0.raid.LevelInfo import LevelInfo
			from unicorn_api.v5.sv0.raid.MigrationStatusInfo import MigrationStatusInfo
			from unicorn_api.v5.sv0.raid.AnyRaidSizeInfo import AnyRaidSizeInfo
			from unicorn_api.v5.sv0.raid.SlotInError import SlotInError

			from transformer.lib import List
			checker = [cli_unicode,cli_unicode,list_cli(int)]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.raid.RaidManagement import RaidManagement
			service = RaidManagement()
			global function, interactive
			function = service.add_spares
			interactive = []
			interactive.append(('async_job_name', cli_unicode))
			interactive.append(('pool_name', cli_unicode))
			interactive.append(('slots_indexes', list_cli(int)))
	methods['raid.RaidManagement.add_spares'] = ('raid_RaidManagement', '--add_spares')
	metavars = () if interactive_mode else ('async_job_name','pool_name','slots_indexes')
	help = '' if interactive_mode else '%s %s ' % ('text', '["int",...]')
	nargs = 0 if interactive_mode else 3
	raid_RaidManagement.add_argument("--add_spares", action=raid_RaidManagement_add_sparesAction, nargs=nargs, metavar=metavars, help=help)
	class raid_RaidManagement_add_sparesResultAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.raid.RaidManagement import RaidManagement
			service = RaidManagement()
			global function, interactive
			function = service.add_spares_result
			interactive = []
			interactive.append(('async_job_id', cli_int))
	methods['raid.RaidManagement.add_spares_result'] = ('raid_RaidManagement', '--add_spares_result')
	metavars = () if interactive_mode else ('async_job_id')
	nargs = 0 if interactive_mode else 1
	raid_RaidManagement.add_argument("--add_spares_result", action=raid_RaidManagement_add_sparesResultAction, nargs=nargs, metavar=metavars)
	class raid_RaidManagement_compute_raid_sizesAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.raid.Pool import Pool
			from unicorn_api.v5.sv0.raid.Slot import Slot
			from unicorn_api.v5.sv0.raid.RaidLevelInfo import RaidLevelInfo
			from unicorn_api.v5.sv0.raid import RaidMode
			from unicorn_api.v5.sv0.raid import RaidLevel
			from unicorn_api.v5.sv0.raid import RedundancyLevel
			from unicorn_api.v5.sv0.raid import LvManagement
			from unicorn_api.v5.sv0.raid.LevelInfo import LevelInfo
			from unicorn_api.v5.sv0.raid.MigrationStatusInfo import MigrationStatusInfo
			from unicorn_api.v5.sv0.raid.AnyRaidSizeInfo import AnyRaidSizeInfo
			from unicorn_api.v5.sv0.raid.SlotInError import SlotInError

			from transformer.lib import List
			checker = [LevelInfo,list_cli(int)]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.raid.RaidManagement import RaidManagement
			service = RaidManagement()
			global function, interactive
			function = service.compute_raid_sizes
			interactive = []
			interactive.append(('level_info', LevelInfo))
			interactive.append(('slots', list_cli(int)))
	methods['raid.RaidManagement.compute_raid_sizes'] = ('raid_RaidManagement', '--compute_raid_sizes')
	metavars = () if interactive_mode else ('level_info','slots')
	help = '' if interactive_mode else '%s %s ' % ('{"mode":MANUAL|OPTIMUM,#"redundancy":NONE|TWO|ONE#,#"level":LINEAR|RAID5|RAID6|RAID1|RAID0|RAID10#}', '["int",...]')
	nargs = 0 if interactive_mode else 2
	raid_RaidManagement.add_argument("--compute_raid_sizes", action=raid_RaidManagement_compute_raid_sizesAction, nargs=nargs, metavar=metavars, help=help)
	class raid_RaidManagement_list_slotsAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.raid.Pool import Pool
			from unicorn_api.v5.sv0.raid.Slot import Slot
			from unicorn_api.v5.sv0.raid.RaidLevelInfo import RaidLevelInfo
			from unicorn_api.v5.sv0.raid import RaidMode
			from unicorn_api.v5.sv0.raid import RaidLevel
			from unicorn_api.v5.sv0.raid import RedundancyLevel
			from unicorn_api.v5.sv0.raid import LvManagement
			from unicorn_api.v5.sv0.raid.LevelInfo import LevelInfo
			from unicorn_api.v5.sv0.raid.MigrationStatusInfo import MigrationStatusInfo
			from unicorn_api.v5.sv0.raid.AnyRaidSizeInfo import AnyRaidSizeInfo
			from unicorn_api.v5.sv0.raid.SlotInError import SlotInError

			from transformer.lib import List
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.raid.RaidManagement import RaidManagement
			service = RaidManagement()
			global function, interactive
			function = service.list_slots
			interactive = []
	methods['raid.RaidManagement.list_slots'] = ('raid_RaidManagement', '--list_slots')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	raid_RaidManagement.add_argument("--list_slots", action=raid_RaidManagement_list_slotsAction, nargs=nargs, metavar=metavars, help=help)
	class raid_RaidManagement_get_pool_propertyAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.raid.Pool import Pool
			from unicorn_api.v5.sv0.raid.Slot import Slot
			from unicorn_api.v5.sv0.raid.RaidLevelInfo import RaidLevelInfo
			from unicorn_api.v5.sv0.raid import RaidMode
			from unicorn_api.v5.sv0.raid import RaidLevel
			from unicorn_api.v5.sv0.raid import RedundancyLevel
			from unicorn_api.v5.sv0.raid import LvManagement
			from unicorn_api.v5.sv0.raid.LevelInfo import LevelInfo
			from unicorn_api.v5.sv0.raid.MigrationStatusInfo import MigrationStatusInfo
			from unicorn_api.v5.sv0.raid.AnyRaidSizeInfo import AnyRaidSizeInfo
			from unicorn_api.v5.sv0.raid.SlotInError import SlotInError

			from transformer.lib import List
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.raid.RaidManagement import RaidManagement
			service = RaidManagement()
			global function, interactive
			function = service.get_pool_property
			interactive = []
			interactive.append(('pool_name', cli_unicode))
	methods['raid.RaidManagement.get_pool_property'] = ('raid_RaidManagement', '--get_pool_property')
	metavars = () if interactive_mode else ('pool_name')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 1
	raid_RaidManagement.add_argument("--get_pool_property", action=raid_RaidManagement_get_pool_propertyAction, nargs=nargs, metavar=metavars, help=help)
	class raid_RaidManagement_is_small_driveAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.raid.Pool import Pool
			from unicorn_api.v5.sv0.raid.Slot import Slot
			from unicorn_api.v5.sv0.raid.RaidLevelInfo import RaidLevelInfo
			from unicorn_api.v5.sv0.raid import RaidMode
			from unicorn_api.v5.sv0.raid import RaidLevel
			from unicorn_api.v5.sv0.raid import RedundancyLevel
			from unicorn_api.v5.sv0.raid import LvManagement
			from unicorn_api.v5.sv0.raid.LevelInfo import LevelInfo
			from unicorn_api.v5.sv0.raid.MigrationStatusInfo import MigrationStatusInfo
			from unicorn_api.v5.sv0.raid.AnyRaidSizeInfo import AnyRaidSizeInfo
			from unicorn_api.v5.sv0.raid.SlotInError import SlotInError

			from transformer.lib import List
			checker = [cli_int,cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.raid.RaidManagement import RaidManagement
			service = RaidManagement()
			global function, interactive
			function = service.is_small_drive
			interactive = []
			interactive.append(('index', cli_int))
			interactive.append(('pool_name', cli_unicode))
	methods['raid.RaidManagement.is_small_drive'] = ('raid_RaidManagement', '--is_small_drive')
	metavars = () if interactive_mode else ('index','pool_name')
	help = '' if interactive_mode else '%s %s ' % ('int', 'text')
	nargs = 0 if interactive_mode else 2
	raid_RaidManagement.add_argument("--is_small_drive", action=raid_RaidManagement_is_small_driveAction, nargs=nargs, metavar=metavars, help=help)
	class raid_RaidManagement_clear_migration_planAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.raid.Pool import Pool
			from unicorn_api.v5.sv0.raid.Slot import Slot
			from unicorn_api.v5.sv0.raid.RaidLevelInfo import RaidLevelInfo
			from unicorn_api.v5.sv0.raid import RaidMode
			from unicorn_api.v5.sv0.raid import RaidLevel
			from unicorn_api.v5.sv0.raid import RedundancyLevel
			from unicorn_api.v5.sv0.raid import LvManagement
			from unicorn_api.v5.sv0.raid.LevelInfo import LevelInfo
			from unicorn_api.v5.sv0.raid.MigrationStatusInfo import MigrationStatusInfo
			from unicorn_api.v5.sv0.raid.AnyRaidSizeInfo import AnyRaidSizeInfo
			from unicorn_api.v5.sv0.raid.SlotInError import SlotInError

			from transformer.lib import List
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.raid.RaidManagement import RaidManagement
			service = RaidManagement()
			global function, interactive
			function = service.clear_migration_plan
			interactive = []
			interactive.append(('pool_name', cli_unicode))
	methods['raid.RaidManagement.clear_migration_plan'] = ('raid_RaidManagement', '--clear_migration_plan')
	metavars = () if interactive_mode else ('pool_name')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 1
	raid_RaidManagement.add_argument("--clear_migration_plan", action=raid_RaidManagement_clear_migration_planAction, nargs=nargs, metavar=metavars, help=help)
	class raid_RaidManagement_list_raid_levelsAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.raid.Pool import Pool
			from unicorn_api.v5.sv0.raid.Slot import Slot
			from unicorn_api.v5.sv0.raid.RaidLevelInfo import RaidLevelInfo
			from unicorn_api.v5.sv0.raid import RaidMode
			from unicorn_api.v5.sv0.raid import RaidLevel
			from unicorn_api.v5.sv0.raid import RedundancyLevel
			from unicorn_api.v5.sv0.raid import LvManagement
			from unicorn_api.v5.sv0.raid.LevelInfo import LevelInfo
			from unicorn_api.v5.sv0.raid.MigrationStatusInfo import MigrationStatusInfo
			from unicorn_api.v5.sv0.raid.AnyRaidSizeInfo import AnyRaidSizeInfo
			from unicorn_api.v5.sv0.raid.SlotInError import SlotInError

			from transformer.lib import List
			checker = [list_cli(int)]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.raid.RaidManagement import RaidManagement
			service = RaidManagement()
			global function, interactive
			function = service.list_raid_levels
			interactive = []
			interactive.append(('slots', list_cli(int)))
	methods['raid.RaidManagement.list_raid_levels'] = ('raid_RaidManagement', '--list_raid_levels')
	metavars = () if interactive_mode else ('slots')
	help = '' if interactive_mode else '%s ' % ('["int",...]')
	nargs = 0 if interactive_mode else 1
	raid_RaidManagement.add_argument("--list_raid_levels", action=raid_RaidManagement_list_raid_levelsAction, nargs=nargs, metavar=metavars, help=help)
	class raid_RaidManagement_change_volume_managementAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.raid.Pool import Pool
			from unicorn_api.v5.sv0.raid.Slot import Slot
			from unicorn_api.v5.sv0.raid.RaidLevelInfo import RaidLevelInfo
			from unicorn_api.v5.sv0.raid import RaidMode
			from unicorn_api.v5.sv0.raid import RaidLevel
			from unicorn_api.v5.sv0.raid import RedundancyLevel
			from unicorn_api.v5.sv0.raid import LvManagement
			from unicorn_api.v5.sv0.raid.LevelInfo import LevelInfo
			from unicorn_api.v5.sv0.raid.MigrationStatusInfo import MigrationStatusInfo
			from unicorn_api.v5.sv0.raid.AnyRaidSizeInfo import AnyRaidSizeInfo
			from unicorn_api.v5.sv0.raid.SlotInError import SlotInError

			from transformer.lib import List
			checker = [cli_unicode,LvManagement]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.raid.RaidManagement import RaidManagement
			service = RaidManagement()
			global function, interactive
			function = service.change_volume_management
			interactive = []
			interactive.append(('pool_name', cli_unicode))
			interactive.append(('management', LvManagement))
	methods['raid.RaidManagement.change_volume_management'] = ('raid_RaidManagement', '--change_volume_management')
	metavars = () if interactive_mode else ('pool_name','management')
	help = '' if interactive_mode else '%s %s ' % ('text', 'MANUAL|AUTO')
	nargs = 0 if interactive_mode else 2
	raid_RaidManagement.add_argument("--change_volume_management", action=raid_RaidManagement_change_volume_managementAction, nargs=nargs, metavar=metavars, help=help)
	class raid_RaidManagement_list_poolsAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.raid.Pool import Pool
			from unicorn_api.v5.sv0.raid.Slot import Slot
			from unicorn_api.v5.sv0.raid.RaidLevelInfo import RaidLevelInfo
			from unicorn_api.v5.sv0.raid import RaidMode
			from unicorn_api.v5.sv0.raid import RaidLevel
			from unicorn_api.v5.sv0.raid import RedundancyLevel
			from unicorn_api.v5.sv0.raid import LvManagement
			from unicorn_api.v5.sv0.raid.LevelInfo import LevelInfo
			from unicorn_api.v5.sv0.raid.MigrationStatusInfo import MigrationStatusInfo
			from unicorn_api.v5.sv0.raid.AnyRaidSizeInfo import AnyRaidSizeInfo
			from unicorn_api.v5.sv0.raid.SlotInError import SlotInError

			from transformer.lib import List
			checker = [list_cli(unicode)]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.raid.RaidManagement import RaidManagement
			service = RaidManagement()
			global function, interactive
			function = service.list_pools
			interactive = []
			interactive.append(('with_parameters', list_cli(unicode)))
	methods['raid.RaidManagement.list_pools'] = ('raid_RaidManagement', '--list_pools')
	metavars = () if interactive_mode else ('with_parameters')
	help = '' if interactive_mode else '%s ' % ('["text",...]')
	nargs = 0 if interactive_mode else 1
	raid_RaidManagement.add_argument("--list_pools", action=raid_RaidManagement_list_poolsAction, nargs=nargs, metavar=metavars, help=help)
	class raid_RaidManagement_configuration_pool_checkerAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.raid.Pool import Pool
			from unicorn_api.v5.sv0.raid.Slot import Slot
			from unicorn_api.v5.sv0.raid.RaidLevelInfo import RaidLevelInfo
			from unicorn_api.v5.sv0.raid import RaidMode
			from unicorn_api.v5.sv0.raid import RaidLevel
			from unicorn_api.v5.sv0.raid import RedundancyLevel
			from unicorn_api.v5.sv0.raid import LvManagement
			from unicorn_api.v5.sv0.raid.LevelInfo import LevelInfo
			from unicorn_api.v5.sv0.raid.MigrationStatusInfo import MigrationStatusInfo
			from unicorn_api.v5.sv0.raid.AnyRaidSizeInfo import AnyRaidSizeInfo
			from unicorn_api.v5.sv0.raid.SlotInError import SlotInError

			from transformer.lib import List
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.raid.RaidManagement import RaidManagement
			service = RaidManagement()
			global function, interactive
			function = service.configuration_pool_checker
			interactive = []
			interactive.append(('pool_name', cli_unicode))
	methods['raid.RaidManagement.configuration_pool_checker'] = ('raid_RaidManagement', '--configuration_pool_checker')
	metavars = () if interactive_mode else ('pool_name')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 1
	raid_RaidManagement.add_argument("--configuration_pool_checker", action=raid_RaidManagement_configuration_pool_checkerAction, nargs=nargs, metavar=metavars, help=help)
	class raid_RaidManagement_can_expandAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.raid.Pool import Pool
			from unicorn_api.v5.sv0.raid.Slot import Slot
			from unicorn_api.v5.sv0.raid.RaidLevelInfo import RaidLevelInfo
			from unicorn_api.v5.sv0.raid import RaidMode
			from unicorn_api.v5.sv0.raid import RaidLevel
			from unicorn_api.v5.sv0.raid import RedundancyLevel
			from unicorn_api.v5.sv0.raid import LvManagement
			from unicorn_api.v5.sv0.raid.LevelInfo import LevelInfo
			from unicorn_api.v5.sv0.raid.MigrationStatusInfo import MigrationStatusInfo
			from unicorn_api.v5.sv0.raid.AnyRaidSizeInfo import AnyRaidSizeInfo
			from unicorn_api.v5.sv0.raid.SlotInError import SlotInError

			from transformer.lib import List
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.raid.RaidManagement import RaidManagement
			service = RaidManagement()
			global function, interactive
			function = service.can_expand
			interactive = []
			interactive.append(('pool_name', cli_unicode))
	methods['raid.RaidManagement.can_expand'] = ('raid_RaidManagement', '--can_expand')
	metavars = () if interactive_mode else ('pool_name')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 1
	raid_RaidManagement.add_argument("--can_expand", action=raid_RaidManagement_can_expandAction, nargs=nargs, metavar=metavars, help=help)
	class raid_RaidManagement_migrate_poolAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.raid.Pool import Pool
			from unicorn_api.v5.sv0.raid.Slot import Slot
			from unicorn_api.v5.sv0.raid.RaidLevelInfo import RaidLevelInfo
			from unicorn_api.v5.sv0.raid import RaidMode
			from unicorn_api.v5.sv0.raid import RaidLevel
			from unicorn_api.v5.sv0.raid import RedundancyLevel
			from unicorn_api.v5.sv0.raid import LvManagement
			from unicorn_api.v5.sv0.raid.LevelInfo import LevelInfo
			from unicorn_api.v5.sv0.raid.MigrationStatusInfo import MigrationStatusInfo
			from unicorn_api.v5.sv0.raid.AnyRaidSizeInfo import AnyRaidSizeInfo
			from unicorn_api.v5.sv0.raid.SlotInError import SlotInError

			from transformer.lib import List
			checker = [cli_unicode,cli_unicode,list_cli(int),RaidMode,RaidLevel,RedundancyLevel]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.raid.RaidManagement import RaidManagement
			service = RaidManagement()
			global function, interactive
			function = service.migrate_pool
			interactive = []
			interactive.append(('async_job_name', cli_unicode))
			interactive.append(('pool_name', cli_unicode))
			interactive.append(('slots', list_cli(int)))
			interactive.append(('raid_mode', RaidMode))
			interactive.append(('raid_level', RaidLevel))
			interactive.append(('redundancy_level', RedundancyLevel))
	methods['raid.RaidManagement.migrate_pool'] = ('raid_RaidManagement', '--migrate_pool')
	metavars = () if interactive_mode else ('async_job_name','pool_name','slots','raid_mode','raid_level','redundancy_level')
	help = '' if interactive_mode else '%s %s %s %s %s ' % ('text', '["int",...]', 'MANUAL|OPTIMUM', 'LINEAR|RAID5|RAID6|RAID1|RAID0|RAID10', 'NONE|TWO|ONE')
	nargs = 0 if interactive_mode else 6
	raid_RaidManagement.add_argument("--migrate_pool", action=raid_RaidManagement_migrate_poolAction, nargs=nargs, metavar=metavars, help=help)
	class raid_RaidManagement_migrate_poolResultAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.raid.RaidManagement import RaidManagement
			service = RaidManagement()
			global function, interactive
			function = service.migrate_pool_result
			interactive = []
			interactive.append(('async_job_id', cli_int))
	methods['raid.RaidManagement.migrate_pool_result'] = ('raid_RaidManagement', '--migrate_pool_result')
	metavars = () if interactive_mode else ('async_job_id')
	nargs = 0 if interactive_mode else 1
	raid_RaidManagement.add_argument("--migrate_pool_result", action=raid_RaidManagement_migrate_poolResultAction, nargs=nargs, metavar=metavars)
	class raid_RaidManagement_maintenance_optimum_modeAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.raid.Pool import Pool
			from unicorn_api.v5.sv0.raid.Slot import Slot
			from unicorn_api.v5.sv0.raid.RaidLevelInfo import RaidLevelInfo
			from unicorn_api.v5.sv0.raid import RaidMode
			from unicorn_api.v5.sv0.raid import RaidLevel
			from unicorn_api.v5.sv0.raid import RedundancyLevel
			from unicorn_api.v5.sv0.raid import LvManagement
			from unicorn_api.v5.sv0.raid.LevelInfo import LevelInfo
			from unicorn_api.v5.sv0.raid.MigrationStatusInfo import MigrationStatusInfo
			from unicorn_api.v5.sv0.raid.AnyRaidSizeInfo import AnyRaidSizeInfo
			from unicorn_api.v5.sv0.raid.SlotInError import SlotInError

			from transformer.lib import List
			checker = [cli_unicode,cli_unicode,cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.raid.RaidManagement import RaidManagement
			service = RaidManagement()
			global function, interactive
			function = service.maintenance_optimum_mode
			interactive = []
			interactive.append(('async_job_name', cli_unicode))
			interactive.append(('pool_name', cli_unicode))
			interactive.append(('index', cli_int))
	methods['raid.RaidManagement.maintenance_optimum_mode'] = ('raid_RaidManagement', '--maintenance_optimum_mode')
	metavars = () if interactive_mode else ('async_job_name','pool_name','index')
	help = '' if interactive_mode else '%s %s ' % ('text', 'int')
	nargs = 0 if interactive_mode else 3
	raid_RaidManagement.add_argument("--maintenance_optimum_mode", action=raid_RaidManagement_maintenance_optimum_modeAction, nargs=nargs, metavar=metavars, help=help)
	class raid_RaidManagement_maintenance_optimum_modeResultAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.raid.RaidManagement import RaidManagement
			service = RaidManagement()
			global function, interactive
			function = service.maintenance_optimum_mode_result
			interactive = []
			interactive.append(('async_job_id', cli_int))
	methods['raid.RaidManagement.maintenance_optimum_mode_result'] = ('raid_RaidManagement', '--maintenance_optimum_mode_result')
	metavars = () if interactive_mode else ('async_job_id')
	nargs = 0 if interactive_mode else 1
	raid_RaidManagement.add_argument("--maintenance_optimum_mode_result", action=raid_RaidManagement_maintenance_optimum_modeResultAction, nargs=nargs, metavar=metavars)
	class raid_RaidManagement_can_change_modeAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.raid.Pool import Pool
			from unicorn_api.v5.sv0.raid.Slot import Slot
			from unicorn_api.v5.sv0.raid.RaidLevelInfo import RaidLevelInfo
			from unicorn_api.v5.sv0.raid import RaidMode
			from unicorn_api.v5.sv0.raid import RaidLevel
			from unicorn_api.v5.sv0.raid import RedundancyLevel
			from unicorn_api.v5.sv0.raid import LvManagement
			from unicorn_api.v5.sv0.raid.LevelInfo import LevelInfo
			from unicorn_api.v5.sv0.raid.MigrationStatusInfo import MigrationStatusInfo
			from unicorn_api.v5.sv0.raid.AnyRaidSizeInfo import AnyRaidSizeInfo
			from unicorn_api.v5.sv0.raid.SlotInError import SlotInError

			from transformer.lib import List
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.raid.RaidManagement import RaidManagement
			service = RaidManagement()
			global function, interactive
			function = service.can_change_mode
			interactive = []
			interactive.append(('pool_name', cli_unicode))
	methods['raid.RaidManagement.can_change_mode'] = ('raid_RaidManagement', '--can_change_mode')
	metavars = () if interactive_mode else ('pool_name')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 1
	raid_RaidManagement.add_argument("--can_change_mode", action=raid_RaidManagement_can_change_modeAction, nargs=nargs, metavar=metavars, help=help)
	class raid_RaidManagement_can_add_sparesAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.raid.Pool import Pool
			from unicorn_api.v5.sv0.raid.Slot import Slot
			from unicorn_api.v5.sv0.raid.RaidLevelInfo import RaidLevelInfo
			from unicorn_api.v5.sv0.raid import RaidMode
			from unicorn_api.v5.sv0.raid import RaidLevel
			from unicorn_api.v5.sv0.raid import RedundancyLevel
			from unicorn_api.v5.sv0.raid import LvManagement
			from unicorn_api.v5.sv0.raid.LevelInfo import LevelInfo
			from unicorn_api.v5.sv0.raid.MigrationStatusInfo import MigrationStatusInfo
			from unicorn_api.v5.sv0.raid.AnyRaidSizeInfo import AnyRaidSizeInfo
			from unicorn_api.v5.sv0.raid.SlotInError import SlotInError

			from transformer.lib import List
			checker = [cli_unicode,list_cli(int)]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.raid.RaidManagement import RaidManagement
			service = RaidManagement()
			global function, interactive
			function = service.can_add_spares
			interactive = []
			interactive.append(('pool_name', cli_unicode))
			interactive.append(('slots_list', list_cli(int)))
	methods['raid.RaidManagement.can_add_spares'] = ('raid_RaidManagement', '--can_add_spares')
	metavars = () if interactive_mode else ('pool_name','slots_list')
	help = '' if interactive_mode else '%s %s ' % ('text', '["int",...]')
	nargs = 0 if interactive_mode else 2
	raid_RaidManagement.add_argument("--can_add_spares", action=raid_RaidManagement_can_add_sparesAction, nargs=nargs, metavar=metavars, help=help)
	class raid_RaidManagement_expandAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.raid.Pool import Pool
			from unicorn_api.v5.sv0.raid.Slot import Slot
			from unicorn_api.v5.sv0.raid.RaidLevelInfo import RaidLevelInfo
			from unicorn_api.v5.sv0.raid import RaidMode
			from unicorn_api.v5.sv0.raid import RaidLevel
			from unicorn_api.v5.sv0.raid import RedundancyLevel
			from unicorn_api.v5.sv0.raid import LvManagement
			from unicorn_api.v5.sv0.raid.LevelInfo import LevelInfo
			from unicorn_api.v5.sv0.raid.MigrationStatusInfo import MigrationStatusInfo
			from unicorn_api.v5.sv0.raid.AnyRaidSizeInfo import AnyRaidSizeInfo
			from unicorn_api.v5.sv0.raid.SlotInError import SlotInError

			from transformer.lib import List
			checker = [cli_unicode,cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.raid.RaidManagement import RaidManagement
			service = RaidManagement()
			global function, interactive
			function = service.expand
			interactive = []
			interactive.append(('async_job_name', cli_unicode))
			interactive.append(('pool_name', cli_unicode))
	methods['raid.RaidManagement.expand'] = ('raid_RaidManagement', '--expand')
	metavars = () if interactive_mode else ('async_job_name','pool_name')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 2
	raid_RaidManagement.add_argument("--expand", action=raid_RaidManagement_expandAction, nargs=nargs, metavar=metavars, help=help)
	class raid_RaidManagement_expandResultAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.raid.RaidManagement import RaidManagement
			service = RaidManagement()
			global function, interactive
			function = service.expand_result
			interactive = []
			interactive.append(('async_job_id', cli_int))
	methods['raid.RaidManagement.expand_result'] = ('raid_RaidManagement', '--expand_result')
	metavars = () if interactive_mode else ('async_job_id')
	nargs = 0 if interactive_mode else 1
	raid_RaidManagement.add_argument("--expand_result", action=raid_RaidManagement_expandResultAction, nargs=nargs, metavar=metavars)
	class raid_RaidManagement_add_slotsAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.raid.Pool import Pool
			from unicorn_api.v5.sv0.raid.Slot import Slot
			from unicorn_api.v5.sv0.raid.RaidLevelInfo import RaidLevelInfo
			from unicorn_api.v5.sv0.raid import RaidMode
			from unicorn_api.v5.sv0.raid import RaidLevel
			from unicorn_api.v5.sv0.raid import RedundancyLevel
			from unicorn_api.v5.sv0.raid import LvManagement
			from unicorn_api.v5.sv0.raid.LevelInfo import LevelInfo
			from unicorn_api.v5.sv0.raid.MigrationStatusInfo import MigrationStatusInfo
			from unicorn_api.v5.sv0.raid.AnyRaidSizeInfo import AnyRaidSizeInfo
			from unicorn_api.v5.sv0.raid.SlotInError import SlotInError

			from transformer.lib import List
			checker = [cli_unicode,cli_unicode,list_cli(int)]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.raid.RaidManagement import RaidManagement
			service = RaidManagement()
			global function, interactive
			function = service.add_slots
			interactive = []
			interactive.append(('async_job_name', cli_unicode))
			interactive.append(('pool_name', cli_unicode))
			interactive.append(('slot_indexes', list_cli(int)))
	methods['raid.RaidManagement.add_slots'] = ('raid_RaidManagement', '--add_slots')
	metavars = () if interactive_mode else ('async_job_name','pool_name','slot_indexes')
	help = '' if interactive_mode else '%s %s ' % ('text', '["int",...]')
	nargs = 0 if interactive_mode else 3
	raid_RaidManagement.add_argument("--add_slots", action=raid_RaidManagement_add_slotsAction, nargs=nargs, metavar=metavars, help=help)
	class raid_RaidManagement_add_slotsResultAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.raid.RaidManagement import RaidManagement
			service = RaidManagement()
			global function, interactive
			function = service.add_slots_result
			interactive = []
			interactive.append(('async_job_id', cli_int))
	methods['raid.RaidManagement.add_slots_result'] = ('raid_RaidManagement', '--add_slots_result')
	metavars = () if interactive_mode else ('async_job_id')
	nargs = 0 if interactive_mode else 1
	raid_RaidManagement.add_argument("--add_slots_result", action=raid_RaidManagement_add_slotsResultAction, nargs=nargs, metavar=metavars)
	class raid_RaidManagement_replace_slotAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.raid.Pool import Pool
			from unicorn_api.v5.sv0.raid.Slot import Slot
			from unicorn_api.v5.sv0.raid.RaidLevelInfo import RaidLevelInfo
			from unicorn_api.v5.sv0.raid import RaidMode
			from unicorn_api.v5.sv0.raid import RaidLevel
			from unicorn_api.v5.sv0.raid import RedundancyLevel
			from unicorn_api.v5.sv0.raid import LvManagement
			from unicorn_api.v5.sv0.raid.LevelInfo import LevelInfo
			from unicorn_api.v5.sv0.raid.MigrationStatusInfo import MigrationStatusInfo
			from unicorn_api.v5.sv0.raid.AnyRaidSizeInfo import AnyRaidSizeInfo
			from unicorn_api.v5.sv0.raid.SlotInError import SlotInError

			from transformer.lib import List
			checker = [cli_unicode,cli_unicode,cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.raid.RaidManagement import RaidManagement
			service = RaidManagement()
			global function, interactive
			function = service.replace_slot
			interactive = []
			interactive.append(('async_job_name', cli_unicode))
			interactive.append(('pool_name', cli_unicode))
			interactive.append(('index', cli_int))
	methods['raid.RaidManagement.replace_slot'] = ('raid_RaidManagement', '--replace_slot')
	metavars = () if interactive_mode else ('async_job_name','pool_name','index')
	help = '' if interactive_mode else '%s %s ' % ('text', 'int')
	nargs = 0 if interactive_mode else 3
	raid_RaidManagement.add_argument("--replace_slot", action=raid_RaidManagement_replace_slotAction, nargs=nargs, metavar=metavars, help=help)
	class raid_RaidManagement_replace_slotResultAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.raid.RaidManagement import RaidManagement
			service = RaidManagement()
			global function, interactive
			function = service.replace_slot_result
			interactive = []
			interactive.append(('async_job_id', cli_int))
	methods['raid.RaidManagement.replace_slot_result'] = ('raid_RaidManagement', '--replace_slot_result')
	metavars = () if interactive_mode else ('async_job_id')
	nargs = 0 if interactive_mode else 1
	raid_RaidManagement.add_argument("--replace_slot_result", action=raid_RaidManagement_replace_slotResultAction, nargs=nargs, metavar=metavars)
	class raid_RaidManagement_get_slot_propertyAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.raid.Pool import Pool
			from unicorn_api.v5.sv0.raid.Slot import Slot
			from unicorn_api.v5.sv0.raid.RaidLevelInfo import RaidLevelInfo
			from unicorn_api.v5.sv0.raid import RaidMode
			from unicorn_api.v5.sv0.raid import RaidLevel
			from unicorn_api.v5.sv0.raid import RedundancyLevel
			from unicorn_api.v5.sv0.raid import LvManagement
			from unicorn_api.v5.sv0.raid.LevelInfo import LevelInfo
			from unicorn_api.v5.sv0.raid.MigrationStatusInfo import MigrationStatusInfo
			from unicorn_api.v5.sv0.raid.AnyRaidSizeInfo import AnyRaidSizeInfo
			from unicorn_api.v5.sv0.raid.SlotInError import SlotInError

			from transformer.lib import List
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.raid.RaidManagement import RaidManagement
			service = RaidManagement()
			global function, interactive
			function = service.get_slot_property
			interactive = []
			interactive.append(('slot_id', cli_int))
	methods['raid.RaidManagement.get_slot_property'] = ('raid_RaidManagement', '--get_slot_property')
	metavars = () if interactive_mode else ('slot_id')
	help = '' if interactive_mode else '%s ' % ('int')
	nargs = 0 if interactive_mode else 1
	raid_RaidManagement.add_argument("--get_slot_property", action=raid_RaidManagement_get_slot_propertyAction, nargs=nargs, metavar=metavars, help=help)
	class raid_RaidManagement_list_migrationsAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.raid.Pool import Pool
			from unicorn_api.v5.sv0.raid.Slot import Slot
			from unicorn_api.v5.sv0.raid.RaidLevelInfo import RaidLevelInfo
			from unicorn_api.v5.sv0.raid import RaidMode
			from unicorn_api.v5.sv0.raid import RaidLevel
			from unicorn_api.v5.sv0.raid import RedundancyLevel
			from unicorn_api.v5.sv0.raid import LvManagement
			from unicorn_api.v5.sv0.raid.LevelInfo import LevelInfo
			from unicorn_api.v5.sv0.raid.MigrationStatusInfo import MigrationStatusInfo
			from unicorn_api.v5.sv0.raid.AnyRaidSizeInfo import AnyRaidSizeInfo
			from unicorn_api.v5.sv0.raid.SlotInError import SlotInError

			from transformer.lib import List
			checker = [cli_unicode,list_cli(int)]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.raid.RaidManagement import RaidManagement
			service = RaidManagement()
			global function, interactive
			function = service.list_migrations
			interactive = []
			interactive.append(('pool_name', cli_unicode))
			interactive.append(('slots', list_cli(int)))
	methods['raid.RaidManagement.list_migrations'] = ('raid_RaidManagement', '--list_migrations')
	metavars = () if interactive_mode else ('pool_name','slots')
	help = '' if interactive_mode else '%s %s ' % ('text', '["int",...]')
	nargs = 0 if interactive_mode else 2
	raid_RaidManagement.add_argument("--list_migrations", action=raid_RaidManagement_list_migrationsAction, nargs=nargs, metavar=metavars, help=help)
	class raid_RaidManagement_get_poolAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.raid.Pool import Pool
			from unicorn_api.v5.sv0.raid.Slot import Slot
			from unicorn_api.v5.sv0.raid.RaidLevelInfo import RaidLevelInfo
			from unicorn_api.v5.sv0.raid import RaidMode
			from unicorn_api.v5.sv0.raid import RaidLevel
			from unicorn_api.v5.sv0.raid import RedundancyLevel
			from unicorn_api.v5.sv0.raid import LvManagement
			from unicorn_api.v5.sv0.raid.LevelInfo import LevelInfo
			from unicorn_api.v5.sv0.raid.MigrationStatusInfo import MigrationStatusInfo
			from unicorn_api.v5.sv0.raid.AnyRaidSizeInfo import AnyRaidSizeInfo
			from unicorn_api.v5.sv0.raid.SlotInError import SlotInError

			from transformer.lib import List
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.raid.RaidManagement import RaidManagement
			service = RaidManagement()
			global function, interactive
			function = service.get_pool
			interactive = []
			interactive.append(('pool_name', cli_unicode))
	methods['raid.RaidManagement.get_pool'] = ('raid_RaidManagement', '--get_pool')
	metavars = () if interactive_mode else ('pool_name')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 1
	raid_RaidManagement.add_argument("--get_pool", action=raid_RaidManagement_get_poolAction, nargs=nargs, metavar=metavars, help=help)
	services_SmbServiceAdministration = subparsers.add_parser('services_SmbServiceAdministration', help="help services.SmbServiceAdministration")
	class services_SmbServiceAdministration_discover_smb_hostsAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.services.SmbHost import SmbHost

			from transformer.lib import List
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.services.SmbServiceAdministration import SmbServiceAdministration
			service = SmbServiceAdministration()
			global function, interactive
			function = service.discover_smb_hosts
			interactive = []
	methods['services.SmbServiceAdministration.discover_smb_hosts'] = ('services_SmbServiceAdministration', '--discover_smb_hosts')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	services_SmbServiceAdministration.add_argument("--discover_smb_hosts", action=services_SmbServiceAdministration_discover_smb_hostsAction, nargs=nargs, metavar=metavars, help=help)
	class services_SmbServiceAdministration_set_signing_modeAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.services.SmbHost import SmbHost

			from transformer.lib import List
			checker = [cli_bool]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.services.SmbServiceAdministration import SmbServiceAdministration
			service = SmbServiceAdministration()
			global function, interactive
			function = service.set_signing_mode
			interactive = []
			interactive.append(('is_signing', cli_bool))
	methods['services.SmbServiceAdministration.set_signing_mode'] = ('services_SmbServiceAdministration', '--set_signing_mode')
	metavars = () if interactive_mode else ('is_signing')
	help = '' if interactive_mode else '%s ' % ('True|False')
	nargs = 0 if interactive_mode else 1
	services_SmbServiceAdministration.add_argument("--set_signing_mode", action=services_SmbServiceAdministration_set_signing_modeAction, nargs=nargs, metavar=metavars, help=help)
	class services_SmbServiceAdministration_get_signing_modeAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.services.SmbHost import SmbHost

			from transformer.lib import List
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.services.SmbServiceAdministration import SmbServiceAdministration
			service = SmbServiceAdministration()
			global function, interactive
			function = service.get_signing_mode
			interactive = []
	methods['services.SmbServiceAdministration.get_signing_mode'] = ('services_SmbServiceAdministration', '--get_signing_mode')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	services_SmbServiceAdministration.add_argument("--get_signing_mode", action=services_SmbServiceAdministration_get_signing_modeAction, nargs=nargs, metavar=metavars, help=help)
	settings_backup_SettingsBackupAdministration = subparsers.add_parser('settings_backup_SettingsBackupAdministration', help="help settings_backup.SettingsBackupAdministration")
	class settings_backup_SettingsBackupAdministration_readAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.settings_backup.SettingsBackupLink import SettingsBackupLink
			from unicorn_api.v5.sv0.settings_backup.SettingsBackupFileInfo import SettingsBackupFileInfo
			from unicorn_api.v5.sv0.settings_backup.RestoreSelection import RestoreSelection

			from transformer.lib import List, Dict
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.settings_backup.SettingsBackupAdministration import SettingsBackupAdministration
			service = SettingsBackupAdministration()
			global function, interactive
			function = service.read
			interactive = []
			interactive.append(('token', cli_unicode))
	methods['settings_backup.SettingsBackupAdministration.read'] = ('settings_backup_SettingsBackupAdministration', '--read')
	metavars = () if interactive_mode else ('token')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 1
	settings_backup_SettingsBackupAdministration.add_argument("--read", action=settings_backup_SettingsBackupAdministration_readAction, nargs=nargs, metavar=metavars, help=help)
	class settings_backup_SettingsBackupAdministration_listAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.settings_backup.SettingsBackupLink import SettingsBackupLink
			from unicorn_api.v5.sv0.settings_backup.SettingsBackupFileInfo import SettingsBackupFileInfo
			from unicorn_api.v5.sv0.settings_backup.RestoreSelection import RestoreSelection

			from transformer.lib import List, Dict
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.settings_backup.SettingsBackupAdministration import SettingsBackupAdministration
			service = SettingsBackupAdministration()
			global function, interactive
			function = service.list
			interactive = []
	methods['settings_backup.SettingsBackupAdministration.list'] = ('settings_backup_SettingsBackupAdministration', '--list')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	settings_backup_SettingsBackupAdministration.add_argument("--list", action=settings_backup_SettingsBackupAdministration_listAction, nargs=nargs, metavar=metavars, help=help)
	class settings_backup_SettingsBackupAdministration_set_fileAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.settings_backup.SettingsBackupLink import SettingsBackupLink
			from unicorn_api.v5.sv0.settings_backup.SettingsBackupFileInfo import SettingsBackupFileInfo
			from unicorn_api.v5.sv0.settings_backup.RestoreSelection import RestoreSelection

			from transformer.lib import List, Dict
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.settings_backup.SettingsBackupAdministration import SettingsBackupAdministration
			service = SettingsBackupAdministration()
			global function, interactive
			function = service.set_file
			interactive = []
			interactive.append(('filename', cli_unicode))
	methods['settings_backup.SettingsBackupAdministration.set_file'] = ('settings_backup_SettingsBackupAdministration', '--set_file')
	metavars = () if interactive_mode else ('filename')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 1
	settings_backup_SettingsBackupAdministration.add_argument("--set_file", action=settings_backup_SettingsBackupAdministration_set_fileAction, nargs=nargs, metavar=metavars, help=help)
	class settings_backup_SettingsBackupAdministration_backupAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.settings_backup.SettingsBackupLink import SettingsBackupLink
			from unicorn_api.v5.sv0.settings_backup.SettingsBackupFileInfo import SettingsBackupFileInfo
			from unicorn_api.v5.sv0.settings_backup.RestoreSelection import RestoreSelection

			from transformer.lib import List, Dict
			checker = [cli_unicode,list_cli(unicode)]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.settings_backup.SettingsBackupAdministration import SettingsBackupAdministration
			service = SettingsBackupAdministration()
			global function, interactive
			function = service.backup
			interactive = []
			interactive.append(('async_job_name', cli_unicode))
			interactive.append(('setting_names', list_cli(unicode)))
	methods['settings_backup.SettingsBackupAdministration.backup'] = ('settings_backup_SettingsBackupAdministration', '--backup')
	metavars = () if interactive_mode else ('async_job_name','setting_names')
	help = '' if interactive_mode else '%s ' % ('["text",...]')
	nargs = 0 if interactive_mode else 2
	settings_backup_SettingsBackupAdministration.add_argument("--backup", action=settings_backup_SettingsBackupAdministration_backupAction, nargs=nargs, metavar=metavars, help=help)
	class settings_backup_SettingsBackupAdministration_backupResultAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.settings_backup.SettingsBackupAdministration import SettingsBackupAdministration
			service = SettingsBackupAdministration()
			global function, interactive
			function = service.backup_result
			interactive = []
			interactive.append(('async_job_id', cli_int))
	methods['settings_backup.SettingsBackupAdministration.backup_result'] = ('settings_backup_SettingsBackupAdministration', '--backup_result')
	metavars = () if interactive_mode else ('async_job_id')
	nargs = 0 if interactive_mode else 1
	settings_backup_SettingsBackupAdministration.add_argument("--backup_result", action=settings_backup_SettingsBackupAdministration_backupResultAction, nargs=nargs, metavar=metavars)
	class settings_backup_SettingsBackupAdministration_restoreAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.settings_backup.SettingsBackupLink import SettingsBackupLink
			from unicorn_api.v5.sv0.settings_backup.SettingsBackupFileInfo import SettingsBackupFileInfo
			from unicorn_api.v5.sv0.settings_backup.RestoreSelection import RestoreSelection

			from transformer.lib import List, Dict
			checker = [cli_unicode,cli_unicode,list_cli(RestoreSelection),dict_cli(int)]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.settings_backup.SettingsBackupAdministration import SettingsBackupAdministration
			service = SettingsBackupAdministration()
			global function, interactive
			function = service.restore
			interactive = []
			interactive.append(('async_job_name', cli_unicode))
			interactive.append(('token', cli_unicode))
			interactive.append(('selections', list_cli(RestoreSelection)))
			interactive.append(('new_volume_mappings', dict_cli(int)))
	methods['settings_backup.SettingsBackupAdministration.restore'] = ('settings_backup_SettingsBackupAdministration', '--restore')
	metavars = () if interactive_mode else ('async_job_name','token','selections','new_volume_mappings')
	help = '' if interactive_mode else '%s %s %s ' % ('text', '["{"name":text,"option":CLEAR_ALL|OVERWRITE|SKIP}",...]', '{"key":int,...}')
	nargs = 0 if interactive_mode else 4
	settings_backup_SettingsBackupAdministration.add_argument("--restore", action=settings_backup_SettingsBackupAdministration_restoreAction, nargs=nargs, metavar=metavars, help=help)
	class settings_backup_SettingsBackupAdministration_restoreResultAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.settings_backup.SettingsBackupAdministration import SettingsBackupAdministration
			service = SettingsBackupAdministration()
			global function, interactive
			function = service.restore_result
			interactive = []
			interactive.append(('async_job_id', cli_int))
	methods['settings_backup.SettingsBackupAdministration.restore_result'] = ('settings_backup_SettingsBackupAdministration', '--restore_result')
	metavars = () if interactive_mode else ('async_job_id')
	nargs = 0 if interactive_mode else 1
	settings_backup_SettingsBackupAdministration.add_argument("--restore_result", action=settings_backup_SettingsBackupAdministration_restoreResultAction, nargs=nargs, metavar=metavars)
	smtp_Smtp = subparsers.add_parser('smtp_Smtp', help="help smtp.Smtp")
	class smtp_Smtp_is_enabledAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.smtp.Smtp import Smtp
			service = Smtp()
			global function, interactive
			function = service.is_enabled
			interactive = []
	methods['smtp.Smtp.is_enabled'] = ('smtp_Smtp', '--is_enabled')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	smtp_Smtp.add_argument("--is_enabled", action=smtp_Smtp_is_enabledAction, nargs=nargs, metavar=metavars, help=help)
	welcome_xp_WelcomeXp = subparsers.add_parser('welcome_xp_WelcomeXp', help="help welcome_xp.WelcomeXp")
	class welcome_xp_WelcomeXp_remote_statusAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.welcome_xp import WelcomeConnectionStatus

			from transformer.lib import List
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.welcome_xp.WelcomeXp import WelcomeXp
			service = WelcomeXp()
			global function, interactive
			function = service.remote_status
			interactive = []
	methods['welcome_xp.WelcomeXp.remote_status'] = ('welcome_xp_WelcomeXp', '--remote_status')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	welcome_xp_WelcomeXp.add_argument("--remote_status", action=welcome_xp_WelcomeXp_remote_statusAction, nargs=nargs, metavar=metavars, help=help)
	class welcome_xp_WelcomeXp_set_welcome_doneAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.welcome_xp import WelcomeConnectionStatus

			from transformer.lib import List
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.welcome_xp.WelcomeXp import WelcomeXp
			service = WelcomeXp()
			global function, interactive
			function = service.set_welcome_done
			interactive = []
	methods['welcome_xp.WelcomeXp.set_welcome_done'] = ('welcome_xp_WelcomeXp', '--set_welcome_done')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	welcome_xp_WelcomeXp.add_argument("--set_welcome_done", action=welcome_xp_WelcomeXp_set_welcome_doneAction, nargs=nargs, metavar=metavars, help=help)
	class welcome_xp_WelcomeXp_list_usersAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.welcome_xp import WelcomeConnectionStatus

			from transformer.lib import List
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.welcome_xp.WelcomeXp import WelcomeXp
			service = WelcomeXp()
			global function, interactive
			function = service.list_users
			interactive = []
	methods['welcome_xp.WelcomeXp.list_users'] = ('welcome_xp_WelcomeXp', '--list_users')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	welcome_xp_WelcomeXp.add_argument("--list_users", action=welcome_xp_WelcomeXp_list_usersAction, nargs=nargs, metavar=metavars, help=help)
	class welcome_xp_WelcomeXp_get_admin_nameAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.welcome_xp import WelcomeConnectionStatus

			from transformer.lib import List
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.welcome_xp.WelcomeXp import WelcomeXp
			service = WelcomeXp()
			global function, interactive
			function = service.get_admin_name
			interactive = []
	methods['welcome_xp.WelcomeXp.get_admin_name'] = ('welcome_xp_WelcomeXp', '--get_admin_name')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	welcome_xp_WelcomeXp.add_argument("--get_admin_name", action=welcome_xp_WelcomeXp_get_admin_nameAction, nargs=nargs, metavar=metavars, help=help)
	class welcome_xp_WelcomeXp_get_skip_foreverAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.welcome_xp import WelcomeConnectionStatus

			from transformer.lib import List
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.welcome_xp.WelcomeXp import WelcomeXp
			service = WelcomeXp()
			global function, interactive
			function = service.get_skip_forever
			interactive = []
	methods['welcome_xp.WelcomeXp.get_skip_forever'] = ('welcome_xp_WelcomeXp', '--get_skip_forever')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	welcome_xp_WelcomeXp.add_argument("--get_skip_forever", action=welcome_xp_WelcomeXp_get_skip_foreverAction, nargs=nargs, metavar=metavars, help=help)
	class welcome_xp_WelcomeXp_set_skip_foreverAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.welcome_xp import WelcomeConnectionStatus

			from transformer.lib import List
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.welcome_xp.WelcomeXp import WelcomeXp
			service = WelcomeXp()
			global function, interactive
			function = service.set_skip_forever
			interactive = []
	methods['welcome_xp.WelcomeXp.set_skip_forever'] = ('welcome_xp_WelcomeXp', '--set_skip_forever')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	welcome_xp_WelcomeXp.add_argument("--set_skip_forever", action=welcome_xp_WelcomeXp_set_skip_foreverAction, nargs=nargs, metavar=metavars, help=help)
	class welcome_xp_WelcomeXp_welcome_statusAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.welcome_xp import WelcomeConnectionStatus

			from transformer.lib import List
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.welcome_xp.WelcomeXp import WelcomeXp
			service = WelcomeXp()
			global function, interactive
			function = service.welcome_status
			interactive = []
	methods['welcome_xp.WelcomeXp.welcome_status'] = ('welcome_xp_WelcomeXp', '--welcome_status')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	welcome_xp_WelcomeXp.add_argument("--welcome_status", action=welcome_xp_WelcomeXp_welcome_statusAction, nargs=nargs, metavar=metavars, help=help)
	class welcome_xp_WelcomeXp_get_welcome_doneAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.welcome_xp import WelcomeConnectionStatus

			from transformer.lib import List
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.welcome_xp.WelcomeXp import WelcomeXp
			service = WelcomeXp()
			global function, interactive
			function = service.get_welcome_done
			interactive = []
	methods['welcome_xp.WelcomeXp.get_welcome_done'] = ('welcome_xp_WelcomeXp', '--get_welcome_done')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	welcome_xp_WelcomeXp.add_argument("--get_welcome_done", action=welcome_xp_WelcomeXp_get_welcome_doneAction, nargs=nargs, metavar=metavars, help=help)
	class welcome_xp_WelcomeXp_delete_userAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.welcome_xp import WelcomeConnectionStatus

			from transformer.lib import List
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.welcome_xp.WelcomeXp import WelcomeXp
			service = WelcomeXp()
			global function, interactive
			function = service.delete_user
			interactive = []
			interactive.append(('login', cli_unicode))
	methods['welcome_xp.WelcomeXp.delete_user'] = ('welcome_xp_WelcomeXp', '--delete_user')
	metavars = () if interactive_mode else ('login')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 1
	welcome_xp_WelcomeXp.add_argument("--delete_user", action=welcome_xp_WelcomeXp_delete_userAction, nargs=nargs, metavar=metavars, help=help)
	class welcome_xp_WelcomeXp_set_public_share_nameAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.welcome_xp import WelcomeConnectionStatus

			from transformer.lib import List
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.welcome_xp.WelcomeXp import WelcomeXp
			service = WelcomeXp()
			global function, interactive
			function = service.set_public_share_name
			interactive = []
			interactive.append(('share_name', cli_unicode))
	methods['welcome_xp.WelcomeXp.set_public_share_name'] = ('welcome_xp_WelcomeXp', '--set_public_share_name')
	metavars = () if interactive_mode else ('share_name')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 1
	welcome_xp_WelcomeXp.add_argument("--set_public_share_name", action=welcome_xp_WelcomeXp_set_public_share_nameAction, nargs=nargs, metavar=metavars, help=help)
	class welcome_xp_WelcomeXp_get_public_share_nameAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.welcome_xp import WelcomeConnectionStatus

			from transformer.lib import List
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.welcome_xp.WelcomeXp import WelcomeXp
			service = WelcomeXp()
			global function, interactive
			function = service.get_public_share_name
			interactive = []
	methods['welcome_xp.WelcomeXp.get_public_share_name'] = ('welcome_xp_WelcomeXp', '--get_public_share_name')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	welcome_xp_WelcomeXp.add_argument("--get_public_share_name", action=welcome_xp_WelcomeXp_get_public_share_nameAction, nargs=nargs, metavar=metavars, help=help)
	class welcome_xp_WelcomeXp_set_adminAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.welcome_xp import WelcomeConnectionStatus

			from transformer.lib import List
			checker = [cli_unicode,cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.welcome_xp.WelcomeXp import WelcomeXp
			service = WelcomeXp()
			global function, interactive
			function = service.set_admin
			interactive = []
			interactive.append(('login', cli_unicode))
			interactive.append(('password', cli_unicode))
	methods['welcome_xp.WelcomeXp.set_admin'] = ('welcome_xp_WelcomeXp', '--set_admin')
	metavars = () if interactive_mode else ('login','password')
	help = '' if interactive_mode else '%s %s ' % ('text', 'text')
	nargs = 0 if interactive_mode else 2
	welcome_xp_WelcomeXp.add_argument("--set_admin", action=welcome_xp_WelcomeXp_set_adminAction, nargs=nargs, metavar=metavars, help=help)
	class welcome_xp_WelcomeXp_add_userAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.welcome_xp import WelcomeConnectionStatus

			from transformer.lib import List
			checker = [cli_unicode,cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.welcome_xp.WelcomeXp import WelcomeXp
			service = WelcomeXp()
			global function, interactive
			function = service.add_user
			interactive = []
			interactive.append(('login', cli_unicode))
			interactive.append(('password', cli_unicode))
	methods['welcome_xp.WelcomeXp.add_user'] = ('welcome_xp_WelcomeXp', '--add_user')
	metavars = () if interactive_mode else ('login','password')
	help = '' if interactive_mode else '%s %s ' % ('text', 'text')
	nargs = 0 if interactive_mode else 2
	welcome_xp_WelcomeXp.add_argument("--add_user", action=welcome_xp_WelcomeXp_add_userAction, nargs=nargs, metavar=metavars, help=help)
	service_by_nic_ServiceByNicManager = subparsers.add_parser('service_by_nic_ServiceByNicManager', help="help service_by_nic.ServiceByNicManager")
	class service_by_nic_ServiceByNicManager_set_enabledAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.service_by_nic.ServiceByNicInfo import ServiceByNicInfo

			from transformer.lib import List, ListInfo, ResultSet
			checker = [cli_int,cli_bool]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.service_by_nic.ServiceByNicManager import ServiceByNicManager
			service = ServiceByNicManager()
			global function, interactive
			function = service.set_enabled
			interactive = []
			interactive.append(('id', cli_int))
			interactive.append(('enabled', cli_bool))
	methods['service_by_nic.ServiceByNicManager.set_enabled'] = ('service_by_nic_ServiceByNicManager', '--set_enabled')
	metavars = () if interactive_mode else ('id','enabled')
	help = '' if interactive_mode else '%s %s ' % ('int', 'True|False')
	nargs = 0 if interactive_mode else 2
	service_by_nic_ServiceByNicManager.add_argument("--set_enabled", action=service_by_nic_ServiceByNicManager_set_enabledAction, nargs=nargs, metavar=metavars, help=help)
	class service_by_nic_ServiceByNicManager_get_service_nic_configAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.service_by_nic.ServiceByNicInfo import ServiceByNicInfo

			from transformer.lib import List, ListInfo, ResultSet
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.service_by_nic.ServiceByNicManager import ServiceByNicManager
			service = ServiceByNicManager()
			global function, interactive
			function = service.get_service_nic_config
			interactive = []
			interactive.append(('service_name', cli_unicode))
	methods['service_by_nic.ServiceByNicManager.get_service_nic_config'] = ('service_by_nic_ServiceByNicManager', '--get_service_nic_config')
	metavars = () if interactive_mode else ('service_name')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 1
	service_by_nic_ServiceByNicManager.add_argument("--get_service_nic_config", action=service_by_nic_ServiceByNicManager_get_service_nic_configAction, nargs=nargs, metavar=metavars, help=help)
	class service_by_nic_ServiceByNicManager_get_services_by_nicAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.service_by_nic.ServiceByNicInfo import ServiceByNicInfo

			from transformer.lib import List, ListInfo, ResultSet
			checker = [cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.service_by_nic.ServiceByNicManager import ServiceByNicManager
			service = ServiceByNicManager()
			global function, interactive
			function = service.get_services_by_nic
			interactive = []
			interactive.append(('list_info', cli_list_info))
	methods['service_by_nic.ServiceByNicManager.get_services_by_nic'] = ('service_by_nic_ServiceByNicManager', '--get_services_by_nic')
	metavars = () if interactive_mode else ('list_info')
	help = '' if interactive_mode else '%s ' % ('offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 1
	service_by_nic_ServiceByNicManager.add_argument("--get_services_by_nic", action=service_by_nic_ServiceByNicManager_get_services_by_nicAction, nargs=nargs, metavar=metavars, help=help)
	class service_by_nic_ServiceByNicManager_set_service_nic_configAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.service_by_nic.ServiceByNicInfo import ServiceByNicInfo

			from transformer.lib import List, ListInfo, ResultSet
			checker = [cli_int,cli_bool,list_cli(int)]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.service_by_nic.ServiceByNicManager import ServiceByNicManager
			service = ServiceByNicManager()
			global function, interactive
			function = service.set_service_nic_config
			interactive = []
			interactive.append(('id', cli_int))
			interactive.append(('all', cli_bool))
			interactive.append(('interface_list', list_cli(int)))
	methods['service_by_nic.ServiceByNicManager.set_service_nic_config'] = ('service_by_nic_ServiceByNicManager', '--set_service_nic_config')
	metavars = () if interactive_mode else ('id','all','interface_list')
	help = '' if interactive_mode else '%s %s %s ' % ('int', 'True|False', '["int",...]')
	nargs = 0 if interactive_mode else 3
	service_by_nic_ServiceByNicManager.add_argument("--set_service_nic_config", action=service_by_nic_ServiceByNicManager_set_service_nic_configAction, nargs=nargs, metavar=metavars, help=help)
	services_RecycleBinAdministration = subparsers.add_parser('services_RecycleBinAdministration', help="help services.RecycleBinAdministration")
	class services_RecycleBinAdministration_empty_allAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.services.RecycleBinInfo import RecycleBinInfo

			from transformer.lib import Long, ListInfo, ResultSet
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.services.RecycleBinAdministration import RecycleBinAdministration
			service = RecycleBinAdministration()
			global function, interactive
			function = service.empty_all
			interactive = []
			interactive.append(('async_job_name', cli_unicode))
	methods['services.RecycleBinAdministration.empty_all'] = ('services_RecycleBinAdministration', '--empty_all')
	metavars = () if interactive_mode else ('async_job_name')
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 1
	services_RecycleBinAdministration.add_argument("--empty_all", action=services_RecycleBinAdministration_empty_allAction, nargs=nargs, metavar=metavars, help=help)
	class services_RecycleBinAdministration_empty_allResultAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.services.RecycleBinAdministration import RecycleBinAdministration
			service = RecycleBinAdministration()
			global function, interactive
			function = service.empty_all_result
			interactive = []
			interactive.append(('async_job_id', cli_int))
	methods['services.RecycleBinAdministration.empty_all_result'] = ('services_RecycleBinAdministration', '--empty_all_result')
	metavars = () if interactive_mode else ('async_job_id')
	nargs = 0 if interactive_mode else 1
	services_RecycleBinAdministration.add_argument("--empty_all_result", action=services_RecycleBinAdministration_empty_allResultAction, nargs=nargs, metavar=metavars)
	class services_RecycleBinAdministration_total_sizeAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.services.RecycleBinInfo import RecycleBinInfo

			from transformer.lib import Long, ListInfo, ResultSet
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.services.RecycleBinAdministration import RecycleBinAdministration
			service = RecycleBinAdministration()
			global function, interactive
			function = service.total_size
			interactive = []
			interactive.append(('async_job_name', cli_unicode))
	methods['services.RecycleBinAdministration.total_size'] = ('services_RecycleBinAdministration', '--total_size')
	metavars = () if interactive_mode else ('async_job_name')
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 1
	services_RecycleBinAdministration.add_argument("--total_size", action=services_RecycleBinAdministration_total_sizeAction, nargs=nargs, metavar=metavars, help=help)
	class services_RecycleBinAdministration_total_sizeResultAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.services.RecycleBinAdministration import RecycleBinAdministration
			service = RecycleBinAdministration()
			global function, interactive
			function = service.total_size_result
			interactive = []
			interactive.append(('async_job_id', cli_int))
	methods['services.RecycleBinAdministration.total_size_result'] = ('services_RecycleBinAdministration', '--total_size_result')
	metavars = () if interactive_mode else ('async_job_id')
	nargs = 0 if interactive_mode else 1
	services_RecycleBinAdministration.add_argument("--total_size_result", action=services_RecycleBinAdministration_total_sizeResultAction, nargs=nargs, metavar=metavars)
	class services_RecycleBinAdministration_get_lifetimeAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.services.RecycleBinInfo import RecycleBinInfo

			from transformer.lib import Long, ListInfo, ResultSet
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.services.RecycleBinAdministration import RecycleBinAdministration
			service = RecycleBinAdministration()
			global function, interactive
			function = service.get_lifetime
			interactive = []
	methods['services.RecycleBinAdministration.get_lifetime'] = ('services_RecycleBinAdministration', '--get_lifetime')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	services_RecycleBinAdministration.add_argument("--get_lifetime", action=services_RecycleBinAdministration_get_lifetimeAction, nargs=nargs, metavar=metavars, help=help)
	class services_RecycleBinAdministration_listAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.services.RecycleBinInfo import RecycleBinInfo

			from transformer.lib import Long, ListInfo, ResultSet
			checker = [cli_unicode,cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.services.RecycleBinAdministration import RecycleBinAdministration
			service = RecycleBinAdministration()
			global function, interactive
			function = service.list
			interactive = []
			interactive.append(('async_job_name', cli_unicode))
			interactive.append(('list_info', cli_list_info))
	methods['services.RecycleBinAdministration.list'] = ('services_RecycleBinAdministration', '--list')
	metavars = () if interactive_mode else ('async_job_name','list_info')
	help = '' if interactive_mode else '%s ' % ('offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 2
	services_RecycleBinAdministration.add_argument("--list", action=services_RecycleBinAdministration_listAction, nargs=nargs, metavar=metavars, help=help)
	class services_RecycleBinAdministration_listResultAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.services.RecycleBinAdministration import RecycleBinAdministration
			service = RecycleBinAdministration()
			global function, interactive
			function = service.list_result
			interactive = []
			interactive.append(('async_job_id', cli_int))
	methods['services.RecycleBinAdministration.list_result'] = ('services_RecycleBinAdministration', '--list_result')
	metavars = () if interactive_mode else ('async_job_id')
	nargs = 0 if interactive_mode else 1
	services_RecycleBinAdministration.add_argument("--list_result", action=services_RecycleBinAdministration_listResultAction, nargs=nargs, metavar=metavars)
	class services_RecycleBinAdministration_set_lifetimeAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.services.RecycleBinInfo import RecycleBinInfo

			from transformer.lib import Long, ListInfo, ResultSet
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.services.RecycleBinAdministration import RecycleBinAdministration
			service = RecycleBinAdministration()
			global function, interactive
			function = service.set_lifetime
			interactive = []
			interactive.append(('days', cli_int))
	methods['services.RecycleBinAdministration.set_lifetime'] = ('services_RecycleBinAdministration', '--set_lifetime')
	metavars = () if interactive_mode else ('days')
	help = '' if interactive_mode else '%s ' % ('int')
	nargs = 0 if interactive_mode else 1
	services_RecycleBinAdministration.add_argument("--set_lifetime", action=services_RecycleBinAdministration_set_lifetimeAction, nargs=nargs, metavar=metavars, help=help)
	class services_RecycleBinAdministration_emptyAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.services.RecycleBinInfo import RecycleBinInfo

			from transformer.lib import Long, ListInfo, ResultSet
			checker = [cli_unicode,cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.services.RecycleBinAdministration import RecycleBinAdministration
			service = RecycleBinAdministration()
			global function, interactive
			function = service.empty
			interactive = []
			interactive.append(('async_job_name', cli_unicode))
			interactive.append(('share_id', cli_int))
	methods['services.RecycleBinAdministration.empty'] = ('services_RecycleBinAdministration', '--empty')
	metavars = () if interactive_mode else ('async_job_name','share_id')
	help = '' if interactive_mode else '%s ' % ('int')
	nargs = 0 if interactive_mode else 2
	services_RecycleBinAdministration.add_argument("--empty", action=services_RecycleBinAdministration_emptyAction, nargs=nargs, metavar=metavars, help=help)
	class services_RecycleBinAdministration_emptyResultAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.services.RecycleBinAdministration import RecycleBinAdministration
			service = RecycleBinAdministration()
			global function, interactive
			function = service.empty_result
			interactive = []
			interactive.append(('async_job_id', cli_int))
	methods['services.RecycleBinAdministration.empty_result'] = ('services_RecycleBinAdministration', '--empty_result')
	metavars = () if interactive_mode else ('async_job_id')
	nargs = 0 if interactive_mode else 1
	services_RecycleBinAdministration.add_argument("--empty_result", action=services_RecycleBinAdministration_emptyResultAction, nargs=nargs, metavar=metavars)
	class services_RecycleBinAdministration_sizeAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.services.RecycleBinInfo import RecycleBinInfo

			from transformer.lib import Long, ListInfo, ResultSet
			checker = [cli_unicode,cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.services.RecycleBinAdministration import RecycleBinAdministration
			service = RecycleBinAdministration()
			global function, interactive
			function = service.size
			interactive = []
			interactive.append(('async_job_name', cli_unicode))
			interactive.append(('share_id', cli_int))
	methods['services.RecycleBinAdministration.size'] = ('services_RecycleBinAdministration', '--size')
	metavars = () if interactive_mode else ('async_job_name','share_id')
	help = '' if interactive_mode else '%s ' % ('int')
	nargs = 0 if interactive_mode else 2
	services_RecycleBinAdministration.add_argument("--size", action=services_RecycleBinAdministration_sizeAction, nargs=nargs, metavar=metavars, help=help)
	class services_RecycleBinAdministration_sizeResultAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.services.RecycleBinAdministration import RecycleBinAdministration
			service = RecycleBinAdministration()
			global function, interactive
			function = service.size_result
			interactive = []
			interactive.append(('async_job_id', cli_int))
	methods['services.RecycleBinAdministration.size_result'] = ('services_RecycleBinAdministration', '--size_result')
	metavars = () if interactive_mode else ('async_job_id')
	nargs = 0 if interactive_mode else 1
	services_RecycleBinAdministration.add_argument("--size_result", action=services_RecycleBinAdministration_sizeResultAction, nargs=nargs, metavar=metavars)
	support_logger_LoggerAdministration = subparsers.add_parser('support_logger_LoggerAdministration', help="help support.logger.LoggerAdministration")
	class support_logger_LoggerAdministration_clear_by_severitiesAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.support.logger.LoggerEntry import LoggerEntry
			from unicorn_api.v5.sv0.support.logger import LogSeverity
			from unicorn_api.v5.sv0.support.logger.Category import Category

			from transformer.lib import ListInfo, ResultSet, List
			checker = [list_cli(LogSeverity)]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.support.logger.LoggerAdministration import LoggerAdministration
			service = LoggerAdministration()
			global function, interactive
			function = service.clear_by_severities
			interactive = []
			interactive.append(('severity_codes', list_cli(LogSeverity)))
	methods['support.logger.LoggerAdministration.clear_by_severities'] = ('support_logger_LoggerAdministration', '--clear_by_severities')
	metavars = () if interactive_mode else ('severity_codes')
	help = '' if interactive_mode else '%s ' % ('["INFO|WARNING|ERROR",...]')
	nargs = 0 if interactive_mode else 1
	support_logger_LoggerAdministration.add_argument("--clear_by_severities", action=support_logger_LoggerAdministration_clear_by_severitiesAction, nargs=nargs, metavar=metavars, help=help)
	class support_logger_LoggerAdministration_list_categoryAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.support.logger.LoggerEntry import LoggerEntry
			from unicorn_api.v5.sv0.support.logger import LogSeverity
			from unicorn_api.v5.sv0.support.logger.Category import Category

			from transformer.lib import ListInfo, ResultSet, List
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.support.logger.LoggerAdministration import LoggerAdministration
			service = LoggerAdministration()
			global function, interactive
			function = service.list_category
			interactive = []
	methods['support.logger.LoggerAdministration.list_category'] = ('support_logger_LoggerAdministration', '--list_category')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	support_logger_LoggerAdministration.add_argument("--list_category", action=support_logger_LoggerAdministration_list_categoryAction, nargs=nargs, metavar=metavars, help=help)
	class support_logger_LoggerAdministration_listAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.support.logger.LoggerEntry import LoggerEntry
			from unicorn_api.v5.sv0.support.logger import LogSeverity
			from unicorn_api.v5.sv0.support.logger.Category import Category

			from transformer.lib import ListInfo, ResultSet, List
			checker = [cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.support.logger.LoggerAdministration import LoggerAdministration
			service = LoggerAdministration()
			global function, interactive
			function = service.list
			interactive = []
			interactive.append(('list_info', cli_list_info))
	methods['support.logger.LoggerAdministration.list'] = ('support_logger_LoggerAdministration', '--list')
	metavars = () if interactive_mode else ('list_info')
	help = '' if interactive_mode else '%s ' % ('offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 1
	support_logger_LoggerAdministration.add_argument("--list", action=support_logger_LoggerAdministration_listAction, nargs=nargs, metavar=metavars, help=help)
	class support_logger_LoggerAdministration_delete_eventAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.support.logger.LoggerEntry import LoggerEntry
			from unicorn_api.v5.sv0.support.logger import LogSeverity
			from unicorn_api.v5.sv0.support.logger.Category import Category

			from transformer.lib import ListInfo, ResultSet, List
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.support.logger.LoggerAdministration import LoggerAdministration
			service = LoggerAdministration()
			global function, interactive
			function = service.delete_event
			interactive = []
			interactive.append(('id', cli_int))
	methods['support.logger.LoggerAdministration.delete_event'] = ('support_logger_LoggerAdministration', '--delete_event')
	metavars = () if interactive_mode else ('id')
	help = '' if interactive_mode else '%s ' % ('int')
	nargs = 0 if interactive_mode else 1
	support_logger_LoggerAdministration.add_argument("--delete_event", action=support_logger_LoggerAdministration_delete_eventAction, nargs=nargs, metavar=metavars, help=help)
	class support_logger_LoggerAdministration_clear_all_logAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.support.logger.LoggerEntry import LoggerEntry
			from unicorn_api.v5.sv0.support.logger import LogSeverity
			from unicorn_api.v5.sv0.support.logger.Category import Category

			from transformer.lib import ListInfo, ResultSet, List
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.support.logger.LoggerAdministration import LoggerAdministration
			service = LoggerAdministration()
			global function, interactive
			function = service.clear_all_log
			interactive = []
	methods['support.logger.LoggerAdministration.clear_all_log'] = ('support_logger_LoggerAdministration', '--clear_all_log')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	support_logger_LoggerAdministration.add_argument("--clear_all_log", action=support_logger_LoggerAdministration_clear_all_logAction, nargs=nargs, metavar=metavars, help=help)
	class support_logger_LoggerAdministration_clear_by_categoriesAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.support.logger.LoggerEntry import LoggerEntry
			from unicorn_api.v5.sv0.support.logger import LogSeverity
			from unicorn_api.v5.sv0.support.logger.Category import Category

			from transformer.lib import ListInfo, ResultSet, List
			checker = [list_cli(unicode)]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.support.logger.LoggerAdministration import LoggerAdministration
			service = LoggerAdministration()
			global function, interactive
			function = service.clear_by_categories
			interactive = []
			interactive.append(('category_codes', list_cli(unicode)))
	methods['support.logger.LoggerAdministration.clear_by_categories'] = ('support_logger_LoggerAdministration', '--clear_by_categories')
	metavars = () if interactive_mode else ('category_codes')
	help = '' if interactive_mode else '%s ' % ('["text",...]')
	nargs = 0 if interactive_mode else 1
	support_logger_LoggerAdministration.add_argument("--clear_by_categories", action=support_logger_LoggerAdministration_clear_by_categoriesAction, nargs=nargs, metavar=metavars, help=help)
	iscsi_IscsiAdministration = subparsers.add_parser('iscsi_IscsiAdministration', help="help iscsi.IscsiAdministration")
	class iscsi_IscsiAdministration_list_initiatorAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.iscsi.IscsiLimits import IscsiLimits
			from unicorn_api.v5.sv0.iscsi.IscsiTarget import IscsiTarget
			from unicorn_api.v5.sv0.iscsi.IscsiLun import IscsiLun
			from unicorn_api.v5.sv0.iscsi import IscsiLunKind
			from unicorn_api.v5.sv0.iscsi.IscsiTargetStatus import IscsiTargetStatus
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiTarget import SimpleIscsiTarget

			from transformer.lib import ListInfo, ResultSet, Long
			checker = [cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.iscsi.IscsiAdministration import IscsiAdministration
			service = IscsiAdministration()
			global function, interactive
			function = service.list_initiator
			interactive = []
			interactive.append(('list_info', cli_list_info))
	methods['iscsi.IscsiAdministration.list_initiator'] = ('iscsi_IscsiAdministration', '--list_initiator')
	metavars = () if interactive_mode else ('list_info')
	help = '' if interactive_mode else '%s ' % ('offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 1
	iscsi_IscsiAdministration.add_argument("--list_initiator", action=iscsi_IscsiAdministration_list_initiatorAction, nargs=nargs, metavar=metavars, help=help)
	class iscsi_IscsiAdministration_create_targetAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.iscsi.IscsiLimits import IscsiLimits
			from unicorn_api.v5.sv0.iscsi.IscsiTarget import IscsiTarget
			from unicorn_api.v5.sv0.iscsi.IscsiLun import IscsiLun
			from unicorn_api.v5.sv0.iscsi import IscsiLunKind
			from unicorn_api.v5.sv0.iscsi.IscsiTargetStatus import IscsiTargetStatus
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiTarget import SimpleIscsiTarget

			from transformer.lib import ListInfo, ResultSet, Long
			checker = [IscsiTarget]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.iscsi.IscsiAdministration import IscsiAdministration
			service = IscsiAdministration()
			global function, interactive
			function = service.create_target
			interactive = []
			interactive.append(('iscsi', IscsiTarget))
	methods['iscsi.IscsiAdministration.create_target'] = ('iscsi_IscsiAdministration', '--create_target')
	metavars = () if interactive_mode else ('iscsi')
	help = '' if interactive_mode else '%s ' % ('{"multiple_session":True|False,"name":text,"iqn_suffix":text,"data_digest":True|False,"header_digest":True|False,#"chap_user":{"login":text,#"password":text#,#"mutual_chap_user":{"login":text,#"password":text#}#}#,#"initiator_iqns":["text",...]#}')
	nargs = 0 if interactive_mode else 1
	iscsi_IscsiAdministration.add_argument("--create_target", action=iscsi_IscsiAdministration_create_targetAction, nargs=nargs, metavar=metavars, help=help)
	class iscsi_IscsiAdministration_create_lunAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.iscsi.IscsiLimits import IscsiLimits
			from unicorn_api.v5.sv0.iscsi.IscsiTarget import IscsiTarget
			from unicorn_api.v5.sv0.iscsi.IscsiLun import IscsiLun
			from unicorn_api.v5.sv0.iscsi import IscsiLunKind
			from unicorn_api.v5.sv0.iscsi.IscsiTargetStatus import IscsiTargetStatus
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiTarget import SimpleIscsiTarget

			from transformer.lib import ListInfo, ResultSet, Long
			checker = [cli_unicode,cli_int,IscsiLunKind,cli_long]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.iscsi.IscsiAdministration import IscsiAdministration
			service = IscsiAdministration()
			global function, interactive
			function = service.create_lun
			interactive = []
			interactive.append(('async_job_name', cli_unicode))
			interactive.append(('volume_id', cli_int))
			interactive.append(('kind', IscsiLunKind))
			interactive.append(('size', cli_long))
	methods['iscsi.IscsiAdministration.create_lun'] = ('iscsi_IscsiAdministration', '--create_lun')
	metavars = () if interactive_mode else ('async_job_name','volume_id','kind','size')
	help = '' if interactive_mode else '%s %s %s ' % ('int', 'BLOCK_LEVEL|FILE_LEVEL', 'long')
	nargs = 0 if interactive_mode else 4
	iscsi_IscsiAdministration.add_argument("--create_lun", action=iscsi_IscsiAdministration_create_lunAction, nargs=nargs, metavar=metavars, help=help)
	class iscsi_IscsiAdministration_create_lunResultAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.iscsi.IscsiAdministration import IscsiAdministration
			service = IscsiAdministration()
			global function, interactive
			function = service.create_lun_result
			interactive = []
			interactive.append(('async_job_id', cli_int))
	methods['iscsi.IscsiAdministration.create_lun_result'] = ('iscsi_IscsiAdministration', '--create_lun_result')
	metavars = () if interactive_mode else ('async_job_id')
	nargs = 0 if interactive_mode else 1
	iscsi_IscsiAdministration.add_argument("--create_lun_result", action=iscsi_IscsiAdministration_create_lunResultAction, nargs=nargs, metavar=metavars)
	class iscsi_IscsiAdministration_list_targetAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.iscsi.IscsiLimits import IscsiLimits
			from unicorn_api.v5.sv0.iscsi.IscsiTarget import IscsiTarget
			from unicorn_api.v5.sv0.iscsi.IscsiLun import IscsiLun
			from unicorn_api.v5.sv0.iscsi import IscsiLunKind
			from unicorn_api.v5.sv0.iscsi.IscsiTargetStatus import IscsiTargetStatus
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiTarget import SimpleIscsiTarget

			from transformer.lib import ListInfo, ResultSet, Long
			checker = [cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.iscsi.IscsiAdministration import IscsiAdministration
			service = IscsiAdministration()
			global function, interactive
			function = service.list_target
			interactive = []
			interactive.append(('listInfo', cli_list_info))
	methods['iscsi.IscsiAdministration.list_target'] = ('iscsi_IscsiAdministration', '--list_target')
	metavars = () if interactive_mode else ('listInfo')
	help = '' if interactive_mode else '%s ' % ('offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 1
	iscsi_IscsiAdministration.add_argument("--list_target", action=iscsi_IscsiAdministration_list_targetAction, nargs=nargs, metavar=metavars, help=help)
	class iscsi_IscsiAdministration_import_lunAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.iscsi.IscsiLimits import IscsiLimits
			from unicorn_api.v5.sv0.iscsi.IscsiTarget import IscsiTarget
			from unicorn_api.v5.sv0.iscsi.IscsiLun import IscsiLun
			from unicorn_api.v5.sv0.iscsi import IscsiLunKind
			from unicorn_api.v5.sv0.iscsi.IscsiTargetStatus import IscsiTargetStatus
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiTarget import SimpleIscsiTarget

			from transformer.lib import ListInfo, ResultSet, Long
			checker = [cli_unicode,cli_int,IscsiLunKind,cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.iscsi.IscsiAdministration import IscsiAdministration
			service = IscsiAdministration()
			global function, interactive
			function = service.import_lun
			interactive = []
			interactive.append(('async_job_name', cli_unicode))
			interactive.append(('volume_id', cli_int))
			interactive.append(('kind', IscsiLunKind))
			interactive.append(('src_lun_file', cli_unicode))
	methods['iscsi.IscsiAdministration.import_lun'] = ('iscsi_IscsiAdministration', '--import_lun')
	metavars = () if interactive_mode else ('async_job_name','volume_id','kind','src_lun_file')
	help = '' if interactive_mode else '%s %s %s ' % ('int', 'BLOCK_LEVEL|FILE_LEVEL', 'text')
	nargs = 0 if interactive_mode else 4
	iscsi_IscsiAdministration.add_argument("--import_lun", action=iscsi_IscsiAdministration_import_lunAction, nargs=nargs, metavar=metavars, help=help)
	class iscsi_IscsiAdministration_import_lunResultAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.iscsi.IscsiAdministration import IscsiAdministration
			service = IscsiAdministration()
			global function, interactive
			function = service.import_lun_result
			interactive = []
			interactive.append(('async_job_id', cli_int))
	methods['iscsi.IscsiAdministration.import_lun_result'] = ('iscsi_IscsiAdministration', '--import_lun_result')
	metavars = () if interactive_mode else ('async_job_id')
	nargs = 0 if interactive_mode else 1
	iscsi_IscsiAdministration.add_argument("--import_lun_result", action=iscsi_IscsiAdministration_import_lunResultAction, nargs=nargs, metavar=metavars)
	class iscsi_IscsiAdministration_delete_lunAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.iscsi.IscsiLimits import IscsiLimits
			from unicorn_api.v5.sv0.iscsi.IscsiTarget import IscsiTarget
			from unicorn_api.v5.sv0.iscsi.IscsiLun import IscsiLun
			from unicorn_api.v5.sv0.iscsi import IscsiLunKind
			from unicorn_api.v5.sv0.iscsi.IscsiTargetStatus import IscsiTargetStatus
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiTarget import SimpleIscsiTarget

			from transformer.lib import ListInfo, ResultSet, Long
			checker = [cli_unicode,cli_int,IscsiLunKind]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.iscsi.IscsiAdministration import IscsiAdministration
			service = IscsiAdministration()
			global function, interactive
			function = service.delete_lun
			interactive = []
			interactive.append(('async_job_name', cli_unicode))
			interactive.append(('id', cli_int))
			interactive.append(('kind', IscsiLunKind))
	methods['iscsi.IscsiAdministration.delete_lun'] = ('iscsi_IscsiAdministration', '--delete_lun')
	metavars = () if interactive_mode else ('async_job_name','id','kind')
	help = '' if interactive_mode else '%s %s ' % ('int', 'BLOCK_LEVEL|FILE_LEVEL')
	nargs = 0 if interactive_mode else 3
	iscsi_IscsiAdministration.add_argument("--delete_lun", action=iscsi_IscsiAdministration_delete_lunAction, nargs=nargs, metavar=metavars, help=help)
	class iscsi_IscsiAdministration_delete_lunResultAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.iscsi.IscsiAdministration import IscsiAdministration
			service = IscsiAdministration()
			global function, interactive
			function = service.delete_lun_result
			interactive = []
			interactive.append(('async_job_id', cli_int))
	methods['iscsi.IscsiAdministration.delete_lun_result'] = ('iscsi_IscsiAdministration', '--delete_lun_result')
	metavars = () if interactive_mode else ('async_job_id')
	nargs = 0 if interactive_mode else 1
	iscsi_IscsiAdministration.add_argument("--delete_lun_result", action=iscsi_IscsiAdministration_delete_lunResultAction, nargs=nargs, metavar=metavars)
	class iscsi_IscsiAdministration_modifyAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.iscsi.IscsiLimits import IscsiLimits
			from unicorn_api.v5.sv0.iscsi.IscsiTarget import IscsiTarget
			from unicorn_api.v5.sv0.iscsi.IscsiLun import IscsiLun
			from unicorn_api.v5.sv0.iscsi import IscsiLunKind
			from unicorn_api.v5.sv0.iscsi.IscsiTargetStatus import IscsiTargetStatus
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiTarget import SimpleIscsiTarget

			from transformer.lib import ListInfo, ResultSet, Long
			checker = [cli_int,IscsiTarget]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.iscsi.IscsiAdministration import IscsiAdministration
			service = IscsiAdministration()
			global function, interactive
			function = service.modify
			interactive = []
			interactive.append(('id', cli_int))
			interactive.append(('isci', IscsiTarget))
	methods['iscsi.IscsiAdministration.modify'] = ('iscsi_IscsiAdministration', '--modify')
	metavars = () if interactive_mode else ('id','isci')
	help = '' if interactive_mode else '%s %s ' % ('int', '{"multiple_session":True|False,"name":text,"iqn_suffix":text,"data_digest":True|False,"header_digest":True|False,#"chap_user":{"login":text,#"password":text#,#"mutual_chap_user":{"login":text,#"password":text#}#}#,#"initiator_iqns":["text",...]#}')
	nargs = 0 if interactive_mode else 2
	iscsi_IscsiAdministration.add_argument("--modify", action=iscsi_IscsiAdministration_modifyAction, nargs=nargs, metavar=metavars, help=help)
	class iscsi_IscsiAdministration_detach_lunAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.iscsi.IscsiLimits import IscsiLimits
			from unicorn_api.v5.sv0.iscsi.IscsiTarget import IscsiTarget
			from unicorn_api.v5.sv0.iscsi.IscsiLun import IscsiLun
			from unicorn_api.v5.sv0.iscsi import IscsiLunKind
			from unicorn_api.v5.sv0.iscsi.IscsiTargetStatus import IscsiTargetStatus
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiTarget import SimpleIscsiTarget

			from transformer.lib import ListInfo, ResultSet, Long
			checker = [cli_int,IscsiLun]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.iscsi.IscsiAdministration import IscsiAdministration
			service = IscsiAdministration()
			global function, interactive
			function = service.detach_lun
			interactive = []
			interactive.append(('id', cli_int))
			interactive.append(('lun', IscsiLun))
	methods['iscsi.IscsiAdministration.detach_lun'] = ('iscsi_IscsiAdministration', '--detach_lun')
	metavars = () if interactive_mode else ('id','lun')
	help = '' if interactive_mode else '%s %s ' % ('int', '{"kind":BLOCK_LEVEL|FILE_LEVEL,"description":text,"id":int}')
	nargs = 0 if interactive_mode else 2
	iscsi_IscsiAdministration.add_argument("--detach_lun", action=iscsi_IscsiAdministration_detach_lunAction, nargs=nargs, metavar=metavars, help=help)
	class iscsi_IscsiAdministration_set_isns_serverAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.iscsi.IscsiLimits import IscsiLimits
			from unicorn_api.v5.sv0.iscsi.IscsiTarget import IscsiTarget
			from unicorn_api.v5.sv0.iscsi.IscsiLun import IscsiLun
			from unicorn_api.v5.sv0.iscsi import IscsiLunKind
			from unicorn_api.v5.sv0.iscsi.IscsiTargetStatus import IscsiTargetStatus
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiTarget import SimpleIscsiTarget

			from transformer.lib import ListInfo, ResultSet, Long
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.iscsi.IscsiAdministration import IscsiAdministration
			service = IscsiAdministration()
			global function, interactive
			function = service.set_isns_server
			interactive = []
			interactive.append(('isns_server', cli_unicode))
	methods['iscsi.IscsiAdministration.set_isns_server'] = ('iscsi_IscsiAdministration', '--set_isns_server')
	metavars = () if interactive_mode else ('isns_server')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 1
	iscsi_IscsiAdministration.add_argument("--set_isns_server", action=iscsi_IscsiAdministration_set_isns_serverAction, nargs=nargs, metavar=metavars, help=help)
	class iscsi_IscsiAdministration_get_limitsAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.iscsi.IscsiLimits import IscsiLimits
			from unicorn_api.v5.sv0.iscsi.IscsiTarget import IscsiTarget
			from unicorn_api.v5.sv0.iscsi.IscsiLun import IscsiLun
			from unicorn_api.v5.sv0.iscsi import IscsiLunKind
			from unicorn_api.v5.sv0.iscsi.IscsiTargetStatus import IscsiTargetStatus
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiTarget import SimpleIscsiTarget

			from transformer.lib import ListInfo, ResultSet, Long
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.iscsi.IscsiAdministration import IscsiAdministration
			service = IscsiAdministration()
			global function, interactive
			function = service.get_limits
			interactive = []
	methods['iscsi.IscsiAdministration.get_limits'] = ('iscsi_IscsiAdministration', '--get_limits')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	iscsi_IscsiAdministration.add_argument("--get_limits", action=iscsi_IscsiAdministration_get_limitsAction, nargs=nargs, metavar=metavars, help=help)
	class iscsi_IscsiAdministration_export_lunAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.iscsi.IscsiLimits import IscsiLimits
			from unicorn_api.v5.sv0.iscsi.IscsiTarget import IscsiTarget
			from unicorn_api.v5.sv0.iscsi.IscsiLun import IscsiLun
			from unicorn_api.v5.sv0.iscsi import IscsiLunKind
			from unicorn_api.v5.sv0.iscsi.IscsiTargetStatus import IscsiTargetStatus
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiTarget import SimpleIscsiTarget

			from transformer.lib import ListInfo, ResultSet, Long
			checker = [cli_unicode,cli_int,IscsiLunKind,cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.iscsi.IscsiAdministration import IscsiAdministration
			service = IscsiAdministration()
			global function, interactive
			function = service.export_lun
			interactive = []
			interactive.append(('async_job_name', cli_unicode))
			interactive.append(('id', cli_int))
			interactive.append(('kind', IscsiLunKind))
			interactive.append(('dest_lun_file', cli_unicode))
	methods['iscsi.IscsiAdministration.export_lun'] = ('iscsi_IscsiAdministration', '--export_lun')
	metavars = () if interactive_mode else ('async_job_name','id','kind','dest_lun_file')
	help = '' if interactive_mode else '%s %s %s ' % ('int', 'BLOCK_LEVEL|FILE_LEVEL', 'text')
	nargs = 0 if interactive_mode else 4
	iscsi_IscsiAdministration.add_argument("--export_lun", action=iscsi_IscsiAdministration_export_lunAction, nargs=nargs, metavar=metavars, help=help)
	class iscsi_IscsiAdministration_export_lunResultAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.iscsi.IscsiAdministration import IscsiAdministration
			service = IscsiAdministration()
			global function, interactive
			function = service.export_lun_result
			interactive = []
			interactive.append(('async_job_id', cli_int))
	methods['iscsi.IscsiAdministration.export_lun_result'] = ('iscsi_IscsiAdministration', '--export_lun_result')
	metavars = () if interactive_mode else ('async_job_id')
	nargs = 0 if interactive_mode else 1
	iscsi_IscsiAdministration.add_argument("--export_lun_result", action=iscsi_IscsiAdministration_export_lunResultAction, nargs=nargs, metavar=metavars)
	class iscsi_IscsiAdministration_get_isns_serverAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.iscsi.IscsiLimits import IscsiLimits
			from unicorn_api.v5.sv0.iscsi.IscsiTarget import IscsiTarget
			from unicorn_api.v5.sv0.iscsi.IscsiLun import IscsiLun
			from unicorn_api.v5.sv0.iscsi import IscsiLunKind
			from unicorn_api.v5.sv0.iscsi.IscsiTargetStatus import IscsiTargetStatus
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiTarget import SimpleIscsiTarget

			from transformer.lib import ListInfo, ResultSet, Long
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.iscsi.IscsiAdministration import IscsiAdministration
			service = IscsiAdministration()
			global function, interactive
			function = service.get_isns_server
			interactive = []
	methods['iscsi.IscsiAdministration.get_isns_server'] = ('iscsi_IscsiAdministration', '--get_isns_server')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	iscsi_IscsiAdministration.add_argument("--get_isns_server", action=iscsi_IscsiAdministration_get_isns_serverAction, nargs=nargs, metavar=metavars, help=help)
	class iscsi_IscsiAdministration_duplicate_lunAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.iscsi.IscsiLimits import IscsiLimits
			from unicorn_api.v5.sv0.iscsi.IscsiTarget import IscsiTarget
			from unicorn_api.v5.sv0.iscsi.IscsiLun import IscsiLun
			from unicorn_api.v5.sv0.iscsi import IscsiLunKind
			from unicorn_api.v5.sv0.iscsi.IscsiTargetStatus import IscsiTargetStatus
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiTarget import SimpleIscsiTarget

			from transformer.lib import ListInfo, ResultSet, Long
			checker = [cli_unicode,cli_int,IscsiLunKind,cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.iscsi.IscsiAdministration import IscsiAdministration
			service = IscsiAdministration()
			global function, interactive
			function = service.duplicate_lun
			interactive = []
			interactive.append(('async_job_name', cli_unicode))
			interactive.append(('volume_id', cli_int))
			interactive.append(('kind', IscsiLunKind))
			interactive.append(('id', cli_int))
	methods['iscsi.IscsiAdministration.duplicate_lun'] = ('iscsi_IscsiAdministration', '--duplicate_lun')
	metavars = () if interactive_mode else ('async_job_name','volume_id','kind','id')
	help = '' if interactive_mode else '%s %s %s ' % ('int', 'BLOCK_LEVEL|FILE_LEVEL', 'int')
	nargs = 0 if interactive_mode else 4
	iscsi_IscsiAdministration.add_argument("--duplicate_lun", action=iscsi_IscsiAdministration_duplicate_lunAction, nargs=nargs, metavar=metavars, help=help)
	class iscsi_IscsiAdministration_duplicate_lunResultAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.iscsi.IscsiAdministration import IscsiAdministration
			service = IscsiAdministration()
			global function, interactive
			function = service.duplicate_lun_result
			interactive = []
			interactive.append(('async_job_id', cli_int))
	methods['iscsi.IscsiAdministration.duplicate_lun_result'] = ('iscsi_IscsiAdministration', '--duplicate_lun_result')
	metavars = () if interactive_mode else ('async_job_id')
	nargs = 0 if interactive_mode else 1
	iscsi_IscsiAdministration.add_argument("--duplicate_lun_result", action=iscsi_IscsiAdministration_duplicate_lunResultAction, nargs=nargs, metavar=metavars)
	class iscsi_IscsiAdministration_set_isns_enabledAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.iscsi.IscsiLimits import IscsiLimits
			from unicorn_api.v5.sv0.iscsi.IscsiTarget import IscsiTarget
			from unicorn_api.v5.sv0.iscsi.IscsiLun import IscsiLun
			from unicorn_api.v5.sv0.iscsi import IscsiLunKind
			from unicorn_api.v5.sv0.iscsi.IscsiTargetStatus import IscsiTargetStatus
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiTarget import SimpleIscsiTarget

			from transformer.lib import ListInfo, ResultSet, Long
			checker = [cli_bool]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.iscsi.IscsiAdministration import IscsiAdministration
			service = IscsiAdministration()
			global function, interactive
			function = service.set_isns_enabled
			interactive = []
			interactive.append(('enabled', cli_bool))
	methods['iscsi.IscsiAdministration.set_isns_enabled'] = ('iscsi_IscsiAdministration', '--set_isns_enabled')
	metavars = () if interactive_mode else ('enabled')
	help = '' if interactive_mode else '%s ' % ('True|False')
	nargs = 0 if interactive_mode else 1
	iscsi_IscsiAdministration.add_argument("--set_isns_enabled", action=iscsi_IscsiAdministration_set_isns_enabledAction, nargs=nargs, metavar=metavars, help=help)
	class iscsi_IscsiAdministration_get_isns_enabledAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.iscsi.IscsiLimits import IscsiLimits
			from unicorn_api.v5.sv0.iscsi.IscsiTarget import IscsiTarget
			from unicorn_api.v5.sv0.iscsi.IscsiLun import IscsiLun
			from unicorn_api.v5.sv0.iscsi import IscsiLunKind
			from unicorn_api.v5.sv0.iscsi.IscsiTargetStatus import IscsiTargetStatus
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiTarget import SimpleIscsiTarget

			from transformer.lib import ListInfo, ResultSet, Long
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.iscsi.IscsiAdministration import IscsiAdministration
			service = IscsiAdministration()
			global function, interactive
			function = service.get_isns_enabled
			interactive = []
	methods['iscsi.IscsiAdministration.get_isns_enabled'] = ('iscsi_IscsiAdministration', '--get_isns_enabled')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	iscsi_IscsiAdministration.add_argument("--get_isns_enabled", action=iscsi_IscsiAdministration_get_isns_enabledAction, nargs=nargs, metavar=metavars, help=help)
	class iscsi_IscsiAdministration_delete_targetAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.iscsi.IscsiLimits import IscsiLimits
			from unicorn_api.v5.sv0.iscsi.IscsiTarget import IscsiTarget
			from unicorn_api.v5.sv0.iscsi.IscsiLun import IscsiLun
			from unicorn_api.v5.sv0.iscsi import IscsiLunKind
			from unicorn_api.v5.sv0.iscsi.IscsiTargetStatus import IscsiTargetStatus
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiTarget import SimpleIscsiTarget

			from transformer.lib import ListInfo, ResultSet, Long
			checker = [cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.iscsi.IscsiAdministration import IscsiAdministration
			service = IscsiAdministration()
			global function, interactive
			function = service.delete_target
			interactive = []
			interactive.append(('id', cli_int))
	methods['iscsi.IscsiAdministration.delete_target'] = ('iscsi_IscsiAdministration', '--delete_target')
	metavars = () if interactive_mode else ('id')
	help = '' if interactive_mode else '%s ' % ('int')
	nargs = 0 if interactive_mode else 1
	iscsi_IscsiAdministration.add_argument("--delete_target", action=iscsi_IscsiAdministration_delete_targetAction, nargs=nargs, metavar=metavars, help=help)
	class iscsi_IscsiAdministration_add_iqnAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.iscsi.IscsiLimits import IscsiLimits
			from unicorn_api.v5.sv0.iscsi.IscsiTarget import IscsiTarget
			from unicorn_api.v5.sv0.iscsi.IscsiLun import IscsiLun
			from unicorn_api.v5.sv0.iscsi import IscsiLunKind
			from unicorn_api.v5.sv0.iscsi.IscsiTargetStatus import IscsiTargetStatus
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiTarget import SimpleIscsiTarget

			from transformer.lib import ListInfo, ResultSet, Long
			checker = [cli_int,cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.iscsi.IscsiAdministration import IscsiAdministration
			service = IscsiAdministration()
			global function, interactive
			function = service.add_iqn
			interactive = []
			interactive.append(('target_id', cli_int))
			interactive.append(('iqn', cli_unicode))
	methods['iscsi.IscsiAdministration.add_iqn'] = ('iscsi_IscsiAdministration', '--add_iqn')
	metavars = () if interactive_mode else ('target_id','iqn')
	help = '' if interactive_mode else '%s %s ' % ('int', 'text')
	nargs = 0 if interactive_mode else 2
	iscsi_IscsiAdministration.add_argument("--add_iqn", action=iscsi_IscsiAdministration_add_iqnAction, nargs=nargs, metavar=metavars, help=help)
	class iscsi_IscsiAdministration_list_lunAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.iscsi.IscsiLimits import IscsiLimits
			from unicorn_api.v5.sv0.iscsi.IscsiTarget import IscsiTarget
			from unicorn_api.v5.sv0.iscsi.IscsiLun import IscsiLun
			from unicorn_api.v5.sv0.iscsi import IscsiLunKind
			from unicorn_api.v5.sv0.iscsi.IscsiTargetStatus import IscsiTargetStatus
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiTarget import SimpleIscsiTarget

			from transformer.lib import ListInfo, ResultSet, Long
			checker = [cli_list_info]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.iscsi.IscsiAdministration import IscsiAdministration
			service = IscsiAdministration()
			global function, interactive
			function = service.list_lun
			interactive = []
			interactive.append(('listInfo', cli_list_info))
	methods['iscsi.IscsiAdministration.list_lun'] = ('iscsi_IscsiAdministration', '--list_lun')
	metavars = () if interactive_mode else ('listInfo')
	help = '' if interactive_mode else '%s ' % ('offset:XXX,limit:YYYY,search_parameters:{key:value,key2:value2}')
	nargs = 0 if interactive_mode else 1
	iscsi_IscsiAdministration.add_argument("--list_lun", action=iscsi_IscsiAdministration_list_lunAction, nargs=nargs, metavar=metavars, help=help)
	class iscsi_IscsiAdministration_attach_lunAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.iscsi.IscsiLimits import IscsiLimits
			from unicorn_api.v5.sv0.iscsi.IscsiTarget import IscsiTarget
			from unicorn_api.v5.sv0.iscsi.IscsiLun import IscsiLun
			from unicorn_api.v5.sv0.iscsi import IscsiLunKind
			from unicorn_api.v5.sv0.iscsi.IscsiTargetStatus import IscsiTargetStatus
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiTarget import SimpleIscsiTarget

			from transformer.lib import ListInfo, ResultSet, Long
			checker = [cli_int,IscsiLun]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.iscsi.IscsiAdministration import IscsiAdministration
			service = IscsiAdministration()
			global function, interactive
			function = service.attach_lun
			interactive = []
			interactive.append(('id', cli_int))
			interactive.append(('lun', IscsiLun))
	methods['iscsi.IscsiAdministration.attach_lun'] = ('iscsi_IscsiAdministration', '--attach_lun')
	metavars = () if interactive_mode else ('id','lun')
	help = '' if interactive_mode else '%s %s ' % ('int', '{"kind":BLOCK_LEVEL|FILE_LEVEL,"description":text,"id":int}')
	nargs = 0 if interactive_mode else 2
	iscsi_IscsiAdministration.add_argument("--attach_lun", action=iscsi_IscsiAdministration_attach_lunAction, nargs=nargs, metavar=metavars, help=help)
	class iscsi_IscsiAdministration_remove_iqnAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.iscsi.IscsiLimits import IscsiLimits
			from unicorn_api.v5.sv0.iscsi.IscsiTarget import IscsiTarget
			from unicorn_api.v5.sv0.iscsi.IscsiLun import IscsiLun
			from unicorn_api.v5.sv0.iscsi import IscsiLunKind
			from unicorn_api.v5.sv0.iscsi.IscsiTargetStatus import IscsiTargetStatus
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiTarget import SimpleIscsiTarget

			from transformer.lib import ListInfo, ResultSet, Long
			checker = [cli_int,cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.iscsi.IscsiAdministration import IscsiAdministration
			service = IscsiAdministration()
			global function, interactive
			function = service.remove_iqn
			interactive = []
			interactive.append(('target_id', cli_int))
			interactive.append(('iqn', cli_unicode))
	methods['iscsi.IscsiAdministration.remove_iqn'] = ('iscsi_IscsiAdministration', '--remove_iqn')
	metavars = () if interactive_mode else ('target_id','iqn')
	help = '' if interactive_mode else '%s %s ' % ('int', 'text')
	nargs = 0 if interactive_mode else 2
	iscsi_IscsiAdministration.add_argument("--remove_iqn", action=iscsi_IscsiAdministration_remove_iqnAction, nargs=nargs, metavar=metavars, help=help)
	class iscsi_IscsiAdministration_check_iqnAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.iscsi.IscsiLimits import IscsiLimits
			from unicorn_api.v5.sv0.iscsi.IscsiTarget import IscsiTarget
			from unicorn_api.v5.sv0.iscsi.IscsiLun import IscsiLun
			from unicorn_api.v5.sv0.iscsi import IscsiLunKind
			from unicorn_api.v5.sv0.iscsi.IscsiTargetStatus import IscsiTargetStatus
			from unicorn_api.v5.sv0.iscsi.SimpleIscsiTarget import SimpleIscsiTarget

			from transformer.lib import ListInfo, ResultSet, Long
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.iscsi.IscsiAdministration import IscsiAdministration
			service = IscsiAdministration()
			global function, interactive
			function = service.check_iqn
			interactive = []
			interactive.append(('iqn', cli_unicode))
	methods['iscsi.IscsiAdministration.check_iqn'] = ('iscsi_IscsiAdministration', '--check_iqn')
	metavars = () if interactive_mode else ('iqn')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 1
	iscsi_IscsiAdministration.add_argument("--check_iqn", action=iscsi_IscsiAdministration_check_iqnAction, nargs=nargs, metavar=metavars, help=help)
	services_UpnpServiceAdministration = subparsers.add_parser('services_UpnpServiceAdministration', help="help services.UpnpServiceAdministration")
	class services_UpnpServiceAdministration_force_rescanAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.services.UpnpServiceAdministration import UpnpServiceAdministration
			service = UpnpServiceAdministration()
			global function, interactive
			function = service.force_rescan
			interactive = []
	methods['services.UpnpServiceAdministration.force_rescan'] = ('services_UpnpServiceAdministration', '--force_rescan')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	services_UpnpServiceAdministration.add_argument("--force_rescan", action=services_UpnpServiceAdministration_force_rescanAction, nargs=nargs, metavar=metavars, help=help)
	email_EmailNotification = subparsers.add_parser('email_EmailNotification', help="help email.EmailNotification")
	class email_EmailNotification_is_enabledAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.email.EmailNotification import EmailNotification
			service = EmailNotification()
			global function, interactive
			function = service.is_enabled
			interactive = []
	methods['email.EmailNotification.is_enabled'] = ('email_EmailNotification', '--is_enabled')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	email_EmailNotification.add_argument("--is_enabled", action=email_EmailNotification_is_enabledAction, nargs=nargs, metavar=metavars, help=help)
	class email_EmailNotification_set_enabledAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			checker = [cli_bool]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.email.EmailNotification import EmailNotification
			service = EmailNotification()
			global function, interactive
			function = service.set_enabled
			interactive = []
			interactive.append(('enabled', cli_bool))
	methods['email.EmailNotification.set_enabled'] = ('email_EmailNotification', '--set_enabled')
	metavars = () if interactive_mode else ('enabled')
	help = '' if interactive_mode else '%s ' % ('True|False')
	nargs = 0 if interactive_mode else 1
	email_EmailNotification.add_argument("--set_enabled", action=email_EmailNotification_set_enabledAction, nargs=nargs, metavar=metavars, help=help)
	netbackup_NetBackupAdministration = subparsers.add_parser('netbackup_NetBackupAdministration', help="help netbackup.NetBackupAdministration")
	class netbackup_NetBackupAdministration_create_netbackup_shareAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.netbackup.NetBackup import NetBackup
			checker = [cli_bool,cli_unicode,cli_int]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.netbackup.NetBackupAdministration import NetBackupAdministration
			service = NetBackupAdministration()
			global function, interactive
			function = service.create_netbackup_share
			interactive = []
			interactive.append(('enable', cli_bool))
			interactive.append(('password', cli_unicode))
			interactive.append(('volume_id', cli_int))
	methods['netbackup.NetBackupAdministration.create_netbackup_share'] = ('netbackup_NetBackupAdministration', '--create_netbackup_share')
	metavars = () if interactive_mode else ('enable','password','volume_id')
	help = '' if interactive_mode else '%s %s %s ' % ('True|False', 'text', 'int')
	nargs = 0 if interactive_mode else 3
	netbackup_NetBackupAdministration.add_argument("--create_netbackup_share", action=netbackup_NetBackupAdministration_create_netbackup_shareAction, nargs=nargs, metavar=metavars, help=help)
	class netbackup_NetBackupAdministration_deactivate_netbackupAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.netbackup.NetBackup import NetBackup
			checker = [cli_bool]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.netbackup.NetBackupAdministration import NetBackupAdministration
			service = NetBackupAdministration()
			global function, interactive
			function = service.deactivate_netbackup
			interactive = []
			interactive.append(('delete_share', cli_bool))
	methods['netbackup.NetBackupAdministration.deactivate_netbackup'] = ('netbackup_NetBackupAdministration', '--deactivate_netbackup')
	metavars = () if interactive_mode else ('delete_share')
	help = '' if interactive_mode else '%s ' % ('True|False')
	nargs = 0 if interactive_mode else 1
	netbackup_NetBackupAdministration.add_argument("--deactivate_netbackup", action=netbackup_NetBackupAdministration_deactivate_netbackupAction, nargs=nargs, metavar=metavars, help=help)
	class netbackup_NetBackupAdministration_get_passwordAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.netbackup.NetBackup import NetBackup
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.netbackup.NetBackupAdministration import NetBackupAdministration
			service = NetBackupAdministration()
			global function, interactive
			function = service.get_password
			interactive = []
	methods['netbackup.NetBackupAdministration.get_password'] = ('netbackup_NetBackupAdministration', '--get_password')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	netbackup_NetBackupAdministration.add_argument("--get_password", action=netbackup_NetBackupAdministration_get_passwordAction, nargs=nargs, metavar=metavars, help=help)
	class netbackup_NetBackupAdministration_is_netbackup_share_createdAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.netbackup.NetBackup import NetBackup
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.netbackup.NetBackupAdministration import NetBackupAdministration
			service = NetBackupAdministration()
			global function, interactive
			function = service.is_netbackup_share_created
			interactive = []
	methods['netbackup.NetBackupAdministration.is_netbackup_share_created'] = ('netbackup_NetBackupAdministration', '--is_netbackup_share_created')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	netbackup_NetBackupAdministration.add_argument("--is_netbackup_share_created", action=netbackup_NetBackupAdministration_is_netbackup_share_createdAction, nargs=nargs, metavar=metavars, help=help)
	class netbackup_NetBackupAdministration_get_netbackupAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.netbackup.NetBackup import NetBackup
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.netbackup.NetBackupAdministration import NetBackupAdministration
			service = NetBackupAdministration()
			global function, interactive
			function = service.get_netbackup
			interactive = []
	methods['netbackup.NetBackupAdministration.get_netbackup'] = ('netbackup_NetBackupAdministration', '--get_netbackup')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	netbackup_NetBackupAdministration.add_argument("--get_netbackup", action=netbackup_NetBackupAdministration_get_netbackupAction, nargs=nargs, metavar=metavars, help=help)
	class netbackup_NetBackupAdministration_set_passwordAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.netbackup.NetBackup import NetBackup
			checker = [cli_unicode]
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.netbackup.NetBackupAdministration import NetBackupAdministration
			service = NetBackupAdministration()
			global function, interactive
			function = service.set_password
			interactive = []
			interactive.append(('password', cli_unicode))
	methods['netbackup.NetBackupAdministration.set_password'] = ('netbackup_NetBackupAdministration', '--set_password')
	metavars = () if interactive_mode else ('password')
	help = '' if interactive_mode else '%s ' % ('text')
	nargs = 0 if interactive_mode else 1
	netbackup_NetBackupAdministration.add_argument("--set_password", action=netbackup_NetBackupAdministration_set_passwordAction, nargs=nargs, metavar=metavars, help=help)
	class netbackup_NetBackupAdministration_activate_netbackupAction(Action):
		def __call__(self, parser, namespace, values, option_string=None):
			from unicorn_api.v5.sv0.netbackup.NetBackup import NetBackup
			checker = []
			global func_args
			func_args = []
			for i in range(0, len(values)):
				func_args.append(checker[i].from_cli(values[i]))
			from unicorn_api.v5.sv0.netbackup.NetBackupAdministration import NetBackupAdministration
			service = NetBackupAdministration()
			global function, interactive
			function = service.activate_netbackup
			interactive = []
	methods['netbackup.NetBackupAdministration.activate_netbackup'] = ('netbackup_NetBackupAdministration', '--activate_netbackup')
	metavars = () if interactive_mode else ()
	help = '' if interactive_mode else '' % ()
	nargs = 0 if interactive_mode else 0
	netbackup_NetBackupAdministration.add_argument("--activate_netbackup", action=netbackup_NetBackupAdministration_activate_netbackupAction, nargs=nargs, metavar=metavars, help=help)
	if search is True:
		for key in methods:
			match=True
			for arg in options.search:
				if not arg.lower() in key.lower():
					match = False
					break
			if match is True:
				print key
				print "		%s %s" % methods[key]
		exit(0)
	from transformer.client_transport import set_client
	ip = u"127.0.0.1"
 	port = 80
	if options.ip is not None:
		ip = options.ip
	if options.port is not None:
		port = options.port
	from transformer.transport.client_http import HTTPClient
	from transformer.lib import ListInfo, Dict
	client = HTTPClient(ip, port)
	set_client(client)
	auth_forced = False
	if lacie_auth is not None:
		user = u"admin"
 		password = u"admin"
		set_lacie_auth = False
		if options.user is not None:
			lacie_auth.set_user(options.user)
			set_lacie_auth = True
		if options.password is not None:
			lacie_auth.set_password(options.password)
			set_lacie_auth = True
		if set_lacie_auth:
			client.set_authentication(lacie_auth)
			auth_forced = True
	if app_auth is not None:
		if options.app is not None:
			app_auth.set_app_id(options.app[0])
			app_auth.set_app_token(options.app[1])
			client.set_authentication(app_auth)
			auth_forced=True
		if options.app_session is not None:
			app_auth.set_session(options.app_session)
			client.set_authentication(app_auth)
		if options.app_user is not None:
			app_auth.set_user_token(options.app_user)
			client.set_authentication(app_auth)
	if not auth_forced:
		#Get the information for the environment variables
		app_id = os.environ.get('APP_ID', None)
		app_token = os.environ.get('APP_TOKEN', None)
		if app_id is not None and app_token is not None:
			app_auth.set_app_id(app_id)
			app_auth.set_app_token(app_token)
			client.set_authentication(app_auth)
	def cleanup_string(value):
		if value.startswith('"') or value.startswith('\''):
			return value[1:-1]
		return value
	if options.open_session is not None:
		client.set_authentication(app_auth)
		for k, v in app_auth.open_session().iteritems():
			print '%s: %s'% (k, v)
		return
	if options.register_app is not None:
		client.set_authentication(app_auth)
		app_id = options.register_app[0]
		mandatory_perms = cleanup_string(options.register_app[1]).split(',')
		optionals_perms = []
		if options.register_app[2]:
			optionals_perms = cleanup_string(options.register_app[2]).split(',')
		print app_auth.request_auth_token(app_id, mandatory_perms, optionals_perms)
		return
	if options.unregister_app is not None:
		client.set_authentication(app_auth)
		app_id = options.unregister_app[0]
		app_token = options.unregister_app[1]
		app_auth.set_app_id(app_id)
		app_auth.set_app_token(app_token)
		app_auth.remove_auth_token()
		return
	elif options.register_status:
		client.set_authentication(app_auth)
		app_auth.req_id = options.register_status
		res = app_auth.get_current_auth_status()
		print 'status %s\ntoken %s' % (res['status'], res['token'])
		return
	if options.async is not None:
		function = client.get_job_status
		func_args.append(options.async)
	options = parser.parse_args()
	#now make the call
	if function is None:
		parser.print_help()
		return
	if interactive_mode:
		print('@@@@@@@@@@Starting interactive mode@@@@@@@@\n')
		from transformer.lib.cli import interactive_builder
		func_args = interactive_builder(interactive)
	try:
		temp = function(*func_args)
		temp = temp.__str__()
		print temp.encode('utf8')
	except ClientError, exc:
		print '%s: %s' % (exc.real_id, exc.text)
		exit(-2)
if __name__ == "__main__":
	main()
